/***************************************/
/*  Use MADS http://mads.atari8.info/  */
/*  Mode: DLI (char mode)              */
/***************************************/

WIDTH	= 40
HEIGHT	= 30

; ---	MAIN PROGRAM
	org $3800
ant	dta $F0
	dta $C4,a(scr),$84,$84,$04,$04,$84,$04,$04,$84,$84,$02,$82,$82,$82,$82,$82
	dta $82,$02,$82,$82,$82,$82,$82,$82,$82,$82,$70,$70,$70
	dta $41,a(ant)

scr	ins "cw_screen2.scr"

	.ds 4*40

	.ALIGN $0400
fnt	ins "cw_screen2.fnt"

	ift USESPRITES
	.ALIGN $0800
pmg	.ds $0300
	ift FADECHR = 0
	SPRITES
	els
	.ds $500
	eif
	eif

.def :main2
; ---	init PMG

	ift USESPRITES
	mva >pmg pmbase		;missiles and players data address
	mva #$03 pmcntl		;enable players and missiles
	eif

	ift CHANGES		;if label CHANGES defined
	jsr save_color		;then save all colors and set value 0 for all colors
	eif

	lda:cmp:req $14		;wait 1 frame

	sei			;stop IRQ interrupts
	mva #$00 nmien		;stop NMI interrupts
	sta dmactl
	mva #$fe portb		;switch off ROM to get 16k more ram

	mwa #NMI_screen2 $fffa		;new NMI handler

	mva #$c0 nmien		;switch on NMI+DLI again

	ift CHANGES		;if label CHANGES defined

	jsr fade_in		;fade in colors

_lp	lda trig0		; FIRE #0
	beq stop

	lda trig1		; FIRE #1
	beq stop

	lda consol		; START
	and #1
	beq stop

	lda skctl
	and #$04
	bne _lp			;wait to press any key; here you can put any own routine

	els

null	jmp DLI_screen2.dli1		;CPU is busy here, so no more routines allowed

	eif


stop
	jsr fade_out		;fade out colors

	mva #$00 pmcntl		;PMG disabled
	tax
	sta:rne hposp0,x+

	mva #$ff portb		;ROM switch on
	mva #$40 nmien		;only NMI interrupts, DLI disabled
	cli					;IRQ enabled

	jmp main3			;return to ... DOS

; ---	DLI PROGRAM

.local	DLI_screen2

	?old_dli = *

	ift !CHANGES

dli1	lda trig0		; FIRE #0
	beq stop

	lda trig1		; FIRE #1
	beq stop

	lda consol		; START
	and #1
	beq stop

	lda skctl
	and #$04
	beq stop

	lda vcount
	cmp #$02
	bne dli1

	:3 sta wsync

	DLINEW dli10

	eif

dli_start

dli10
	sta regA

	sta wsync		;line=8
	sta wsync		;line=9
	sta wsync		;line=10
	sta wsync		;line=11
	sta wsync		;line=12
c7	lda #$42
	sta wsync		;line=13
	sta color2
	DLINEW dli11 1 0 0

dli11
	sta regA

	sta wsync		;line=16
c8	lda #$44
	sta wsync		;line=17
	sta color2
c9	lda #$42
	sta wsync		;line=18
	sta color2
c10	lda #$44
	sta wsync		;line=19
	sta color2
c11	lda #$42
	sta wsync		;line=20
	sta color2
c12	lda #$44
	sta wsync		;line=21
	sta color2
	DLINEW dli12 1 0 0

dli12
	sta regA

	sta wsync		;line=24
c13	lda #$46
	sta wsync		;line=25
	sta color2
c14	lda #$44
	sta wsync		;line=26
	sta color2
c15	lda #$46
	sta wsync		;line=27
	sta color2
c16	lda #$44
	sta wsync		;line=28
	sta color2
c17	lda #$46
	sta wsync		;line=29
	sta color2
	DLINEW dli13 1 0 0

dli13
	sta regA

	sta wsync		;line=32
	sta wsync		;line=33
	sta wsync		;line=34
	sta wsync		;line=35
	sta wsync		;line=36
c18	lda #$48
	sta wsync		;line=37
	sta color2
c19	lda #$46
	sta wsync		;line=38
	sta color2
c20	lda #$48
	sta wsync		;line=39
	sta color2
c21	lda #$46
	sta wsync		;line=40
	sta color2
c22	lda #$48
	sta wsync		;line=41
	sta color2
	sta wsync		;line=42
c23	lda #$4A
	sta wsync		;line=43
	sta color2
c24	lda #$48
	sta wsync		;line=44
	sta color2
c25	lda #$44
	sta wsync		;line=45
	sta color2
	DLINEW DLI_screen2.dli2 1 0 0

dli2
	sta regA
	lda >fnt+$400*$01
	sta wsync		;line=56
	sta chbase
	sta wsync		;line=57
	sta wsync		;line=58
c26	lda #$46
	sta wsync		;line=59
	sta color2
c27	lda #$44
	sta wsync		;line=60
	sta color2
c28	lda #$46
	sta wsync		;line=61
	sta color2
c29	lda #$44
	sta wsync		;line=62
	sta color2
c30	lda #$46
	sta wsync		;line=63
	sta color2
	sta wsync		;line=64
	sta wsync		;line=65
	sta wsync		;line=66
	sta wsync		;line=67
	sta wsync		;line=68
c31	lda #$48
	sta wsync		;line=69
	sta color2
c32	lda #$46
	sta wsync		;line=70
	sta color2
c33	lda #$48
	sta wsync		;line=71
	sta color2
c34	lda #$46
	sta wsync		;line=72
	sta color2
c35	lda #$48
	sta wsync		;line=73
	sta color2
	sta wsync		;line=74
	sta wsync		;line=75
	sta wsync		;line=76
c36	lda #$4A
	sta wsync		;line=77
	sta color2
	DLINEW dli3 1 0 0

dli3
	sta regA
	lda >fnt+$400*$00
	sta wsync		;line=80
	sta chbase
	DLINEW dli4 1 0 0

dli4
	sta regA
	stx regX
	sty regY
	lda >fnt+$400*$01
c37	ldx #$00
c38	ldy #$0E
	sta wsync		;line=88
	sta chbase
	stx color0
	sty color1
c39	lda #$00
	sta color2
	DLINEW dli14 1 1 1

dli14
	sta regA

c40	lda #$0C
	sta wsync		;line=104
	sta color1
	DLINEW dli15 1 0 0

dli15
	sta regA

c41	lda #$0A
	sta wsync		;line=112
	sta color1
	DLINEW dli16 1 0 0

dli16
	sta regA

c42	lda #$08
	sta wsync		;line=120
	sta color1
	DLINEW dli17 1 0 0

dli17
	sta regA

c43	lda #$0E
	sta wsync		;line=128
	sta color1
	DLINEW dli18 1 0 0

dli18
	sta regA

c44	lda #$0C
	sta wsync		;line=136
	sta color1
	DLINEW dli19 1 0 0

dli19
	sta regA

c45	lda #$0E
	sta wsync		;line=144
	sta color1
	DLINEW dli20 1 0 0

dli20
	sta regA
	stx regX
	sty regY

c46	lda #$08
x8	ldx #$98
c47	ldy #$B0
	sta wsync		;line=160
	sta color1
	stx hposp0
	sty colpm0
	DLINEW dli21 1 1 1

dli21
	sta regA
	stx regX
	sty regY

c48	lda #$0E
x9	ldx #$78
x10	ldy #$58
	sta wsync		;line=168
	sta color1
	stx hposp1
	sty hposp2
x11	lda #$38
	sta hposp3
x12	lda #$C4
	sta hposm0
c49	lda #$B0
	sta colpm1
	sta colpm2
c50	lda #$60
	sta colpm3
	DLINEW dli22 1 1 1

dli22
	sta regA

c51	lda #$0C
	sta wsync		;line=176
	sta color1
	DLINEW dli23 1 0 0

dli23
	sta regA

c52	lda #$0A
	sta wsync		;line=184
	sta color1
	DLINEW dli24 1 0 0

dli24
	sta regA

c53	lda #$08
	sta wsync		;line=192
	sta color1
	DLINEW dli5 1 0 0

dli5
	sta regA
	stx regX
	sty regY
	lda >fnt+$400*$00
c54	ldx #$0E
x13	ldy #$8C
	sta wsync		;line=200
	sta chbase
	stx color1
	sty hposp0
c55	lda #$80
	sta colpm0
x14	lda #$90
x15	ldx #$C8
	sta wsync		;line=201
	sta hposp0
	stx hposm0
	DLINEW dli6 1 1 1

dli6
	sta regA
	lda >fnt+$400*$01
	sta wsync		;line=208
	sta chbase
	DLINEW dli7 1 0 0

dli7
	sta regA
	lda >fnt+$400*$00
	sta wsync		;line=216
	sta chbase

	lda regA
	rti

.endl

; ---

CHANGES = 1
FADECHR	= 0

SCHR	= 127

; ---

.proc	NMI_screen2

	bit nmist
	bpl VBL

	jmp DLI_screen2.dli_start
dliv	equ *-2

VBL
	sta regA
	stx regX
	sty regY

	sta nmist		;reset NMI flag

	mwa #ant dlptr		;ANTIC address program

	mva #@dmactl(standard|dma|lineX1|players|missiles) dmactl	;set new screen width

	inc cloc		;little timer

; Initial values

	lda >fnt+$400*$00
	sta chbase
c0	lda #$00
	sta colbak
	lda #$02
	sta chrctl
	lda #$01
	sta gtictl
c1	lda #$74
	sta color0
c2	lda #$7C
	sta color1
c3	lda #$44
	sta color2
c4	lda #$00
	sta color3
s0	lda #$03
	sta sizep1
x0	lda #$70
	sta hposp1
c5	lda #$80
	sta colpm1
s1	lda #$03
	sta sizep0
	sta sizep2
s2	lda #$FF
	sta sizem
x1	lda #$90
	sta hposp0
x2	lda #$50
	sta hposp2
x3	lda #$C8
	sta hposm0
x4	lda #$C0
	sta hposm1
x5	lda #$B8
	sta hposm2
x6	lda #$B0
	sta hposm3
c6	lda #$80
	sta colpm0
	sta colpm2
	sta colpm3
s3	lda #$03
	sta sizep3
x7	lda #$30
	sta hposp3

	mwa #DLI_screen2.dli_start dliv	;set the first address of DLI interrupt

;this area is for yours routines

quit
	lda regA
	ldx regX
	ldy regY
	rti

.endp

; ---
	ift CHANGES
		ift FADECHR = 0
		icl 'cw_screen2.fad'
		eif
	eif

;	run main
; ---

	opt l-

.MACRO	SPRITES
missiles
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 70 70 71 70 70 00
	.he 00 58 DC DC DC DC DC 00 00 8C 6E EE EE EE EE 20
	.he 00 00 00 00 00 00 00 00 00 80 BC BC BC BC BC 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 10 30 30 30 30 38 08
	.he 00 08 38 38 38 38 38 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player0
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 28 F9 F9 F9 F9 FD 04
	.he 00 58 7E 7E 7E 7E 7E 00 00 48 6F 6F 6F 6F 6F 23
	.he 00 00 00 00 00 00 00 00 00 03 F5 F7 F7 F7 F7 40
	.he 00 00 E0 E0 E0 E0 F0 40 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 46 7E 7E 7E 7E 7F 03 20 28 EF EF EF EF EF 00
	.he 00 3E FE FE FE FC FE 42 00 2C FC FC FC FC FE 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player1
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 43 2F 6F 6F 6F 6F 00
	.he 00 16 B7 B7 B7 B7 B7 00 00 00 BF BF BF BF BF 04
	.he 00 00 00 00 00 00 00 00 00 30 BB BB BB BB BB 00
	.he 00 72 B7 F7 F7 F7 F7 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 80 00 00 80 00
	.he 00 50 DF DF DF DF DF 00 00 CE BD FF FF FF FF 00
	.he 00 62 FB FB FB FB FB 00 00 94 F7 F7 F7 F7 F7 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player2
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 80 00 00 00 00 00 00 00 00 BF BF BF BF BF 04
	.he 00 C0 DF DF DF DF DF 0C 00 52 7E 7E 7E 7E 7E 00
	.he 00 B0 BC BC BC BC BE 00 00 02 EF EF EF EF EF 00
	.he 00 00 7E 7E 7E 7E 7E 48 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 F7 F7 F7 F7 F7 80
	.he 00 72 7F 7F 7F 7F 7F 00 00 6E 7C 7F 7E 7E 7E 00
	.he 00 6D 79 7F 7D 7D 7D 00 00 62 7E 7E 7E 7E 7E 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player3
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 10 1E 1E 1E 1E 1E 00
	.he 00 41 3A 7B 7B 7B 7B 00 00 00 7E 7E 7E 7E 7F 00
	.he 00 46 3D 7F 7F 7F 7F 50 00 60 77 77 77 77 77 00
	.he 00 16 77 77 77 77 77 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 60 77 77 77 77 77 00
	.he 00 2A 2A 2A 2A 2A 3F 00 00 2A 2A 2A 2A 2A 3F 00
	.he 00 2A 2A 2A 2A 2A 3F 00 00 2A 2A 2A 2A 2A 3F 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
.ENDM

USESPRITES = 1

.MACRO	DLINEW
	mva <:1 NMI_screen2.dliv
	ift [>?old_dli]<>[>:1]
	mva >:1 NMI_screen2.dliv+1
	eif

	ift :2
	lda regA
	eif

	ift :3
	ldx regX
	eif

	ift :4
	ldy regY
	eif

	rti

	.def ?old_dli = *
.ENDM

