/***************************************/
/*  Use MADS http://mads.atari8.info/  */
/*  Mode: DLI (char mode)              */
/***************************************/
/*
	icl "cw_title.h"

	org $f0

fcnt	.ds 2
fadr	.ds 2
fhlp	.ds 2
cloc	.ds 1
regA	.ds 1
regX	.ds 1
regY	.ds 1
*/
WIDTH	= 48
HEIGHT	= 30

; ---	MAIN PROGRAM
	org $4000

ant	dta $70
	dta $70,$44,a(scr),$04,$04,$04,$84,$04,$04,$04,$04,$84,$04,$04,$84,$84,$04
	dta $04,$84,$04,$04,$84,$04,$04,$04,$04,$04,$04,$70,$70
	dta $41,a(ant)
	
scr	ins "cw_title.scr"

	.ds 4*40

	.ALIGN $0400
fnt	ins "cw_title.fnt"

	ift USESPRITES
	.ALIGN $0800
pmg	.ds $0300
	ift FADECHR = 0
	SPRITES
	els
	.ds $500
	eif
	eif

show_cw_title
; ---	init PMG

	ift USESPRITES
	mva >pmg pmbase			; missiles and players data address
	mva #$03 pmcntl			; enable players and missiles
	eif

    jsr wait_one_frame
	;lda:cmp:req $14		; wait 1 frame

	sei						; stop IRQ interrupts
	mva #$00 nmien			; stop NMI interrupts
	sta dmactl
	;mva #$fe portb			; switch off ROM to get 16k more ram
     
	mwa #NMI $fffa			; new NMI handler
  	mva #$00 cloc           ; wait frames(1/50) to quit from title picture  
	mva #$c0 nmien			; switch on NMI+DLI again

    ldx #50
_lp0 
    jsr wait_one_frame
   	dex
   	bne _lp0
   	
	ift CHANGES				; if label CHANGES defined

_lp	lda cloc				; wait some to time to quit
    cmp #$ff
    beq stop
    
	lda trig0				; FIRE #0
	beq stop

	lda trig1				; FIRE #1
	beq stop

	lda consol				; START
	and #1
	beq stop

	lda skctl
	and #$04
	bne _lp					; wait to press any key; here you can put any own routine

	els

null	jmp DLI.dli1		; CPU is busy here, so no more routines allowed

	eif


stop
	mva #$00 pmcntl			; PMG disabled
	tax
	sta:rne hposp0,x+

	;mva #$ff portb			; ROM switch on
	mva #$00 nmien			;only NMI interrupts, DLI disable
	sta      dmactl
	mwa #_NMI $fffa
	mva #$c0 nmien			; only NMI interrupts, DLI disable

	;cli					; IRQ enabled

	rts						; return to ... DOS

; ---	DLI PROGRAM

.local	DLI

	?old_dli = *

	ift !CHANGES

dli1	   
    lda trig0			    ; FIRE #0
	beq stop

	lda trig1				; FIRE #1
	beq stop

	lda consol				; START
	and #1
	beq stop

	lda skctl
	and #$04
	beq stop

	lda vcount
	cmp #$02
	bne dli1

	:3 sta wsync

	DLINEW dli8

	eif

dli_start

dli8
	sta regA
	stx regX

c8	lda #$42
	sta wsync		;line=56
	sta color3
	sta wsync		;line=57
	sta wsync		;line=58
	sta wsync		;line=59
c9	lda #$44
	sta wsync		;line=60
	sta color3
c10	lda #$42
	sta wsync		;line=61
	sta color3
c11	lda #$44
	sta wsync		;line=62
	sta color3
c12	lda #$42
	sta wsync		;line=63
	sta color3
c13	lda #$44
	sta wsync		;line=64
	sta color3
	sta wsync		;line=65
	sta wsync		;line=66
	sta wsync		;line=67
c14	lda #$46
	sta wsync		;line=68
	sta color3
c15	lda #$44
	sta wsync		;line=69
	sta color3
c16	lda #$46
	sta wsync		;line=70
	sta color3
c17	lda #$44
	sta wsync		;line=71
	sta color3
	lda >fnt+$400*$01
c18	ldx #$46
	sta wsync		;line=72
	sta chbase
	stx color3
	sta wsync		;line=73
	sta wsync		;line=74
	sta wsync		;line=75
	sta wsync		;line=76
	sta wsync		;line=77
	sta wsync		;line=78
c19	lda #$26
	sta wsync		;line=79
	sta colpm3
c20	lda #$48
	sta wsync		;line=80
	sta color3
c21	lda #$46
	sta wsync		;line=81
	sta color3
c22	lda #$48
	sta wsync		;line=82
	sta color3
c23	lda #$46
	sta wsync		;line=83
	sta color3
c24	lda #$48
	sta wsync		;line=84
	sta color3
	sta wsync		;line=85
c25	lda #$4A
	sta wsync		;line=86
	sta color3
c26	lda #$48
	sta wsync		;line=87
	sta color3
c27	lda #$44
	sta wsync		;line=88
	sta color3
	DLINEW DLI.dli2 1 1 0

dli2
	sta regA
	stx regX
	lda >fnt+$400*$02
	sta wsync		;line=96
	sta chbase
	sta wsync		;line=97
	sta wsync		;line=98
	sta wsync		;line=99
	sta wsync		;line=100
	sta wsync		;line=101
c28	lda #$46
	sta wsync		;line=102
	sta color3
c29	lda #$44
	sta wsync		;line=103
	sta color3
c30	lda #$46
	sta wsync		;line=104
	sta color3
c31	lda #$44
	sta wsync		;line=105
	sta color3
c32	lda #$46
	sta wsync		;line=106
	sta color3
x6	lda #$99
c33	ldx #$1A
	sta wsync		;line=107
	sta hposp3
	stx colpm3
	sta wsync		;line=108
	sta wsync		;line=109
x7	lda #$A1
	sta wsync		;line=110
	sta hposp2
	sta wsync		;line=111
c34	lda #$48
	sta wsync		;line=112
	sta color3
c35	lda #$46
	sta wsync		;line=113
	sta color3
c36	lda #$48
	sta wsync		;line=114
	sta color3
c37	lda #$46
	sta wsync		;line=115
	sta color3
c38	lda #$48
	sta wsync		;line=116
	sta color3
x8	lda #$C9
	sta wsync		;line=117
	sta hposm3
	DLINEW dli3 1 1 0

dli3
	sta regA
	stx regX
	lda >fnt+$400*$03
c39	ldx #$4A
	sta wsync		;line=120
	sta chbase
	stx color3
	sta wsync		;line=121
	sta wsync		;line=122
x9	lda #$B9
	sta wsync		;line=123
	sta hposp2
	sta wsync		;line=124
x10	lda #$80
	sta wsync		;line=125
	sta hposp3
	DLINEW dli9 1 1 0

dli9
	sta regA

c40	lda #$C8
	sta wsync		;line=128
	sta color3
	sta wsync		;line=129
	sta wsync		;line=130
	sta wsync		;line=131
	sta wsync		;line=132
c41	lda #$C2
	sta wsync		;line=133
	sta color3
	sta wsync		;line=134
c42	lda #$C4
	sta wsync		;line=135
	sta color3
	sta wsync		;line=136
c43	lda #$C6
	sta wsync		;line=137
	sta color3
x11	lda #$98
	sta wsync		;line=138
	sta hposp3
	sta wsync		;line=139
c44	lda #$C8
	sta wsync		;line=140
	sta color3
	DLINEW dli4 1 0 0

dli4
	sta regA
	stx regX
	lda >fnt+$400*$04
c45	ldx #$CC
	sta wsync		;line=152
	sta chbase
	stx color3
	sta wsync		;line=153
	sta wsync		;line=154
	sta wsync		;line=155
	sta wsync		;line=156
c46	lda #$C6
	sta wsync		;line=157
	sta color3
x12	lda #$A5
	sta wsync		;line=158
	sta hposp3
c47	lda #$C8
	sta wsync		;line=159
	sta color3
	sta wsync		;line=160
c48	lda #$CA
	sta wsync		;line=161
	sta color3
	sta wsync		;line=162
	sta wsync		;line=163
c49	lda #$CC
	sta wsync		;line=164
	sta color3
	DLINEW dli5 1 1 0

dli5
	sta regA
	stx regX
	lda >fnt+$400*$05
	sta wsync		;line=176
	sta chbase
	sta wsync		;line=177
	sta wsync		;line=178
	sta wsync		;line=179
	sta wsync		;line=180
	sta wsync		;line=181
x13	lda #$9B
c50	ldx #$26
	sta wsync		;line=182
	sta hposp3
	stx colpm3
	sta wsync		;line=183
x14	lda #$A3
c51	ldx #$26
	sta wsync		;line=184
	sta hposp2
	stx colpm2

	lda regA
	ldx regX
	rti

.endl

; ---

CHANGES = 1
FADECHR	= 0

SCHR	= 127

; ---

.proc	NMI

	bit nmist
	bpl VBL

	jmp DLI.dli_start
dliv	equ *-2

VBL
	sta regA
	stx regX
	sty regY

	sta nmist		;reset NMI flag

	mwa #ant dlptr		;ANTIC address program

	mva #@dmactl(wide|dma|lineX1|players|missiles) dmactl	;set new screen width

	inc cloc		;little timer

; Initial values

	lda >fnt+$400*$00
	sta chbase
c0	lda #$00
	sta colbak
	lda #$02
	sta chrctl
	sta gtictl
s0	lda #$03
	sta sizep1
x0	lda #$DC
	sta hposp1
c1	lda #$00
	sta colpm1
c2	lda #$74
	sta color0
c3	lda #$7C
	sta color1
c4	lda #$0E
	sta color2
c5	lda #$44
	sta color3
x1	lda #$A9
	sta hposm2
c6	lda #$1A
	sta colpm2
s1	lda #$00
	sta sizep2
x2	lda #$CF
	sta hposp2
s2	lda #$00
	sta sizep3
x3	lda #$D0
	sta hposp3
c7	lda #$24
	sta colpm3
x4	lda #$CA
	sta hposm3
x5	lda #$00
	sta hposp0
	sta hposm0
	sta hposm1
	sta sizep0
	sta sizem
	sta colpm0

	mwa #DLI.dli_start dliv	;set the first address of DLI interrupt

;this area is for yours routines

quit
    lda is_music
    bmi quit2
    
    jsr rmt_play
    
quit2  
	lda regA
	ldx regX
	ldy regY
	rti

.endp

; ---
;	run main
; ---

	opt l-

.MACRO	SPRITES
missiles
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 40 40 40 80 80 80 80 80 80 90
	.he 90 20 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player0
	.ds $100
player1
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player2
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 80 80 03 06 0C 18 30 20 00 80
	.he C0 C2 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 F7 00 00 00 00 00 00 00 F0 E0
	.he C0 C0 00 20 60 60 60 60 60 60 60 60 60 40 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 F0 E0 00 00 E0 C0 00 00 E0 C0 00 00
	.he E0 C0 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player3
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 02 06 0E 1E 1E 3C 7C 3C
	.he 38 18 08 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 FF FF 7F EF F0 FF FF FF 7F 00 70 7F 7F
	.he 7F 3F 0F 00 10 10 18 38 38 38 38 38 38 30 70 70
	.he 70 70 60 00 00 3C 7C 7C 00 00 00 00 00 30 60 40
	.he 00 00 00 00 00 00 7F 00 00 08 18 18 18 18 18 0C
	.he 0C 0C 0C 04 04 00 00 00 00 00 00 00 00 00 F3 E7
	.he EF E7 00 00 1F 3F 00 00 7F 3F 00 00 7F 3F 00 00
	.he 7F 3F 00 FF 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
.ENDM

USESPRITES = 1

.MACRO	DLINEW
	mva <:1 NMI.dliv
	ift [>?old_dli]<>[>:1]
	mva >:1 NMI.dliv+1
	eif

	ift :2
	lda regA
	eif

	ift :3
	ldx regX
	eif

	ift :4
	ldy regY
	eif

	rti

	.def ?old_dli = *
.ENDM

