 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; set graphics mode $0e
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
graphics .macro
 ;   .if :1=0
;		mva #<DList_mode_02 dlptr
;		sta dlptrs
;		mva #>DList_mode_02 dlptr+1
;		sta dlptrs+1
 ;   .endif
    .if :1=1
		mva #<DList_mode_06 dlptr
		sta dlptrs
		mva #>DList_mode_06 dlptr+1
		sta dlptrs+1
    .endif
    .if :1=12
		mva #<DList_mode_04 dlptr
		sta dlptrs
		mva #>DList_mode_04 dlptr+1
		sta dlptrs+1    
    .endif
  ;  .if :1=15
;		mva #<DList_mode_0e dlptr
;		sta dlptrs
;		mva #>DList_mode_0e dlptr+1
	;	sta dlptrs+1    
  ;  .endif
 .endm

; Display List cannot across 1KB boundary
; Screen Memory cannot across 4KB boundary

 ;.align $0400 
;DList_mode_02
;	dta d'ppp',$42,a(screen_chars1)
;	:+23 dta $02
;	dta $41,a(DList_mode_02)
  
DList_mode_06
	dta d'ppp',$46,a(screen_chars1)
	:+23 dta $06
	dta $41,a(DList_mode_06)

DList_mode_04    
 	   dta d'ppp',$c4,a(screen_chars1),$84,$84
 	   dta $84,$84,$84
 	   dta $84,$84,$84
 	   dta $84,$84,$84 
 	   
 	   dta $84,$84,$84
 	   dta $84,$84,$84
 	   dta $84,$84,$84
 	   dta $84,$84,$84
 	   dta $82,$02
 	dta $41,a(DList_mode_04)

;DList_mode_0e    
 ;	dta d'ppp',$4e,a(buff1_charset0+$0100)
 ;   :+95 dta $0e
 ;	dta $4e,a(buff1_charset0+$0100+96*40)
 ;	:+95 dta $0e
 ;	dta $41,a(DList_mode_0e)
  
; 1KB for screen, graphics 12
screen_chars1
 	.rept 8
 		:120 dta #
 	.endr
 	    :80  dta $00

tab_screen_chars_lo  :26 dta <[#*40+screen_chars1]
tab_screen_chars_hi  :26 dta >[#*40+screen_chars1]
 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; procedura system_off - wylaczamy OS, podlaczamy RAM pod ROMem i 
; zajmujemy sie na wlasna reke obsluga NMI 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
system_off .macro
		jsr system_off1
.endm

system_off1 .proc
 		jsr wait_one_frame
 		mva #$00      $d40e   										; wylaczamy NMI 
 		sei         												; oraz IRQ
 		mva #$fe      $d301 										; oraz podlaczamy RAM pod ROMem, wylaczajac OS
 		mwa #_NMI     $fffa											; poniewaz nie mamy juz systemu nalezy zadbac o wlasna obsluge przerwan NMI
 		mva #$c0      $d40e   										; wlaczamy NMI
 		rts
.endp

_NMI 	bit $d40f 													; sprawdzamy czy przerwanie to VBL czy DLI 
 		bpl _no
 		jmp (_DLI) 
_no 	sta $d40f
 		jmp (_VBL)
 
_DLI 	dta a(my_dli) 												; my_vbl i my_dli to juz nasze procedury obslugi przerwan. 
_VBL 	dta a(my_vbl)

my_dli 	 rti
my_vbl 	 rti


;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; jsr to procedure in BANK Memory
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
bank_jsr .macro addr
 			lda @TAB_MEM_BANKS+=:addr \ and #$fe \ sta PORTB 
    		jsr :addr
    		lda @TAB_MEM_BANKS \ and #$fe \ sta PORTB
.endm

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; initialize PMG 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
PMG_init .proc
			jsr PMG_clr
			
			lda #>PMG0
			sta PMBASE
			sta vbl_PMBASE
			
			lda #%10101010
			sta SIZEP0
			sta SIZEP1
			sta SIZEP2
			sta SIZEP3
			sta SIZEM
			
			mva #color_player_COLPM0   COLPM0
		 	mva #color_player_COLPM1   COLPM1     
			mva #color_player_COLPM2   COLPM2
			mva #color_player_COLPM3   COLPM3					

			lda #3
			sta pmcntl
			lda #%00100001
			sta gtiactls
		;	sta gtiactl
			lda #%11111100
			sta dmactls
		;	sta dmactl
			rts
.endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; clear PMG0/1 area
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
PMG_clr .proc
			mva #>[PMG0+$0300] loop1+2
			mva #>[PMG1+$0300] loop1+5
			
			lda #0
			tax
			ldy #5		
					
loop1		sta PMG0+$0300,x
			sta PMG1+$0300,x
			dex
			bne loop1
			
			inc loop1+2
			inc loop1+5 
			
			dex
			dey
			bne loop1 
		
			rts
.endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; clear 5-th color on screen, remove bit7=0
; without last 3th rows (bottom panel is always the same)
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
clear_5th_color .proc  
				mwa #screen_chars1+40 $00
				
				ldx #7

loop0			ldy #120-1
				
loop1           lda ($00),y
                and #$7f											 ; bit7 = 0
                sta ($00),y              
                dey
                bpl loop1 
               
                adw $00 #120
			    dex	
                bne loop0  
                
                rts
.endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; add 5-th color on screen, set bit7=1
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
plot_5th_color .proc  
			jsr clear_5th_color
                
			ldx #9+128
			ldy #24+128
			
			.rept 7													; add 5th color(bit7=1) for player score (PLAYER ONE & TWO)
				stx screen_chars1+40*0+9+#
				sty screen_chars1+40*0+24+#
				inx
				iny
			.endr
		   	
			ldx #5+128
			ldy #40+5+128
			
			.rept 6													; add 5th color(bit7=1) for bottom panel PLAYER ONE
				stx screen_chars1+40*21+5+#
				sty screen_chars1+40*22+5+#
				inx
				iny
			.endr
			.rept 2
				sty screen_chars1+40*22+5+#+6
				iny
			.endr
			
			ldx #27+128
			ldy #40+27+128
			
			.rept 6													; add 5th color(bit7=1) for bottom panel PLAYER TWO
				stx screen_chars1+40*21+27+#
				sty screen_chars1+40*22+27+#
				inx
				iny
			.endr
			.rept 2
				sty screen_chars1+40*22+27+#+6
				iny
			.endr
			
			rts
.endp
			
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; move a player on the maximum left
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
max_left_player_one .proc
				lda #0
				sta old_player0_x
				sta old_player0_x+1
				sta HPOSP0
				sta vbl_HPOSP0
				sta vbl_HPOSP0+1
 				sta HPOSP1
				sta HPOSM0
				sta vbl_HPOSM0
				sta vbl_HPOSM0+1
				sta HPOSM1
				rts
.endp

max_left_player_two .proc
				lda #0
				sta old_player1_x
				sta old_player1_x+1
				sta HPOSP2
				sta vbl_HPOSP2
				sta vbl_HPOSP2+1
 				sta HPOSP3
				sta HPOSM2
				sta vbl_HPOSM2
				sta vbl_HPOSM2+1
				sta HPOSM3
 				rts			
 .endp
				
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; clear PMG0 player and PMG1 player
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
clear_PMG .proc
			   	pha
				stx reg_X
				sty reg_Y
				
				jsr clear_PMG_player0
				jsr clear_PMG_player1
				
				ldx reg_X
				ldy reg_Y
				pla
				rts
.endp

clear_PMG_player0 .proc
				pha
				stx reg_X
				sty reg_Y	
				
				ldx #0
				ldy #128

loop1			lda PMG0+$0320,y
				and #$f0
				sta PMG0+$0320,y
				lda PMG1+$0320,y
				and #$f0
				sta PMG1+$0320,y
				txa	
				sta PMG0+$0420,y
				sta PMG1+$0420,y
				sta PMG0+$0520,y
				sta PMG1+$0520,y
				dey
				bne loop1
				
				ldx reg_X
				ldy reg_Y
				pla
				rts	
.endp
				
clear_PMG_player1 .proc
				pha
				stx reg_X
				sty reg_Y	
				
				ldx #0
				ldy #128

loop1			lda PMG0+$0320,y
				and #$0f
				sta PMG0+$0320,y
				lda PMG1+$0320,y
				and #$0f
				sta PMG1+$0320,y
				txa
		        sta PMG0+$0620,y
		        sta PMG1+$0620,y
				sta PMG0+$0720,y
				sta PMG1+$0720,y
				dey
				bne loop1
								
				ldx reg_X
				ldy reg_Y
				pla
				rts										       
.endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; fill memory 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
fill_mem .macro address bytes value
	mwa :address address1
	mwa :bytes   counter1
	lda :value 
	jsr fill_mem0
 .endm
 
fill_mem0   
   ldy #0

   ldx counter1+1
   beq fill_mem2
       
fill_mem1       
   sta (address1),y   
   dey
   bne fill_mem1  
   
   inc address1+1
   dex
   bne fill_mem1
   
fill_mem2
   ldx counter1
   bne *+3
   rts
   
   ldy counter1
   dey
       
fill_mem3
   sta (address1),y
   dey   
   dex
   bne fill_mem3  
   
   rts

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; copy memory 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
copy_mem .macro address1 address2 bytes
	mwa :address1 address1
	mwa :address2 address2
	mwa :bytes    counter1
	jsr copy_mem0
.endm
 
copy_mem0   
   ldy #0

   ldx counter1+1
   beq copy_mem2
       
copy_mem1 
   lda (address1),y      
   sta (address2),y   
   dey
   bne copy_mem1  
   
   inc address1+1
   inc address2+1
   dex
   bne copy_mem1
   
copy_mem2
   ldx counter1
   beq copy_mem_rts
   
   ldy counter1
   dey
       
copy_mem3
   lda (address1),y
   sta (address2),y
   dey   
   dex
   bne copy_mem3  
   
copy_mem_rts
   rts

tab_address_buff1_lo dta <(buff1_charset0+0*40*8),<(buff1_charset0+1*40*8),<(buff1_charset0+2*40*8)
					 dta <(buff1_charset1+0*40*8),<(buff1_charset1+1*40*8),<(buff1_charset1+2*40*8)
					 dta <(buff1_charset2+0*40*8),<(buff1_charset2+1*40*8),<(buff1_charset2+2*40*8)
					 dta <(buff1_charset3+0*40*8),<(buff1_charset3+1*40*8),<(buff1_charset3+2*40*8)
					 dta <(buff1_charset4+0*40*8),<(buff1_charset4+1*40*8),<(buff1_charset4+2*40*8)
					 dta <(buff1_charset5+0*40*8),<(buff1_charset5+1*40*8),<(buff1_charset5+2*40*8)
					 dta <(buff1_charset6+0*40*8),<(buff1_charset6+1*40*8),<(buff1_charset6+2*40*8)
					 dta <(buff1_charset7+0*40*8),<(buff1_charset7+1*40*8),<(buff1_charset7+2*40*8)

tab_address_buff1_hi dta >(buff1_charset0+0*40*8),>(buff1_charset0+1*40*8),>(buff1_charset0+2*40*8)
					 dta >(buff1_charset1+0*40*8),>(buff1_charset1+1*40*8),>(buff1_charset1+2*40*8)
					 dta >(buff1_charset2+0*40*8),>(buff1_charset2+1*40*8),>(buff1_charset2+2*40*8)
					 dta >(buff1_charset3+0*40*8),>(buff1_charset3+1*40*8),>(buff1_charset3+2*40*8)
					 dta >(buff1_charset4+0*40*8),>(buff1_charset4+1*40*8),>(buff1_charset4+2*40*8)
					 dta >(buff1_charset5+0*40*8),>(buff1_charset5+1*40*8),>(buff1_charset5+2*40*8)
					 dta >(buff1_charset6+0*40*8),>(buff1_charset6+1*40*8),>(buff1_charset6+2*40*8)
					 dta >(buff1_charset7+0*40*8),>(buff1_charset7+1*40*8),>(buff1_charset7+2*40*8)

tab_address_buff2_lo dta <(buff2_charset0+0*40*8),<(buff2_charset0+1*40*8),<(buff2_charset0+2*40*8)
					 dta <(buff2_charset1+0*40*8),<(buff2_charset1+1*40*8),<(buff2_charset1+2*40*8)
					 dta <(buff2_charset2+0*40*8),<(buff2_charset2+1*40*8),<(buff2_charset2+2*40*8)
					 dta <(buff2_charset3+0*40*8),<(buff2_charset3+1*40*8),<(buff2_charset3+2*40*8)
					 dta <(buff2_charset4+0*40*8),<(buff2_charset4+1*40*8),<(buff2_charset4+2*40*8)
					 dta <(buff2_charset5+0*40*8),<(buff2_charset5+1*40*8),<(buff2_charset5+2*40*8)
					 dta <(buff2_charset6+0*40*8),<(buff2_charset6+1*40*8),<(buff2_charset6+2*40*8)
					 dta <(buff2_charset7+0*40*8),<(buff2_charset7+1*40*8),<(buff2_charset7+2*40*8)

tab_address_buff2_hi dta >(buff2_charset0+0*40*8),>(buff2_charset0+1*40*8),>(buff2_charset0+2*40*8)
					 dta >(buff2_charset1+0*40*8),>(buff2_charset1+1*40*8),>(buff2_charset1+2*40*8)
					 dta >(buff2_charset2+0*40*8),>(buff2_charset2+1*40*8),>(buff2_charset2+2*40*8)
					 dta >(buff2_charset3+0*40*8),>(buff2_charset3+1*40*8),>(buff2_charset3+2*40*8)
					 dta >(buff2_charset4+0*40*8),>(buff2_charset4+1*40*8),>(buff2_charset4+2*40*8)
					 dta >(buff2_charset5+0*40*8),>(buff2_charset5+1*40*8),>(buff2_charset5+2*40*8)
					 dta >(buff2_charset6+0*40*8),>(buff2_charset6+1*40*8),>(buff2_charset6+2*40*8)
					 dta >(buff2_charset7+0*40*8),>(buff2_charset7+1*40*8),>(buff2_charset7+2*40*8)
					 					 
; copy 8x8 chars into screen
; bitmap must be multiply 40 bytes 
tab_conv_bits_lo    dta %00000000,%00000001,%00000100,%00000101,%00010000,%00010001,%00010100,%00010101,%01000000,%01000001,%01000100,%01000101,%01010000,%01010001,%01010100,%01010101
tab_conv_bits_hi    dta %00000000,%00000010,%00001000,%00001010,%00100000,%00100010,%00101000,%00101010,%10000000,%10000010,%10001000,%10001010,%10100000,%10100010,%10101000,%10101010   

draw_char_buff1 .macro col row address1 bytes
	mva :col      				 draw_char_bitmap1.pos_x
	mva :row     				 draw_char_bitmap1.pos_y
	mwa :address1				 address1
	mwa #tab_address_buff1_lo	 draw_char_bitmap1.set_buff_lo+1
	mwa #tab_address_buff1_hi    draw_char_bitmap1.set_buff_hi+1
	mwa :bytes   				 counter1
	jsr draw_char_bitmap1
 .endm

draw_char_buff2 .macro col row address1 bytes
	mva :col      				 draw_char_bitmap1.pos_x
	mvx :row     				 draw_char_bitmap1.pos_y
	mwa :address1				 address1
	mwa #tab_address_buff2_lo    draw_char_bitmap1.set_buff_lo+1
	mwa #tab_address_buff2_hi    draw_char_bitmap1.set_buff_hi+1
	mwa :bytes   				 counter1
	jsr draw_char_bitmap1
 .endm
   
draw_char_bitmap1 .proc    
   		divide_word_by_word counter1 #40*8
   		stx all_row1
   
copy_mem_chars1
   			ldx pos_y

set_buff_lo mva tab_address_buff1_lo,x  address2
set_buff_hi mva tab_address_buff1_hi,x  address2+1   

   			ldx #40
   		
copy_mem_chars2
   ldy #0
   lda (address1),y      
   sta (address2),y
   iny   
   lda (address1),y
   sta (address2),y
   iny   
   lda (address1),y
   sta (address2),y
   iny   
   lda (address1),y
   sta (address2),y
   iny   
   lda (address1),y
   sta (address2),y
   iny   
   lda (address1),y
   sta (address2),y
   iny   
   lda (address1),y
   sta (address2),y
   iny   
   lda (address1),y
   sta (address2),y

   adw address1 #8
   adw address2 #8
   
   dex 
   bne copy_mem_chars2
      
   inc pos_y
   
   dec all_row1
   bne copy_mem_chars1 
 
copy_mem_skip1
   			rts
   
pos_x    .ds 1
pos_y    .ds 1
all_row1 .ds 1
 
 .endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 16-bit divide by 16-bit
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
divide_word_by_word .macro
	mwa :1 divide_word_by_word1.dividend
	mwa :2 divide_word_by_word1.divisor
	jsr divide_word_by_word1
.endm

divide_word_by_word1 .proc
	lda #0	        											; preset remainder to 0
	sta remainder
	sta remainder+1
	ldx #16	        											; repeat for each bit: ...

divloop	
    asl dividend												; dividend lb & hb*2, msb -> Carry
	rol dividend+1	
	rol remainder												; remainder lb & hb * 2 + msb from carry
	rol remainder+1
	lda remainder
	sec
	sbc divisor													; substract divisor to see if it fits in
	tay	        												; lb result -> Y, for we may need it later
	lda remainder+1
	sbc divisor+1
	bcc skip													; if carry=0 then divisor didn't fit in yet

	sta remainder+1												; else save substraction result as new remainder,
	sty remainder	
	inc result													; and INCrement result cause divisor fit in 1 times

skip	
    dex
	bne divloop
	
	ldx result
	ldy result+1
		
	rts
	
divisor    dta a($0000) 
dividend   dta a($0000) 
.endp

remainder  dta a($0000) 
result     = divide_word_by_word1.dividend						; save memory by reusing divident to store the result

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 8-bit byte divide by 10 (unsigned)
;  input: reg.A
; output: reg.A, temp 
; 17 bytes, 30 cycles
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
divide_byte_by_10 .proc
  		lsr @
  		sta temp
  		lsr @
  		adc temp
  		ror @
  		lsr @
  		lsr @
  		adc temp
  		ror @
  		adc temp
  		ror @
  		lsr @
  		lsr @
  		rts

temp .ds 1 	

.endp
  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; wait 1 frame
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
wait_one_frame .proc
	lda vcount
	cmp #120
	bmi *-5

@loop1	
	lda vcount
	beq @skip1
	cmp #1
	beq @skip1
	cmp #2
	bne @loop1 
	
@skip1
	lda vcount
	cmp #120
	bmi @skip1
	
	rts
.endp
	
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; turn OFF screen 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
screen_off .macro
	jsr wait_one_frame
    lda #0
	sta	dmactls
	sta dmactl
	sta gtiactls
	sta gtiactl
 .endm

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; turn ON screen 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
screen_on .macro
	jsr wait_one_frame
	lda #%11111110
	sta	dmactls
	sta dmactl
	lda #%00100001
	sta gtiactls
	sta gtiactl	
 .endm
 	
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; wait until 8 sec or key pressed
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
wait_time_or_key .macro
	mwa :1 wait_time_or_key1.counter
	jsr wait_time_or_key1
.endm

wait_time_or_key1 .proc 
 
wait_time_or_key2
    lda SKSTAT \ and #4 \ beq wait_time_or_key3 
    jsr wait_one_frame   
    dec counter
    bne wait_time_or_key2
    
    dec counter+1
    bpl wait_time_or_key2

wait_time_or_key3
    mva #$ff KBCODES
    rts
  
counter dta a($0000)    
.endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; read until key is pressed
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
wait_key .macro
		jsr wait_key1		
.endm

wait_key1 .proc
        sta reg_A
        stx reg_X
 
 		ldx #10
 		
loop0   jsr wait_one_frame
 		dex
 		bne loop0
 		
loop1   lda skctl
		and #4
        bne loop1

        lda reg_A
        ldx reg_X
        
        rts
.endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; wait until key space pressed 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
wait_key_space .proc
loop	
    lda	$d20f
	and	#$04
	bne	loop
     
loopkey1
    lda KBCODES
    cmp #33                       ;key = SPACE      
    bne loopkey1
    
    lda #$ff
    sta KBCODES    
    rts
 .endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; convert bitmap from BBC MICRO into ATARI format
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
conv_char_bitmap .macro src length 
			mwa :src     src1
			mwa :length  counter1
			jsr proc_conv_char_bitmap
.endm
 
proc_conv_char_bitmap .proc			
			ldy #0
			dew counter1
			
loop1		dew counter1
skip1		lda (src1),y
			jsr conv_byte_BBC_ATARI	
			sta (src1),y
			
			inw src1 
			
			lda counter1
			ora counter1+1
			bne loop1
			
			rts
			
.endp

bi_result .ds 1
hi_nibble .ds 1
lo_nibble .ds 1

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; convert byte from BBC MICRO to ATARI format
; reg.A = byte
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
conv_byte_BBC_ATARI .proc
			sta hi_nibble
			asl @
			asl @
			asl @
			asl @
			sta lo_nibble
			
			.rept 4			
			asl hi_nibble
			rol bi_result
			asl lo_nibble
			rol bi_result
			.endr
			
			lda bi_result			
			rts			
.endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; change color 11 --> 01
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
convert_11_to_01 .macro src dst
			mwa :1 src1
			mwa :2 dst1
			mva #%01 tab_exchange_10_to_01+1
			sta      tab_exchange_10_to_01+3
			mva #%10 tab_exchange_10_to_01+2
			jsr proc_exchange
.endm

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; change color 10 --> 01
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
convert_10_to_01 .macro src dst
			mwa :1 src1
			mwa :2 dst1
			mva #%01 tab_exchange_10_to_01+1
			sta      tab_exchange_10_to_01+2
			mva #%11 tab_exchange_10_to_01+3
			jsr proc_exchange
.endm

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; exchange color 10 --> 01 and 01 --> 10
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
exchange_10_to_01 .macro src dst
			mwa :1 src1
			mwa :2 dst1
			mva #%10 tab_exchange_10_to_01+1
			mva #%01 tab_exchange_10_to_01+2
			mva #%11 tab_exchange_10_to_01+3
			jsr proc_exchange
.endm

proc_exchange .proc
			sbw dst1 src1 counter1
			
			ldy #0
     		sty bi_result
     	    dew counter1

loop1		dew counter1
skip1		lda (src1),y
			sta reg_a
			
			and #%11
			tax
			lda tab_exchange_10_to_01,x
			sta bi_result
			
			lda reg_a
			lsr @
			lsr @
			and #%11
			tax			
			lda tab_exchange_10_to_01,x
			asl @
			asl @
			ora bi_result
			sta bi_result
					
			lda reg_a
			lsr @
			lsr @
			lsr @
			lsr @
			and #%11
			tax			
			lda tab_exchange_10_to_01,x
			asl @
			asl @
			asl @
			asl @
			ora bi_result
			sta bi_result

			lda reg_a
			lsr @
			lsr @
			lsr @
			lsr @
			lsr @
			lsr @
			and #%11
			tax			
			lda tab_exchange_10_to_01,x
			asl @
			asl @
			asl @
			asl @
			asl @
			asl @
			ora bi_result
			sta bi_result

			sta (src1),y

			inw src1 
			
			lda counter1
			ora counter1+1
			bne loop1
						
			rts
.endp

tab_exchange_10_to_01 dta %00,%01,%10,%11

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
;  INPUT STRING
;  wprowadza znaki 'A'..'Z' z klawiatury pod adres 'string' bez uzycia OS-u
;  adres 'string' zwraca w zmiennej ZP0
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
zp0		= $00    						    
chars	= 8									; maksymalna liczba znakow do wprowadzenia
 
input_string .proc
		lda #0
		sta _2+1

		ldx #7
		lda #" "
		
_loop1	sta string,x					    ; czyszczenie string = " "
		dex
		bpl _loop1

		lda #48
		sub $76 							; high_score_offset
		lsr @
		lsr @
;		lsr @
		add #6
		tax
		mva tab_address_buff1_lo,x zp0
		mva tab_address_buff1_hi,x zp0+1
		adw zp0 #7*8 
        jmp _in

_1		jsr get_key
		
		cmp #$9b	
		beq _end
		
		cmp #$7e
		beq _del

char_ok	ldy _2+1
		cpy #chars							; maksymalna dopuszczalna liczba znakow
		beq _1

_2		ldy #0
		sta string,y
		jsr plot_character_internal
		inc _2+1
						
_in		lda #"_"
		jsr plot_character_internal
		sbw zp0 #16
		jmp _1

_del	ldy _2+1
		beq _1
							
		lda #" "
		sta string,y
		sta string-1,y
		sbw zp0 #16
	    lda #"_"	
		jsr plot_character_internal		
	;	dec _2+1
			
		lda #" "

		ldy _2+1
		cpy #chars
		beq _5
		
		lda #"."
		
_5		dec _2+1
		jsr plot_character_internal
		sbw zp0 #32	
	
		jmp _1
			
_end	rts

.endp

get_key .proc
		ldx #6-4

get_key0		
		jsr wait_one_frame
		dex
		bne get_key0 

		lda $d20f
		and #4
		bne get_key

		ldy $d209
		lda tab,y
		cmp #$ff
		beq get_key

		cmp #0
old_key equ *-1
		bne skp

		ldx #6
delay	equ *-1
		dex
		stx delay
		bne get_key

		mvx #6 delay 

skp		sta old_key

		mvx #6 delay
		rts
.endp

tab	.array [256] = $ff

	[63] = "a"
	[21] = "b"
	[18] = "c"
	[58] = "d"
	[42] = "e"
	[56] = "f"
	[61] = "g"
	[57] = "h"
	[13] = "i"
	[1]  = "j"
	[5]  = "k"
	[0]  = "l"
	[37] = "m"
	[35] = "n"
	[8]  = "o"
	[10] = "p"
	[47] = "q"
	[40] = "r"
	[62] = "s"
	[45] = "t"
	[11] = "u"
	[16] = "v"
	[46] = "w"
	[22] = "x"
	[43] = "y"
	[23] = "z"
	
	[127] = "A"
	[85]  = "B"
	[82]  = "C"
	[122] = "D"
	[106] = "E"
	[120] = "F"
	[125] = "G"
	[121] = "H"
	[77]  = "I"
	[65]  = "J"
	[69]  = "K"
	[64]  = "L"
	[101] = "M"
	[99]  = "N"
	[72]  = "O"
	[74]  = "P"
	[111] = "Q"
	[104] = "R"
	[126] = "S"
	[109] = "T"
	[75]  = "U"
	[80]  = "V"
	[110] = "W"
	[86]  = "X"
	[107] = "Y"
	[87]  = "Z"
	
	[33]:[97]  = " "
	[52]:[180] = $7e  ; DELETE
	[12]:[76]  = $9b  ; END OF LINE
	[60]:[188] = $3c  ; CAPS

	.enda

string	.ds chars+1

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; my interrupt handler of DLI	                        
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
title_tab_dli_COLPF0   dta $42,$42,$0f,$0f,$4a,$42,$0f,$0f,$4a,$36,$36,$36,$36,$36,$36,$36,$46,$46,$46,$46,$56,$46,$aa,$aa		; colors in rows for COLPF0 during the title screen, the high score screen etc.
title_tab_dli_COLPF1   dta $44,$44,$44,$48,$48,$44,$44,$48,$48,$36,$36,$36,$36,$36,$36,$36,$46,$46,$46,$46,$46,$66,$0a,$0a
title_tab_dli_COLPF2   dta $0f,$0f,$46,$46,$46,$0f,$46,$46,$46,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f		; colors in rows for COLPF2 during 
title_tab_dli_COLPF3   dta $0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f,$8e,$8e,$8e,$8e,$8e,$8e,$8e,$8e,$8e,$8e,$8e,$8e,$8e,$8e,$8e
									                                                                          
score_tab_dli_COLPF0   dta $1e,$1e,$1e,$1e,$0f,$26,$26,$36,$36,$46,$46,$56,$56,$86,$86,$a6,$a6,$b6,$b6,$36,$1a,$36,$aa,$aa		; colors in rows for COLPF0 during 
score_tab_dli_COLPF1   dta $aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$0a,$0a
score_tab_dli_COLPF2   dta $68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68		; colors in rows for COLPF2 during 
score_tab_dli_COLPF3   dta $a6,$a6,$a6,$a6,$a6,$36,$36,$36,$36,$36,$36,$36,$86,$86,$86,$86,$a6,$a6,$a6,$a6,$a6,$a6,$a6,$a6

game_tab_dli_COLPF0    dta $fc,$38,$38,$38,$38,$38,$38,$38,$38,$38,$38,$38,$38,$38,$38,$c8,$c8,$c8,$c8,$c8,$c8,$46,$46,$46      ; colors in rows for COLPF0 during the main game
game_tab_dli_COLPF1    dta $2a,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$66,$66,$66
game_tab_dli_COLPF2    dta $38,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$aa,$0f		; colors in rows for COLPF2 during 
game_tab_dli_COLPF3    dta $0f,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$36,$36,$36
 										                                                                  
tab_dli_COLPF0  	   dta $fc,$38,$38,$38,$38,$38,$38,$38,$38,$38,$38,$38,$38,$38,$38,$c8,$c8,$c8,$c8,$c8,$c8,$46,$46,$46		; coloros in rows (changing in DLI)
tab_dli_COLPF1  	   dta $2a,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$46,$66,$66,$66
tab_dli_COLPF2  	   dta $38,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f
tab_dli_COLPF3  	   dta $0f,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$36,$36,$36
len_tab_dli            = *-tab_dli_COLPF0 
 
bonus_tab_dli_COLPF3   dta $0f,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$34,$36,$36,$36
                                                                                                              
tab_dli_charset        dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00      ; set this table on every VBL
tab_dli_charset_offset dta   0,  0,  0,  4,  4,  4,  8,  8,  8, 12, 12, 12, 16, 16, 16, 20, 20, 20, 24, 24, 24, 28, 28, 28 		; offset charset in rows (changing in DLI)

len_tab_dli_charset_offset = *-tab_dli_charset_offset
 
myDLI1 .proc
		pha
		txa
		pha
	
		ldx dli_cnt
		lda tab_dli_charset+1,x
		
 		cpx #23
 		bmi skip0
 		    
 		lda #>atari_font1
 	;	sta WSYNC
 		sta CHBASE
 		lda #$00
 		sta COLPF2
 		lda #$0f
 		sta COLPF1	
 		 		
 		pla 
 		tax
 		pla
 		rti       
 		    
skip0	;sta WSYNC
		sta CHBASE
		
		mva tab_dli_COLPF1+1,x COLPF1 
		mva tab_dli_COLPF2+1,x COLPF2 
		mva tab_dli_COLPF3+1,x COLPF3
;huj 		
		lda tab_dli_COLPF0+1,x
    	cpx #5+9
    	bne skip1
    	
    	:5 sta wsync                     ; wait 6 lines to change color in proper line (markers!)
 		sta COLPF0

		inc dli_cnt

 		pla 
 		tax
 		pla
 		rti   
 
skip1   sta COLPF0
		inc dli_cnt

   	 	pla
    	tax
		pla
		rti
.endp
	
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
;my interrupt handler of VBL	
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
myVBL .proc		
				pha
				txa
				pha
				tya
				pha
				
				lda cloc								; counter
				beq *+4
				dec cloc
				
				lda message_timer1						; counter how long we could showing the message no.1
				beq *+5
				dec message_timer1
				cmp #1
				bne *+7
				mva #1 message_clr1
				
				lda message_timer2						; counter how long we could showing the message no.2
				beq *+5
				dec message_timer2
				cmp #1
				bne *+7
				mva #1 message_clr2
					
		  	    lda #0
				sta v_pending  							; set 0 to vsync_pending
				
				inc vbl_timer
				
				lda delay_change_weapon					; delay for change weapon - PLAYER ONE
				beq *+5
				dec delay_change_weapon

				lda delay_change_weapon+1				; delay for change weapon - PLAYER TWO
				beq *+5
				dec delay_change_weapon+1
				
		        mwa dlptrs  	dlptr					; copy shadow registers to hardware registers on VBL
			    mva dmactls 	dmactl
			    mva gtiactls 	gtiactl
 				lda vbl_pmbase 	
 				beq *+5
 				sta pmbase
 				
				lda KEYREP								; check key
				beq _myVBL1
				dec KEYREP
				bne _myVBL1 
				
				ldx #$ff								; if key is not pressed, reset all
				stx KBCODES
				;inx
				;stx KEYDEL
				jmp myVBL2    
				
_myVBL1    		lda SKSTAT      						; check key is pressed? 
				and #$04 								; test only bit 2
				beq myVBL1  							; 0 - key is pressed, 1 - key is not pressed
				
				ldx #$ff								; if key is not pressed, reset all
				stx KBCODES
				inx
				stx KEYDEL
				jmp myVBL2
				
myVBL1			lda KEYDEL								; if 0 then key is pressed and then is not pressed
				bne myVBL2
				
				lda KBCODE								; is new key pressed?
				sta KBCODES
				;sta OLDKBC
				lda #10*1
				sta KEYREP
				lda #1
				sta KEYDEL
				
myVBL2      	ldx #len_tab_dli_charset_offset-1
		
				clc
								
loop1    		lda buff_addr_hi
				adc tab_dli_charset_offset,x
				sta tab_dli_charset,x
				dex
				bpl loop1
				
;myVBL3			;sta WSYNC
				sta CHBASE
				
				mva tab_dli_COLPF0 COLPF0 
				mva tab_dli_COLPF1 COLPF1 
				mva tab_dli_COLPF2 COLPF2 
				mva tab_dli_COLPF3 COLPF3 
				
				mva #0      dli_cnt
		
; clear bit=7(5th color) on screen after RESUME GAME		
				lda is_resume_game_vbl
				beq *+5
				dec is_resume_game_vbl

				cmp #1
				bne _skp1 
	
				ldx #17-1										    ; clear bit7 on PAUSE, ESC, DELETE
								
_pause1			lda screen_chars1+[row_PAUSE+0]*40+row_DEL,x
				and #127
				sta screen_chars1+[row_PAUSE+0]*40+row_DEL,x				
				lda screen_chars1+[row_PAUSE+1]*40+row_DEL,x
				and #127
				sta screen_chars1+[row_PAUSE+1]*40+row_DEL,x		
				lda screen_chars1+[row_PAUSE+2]*40+row_DEL,x
				and #127
				sta screen_chars1+[row_PAUSE+2]*40+row_DEL,x

			    dex
			    bpl _pause1

; set bit=7(5th color) on screen for BONUS 1 or 2
_skp1	      	lda is_bit7_BONUS1								 ; is bit7=128 for BONUS1 set on screen?
				beq _skp2
				
				jsr set_bit7_BONUS1	
				mva #0 is_bit7_BONUS1
				
_skp2			lda is_bit7_BONUS2								 ; is bit7=128 for BONUS1 set on screen?
				beq _sfx_effect

				jsr set_bit7_BONUS2	
				mva #0 is_bit7_BONUS2

; play SFX				  		
_sfx_effect		lda #$ff
				bmi _skp4
				
				asl @											; * 2
				tay												; Y = 2,4,..,16  	instrument number * 2 (0,2,4,..,126)
_sfx_channel	ldx #3											; X = 3		 	    channel (0..3 or 0..7 for stereo module)
				lda #12											; A = 12			note (0..60)
				jsr rmt_sfx										; RMT_SFX 			start tone (It works only if FEAT_SFX is enabled !!!)			
				mva #$ff _sfx_effect+1							; reinit value
				mva #3   _sfx_channel+1							; reinit value

; play MUSIC
_skp4
_is_music		lda #$ff
				bmi _skp5
			
				lda pal	
				cmp #1											; is ATARI in PAL mode?
				beq _play1										; or NTSC?
				
				lda vbl_ntsc									; skip every 6th frame to slow down play music on NTSC
				cmp #5
				beq _skp5
				
_play1			jsr rmt_play        				 			; 1 play			
        
_skp5	    	inc vbl_ntsc
				
				lda vbl_ntsc
				cmp #6
				bne _skp6
				
				mva #0 vbl_ntsc

; blink PLAYER ONE or TWO at beginning game				
_skp6			lda vbl_timer
				and #7
				tax
				
				lda is_shield
				bmi _blink1
				
				lda $30											; players_or_enemies_timer
				bmi _blink1
				cmp #player_time_invulnerable					; Player is invulnerable at start of new life
				bmi _skp71
				
_blink1			mva tab_COLPM1,x COLPM1
				bne _skp7										; always branches!
					
_skp71          mva tab_COLPM1   COLPM1	
						
_skp7		    
				lda is_shield
				bmi _blink2
				
				lda $31											; players_or_enemies_timer + 1
				bmi _blink2
				cmp #player_time_invulnerable					; Player is invulnerable at start of new life
				bmi _skp81
	
_blink2			mva tab_COLPM3,x COLPM3
				bne _skp8										; always branches!
					
_skp81			mva tab_COLPM3   COLPM3				

_skp8	       

; move player0/1 on proper X position
_exit			lda $94
				and #1
				eor #1
				tax
				mva vbl_HPOSP0,x 	HPOSP0
		        sta 				HPOSP1
				mva vbl_HPOSM0,x 	HPOSM0
		        sta 				HPOSM1
		        
				mva vbl_HPOSP2,x 	HPOSP2
		        sta 				HPOSP3
				mva vbl_HPOSM2,x 	HPOSM2
		        sta 				HPOSM3
		        
				pla
				tay			
				pla
				tax
				pla
				rti

.endp

set_enemy_COLPF1 .proc
				:15 sta tab_dli_COLPF1+#+1
				rts
.endp

; initialize RMT player
rmt_init2	    ldx #<MODUL											 ; low byte of RMT module to X reg
				ldy #>MODUL											 ; hi byte of RMT module to Y reg
				sta rmt_actual_song
			    pha
			    mva #$ff is_music
			    pla
			    jsr rmt_init
			    mva #$01 is_music
			    rts

sfx_channel					= myVBL._sfx_channel+1				; choose channel to play sfx (0-3)
sfx_effect 					= myVBL._sfx_effect+1				; is play sfx on vbl?
is_music   					= myVBL._is_music+1					; is play music on vbl?

tab_move_stars_offset_lo
    dta <[8*18+6],<[8*32],  <[8*36+7],<[8*39+3]
    dta	  <[8*24],<[8*37],  <[8*38+7],<[8*28+7],<[12*8]
    dta	 <[8*20+7],<[8*30+6],  <[8*36],<[8*26+7]
    dta	  <[8*18],<[8*36],  <[8*24+7], <[8*8+3],<[8*13+7]
tab_move_stars_offset_hi
    dta >[8*18+6],>[8*32],  >[8*36+7],>[8*39+3]
    dta	  >[8*24],>[8*37],  >[8*38+7],>[8*28+7],>[12*8]
    dta	 >[8*20+7],>[8*30+6],  >[8*36],>[8*26+7]
    dta	  >[8*18],>[8*36],  >[8*24+7], >[8*8+3],>[8*13+7]


    	  
stars_ind					dta $00					; move stars, 1 byte

    .print ' '
	.print 'library   = $8000 - ', *-1    

    
