;===================================================================================
;                                 Cyborg Warriors 
;
;                      Conversion from BBC Micro to ATARI XE/XL
;                                  
;									  code - VEGA
;                                 graphics - KAZ
;								 music+sfx - MIKER	
;                               
;							      v1.28 for 128KB
; 
;===================================================================================
  
			icl "DATA\registers.h"
			  	
  			;opt s+
  			opt b+
  
 			org $c8 
 			 
; zero page variables
src1            					.ds 2
src2                        		.ds 2
dst1								.ds 2
dst2								.ds 2
exp1                        		.ds 2                ; adress on screen for explosion
bns1                        		.ds 2				 ; adress on screen for bonus
reg_A           					.ds 1 
reg_X           					.ds 1 			     ; save register X for later
reg_Y           					.ds 1 				 ; save register Y for later
dli_charset     					.ds 1
counter1        					.ds 2
counter2        					.ds 2
address1        					.ds 2
address2        					.ds 2
fcnt								.ds 2
fadr								.ds 2
fhlp								.ds 2
cloc								.ds 1
regA            					.ds 1 
regX            					.ds 1 					
regY            					.ds 1
dli_cnt             				.ds 1
v_pending							.ds 1
zero_page_RMT_variables = *
  
; global variables	
@TAB_MEM_BANKS	          			= $0400   			; table with the addresses of banks
@PROC_ADD_BANK	          			= $0600   			; procedure changes banks
max_sprite_right          			= $58+4 			; max position of player 0/1 on right screen
			
player_time_invulnerable  			= $5a-50			; less longer time of invulnerable when player starts new life
			
color_bonus1              			= $1e
color_bonus2              			= $1a
color_game_over           			= $0e
color_pause               			= $0e
color_explosion           			= $34
color_message						= $0f
color_resume						= $0a
			
color_player_COLPM0       			= $b0 
color_player_COLPM1       			= $18 				; $b0 ora $18 = $b8 
color_player_COLPM2       			= $80 
color_player_COLPM3       			= $18 				; $80 ora $18 = $98 
			
sfx_explosion						= $20
sfx_bonus							= $21
sfx_torpedo							= $22
sfx_laser							= $23
sfx_dead_player						= $24
sfx_start_rocket					= $25
sfx_bounce_balls					= $26
sfx_flying_rocket					= $27
sfx_new_weapon            			= $28
sfx_change_weapon         			= $29
			
song_title							= $00
song_game_over						= $0f
song_silence              			= $12
song_start_level          			= $14
song_get_name             			= $17
song_enter_name           			= $19

joystick_up     					= %00000001
joystick_down   					= %00000010
joystick_left   					= %00000100
joystick_right 		    			= %00001000

buff1_progress_bar 					= buff1_charset7+320*1+8*16     	; progress bar which showing position on level
buff2_progress_bar 					= buff2_charset7+320*1+8*16
buff1_level_bottom_panel    		= buff1_charset7 + $140*1 + 8*14 	; level on bottom panel 
buff2_level_bottom_panel    		= buff2_charset7 + $140*1 + 8*14
buff1_lives_player1_bottom_panel    = buff1_charset7 + $140*1 + 8*4		; lives on bottom panel
buff2_lives_player1_bottom_panel    = buff2_charset7 + $140*1 + 8*4
buff1_lives_player2_bottom_panel    = buff1_charset7 + $140*1 + 8*39
buff2_lives_player2_bottom_panel    = buff2_charset7 + $140*1 + 8*39
buff1_weapon_selector               = buff1_charset7 + 320*2 + 8*5 + 3  ; weapon selector for player ONE & TWO
buff2_weapon_selector               = buff2_charset7 + 320*2 + 8*5 + 3
buff1_high_score                    = buff1_charset2+320*0+8*7			; scores on HIGH SCORE screen

; buffors variables (SCREENS)
buff1_charset0   					= $9000			 					; $9000-$AFFF - 8KB for charsets (screen buffor 1)
buff1_charset1   					= $9400
buff1_charset2   					= $9800
buff1_charset3   					= $9c00
buff1_charset4   					= $A000
buff1_charset5   					= $A400
buff1_charset6   					= $A800
buff1_charset7   					= $Ac00
			
buff2_charset0   					= $B000			    				; $B000-$CFFF - 8KB for charsets (screen buffor 2)
buff2_charset1   					= $B400
buff2_charset2   					= $B800
buff2_charset3   					= $BC00
buff2_charset4   					= $C000
buff2_charset5   					= $C400
buff2_charset6   					= $C800
buff2_charset7   					= $CC00

;--------------------------------------------------------------------------------------------------------------------------------------------------------------------
; $2000-$BFFF Load tables/datas for a while to relocate in memory
; $0B00-$3FFF Initialize the game "CYBORG WARRIORS"
; $0B00-$3FFF Main code of game "CYBORG WARRIORS"
; $4000-$7FFF 16KB Bank of Memory (for example: datas of sprites, music+SFX, PMG etc.)
; $8000-$8FFF Load library with useful procedures
; $9000-$CFFF Buffor 1 (8KB) and Buffor 2 (8KB) of screen
; $D000-$D7FF Hardware registers
;--------------------------------------------------------------------------------------------------------------------------------------------------------------------

RMT_PLAYER                  		= $1000									; 2KB for RMT Player
	
reloc_atari_font1 					= $BC00
reloc_MODUL     					= $9c00

MODUL                       		= $D800									; $D800-$E7FF (max.4KB) for RMT Module
PMG0             					= $e800   								; 2KB PMG0 area (768bytes - free)
PMG1		                  		= $f000									; 2KB PMG1 area (768bytes - free)
horizon_shifted_1_sprite  			= $f000     							; 0,5KB horizon shifted 1 pixel (2 bits)
horizon_shifted_2_sprite  			= $f800	 								; 0,5KB horizon shifted 2 pixel (4 bits)
horizon_shifted_3_sprite  			= $fa00	 								; 0,5KB horizon shifted 3 pixel (6 bits)
atari_font1      					= $fc00									; 1KB Font 8x8 
   	 
;--------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Check Extended Memory, save banks into @TAB_MEM_BANKS
;--------------------------------------------------------------------------------------------------------------------------------------------------------------------
	 		org $1000
	 
detect 	  	mva #0 dmactls	
			lda:cmp:req $14													;wait 1 frame
			icl 'DATA\mem_detect\detect_ext_mem.asm'
            icl 'DATA\mem_detect\@bank_add.mac'
    		icl 'DATA\mem_detect\@bank_jmp.mac'	
	 		ini detect

;--------------------------------------------------------------------------------------------------------------------------------------------------------------------
; load atari font 8x8, we can't load last 6 bytes because we could destroy NMIEN,IRQ & RESET vectors
;--------------------------------------------------------------------------------------------------------------------------------------------------------------------
    		org atari_font1,reloc_atari_font1 
			
			ins 'DATA\fonts\thin.fnt',+0,1024-6      
      
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; CYBORG WARRIORS loading...
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
 	 		org $0100

txt_load 	dta d'      LOADING       '+0
		 	dta d'  CYBORG WARRIORS   '+64
		 	dta d'    PLEASE WAIT     '+128
len_txt_load = *-txt_load 

DList_loading
			dta d'ppppppppppppp',$46,a(txt_load)
			:+2 dta $06
			dta $41,a(DList_loading)

loading1	mwa #DList_loading 		dlptrs
			mva #$86 				COLPF0S
			mva #$36 				COLPF1S
			mva #$a6 				COLPF2S
			mva #>reloc_atari_font1	CHBAS
			mva #%11111110          dmactls
			lda:cmp:req $14											;wait 1 frame	
  			rts
		 		
   		    ini loading1
   		 			    
;--------------------------------------------------------------------------------------------------------------------------------------------------------------------
; show screen 1 (Graph2Font)
;--------------------------------------------------------------------------------------------------------------------------------------------------------------------
		 .local   
		    icl 'DATA\graphics\cw_screen1.asm'	   
		 .endl
		 .local   
		    icl 'DATA\graphics\cw_screen2.asm'	   
		 .endl
		 .local   
		    icl 'DATA\graphics\cw_screen3.asm'	   
		 .endl
			
			ini main1 
			
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; CYBORG WARRIORS loading...
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
		 
		    ini loading1
		 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; load RMT player
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
            org RMT_PLAYER 
                       
     		icl 'DATA\rmt_player\rmt_player.asm'

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; load RMT module
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
			org MODUL, reloc_MODUL
	
			rmt_relocator 'DATA\rmt_player\cyborg_music.rmt' MODUL	 
len_MODUL = *-MODUL
 
;--------------------------------------------------------------------------------------------------------------------------------------------------------------------
; load useful datas & procedures
;--------------------------------------------------------------------------------------------------------------------------------------------------------------------
			org $8000
			
			icl 'DATA\library.asm'
      
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; $0B00-$3FFF Main start code of game 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------		
			org $1800

PORTA_JOY1 					.ds 1   				; PORTA and $0f
PORTA_JOY2 					.ds 1   				; PORTA 4 x lsr @

waves_COLPF1				.ds 1					; color of enemy (we change during the game)
waves_depending             .ds 1					; 0, 1=wait until all enemies behind the screen, 2=start to add enemies,3=all enemies(6) on the screen
waves_level_position		.ds 1					; save level_position for later

KEYREP         				.ds 1 					; Key RePeat DELay
KEYDEL		   				.ds 1 					; KEYboard DELay
vbl_timer                   .ds 1
vbl_ntsc                    .ds 1

tab_buff_addr_hi            dta >buff1_charset0,>buff2_charset0
buff_addr_hi   				.ds 2					; show actual buffor 1 or 2 on the screen
is_bit7_BONUS1 				.ds 1					; is set bit=7 for 5th color for BONUS 1?
is_bit7_BONUS2 				.ds 1					; is set bit=7 for 5th color for BONUS 2?

is_resume_game_vbl 			.ds 1					; is resume game after PAUSE?
is_remove_bonus1            .ds 1					; =1 player has taken bonus 1 so remove it
is_remove_bonus2            .ds 1					; =1 player has taken bonus 2 so remove it
is_escape_game              .ds 1					; is NEW GAME after press ESC?
number_bombs				.ds 2			    	; number of bombs (4th weapon) for player 1 and 2 (2 bytes!)
delay_change_weapon         .ds 2					; delay to change weapon again for player 1 and 2 (2 bytes!)
rmt_actual_song				.ds 1					; actual song played by RMT

is_shield                   .ds 1					; =$ff immortality/shield ON, =$00 OFF
is_all_weapon               .ds 1					; =$ff         all weapon ON, =$00 OFF
is_x_level					.ds 1					; =$ff            x level ON, =$00 OFF

move_player_right			.ds 1					; after killing boss, it counts moving player 1 or 2 into right direction
message_shw1                .ds 1                   ; =1 show message text no.1
message_shw2                .ds 1                   ; =1 show message text no.2
message_clr1                .ds 1                   ; =1 clear message text no.1
message_clr2                .ds 1                   ; =1 clear message text no.2
message_timer1              .ds 1					; showing message for example about new weapon (1/50 frames)
message_timer2              .ds 1					; showing message for example about new weapon (1/50 frames)
message_addr_text1          .ds 2					; addres of message
message_addr_text2          .ds 2					; addres of message

old_player0_x     			dta $00,$00				; the last X position of player 1 (2 buffors)
old_player1_x     			dta $00,$00				; the last X position of player 2 (2 buffors)
old_player0_y     			dta $00,$00				; the last Y position of player 1 (2 buffors)
old_player1_y     			dta $00,$00				; the last Y position of player 2 (2 buffors)

vbl_HPOSP0					.ds 2					; shadow HPOSP0, we copy it to HPOSP0-1 on VBL (2 buffors)
vbl_HPOSM0					.ds 2					; shadow HPOSM0, we copy it to HPOSM0-1 on VBL (2 buffors)
vbl_HPOSP2					.ds 2					; shadow HPOSP2, we copy it to HPOSP2-3 on VBL (2 buffors)
vbl_HPOSM2					.ds 2					; shadow HPOSM2, we copy it to HPOSM2-3 on VBL (2 buffors)

x_pmg_pl1        			.ds 1
x_pmg_pl2        			.ds 1
y_pmg_pl1        			.ds 1
y_pmg_pl2        			.ds 1

tab_addr_explosion_lo   	.ds 8										; lo addres of explosion (0-7 no. sprite)	
tab_addr_explosion_hi 		.ds 8										; hi addres of explosion (0-7 no. sprite)
tab_remove_explosion    	.ds 8										; =1 need to remove 5th color for explosion (on the next frame)
reg_xx						.ds 1										; save for later reg. X
reg_yy						.ds 1										; save for later reg. Y

left_clip1 					dta $00   									; pass pixels of position X to clip sprite on maximum left
right_clip1					dta $00

lo_offset_row1				.ds 1										; +320bytes - address of next row
hi_offset_row1				.ds 1
lo_offset_row2				.ds 1										; +320bytes - address of next row
hi_offset_row2				.ds 1

save_00         			.ds 1										; temp
save_01         			.ds 1
save_0a         			.ds 1										; temp
save_0b         			.ds 1

sprite_col      			.ds 1               						; column of sprite during in drawing sprite
sprite_row      			.ds 1               						; row of sprite during in drawing sprite

bonus1_col					.ds 1
bonus1_row					.ds 1										; 0-23
bonus2_col					.ds 1
bonus2_row					.ds 1										; 0-23

margin_x1					.ds 1
margin_x2     				.ds 1

initial_players_maximum_weapon  dta $00,$00
initial_players_lives			dta $00,$00

tab_COLPM1 			dta color_player_COLPM1,color_player_COLPM1,color_player_COLPM1,color_player_COLPM1,color_player_COLPM1+6,color_player_COLPM1+6,color_player_COLPM1+6,color_player_COLPM1+6
tab_COLPM3 			dta color_player_COLPM3,color_player_COLPM3,color_player_COLPM3,color_player_COLPM3,color_player_COLPM3+6,color_player_COLPM3+6,color_player_COLPM3+6,color_player_COLPM3+6

tab_bonus_addr_ora 	dta a(sprite_score_bonus_even_group_0),a(sprite_life_bonus_even_group_0),a(sprite_arms_bonus_even_group_0),a(sprite_score_bonus_even_group_0)
tab_bonus_addr_msk 	dta   a(mask_score_bonus_even_group_0),  a(mask_life_bonus_even_group_0),  a(mask_arms_bonus_even_group_0),  a(mask_score_bonus_even_group_0)

index_tab_bonus_player1		.ds 1										; index of tab_bonus_addr_ora (PLAYER ONE)
index_tab_bonus_player2		.ds 1										; index of tab_bonus_addr_ora (PLAYER TWO)
active_bonus1				.ds 1										; 0-3 kind of bonus 
active_bonus2				.ds 1										; 0-3 kind of bonus
is_active_bonus1            .ds 1										; =1 bonus is set
is_active_bonus2			.ds 1										; =1 bonus is set
 
no_stars					.ds 1										; number of animated stars (1-17)

tmp_PORTB					.ds 1										; save for later PORTB

vbl_pmbase					.ds 1										; shadow register of pmbase

    
run_game    	sei		
				screen_off		
    			system_off										; OS=off, BASIC=off, RAM=on 	   
    				
; initalize my handlers of DLI and VBL interrupts
  				mva #00           NMIEN                 		; dli+vbl off
  				mwa #myDLI1       _DLI
  				mwa #myVBL        _VBL
  				mva #$c0		  NMIEN                 		; dli+vbl on

; prepare char screen - 8 x 120chars
				ldy #7	
run_game_loop0	ldx #119
run_game_loop1	txa	
				sta screen_chars1,x
				dex
				bpl run_game_loop1	
				adw run_game_loop1+2 #120
    			dey
    			bpl run_game_loop0

				jsr clr_2_last_rows									  ; we use these 2 rows for example: "PLAYER ONE - EXTRA ARMS !"
							
; relocate to proper addreses   	
				copy_mem #reloc_MODUL       #MODUL       #len_MODUL    
				copy_mem #reloc_atari_font1 #atari_font1 #1024-6      ; we can't copy last 6 bytes because we could destroy NMIEN,IRQ & RESET vectors
  
; convert bitmaps from BBC format into ATARI format   
				conv_char_bitmap #sprite_data0	   	#[end_sprite_data0-sprite_data0]				
				conv_char_bitmap #sprite_data1	   	#[end_sprite_data1-sprite_data1]				
				conv_char_bitmap #sprite_data2	   	#[end_sprite_data2-sprite_data2]				

       	     	lda @TAB_MEM_BANKS+=horizon_0_sprite \ and #$fe \ sta PORTB 		
    			conv_char_bitmap #horizon_0_sprite 	#[end_horizon_sprite-horizon_0_sprite]						
    			convert_10_to_01 #horizon_0_sprite 	#end_horizon_sprite						; exchange color %10 ---> %01 (for horizons 0-3)
    			
    			lda @TAB_MEM_BANKS+=TOPSTR \ and #$fe \ sta PORTB 		
    			conv_char_bitmap #TOPSTR  			#$0140
    			conv_char_bitmap #BOTSTR  			#$03c0
				lda @TAB_MEM_BANKS \ and #$fe \ sta PORTB 
				
				bank_jsr convert_colors_sprite_data 
				
; initial music + sfx
				mva #$f0 	RMTSFXVOLUME								; sfx note volume * 16 (0,16,32,...,240)
			   	mvx #$ff 	is_music
				stx      	sfx_effect									; initial value for sfx effect
				inx
				stx			is_shield			
				stx			is_all_weapon
				stx			is_x_level
				
				lda #song_title											; starting song line 0-255 to A reg
				jsr rmt_init2											; init music
			
; show Graph2Font picture (cw_title)
show_picture    screen_off
				mva #1 is_music
				mva #0 vbl_pmbase
    			bank_jsr show_cw_title											

; show TITLE SCREEN
				graphics 12	   
    			fill_mem #buff1_charset0 #16*1024 #$00					; clear screen buffor 1 and 2
				jsr PMG_init
  
; reset variables
               	lda #$00
  				sta vbl_ntsc 
				sta vbl_timer
				sta number_bombs										; number of bombs PLAYER ONE
				sta number_bombs+1										; number of bombs PLAYER TWO
				
               	ldx #$9f
wipe_0001_to_009f_loop                                              	; Wipe $0001 - $009f (variables)
               	sta $00,x
               	dex
               	bne wipe_0001_to_009f_loop
               	        
               	dex 													; $ff
               	txs                                                 	; Reset stack pointer	            

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; start NEW GAME - TITLE SCREEN or HIGH SCORE SCREEN
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
start_new_game screen_off    
   			   jsr clr_2_last_rows
               lda #$02                                             	; Use magenta for colour 3
               sta $96                                              	; colour_scheme
               jsr title_screen_after_checking_for_high_score
 
 			   screen_off
 			
               lda #$00
               ldx #$9a
wipe_game_variables_loop                                            	; Wipe $0001 - $009a (variables)
               STA $00,X
               DEX
               BNE wipe_game_variables_loop
 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; start NEW LEVEL
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
start_new_level	
				screen_off
								
				bank_jsr reset_screen_for_new_level
				bank_jsr plot_level_number
				bank_jsr plot_lives					  
			   	bank_jsr plot_number_bombs
			   	bank_jsr plot_score_player_one
			   	bank_jsr plot_score_player_two
			
  				lda #1
 				ldx #<txt_LEVEL
 				ldy #>txt_LEVEL
 				jsr plot_string2
 
 				//copy_mem #game_tab_dli_COLPF0 #tab_dli_COLPF0 #[tab_dli_COLPF0-game_tab_dli_COLPF0]
			
				ldx #len_tab_dli
				
loop_copy_game1	lda game_tab_dli_COLPF0-1,x
				sta tab_dli_COLPF0-1,x
				dex
				bne loop_copy_game1
								
  				screen_on
  				
 				ldx #50*2	
delay_loop		JSR delay
 				DEX
 				BNE delay_loop
 			 			
				bank_jsr prepare_shifted_horizon_sprites  
				jsr PMG_clr	               				
				bank_jsr init_variables
				 
; init silence music, it's necessary to play SFX																		   
			    lda #song_silence
			    jsr rmt_init2
	
				screen_off
				
				jsr plot_static_background_buff1									; black color in some rows to hide it
				jsr plot_static_background_buff2									; black color in some rows to hide it			
				jmp copy_not_pressed
				
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; MAIN GAME LOOP
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
main_game_loop								
				bank_jsr set_color_background

				lda #%11111110
				sta	dmactls
				lda #%00100001
				sta gtiactls
	
				ldx KBCODES	
				cpx #33												 ; SPACE  ( COPY ) - PAUSE GAME
				bne copy_not_pressed 

; plot PAUSE, ESC - NEW GAME, DEL - RESUME GAME
		        lda $99 											 ; check game_over_timer?
		        bne	copy_not_pressed	
				
				lda #4												 ; set color 4 (color=3 and bit7=128)
				ldx #<txt_PAUSE										 ; PAUSE (buffor 1 & 2)
				ldy #>txt_PAUSE											 
				jsr plot_string2
				lda #4
				ldx #<txt_RESUME_GAME								 ; DEL - RESUME GAME (buffor 1 & 2)
				ldy #>txt_RESUME_GAME
				jsr plot4x8_string 
				lda #4
				ldx #<txt_NEW_GAME									 ; ESC - NEW GAME (buffor 1 & 2)
				ldy #>txt_NEW_GAME
				jsr plot4x8_string 
			   	
			   	mva #color_pause 	tab_dli_COLPF3+9			   	
				mva #color_resume 	tab_dli_COLPF3+10	     		 ; colors for RESUME text
				sta		 			tab_dli_COLPF3+11        		 ; and ESC text
							  	
delete_not_pressed
				ldx KBCODES
				cpx #28												 ; ESCAPE - START NEW GAME
				bne escape_not_pressed
				
				lda #0
               	ldx #7	
start_loop1    	sta $82,x											 ; delete score for player 1/2 after press ESCAPE
               	sta $89,x											 ; we don't need execute "get_name"
               	dex
               	bpl start_loop1

				jmp start_new_game                                	 ; End game if ESCAPE pressed

escape_not_pressed				
				cpx #52												 ; DELETE - RESUME GAME
				bne delete_not_pressed								 ; Pause until DELETE pressed

				mva #3 is_resume_game_vbl

copy_not_pressed
				lda $9b 									 		 ; level_number
				and #$07
				sta $96 											 ; colour_scheme				
				tax

				LDA $99 											 ; game_over_timer
				BEQ update_game                                      ; Zero if game not over

				DEC $99 											 ; game_over_timer
			    bne game_over1
					   	
			   	mva #$ff is_music
				jmp start_new_game
				
game_over1   	JMP skip_updating_firing_cooldowns

; after using smart bomb (4th weapon)
finish_smart_bomb                                                    ; Also called when boss is destroyed
				LDA #$00
				STA $72 											 ; smart_bomb_or_boss_active            ; Set to zero to indicate no boss or smart bomb active
				STA $93 											 ; group_of_enemies_added               ; Set to zero to indicate no group of enemies (boss)
				LDA $71 											 ; level_position
				CMP #$23                                             ; Is the player at the end of the level?
				beq *+5
				jmp skip_updating_smart_bomb                         ; (i.e. has destroyed the boss)

; boss is killed, end of level
level_completed	LDA #$64											 ; move player to right 
				STA $71 											 ; count
				sta	move_player_right									 	 

level_completed_loop
				LDX #$01

move_players_right_loop
				LDA $9c,X 											 ; players_lives
				BEQ skip_moving_player_right
				
				lda $10,X
				cmp #120											 ; check if player is behing on right margin?
				bpl skip_move0
	
				INC $10,X 											 ; players_or_enemies_x                     ; If so, move active players right

skip_move0
skip_moving_player_right
				DEX
				BPL move_players_right_loop
					
				INC $70 											 ; frame_counter
				JSR replot_screen
				dec move_player_right
				DEC $71 											 ; count
				BPL level_completed_loop
				
				INC $9b 											 ; level_number
				JMP start_new_level

update_game     LDA $9c 											 ; players_lives
                ORA $9d 											 ; players_lives + 1
                BNE game_not_over                                    ; If both player one and player two have no lives,

                LDA #$60
                STA $99 											 ; game_over_timer      ; Display "GAME OVER" for 96 frames
									 			   
			   	lda #song_game_over
			   	jsr rmt_init2
			   	
game_not_over	LDA $72 											; smart_bomb_or_boss_active
				BPL skip_updating_smart_bomb                 		; Negative if smart bomb active or boss is exploding
				
				INC $c5 											; smart_bomb_timer
				LDA $c5 											; smart_bomb_timer
				CMP #$0b											; 11
				bmi *+5
				jmp finish_smart_bomb
				
				LSR @                                               ; Destroy an enemy every two frames
				TAY
				
				LDA $c5 											; smart_bomb_timer
				CLC
				ADC #smart_bomb_colours - level_colours				; 8
				STA $96 											; colour_scheme
						
; test if bonus, don't explode bonus!		
				lda $2a,y											; players_or_enemies_type + 2
				cmp #$20
				bne *+5
				jmp consider_updating_player_one
				cmp #$24
				bne *+5
				jmp consider_updating_player_one				
					
				LDA $0022,Y 										; players_or_enemies_energy + 2
				STY $75 											; sprite_to_update
				bpl *+5
				jmp consider_updating_player_one             		; Don't explode enemy if enemy is already exploding
				
				LDA $9c 											; players_lives
				BEQ skip_exploding_enemy_by_player_one       		; If player one is alive,
				
				JSR explode_enemy                            		; Explode enemy and score for player one

skip_exploding_enemy_by_player_one
				LDA $9d 										    ; players_lives + 1
				BEQ skip_exploding_enemy_by_player_two       		; If player two is alive,
				
				LDY $75 											; sprite_to_update
				JSR explode_enemy_by_player_two              		; Explode enemy and score for player two

skip_exploding_enemy_by_player_two
skip_updating_smart_bomb
 				DEC $02 											 ; players_firing_cooldown
				BPL skip_floor_one
				
				LDA #$00
				STA $02 											 ; players_firing_cooldown

skip_floor_one
				DEC $03 											 ; players_firing_cooldown + 1
				BPL skip_floor_two
				
				LDA #$00
				STA $03 											 ; players_firing_cooldown + 1

skip_floor_two
skip_updating_firing_cooldowns
 				INC $70 											 ; frame_counter
				BEQ update_level_position
				
				LDA $70 										 	 ; frame_counter
				AND #$3f
				BNE consider_updating_player_one        		     ; Every 64 frames, update level position

update_level_position	
 				LDA $71 											 ; level_position
				CMP #$23
				BEQ consider_updating_player_one            		 ; Don't update level position at boss
			
	            ldx waves_COLPF1
	            beq update_level_position2
	            		
				ldx waves_depending									 
				cpx #1												 ; =1 don't update level_position until all enemies will be outside the screen
				beq consider_updating_player_one								
				cpx #2												 ; =2 start to add new enemies on the screen, don't update level_position
				beq consider_updating_player_one

update_level_position2								
				INC $71 											 ; level_position
				
update_level_skp1
				AND #$07
				CMP #$07
				BNE consider_updating_player_one            		 ; Every 8 positions, consider adding bonuses
				
				LDA #$01
				LDX $9c 											 ; players_lives
				BEQ skip_player_one_bonus        		             ; Don't add bonus for player one if player one is dead
				
				STA $97 											 ; player_one_due_bonus      ; Set to non-zero to create bonus when possible

skip_player_one_bonus
				LDX $9d 											 ; players_lives + 1
				BEQ skip_player_two_bonus                    	  	 ; Don't add bonus for player two if player two is dead
				
				STA $98 											 ; player_two_due_bonus      ; Set to non-zero to create bonus when possible

skip_player_two_bonus
consider_updating_player_one
				LDA $9c 											; players_lives
				BEQ to_update_player_two                     		; Don't update player one if player one is dead
				
				LDA $30 											; players_or_enemies_timer
				BPL update_player_one                        		; Negative if player one is moving onto screen

  				INC $10 											; players_or_enemies_x
    
skip_move1		DEC $30 											; players_or_enemies_timer

to_update_player_two
to_consider_updating_player_two	JMP consider_updating_player_two

update_player_one
				DEC $30 											; players_or_enemies_timer
				BPL skip_floor_1
				
				LDA #$00
				STA $30 											; players_or_enemies_timer

skip_floor_1	LDA #$00                                            ; Set to zero to indicate not able to change weapon
				STA $73 											; player_in_position_to_change_weapon

check_if_left_pressed
				lda PORTA
				and #$0f
				sta PORTA_JOY1
				and #joystick_left
				bne check_if_right_pressed
			
				LDA $10 											 ; players_or_enemies_x
				CMP #$1c                                             ; If player one is at the left of the screen,
				BNE move_player_one_left
				
				DEC $73 											 ; player_in_position_to_change_weapon   Set to non-zero to indicate able to change weapon
				BNE check_if_right_pressed                           ; Always branches

move_player_one_left
				DEC $10 											 ; players_or_enemies_x       ; Otherwise move player one left
   
check_if_right_pressed
				LDA $10 											 ; players_or_enemies_x
				CMP #max_sprite_right    		                     ; If player one isn't at the right of the screen,
				BEQ check_if_up_pressed
	
				lda PORTA_JOY1
				and #joystick_right
				bne check_if_up_pressed							 	 ; move right
			
				INC $10 											 ; players_or_enemies_x                       ; Move player one right

check_if_up_pressed
				lda PORTA_JOY1				
				and #joystick_up
				bne check_if_down_pressed
				
        		LDA $18 											 ; players_or_enemies_y
				CMP #$02                                             ; If player one isn't at the top of the screen,
				BEQ check_if_down_pressed
				
				DEC $18 											 ; players_or_enemies_y                       ; Move player one up

check_if_down_pressed
			    lda PORTA_JOY1
				and #joystick_down
				bne check_if_space_pressed2

				LDA $18 											 ; players_or_enemies_y
				CMP #$18                                             ; If player bottom isn't at the top of the screen,
				BEQ check_if_space_pressed2
				
				INC $18 											 ; players_or_enemies_y                       ; Move player one down

check_if_space_pressed2
								 
				sec													; always fire!

trig01			LDX #$00 											; player 0
				JSR consider_firing_or_changing_weapon
			
				lda trig0											; fire = change weapon
				bne consider_updating_player_two
			
			    lda delay_change_weapon+0							; check delay for change weapon
			    bne consider_updating_player_two
			    
	            lda $c6 											; players_maximum_weapon
				beq consider_updating_player_two
		
			    sec

               	LDX #$00 											; player 0
               	BCC *+5
               	JSR change_weapon   
         
consider_updating_player_two
				LDA $9d 											; players_lives + 1    ; Don't update player two if player two is dead
				BEQ to_update_enemies_and_check_for_collisions
				
				LDA $31 											; players_or_enemies_timer + 1
				BPL update_player_two                       		; Negative if player two is moving onto screen
	
				INC $11
	
skip_move2		DEC $31 											; players_or_enemies_timer + 1

to_update_enemies_and_check_for_collisions
				JMP update_enemies_and_check_for_collisions

update_player_two
				DEC $31 											; players_or_enemies_timer + 1
				BPL skip_floor_2
				
				LDA #$00
				STA $31 											; players_or_enemies_timer + 1

skip_floor_2
				LDX #$00                                            ; Set to zero to indicate not able to change weapon
				STX $73 											; player_in_position_to_change_weapon
				INX 												; +1
			
				lda PORTA
				lsr @
				lsr @
				lsr @
				lsr @
				sta PORTA_JOY2
				and #joystick_right
				beq consider_moving_player_two_right				; move right
				lda PORTA_JOY2
				and #joystick_left
				bne check_joystick_vertically 							

				LDA $11 											; players_or_enemies_x + 1
				CMP #$1c                                            ; If player two is at the left of the screen,
				BNE move_player_two_left
				DEC $73 											; player_in_position_to_change_weapon  ; Set to non-zero to indicate able to change weapon
				BNE check_joystick_vertically                		; Always branches

move_player_two_left
				DEC $11 											; players_or_enemies_x + 1             ; Otherwise move player two left
				JMP check_joystick_vertically

consider_moving_player_two_right                                    ; If the joystick is to the right,
				LDA $11 											; players_or_enemies_x + 1
				CMP #max_sprite_right        			            ; If player two isn't at the right of the screen,
				BEQ check_joystick_vertically
				
				INC $11 											; players_or_enemies_x + 1             ; Move player two right

check_joystick_vertically			
				lda PORTA_JOY2
				and #joystick_down
				beq consider_moving_player_two_down					
				lda PORTA_JOY2
				and #joystick_up
				bne check_joystick_fire							

				LDA $19 											; players_or_enemies_y + 1
				CMP #$02                                            ; If player two isn't at the top of the screen,
				BEQ check_joystick_fire
				DEC $19 											; players_or_enemies_y + 1             ; Move player two up
				JMP check_joystick_fire

consider_moving_player_two_down                                   	; If the joystick is down,
				LDA $19 											; players_or_enemies_y + 1
				CMP #$18                                            ; If player two isn't at the bottom of the screen,
				BEQ check_joystick_fire
				INC $19 											; players_or_enemies_y + 1             ; Move player two down

check_joystick_fire					
				sec

				LDX #$01   											; player 1
				JSR consider_firing_or_changing_weapon

				lda trig1											; fire = change weapon
				bne update_enemies_and_check_for_collisions

			    lda delay_change_weapon+1							; check delay for change weapon
			    bne update_enemies_and_check_for_collisions
					
	            lda $c7 										 	; players_maximum_weapon
				beq update_enemies_and_check_for_collisions

				sec
  
               	LDX #$01   											; player 1
               	BCC *+5
               	JSR change_weapon   
				
update_enemies_and_check_for_collisions
				LDA $10 											; players_or_enemies_x
				CLC
				ADC #$05
				STA $75 											; player_one_maximum_x
				LDA $18 											; players_or_enemies_y
				ADC #$07
				STA $76 											; player_one_maximum_y
				LDA $11 											; players_or_enemies_x + 1
				ADC #$05
				STA $77 											; player_two_maximum_x
				LDA $19 											; players_or_enemies_y + 1
				ADC #$07
				STA $78 											; player_two_maximum_y
				
				LDX #$05

update_enemies_and_check_for_collisions_loop
				LDA $12,X 											; player_or_enemies_x + 2
				BNE update_enemy                            		; Non-zero if enemy is present

to_consider_next_enemy
				JMP consider_next_enemy1

apply_inverse_vertical_movement
set_enemy_y1
				SEC
				SBC ($08),Y 										; y_pattern_table_address_low
				JMP after_applying_delta

update_enemy	LDA $22,X 											; players_or_enemies_energy + 2
				BMI to_consider_next_enemy                   		; Negative if enemy is exploding
				
				INC $32,X 											; players_or_enemies_timer + 2
				LDA $32,X 											; players_or_enemies_timer + 2
				AND #$7f
				LSR @
				LSR @
				LSR @
				LSR @
				STA $73     										; movement_frame
				LDY $2a,X   										; players_or_enemies_type + 2
addr_sprite_sizes_and_data1
				LDA sprite_sizes_and_data + 1,Y
				LSR @
				LSR @
				LSR @
				STA $95 											; enemy_width
				LDA $2a,X 											; players_or_enemies_type + 2
				LSR @
				LSR @
				TAY
	
				mva #>patterns_for_horizontal_movement _adr1+2
				mva #>patterns_for_vertical_movement   _adr2+2
				
				LDA enemy_pattern_types - 5,Y
				cmp #$20													; is more than 255bytes? $20 * 8 =256
				bne _skp1
	
	            inc _adr1+2
	            inc _adr2+2
				and #%11011111												; clear bit5=0
				
_skp1			ORA $92 													; current_wave_type
				STA $74 													; movement_flags
				LDA enemy_pattern_types - 5,Y
				and #%11011111												; clear bit5=0
				ASL @														; *8
				ASL @
				ASL @
				CLC
				ADC $73 													; movement_frame
				TAY
_adr1			LDA patterns_for_horizontal_movement,Y
				ASL @														; *16
				ASL @
				ASL @
				ASL @
				STA $00 													; x_pattern_table_address_low
				LDA #$00
						
				ADC #>movement_patterns   									; $09 ; $0900 = movement_patterns
				STA $01 													; x_pattern_table_address_high
				
_adr2			LDA patterns_for_vertical_movement,Y
				ASL @
				ASL @
				ASL @
				ASL @
				STA $08 													; y_pattern_table_address_low
				LDA #>movement_patterns  									;$09 ; $0900 = movement_patterns
				ADC #$00
				STA $09 													; y_pattern_table_address_high
				
				LDA $32,X 													; players_or_enemies_timer + 2
				AND #$0f
				TAY
				LDA $1a,X 													; players_or_enemies_y + 2
				BIT $74 													; movement_flags
				BMI apply_inverse_vertical_movement          				; If $80 set, subtract vertical movement
			
				ADC ($08),Y 												; y_pattern_table_address     ; If $80 clear, add vertical movement

after_applying_delta
set_enemy_y2
				STA $1a,X 													; players_or_enemies_y + 2
				CMP #$02
				bpl not_off_top_of_screen                    		 		; Remove enemy if enemy is beyond top of screen
 
remove_enemy
				LDA #$00                                             		; Set to zero to remove enemy
				STA $12,X 													; player_or_enemies_x + 2
				CPX #$05
				BEQ check_for_collision_with_player_two

				STA $72 													; smart_bomb_or_boss_active ; Set to zero to indicate no boss or smart bomb active
				STA $93 													; group_of_enemies_added  ; Set to zero to indicate no group of enemies (boss)
				BNE check_for_collision_with_player_two

not_off_top_of_screen
				CMP #$1d
				BPL remove_enemy                             				; Remove enemy if enemy if beyond bottom of screen

				LDA $12,X 									 				; player_or_enemies_x + 2
				BIT $74 									 				; movement_flags
				BVC skip_applying_horizontal_movement        				; If $40 clear, don't add horizontal movement

				ADC ($00),Y 								 				; x_pattern_table_address

skip_applying_horizontal_movement
				CLC
				ADC ($00),Y 								 				; x_pattern_table_address
				BEQ remove_enemy                             				; Remove enemy if enemy is beyond left of screen
				BMI remove_enemy                             				; Remove enemy if enemy is beyond left of screen

				STA $12,X 									 				; player_or_enemies_x + 2

check_for_collision_with_player_one
				CMP $75 									 				; player_one_maximum_x
				BPL check_for_collision_with_player_two
				CLC
				ADC $95 								 	 				; enemy_width
				CMP $10 									 				; players_or_enemies_x
				BMI check_for_collision_with_player_two
			
				LDA $1a,X 									 				; players_or_enemies_y + 2
				CMP $76 									 				; player_one_maximum_y
				BPL check_for_collision_with_player_two
		
				CLC
				ADC $3a,X 									 				; enemies_height
				SBC #$01
				CMP $18 									 				; players_or_enemies_y
				BMI check_for_collision_with_player_two

player_one_collided
				LDA $2a,X 													; players_or_enemies_type + 2
				LDY #$00
				CMP #$24 													; BONUS_PLAYER_TWO
				BEQ player_one_collided_with_bonus_two      			
				CMP #$20 													; BONUS_PLAYER_ONE
				beq player_one_collided_with_bonus_one
				JMP player_collided_with_enemy

check_for_collision_with_player_two
				JSR consider_spawning_enemies
				LDA $12,X 													; player_or_enemies_x + 2
				CMP $77 													; player_two_maximum_x
				BPL consider_next_enemy_if_positive

				CLC
				ADC $95 													; enemy_width
				CMP $11 													; players_or_enemies_x + 1
				BMI consider_next_enemy_if_negative

				LDA $1a,X 													; players_or_enemies_y + 2
				CMP $78 													; player_two_maximum_y

consider_next_enemy_if_positive
				BMI *+5
				JMP consider_next_enemy1
				
				CLC
				ADC $3a,X 													; enemies_height
				SBC #$01
				CMP $19 													; players_or_enemies_y + 1
				
consider_next_enemy_if_negative
				bpl player_two_collided
				jmp consider_next_enemy1

player_two_collided
				LDY #$01
				LDA $2a,X 													; players_or_enemies_type + 2
				CMP #$20 													; BONUS_PLAYER_ONE
			    BEQ player_two_collided_with_bonus_one
				CMP #$24 													; BONUS_PLAYER_TWO
				BEQ player_two_collided_with_bonus_two
				jmp player_collided_with_enemy

player_one_collided_with_bonus_one
player_two_collided_with_bonus_one
				mva #1 is_remove_bonus1
				mva #0 no_bonus
				jmp player_collided_with_bonus
				
player_one_collided_with_bonus_two
player_two_collided_with_bonus_two
				mva #1 is_remove_bonus2
				sta    no_bonus
				
;---------------------------------------------------------------------------------------------------------------------------------------------------				
player_collided_with_bonus
				lda $009c,y 												; players_lives
				bne *+5
				jmp consider_next_enemy1

				lda #$00                                            		; Set to zero to remove bonus
				sta $12,x 													; player_or_enemies_x + 2
				stx $78 													; tmp_x
				stx no_sprite
				tya
				tax
				stx no_player
				
				inc $c2,x 													; players_bonuses_collected
				
				ldx no_bonus
				lda active_bonus1,x
				cmp #$02-1
				bne not_extra_life_bonus

extra_life_bonus
				ldx no_player
				lda $9c,x 													; players_lives
				cmp #10
				bne *+5
				jmp score_bonus                              				; Score 400 for collecting life bonus with 10 lives

				lda $9c,x													; check max lives?
				cmp #9
				beq extra_life_bonus2

				inc $9c,X 													; players_lives			

extra_life_bonus2
				jsr remove_bonus
								
				ldx no_player
				beq extra_life_bonus3
			
				mwa #txt_new_life2 	message_addr_text2
				mva #96 			message_timer2
				mva #1              message_shw2		
				jmp extra_life_bonus4
				
extra_life_bonus3										
				mwa #txt_new_life1  message_addr_text1
				mva #96 			message_timer1
				mva #1              message_shw1
					
extra_life_bonus4
				bank_jsr plot_lives
				jmp play_bonus_sound_and_consider_next_enemy

not_extra_life_bonus
				cmp #$03-1
				beq *+5
				jmp score_bonus

extra_weapon_bonus		
			    ldx no_player
				lda $c6,x 													; players_maximum_weapon
				cmp #$03
				bne *+5
				jmp score_bonus                              				; Score 600 for collecting weapons bonus with all weapons
			
				cmp #$02
				bne extra_weapon1
				
				mva #$01 number_bombs,x								
				bank_jsr plot_number_bombs
				
extra_weapon1	inc $c6,X 													; players_maximum_weapon

				jsr remove_bonus
				
				ldx no_player
				beq extra_weapon_bonus3
			
				mwa #txt_new_weapon2 	message_addr_text2
				mva #96 				message_timer2
				mva #1              	message_shw2	
				jmp extra_weapon_bonus4
				
extra_weapon_bonus3										
				mwa #txt_new_weapon1	message_addr_text1
				mva #96 				message_timer1
				mva #1              	message_shw1
					
extra_weapon_bonus4		
				bank_jsr plot_weapon_slots
				jsr play_bonus_extra_weapon_sound
				jmp play_bonus_sound_and_consider_next_enemy2

no_player dta $00
no_sprite dta $00
no_bonus  dta $00

; remove bonus because it's collected by player 1/2
remove_bonus .proc	
				ldx no_sprite
				lda $2a,x
				cmp #$20
				beq remove_bonus1
				cmp #$24
				beq remove_bonus2
				rts
				
remove_bonus1	lda #0
				sta is_active_bonus1
				sta active_bonus1
				jmp remove_bonus3
				
remove_bonus2	lda #0
				sta is_active_bonus2
				sta active_bonus2

remove_bonus3	ldx no_bonus
				inc index_tab_bonus_player1,x
	            rts								
.endp

    
;---------------------------------------------------------------------------------------------------------------------------------------------------				
play_bonus_sound_and_consider_next_enemy
				jsr play_bonus_sound
play_bonus_sound_and_consider_next_enemy2
				LDX $78 											; tmp_x
				JMP consider_next_enemy1

player_collided_with_enemy
				LDA $009c,Y 										; players_lives
				BEQ consider_next_enemy1
				LDA $0030,Y 										; players_or_enemies_timer
				BMI consider_next_enemy1                      		; Negative if player is moving onto screen
				CMP #player_time_invulnerable
				BPL consider_next_enemy1                      		; Player is invulnerable at start of new life
							
				LDA $72 											; smart_bomb_or_boss_active       ; Zero if no boss or smart bomb active
				BNE skip_killing_enemy                        		; i.e. don't destroy part of boss on collision
	
				LDA #$ff
				STA $22,X 											; players_or_enemies_energy + 2   ; Set to negative to indicate enemy is exploding

skip_killing_enemy
				lda is_shield										;  immortality!!!!!!!!!!!!!!
				bpl *+5 			
			    jmp consider_next_enemy1	
		
				LDA #$ff
				STA $0020,Y 										; players_or_enemies_energy       ; Set to negative to indicate player is exploding
				STA $0030,Y 										; players_or_enemies_timer        ; Set player moving onto screen
				STX $73 											; tmp_x
				TYA
				TAX
		
				DEC $9c,X 											; players_lives
				     	        		        				
				jsr play_dead_player_sound			
			
				LDX $73 											; tmp_x
				bank_jsr plot_lives

consider_next_enemy1
				DEX
				BMI update_status
					
				JMP update_enemies_and_check_for_collisions_loop
				
bonus_score_offsets
;         p1 p2
	dta $04,$0b                                                     ; Score x100

score_bonus  	jsr remove_bonus
					
				ldx no_player
				beq score_bonus3
			
				mwa #txt_new_bonus2 	message_addr_text2
				mva #96 				message_timer2
				mva #1              	message_shw2	
				jmp score_bonus4
				
score_bonus3										
				mwa #txt_new_bonus1 	message_addr_text1
				mva #96 				message_timer1
				mva #1              	message_shw1
					
score_bonus4	ldy no_player
				lda $c2,Y 											; players_bonuses_collected              ; Score 200 or 800 for collecting score bonuses
				ASL @
				ASL @
				ASL @
				ASL @
				LDX bonus_score_offsets,Y
				JSR increase_score

				JMP play_bonus_sound_and_consider_next_enemy

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
update_status
    			LDA $70 											; frame_counter
				AND #$02
				BNE update_status_on_frames_2_and_3			
				JMP update_status_on_frames_0_and_1
				
update_status_on_frames_2_and_3
				lda $70 											; frame_counter
				and #$01
				bne plot_player_two_score							; Replot player two score on frame 3
				
				bank_jsr plot_score_player_one
				jmp to_replot_screen_and_main_game_loop
				
plot_player_two_score                                               ; Replot player two score on frame 3
				bank_jsr plot_score_player_two
				jmp to_replot_screen_and_main_game_loop

next_enemy_cooldowns
;       0   1   2   3
  dta $00,$01,$03,$05

update_status_on_frames_0_and_1
				LDA $70 											; frame_counter
				AND #$01
				BEQ consider_adding_bonuses                  		; Add bonuses and enemies on frame 0

 				bank_jsr update_progress_bar                  		; Replot progress bar on frame 1
				jmp to_replot_screen_and_main_game_loop

consider_adding_bonuses
				LDA $97 											; player_one_due_bonus
				BEQ skip_adding_player_one_bonus             		; Non-zero if bonus is due						
				
; get new shape of bonus
				lda index_tab_bonus_player1
				and #3
				sta index_tab_bonus_player1
				sta active_bonus1
				asl @
				tay
				mwa tab_bonus_addr_ora,y bonus_addr1+0
				mwa tab_bonus_addr_msk,y bonus_addr1+2

				ldy #$20 											; BONUS_PLAYER_ONE
				jsr add_enemy                                		; Returns carry set if enemy added
				bcc skip_adding_player_one_bonus
							
				mva #1 is_active_bonus1
								
				lda #$00                                        	; Set to zero to suppress adding bonus
				sta $97												; player_one_due_bonus

skip_adding_player_one_bonus
				LDA $98 											; player_two_due_bonus
				BEQ skip_adding_player_two_bonus             		; Non-zero if bonus is due

; get new shape of bonus
				lda index_tab_bonus_player2
				and #3
				sta index_tab_bonus_player2
				sta active_bonus2
				asl @
				tay
				mwa tab_bonus_addr_ora,y bonus_addr2+0
				mwa tab_bonus_addr_msk,y bonus_addr2+2
									
				ldy #$24
				jsr add_enemy                                	; Returns carry set if enemy added
			
				bcc skip_adding_player_two_bonus
		
				mva #1 is_active_bonus2
				
				lda #$00                                        ; Set to zero to suppress adding bonus
				sta $98 										; player_two_due_bonus
				
skip_adding_player_two_bonus
				LDA $70 										; frame_counter
				AND #$3f
				BNE consider_adding_new_enemy                	; Is this the start of a new wave?
				LDA $72 										; smart_bomb_or_boss_active         ; Non-zero if boss or smart bomb active
				BNE consider_adding_new_enemy

				STA $90 										; next_enemy_to_add                 ; Start adding enemies for the new wave

consider_adding_new_enemy
				LDA $90 										; next_enemy_to_add
				CMP #$06                                        ; Have all the enemies for this wave been added?
				BEQ to_to_replot_screen_and_main_game_loop
				
				DEC $91 										; next_enemy_cooldown
				BMI add_next_enemy1                           	; If not, is it time to add the next enemy?
				
to_to_replot_screen_and_main_game_loop
				JMP to_replot_screen_and_main_game_loop

add_next_enemy1
				LDX $71 											 ; level_position

level_waves_data_address_low
               LDA level_waves_data,X
;     actually LDA level_waves_data_address,X
				
				STA $76 											 ; wave_type    ; Get wave type from on position in level
				ASL @												 ; *8
				ASL @
				ASL @
				STA $00 											 ; wave_data_address_low
				LDA #>wave_data 									 ; $2800 = wave_data
				ADC #$00
				STA $01 											 ; wave_data_address_high
			
				lda $76 	
				cmp #$04											 ; is the group of enemy rockets?
				bne level_wave1
	
; check if we have to play sound for rockets		
				ldx #5
lavel_wave_loop1
				lda $2a,x
				cmp #$2c                                             ; is single rocket?
				beq lavel_wave_skip1
lavel_wave_loop2
				dex
				bpl lavel_wave_loop1
				bmi level_cont1										 ; always branches!

lavel_wave_skip1
level_wave0		jsr play_flying_rocket_sound						 ; new rocket is visible so play sound
				jmp level_cont1

level_wave1		cmp #$06											 ; is the group of enemy bouncing balls?
				bne	level_wave2		
				
				jsr play_bounce_balls_sound
				jmp level_cont1
				
level_wave2	
	      																			
; test if possible change color COLPF1 for enemy
level_cont1	    ldx $71
				lda waves_depending
			    cmp #1
			    beq _wave_check1

level_waves_COLPF1_address_low	            	
				lda level_waves_COLPF1,x
				beq _wave_cont1
				cpx waves_level_position
				beq _wave_cont1
  
_wave_start0	sta waves_COLPF1
			    stx waves_level_position
			    mva #1 waves_depending								 ; =1 wait until all enemies go outside the screen
				
				lda $76
				cmp #$08											 ; is odd boss?
				beq _wave_check0
				cmp #$13											 ; is even boss?
				bne _wave_check1
				
_wave_check0    inc waves_depending
				lda waves_COLPF1
				jsr set_enemy_COLPF1
				mva #0 waves_COLPF1 							     ; reinit color				
  
; check is only BONUS on the screen?
_wave_check1	ldx #6-1
				
_loop_bonus1	lda $12,x
				bne _skip_bonus1
_skip_bonus0	dex
				bpl _loop_bonus1 		
				bmi _wave_check2
						
_skip_bonus1	lda $2a,x
				cmp #$20   											 ; BONUS PLAYER ONE?
				beq _skip_bonus0
				cmp #$24											 ; BONUS PLAYER TWO?
				beq _skip_bonus0
				jmp to_replot_screen_and_main_game_loop					
				
_wave_check2	mva #2 waves_depending    							 ; =2 start to add new enemies
				
				lda waves_COLPF1
				beq _wave_cont1
				 
				lda waves_COLPF1
				jsr set_enemy_COLPF1
				mva #0 waves_COLPF1 							     ; reinit color
						
_wave_cont1		LDY #$06
				LDA ($00),Y 										 ; wave_data_address                      ; Seventh byte of wave data sets flags for wave
				STA $75 											 ; wave_flags
				INY
				LDA ($00),Y 										 ; wave_data_address                      ; Eighth byte of wave data is non-zero for grouped boss
				STA $77 											 ; wave_group
				LDY $90 											 ; next_enemy_to_add
				LDA ($00),Y 										 ; wave_data_address                      ; First six bytes of wave data set enemy types and delay
				STA $73 											 ; byte_for_enemy
				ASL @
				ASL @
				CLC
				ADC #$14 											 ; SPRITE_FIRST_ENEMY
				TAY                                                  ; Low six bits of enemy byte set enemy type
				LDA $73 											 ; byte_for_enemy
				LSR @
				LSR @
				LSR @
				LSR @
				LSR @
				LSR @                                                ; Top two bits of enemy byte set delay until next enemy
				TAX
				LDA next_enemy_cooldowns,X
				STA $91 											 ; next_enemy_cooldown
				LDA $90 											 ; next_enemy_to_add
				BNE not_start_of_wave
				
				LDA $75 											 ; wave_flags
				BPL consider_adding_enemy_in_empty_slot      		 ; If top bit of flags set,
					
				LDA $12 											 ; player_or_enemies_x + 2                    ; all enemies in wave must be destroyed
				ORA $13 											 ; player_or_enemies_x + 3
				ORA $14 											 ; player_or_enemies_x + 4
				ORA $15 											 ; player_or_enemies_x + 5
				ORA $16 											 ; player_or_enemies_x + 6
				ORA $17 											 ; player_or_enemies_x + 7			
				BNE to_replot_screen_and_main_game_loop      		 ; Have all the enemies been destroyed?
				
				LDA $76 											 ; wave_type
				STA $92 											 ; current_wave_type
				LDA $75 											 ; wave_flags
				AND #$02                                             ; If $02 set, treat enemies as group (boss)
				BEQ add_next_enemy2
				BIT $72 											 ; smart_bomb_or_boss_active                  ; Negative if smart bomb active
				BMI to_replot_screen_and_main_game_loop
				LDA $77 											 ; wave_group
				STA $93 											 ; group_of_enemies_added
				LDA #$01
				STA $72 											 ; smart_bomb_or_boss_active                  ; Set to one to indicate boss present
				BNE add_next_enemy2                           		 ; Always branches
				
consider_adding_enemy_in_empty_slot
				LDA $76 											 ; wave_type
				STA $92 											 ; current_wave_type
not_start_of_wave
				LDA $93 											 ; group_of_enemies_added                     ; Non-zero if group of enemies already added
				BNE skip_adding_enemy
add_next_enemy2	
				JSR add_enemy_or_group_of_enemies            		 ; Returns carry set if enemy added
				BCC to_replot_screen_and_main_game_loop

skip_adding_enemy	
				INC $90 											 ; next_enemy_to_add

				LDA $90 											 ; next_enemy_to_add
				CMP #$06
				BNE to_consider_adding_new_enemy

				lda waves_depending
				cmp #2
				bne _wave_cont2
			
				inc waves_depending								 	 ; =3 end to add new enemies (all 6th enemies on the screen) 
		
_wave_cont2		LDA $75 											 ; wave_flags
				BNE to_replot_screen_and_main_game_loop      		 ; If zero, add new enemies when old enemies destroyed
				
				STA $90 											 ; next_enemy_to_add

to_consider_adding_new_enemy
				JMP consider_adding_new_enemy

to_replot_screen_and_main_game_loop
				JSR replot_screen
				JMP main_game_loop

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------				
; set bi7=128 to use 5th color for BONUS
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------				
set_bit7_BONUS1	.proc
				tya
				pha

				ldx bonus1_row	
				beq _error1		
				
				mva #color_bonus1 	tab_dli_COLPF3+0,x			; set color 3(bit7) on DLI
				sta 	 			tab_dli_COLPF3+1,x
				sta                 bonus_tab_dli_COLPF3+0,x
				sta                 bonus_tab_dli_COLPF3+1,x
				
				lda tab_screen_chars_lo,x
				add bonus1_col
				sta bns1 
				lda tab_screen_chars_hi,x
				adc #0
				sta bns1+1
				
				ldy #0  \ jsr set_bit7_row				
				ldy #40 \ jsr set_bit7_row
				
_error1			pla
				tay				
				rts
.endp

set_bit7_BONUS2	.proc
				tya
				pha

				ldx bonus2_row
				beq _error1	
				
				mva #color_bonus2 	tab_dli_COLPF3+0,x			; set color 3(bit7) on DLI
				sta 	 			tab_dli_COLPF3+1,x
				sta                 bonus_tab_dli_COLPF3+0,x
				sta                 bonus_tab_dli_COLPF3+1,x
				
				lda tab_screen_chars_lo,x
				add bonus2_col
				sta bns1 
				lda tab_screen_chars_hi,x
				adc #0
				sta bns1+1

				ldy #0  \ jsr set_bit7_row				
				ldy #40 \ jsr set_bit7_row
				
_error1			pla
				tay				
				rts
.endp

; set bit=7(5th color) on the screen			
set_bit7_row .proc
				lda (bns1),y
				ora #128	
				sta (bns1),y
				iny							
				lda (bns1),y
				ora #128	
				sta (bns1),y
				iny					
     			lda (bns1),y
				ora #128	
				sta (bns1),y
				iny					
     			lda (bns1),y
				and #127	
				sta (bns1),y
				
				rts	
.endp

; set bit=7(5th color) on the screen			
set_bit7_row_exp .proc
				lda (exp1),y
				ora #128	
				sta (exp1),y
				iny							
				lda (exp1),y
				ora #128	
				sta (exp1),y
				iny					
				lda (exp1),y
				ora #128	
				sta (exp1),y
	
				rts	
.endp

; clear bit=7(5th color) on the screen			
clr_bit7_row_exp .proc
				lda (exp1),y
				and #127	
				sta (exp1),y
				iny							
				lda (exp1),y
				and #127	
				sta (exp1),y
				iny					
				lda (exp1),y
				and #127	
				sta (exp1),y
	
				rts	
.endp

clr_bit7_BONUS1	.proc
				tya
				pha
				
				ldx bonus1_row
				mva game_tab_dli_COLPF3+0,x tab_dli_COLPF3+0,x				; set color 3(bit7) on DLI
				mva game_tab_dli_COLPF3+1,x	tab_dli_COLPF3+1,x
				
				lda tab_screen_chars_lo,x
				add bonus1_col
				sta bns1 
				lda tab_screen_chars_hi,x
				adc #0
				sta bns1+1
				
				ldy #0  \ jsr clr_bit7_row				
				ldy #40 \ jsr clr_bit7_row
				
				pla
				tay				
				rts
.endp

clr_bit7_BONUS2	.proc
				tya
				pha

				ldx bonus2_row
				mva game_tab_dli_COLPF3+0,x tab_dli_COLPF3+0,x				; set color 3(bit7) on DLI
				mva game_tab_dli_COLPF3+1,x	tab_dli_COLPF3+1,x

				lda tab_screen_chars_lo,x
				add bonus2_col
				sta bns1 
				lda tab_screen_chars_hi,x
				adc #0
				sta bns1+1
				
				ldy #0  \ jsr clr_bit7_row				
				ldy #40 \ jsr clr_bit7_row
				
				pla
				tay				
				rts
.endp
   
; clr bit=7(5th color) on the screen			
clr_bit7_row .proc
				lda (bns1),y
				and #127	
				sta (bns1),y
				iny							
				lda (bns1),y
				and #127	
				sta (bns1),y
				iny				
     			lda (bns1),y
				and #127	
				sta (bns1),y
				iny
     			lda (bns1),y
				and #127	
				sta (bns1),y
				
				rts	
.endp
 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; plot 8x8 string on the last 2 rows
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
plot8x8_string .proc
				stx dst1
				sty dst1+1
				ldy #1
				lda (dst1),y
				tax
				ldy #0
				lda (dst1),y
				add tab_screen_chars_lo+24,x
				sta dst2
				lda #0
				adc tab_screen_chars_hi+24,x
				sta dst2+1
				adw dst1 #2
				jmp skip1

loop1			sta (dst2),y
				iny
skip1			lda (dst1),y
				cmp #$9b
				bne loop1
				
				rts
.endp
 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; replot all screen
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
replot_screen				
				lda $94
				and #1
				sta $94

				jsr replot_background		
				jsr plot_sprites

				lda message_shw1
				beq replot1
				        												     
				ldx message_addr_text1
				ldy message_addr_text1+1
				jsr plot8x8_string				
 				lda #color_message 
				sta tab_dli_COLPF0+18
				mva #0 message_shw1		 	
											
replot1			lda message_shw2
				beq replot2
				
				ldx message_addr_text2
				ldy message_addr_text2+1
				jsr plot8x8_string				
 				lda #color_message 
				sta tab_dli_COLPF0+19
				mva #0 message_shw2		 	
											
replot2			lda message_clr1
				beq replot3
			
				ldy #39
				mva #0 message_clr1
loop_re1		sta screen_chars1+24*40,y
				dey
				bpl loop_re1
				
replot3			lda message_clr2
				beq replot4
				
				ldy #39
				mva #0 message_clr2
loop_re2		sta screen_chars1+25*40,y
				dey
				bpl loop_re2				
				
replot4			LDA $99 											 ; game_over_timer
				beq replot5 
			
				lda #4											     ; Plot "GAME OVER" in buffor 1 & 2
				ldx #<txt_GAME_OVER
				ldy #>txt_GAME_OVER
				jsr plot_string2		
    			lda #color_game_over 
				sta tab_dli_COLPF3+9

replot5		    lda $20												 ; check is player 0 exploding?
		        bpl _plot0
		        
		        jsr max_left_player_one
		        jsr clear_PMG_player0
		        jmp skip_pmg0
		        
; set position X for PMG player0
_plot0	        ldx $94
				
				lda $10
				cmp old_player0_x,x
				beq skip_x1
				
				sta old_player0_x,x
				
		        asl @
		        sec
		        sbc #4
		        sta vbl_HPOSP0,x
		   ;     sta vbl_HPOSP1
		        clc
		        adc #8
		        sta vbl_HPOSM0,x
		    ;    sta vbl_HPOSM1
	
; set position Y for PMG player0
skip_x1			lda $18											   ; check is player 1 on the same y position?
				cmp old_player0_y,x
				beq skip_pmg0
				
				sta old_player0_y,x
				
				asl @
				asl @
				sub #6
		        tax
		        
				ldy #0
				
				lda $94
				bne loop_pmg11 
	     
loop_pmg1       mva PMG_player_shape0,y  PMG0+$0420,x
		        mva PMG_player_shape1,y  PMG0+$0520,x
		        
		        lda PMG0+$0320,x	
		        and #%11110000	        
		        ora PMG_missile_ORA0,y
		        sta PMG0+$0320,x
		        
		        inx
		        iny
		        cpy #len_PMG_player_shape0
		        bne loop_pmg1
		        beq skip_pmg0												; always branches!
		        
loop_pmg11      mva PMG_player_shape0,y  PMG1+$0420,x
		        mva PMG_player_shape1,y  PMG1+$0520,x
		        
		        lda PMG1+$0320,x	
		        and #%11110000	        
		        ora PMG_missile_ORA0,y
		        sta PMG1+$0320,x
		        
		        inx
		        iny
		        cpy #len_PMG_player_shape0
		        bne loop_pmg11		        
		        		      
skip_pmg0       lda $11												; check if player 1 is active?
		        bne *+5
		        jmp replot_end

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------

skip_pmg1		lda $21												; check is player 1 exploding?
		        bpl _plot1
		        
  	            jsr max_left_player_two
  	            jsr clear_PMG_player1
		        jmp replot_end
		        
; set position X for PMG player1
_plot1	    	ldx $94
				
				lda $11
				cmp old_player1_x,x
				beq skip_x2
				
				sta old_player1_x,x
				
		        asl @
		        sec
		        sbc #4
		        sta vbl_HPOSP2,x
		      ;  sta vbl_HPOSP3
		        clc
		        adc #8
		        sta vbl_HPOSM2,x
		      ;  sta vbl_HPOSM3		        
		       
; set position Y for PMG player1
skip_x2			lda $19											   ; check is player 2 on the same y position?
				cmp old_player1_y,x
				bne *+5
				jmp replot_end
				
				sta old_player1_y,x
				
				asl @
				asl @
				sub #6
		        tax
		
				ldy #0
				
				lda $94
				bne loop_pmg22
	       
loop_pmg2       mva PMG_player_shape0,y  PMG0+$0620,x
		        mva PMG_player_shape1,y  PMG0+$0720,x
		            
		        lda PMG0+$0320,x
		        and #%00001111	   
		        ora PMG_missile_ORA1,y
		        sta PMG0+$0320,x
		        
		        inx
		        iny
		        cpy #len_PMG_player_shape0
		        bne loop_pmg2
		        beq replot_end										; always branches!

loop_pmg22      mva PMG_player_shape0,y  PMG1+$0620,x
		        mva PMG_player_shape1,y  PMG1+$0720,x
		            
		        lda PMG1+$0320,x
		        and #%00001111	   
		        ora PMG_missile_ORA1,y
		        sta PMG1+$0320,x
		        
		        inx
		        iny
		        cpy #len_PMG_player_shape0
		        bne loop_pmg22

replot_end		;LDA $70 										   	 ; frame_counter
				;AND #$01

				lda $94
				bne use_buffer_two	
;use_buffer_one
				lda #>buff1_charset0
				ldx #$01
				ldy #>PMG0	
				bne set_screen_start_address                  	 	 ; Always branches				

use_buffer_two	lda #>buff2_charset0
				ldx #$00
				ldy #>PMG1

set_screen_start_address
				stx $94 											 ; buffer_to_use  		; Zero if buffer two, non-zero if buffer one
				sty vbl_pmbase
				sta buff_addr_hi

				mva #1 v_pending				
wait_vsync1		lda v_pending \ bne wait_vsync1	

; clear bit=7(5th color) on screen for BONUS 1 or 2				
				lda is_remove_bonus1
				beq _remove1
				
				jsr clr_bit7_BONUS1
				mva #0 is_remove_bonus1
				
_remove1		lda is_remove_bonus2
				beq _remove2
				
				jsr clr_bit7_BONUS2
				mva #0 is_remove_bonus2
							
_remove2		rts
				
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; player fires or changes the weapon 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
player_laser_offsets dta $00,$18

consider_firing_or_changing_weapon                                   ; Called with X = player
				BCC skip_firing
				jmp set_firing_intent
		
change_weapon  	jsr play_change_weapon_sound					  	 ; play SFX - change weapon 

				LDA #$00
				LDY player_laser_offsets,X
				STA $0042,Y 										 ; lasers_x             ; Set to zero to remove lasers
				STA $0046,Y 								 		 ; lasers_x + 4
				STA $004a,Y 										 ; lasers_x + 4 * 2
				STA $004e,Y 										 ; lasers_x + 4 * 3
				STA $0052,Y 										 ; lasers_x + 4 * 4
				STA $0056,Y 										 ; lasers_x + 4 * 5
				
				:4 INC $0e,X   										 ; players_selected_weapon
				
				LDA $c6,X   										 ; players_maximum_weapon
				ASL @
				ASL @
				ADC #$03
				CMP $0e,X 											 ; players_selected_weapon
				BPL skip_wraparound
		
				LDA #$00 											 ; WEAPON_STANDARD
				STA $0e,X 											 ; players_selected_weapon

skip_wraparound	bank_jsr replot_weapon_selector
				JMP set_firing

; player fires
set_firing_intent
				LDA #$01                                             ; Set to non-zero to indicate wanting to fire
				STA $04,X 											 ; players_firing_intent
				LDA #$00                                             ; Set to zero to suppress change of weapon
				STA $38,X 											 ; players_suppress_weapon_change
				BEQ leave_1                                          ; Always branches

; player do not fire
skip_firing
set_firing
				LDA #$01                                             ; Set to non-zero to allow change of weapon
				STA $38,X 											 ; players_suppress_weapon_change

leave_1			RTS

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; add enemy or group of enemies 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
add_enemy_or_group_of_enemies
				LDX #$05
				LDA $93 											; group_of_enemies_added ; Non-zero if the wave is a group of enemies (boss)
				BEQ add_enemy
  
add_group_of_enemies_loop
				TXA
				TAY
				LDA ($00),Y 										; wave_data_address           ; Get byte for enemy
				ASL @
				ASL @
				CLC
				ADC #$14 											; SPRITE_FIRST_ENEMY
				STA $73 											; enemy_sprite                ; Low six bits of enemy byte set enemy type
				TXA
				LDY #$07
				ADC ($00),Y                         		 		 ; Add group base to enemy offset
				TAY
				BEQ consider_adding_next_enemy_in_group      		 ; Don't add enemy if enemy is empty type

				LDA grouped_enemies_x_positions - 6,Y
				LDY $73 											 ; enemy_sprite
				JSR add_enemy_to_slot_X_at_x_position_A

consider_adding_next_enemy_in_group
				DEX
				BPL add_group_of_enemies_loop
				
				RTS

; add enemy 
add_enemy                                                       	; Called with Y = enemy type				
				LDX #$05

find_empty_enemy_slot_loop
				LDA $12,X 											; player_or_enemies_x + 2                  ; Zero if no enemy in slot
				BEQ add_enemy_to_slot			
				DEX
				BPL find_empty_enemy_slot_loop
				
				CLC                                             	; Leave with carry clear to indicate unable to add enemy
				RTS
				
use_low_bits
				LDA #$05
				BNE add_low_bits                             		; Always branches
				
add_enemy_to_slot
				LDA #$6a                                     		; Add enemy at right of screen
add_enemy_to_slot_X_at_x_position_A
				CPY #$00
				BEQ leave_with_carry_set                     		; Leave with carry set if enemy is empty type
				
				STA $12,X 									 		; player_or_enemies_x + 2
				STY $2a,X 									 		; players_or_enemies_type + 2
addr_sprite_sizes_and_data2					
				LDA sprite_sizes_and_data + 2,Y              		; Third byte of table sets y position of enemy
				BEQ use_low_bits                             		; If zero, use low bits of frame counter
				BPL consider_inversion                       		; If positive, use value as absolute position
				
use_high_and_low_bits
				LDA $70 									 		; frame_counter          ; If negative, use high and low bits of frame counter
				LSR @
				LSR @
				LSR @
				LSR @
				AND #$07
add_low_bits
				STA $74 											; tmp
				LDA $70 											; frame_counter
				AND #$0f
				ADC $74 											; tmp
				ADC #$04

consider_inversion
				BIT $92 											; current_wave_type   ; If top bit of wave type set, invert vertical position
				BPL set_enemy_y_1
				
				STA $73 											; tmp
				SEC
				LDA #$1e                                            ; Subtract from bottom of screen
				SBC $73 											; tmp

set_enemy_y_1	STA $1a,X 											; players_or_enemies_y + 2
addr_sprite_sizes_and_data3
				LDA sprite_sizes_and_data + 3,Y              		; Low seven bits of fourth byte set enemy energy
				AND #$7f
				STA $22,X 											; players_or_enemies_energy + 2
addr_sprite_sizes_and_data4
				LDA sprite_sizes_and_data,Y                  		; Low two bits of first byte set enemy height
				AND #$03
				CLC
				ADC #$01
				ASL @
				STA $3a,X 
addr_sprite_sizes_and_data5											; enemies_height
				LDA sprite_sizes_and_data,Y                  		; Next three lowest bits set type of enemy spawned
				AND #$1c
				STA $7c,X 											; enemies_spawn_type
				LDA #$00
				STA $32,X 											; players_or_enemies_timer + 2

;leave_with_carry_set
				SEC                                                 ; Leave with carry set to indicate enemy added
				RTS

leave_with_carry_set
				mva #3 waves_depending
				sec
				rts

shifted_horizon_addresses_high dta >horizon_0_sprite,>horizon_shifted_1_sprite,>horizon_shifted_2_sprite,>horizon_shifted_3_sprite

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; plot stitic background on buffor 1 (never changing)
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
plot_static_background_buff1 .proc
				bank_jsr static_clear_buffor1			
 				bank_jsr fast_clear_cont_buffor1
 				rts
.endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; plot stitic background on buffor 2 (never changing)
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
plot_static_background_buff2 .proc
				bank_jsr static_clear_buffor2	
 				bank_jsr fast_clear_cont_buffor2
 				rts
.endp
 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; plot background on screen buffor 1/2
; sky, stars, horizon, ground, movement markers
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
replot_background
 				lda $94 											; buffer_to_use  ; zero for buffer one, non-zero for buffer two
				beq plot_background_in_buffer_one

plot_background_in_buffer_two
				bank_jsr fast_clear_buffor2				
				bank_jsr plot_horizon_buff2	
				bank_jsr fast_clear_border_buffor2 	
				rts
											
plot_background_in_buffer_one
				bank_jsr fast_clear_buffor1			
				bank_jsr plot_horizon_buff1
			    bank_jsr fast_clear_border_buffor1 	
       			rts
                
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; play SFX effects
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------

; reg. X=0 - PLAYER ONE, X=1 - PLAYER TWO
play_change_weapon_sound
			 	mva #sfx_change_weapon sfx_effect
			   	mva #15 			   delay_change_weapon,x
			   	txa
			   	add #2
			   	sta                    sfx_channel
		   		rts	   		
		   		
play_start_rocket_sound
			 	mva #sfx_start_rocket  sfx_effect
			 	mva #0                 sfx_channel
				rts

play_flying_rocket_sound
			 	mva #sfx_flying_rocket sfx_effect
			 	mva #0                 sfx_channel
				rts

play_bounce_balls_sound
			 	mva #sfx_bounce_balls  sfx_effect
			 	mva #0                 sfx_channel
				rts

play_explosion_sound
			 	mva #sfx_explosion 	   sfx_effect
			 	mva #1                 sfx_channel
				rts

play_bonus_sound
			   	mva #sfx_bonus 		   sfx_effect
				mva #1         		   sfx_channel
		   		rts

play_bonus_extra_weapon_sound
			   	mva #sfx_new_weapon	   sfx_effect
				mva #1         		   sfx_channel
		   		rts

play_dead_player_sound
			   	mva #sfx_dead_player   sfx_effect
			   	mva #0                 sfx_channel
		   		rts	   		

; reg. Y=0 - PLAYER ONE, y=1 - PLAYER TWO
play_laser_sound
			   	mva #sfx_laser         sfx_effect
			   	tya
			   	add #2
			   	sta                    sfx_channel
		   		rts	   		

; reg. Y=0 - PLAYER ONE, y=1 - PLAYER TWO
play_torpedo_sound
			   	mva #sfx_torpedo       sfx_effect
			   	tya
			   	add #2
			   	sta                    sfx_channel
		   		rts	   		

level_waves_data_addresses_low_table
;         0   1   2   3   4   5   6   7
	dta $00,$24,$48,$6c,$90,$b4,$d8,$fc
	
; Weapons
; =======
;                               damage  turns between uses
; $00 standard laser                 2                   4
; $04 multidirectional laser         2                   4
; $08 antimatter torpedo            32                  20
; $0c smart bomb                     *                  20      (destroys up to one enemy per frame for ten frames)

weapon_damages
;         0   4   8   c
	dta $02,$04,$20,$28

weapon_cooldowns                        
;         0   4   8   c
	dta $04,$04,$14,$14

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; draw sprites (player or enemy) on screen buffor 1/2
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
plot_sprites	LDA #$07											; 8 sprites to plot, 1-2 player(s) and 6 enemies
				STA $75 											; sprite_to_update

plot_sprites_loop
				LDX $75 											; sprite_to_update
		
				JSR plot_player_or_enemy
				LDY $75 											; sprite_to_update
				BEQ is_player
				CPY #$01
				BNE not_player

is_player		JSR plot_player_weapon_and_consider_firing
										
not_player
				DEC $75 				    						; sprite_to_update
				BPL plot_sprites_loop
				
				RTS

;                       Y=0 player0   , Y=1 player1
first_laser_offsets dta         $00   ,         $18     			; first offset for lasers
last_laser_offsets	dta         $14   ,         $2c                 ; last offset for lasers

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; draw player weapon and shoots, Called with Y = player, 0 or 1
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
plot_player_weapon_and_consider_firing                  ; Called with Y = player
				LDA $20,Y 								; is player exploding?
				BPL *+3
				RTS				

; check if player behind the screen
				lda $10,y 							
				cmp #$1c                             
			    bpl plot_player_weapon2	
				cmp #$18
				bpl plot_player_weapon2	
				
				rts

plot_player_weapon2				
				TYA
				ADC #$11                                ; Use channels 1 and 2 for player one and two firing
				STA explosion_and_firing_sound  		;(channel)
				LDA #<mask_player_weapon_0_odd  		; $2e68 = mask_player_weapon_0_odd
				STA $06   								; mask_address_low
				LDA #>mask_player_weapon_0_odd  		; $2e 
				STA $07   								; mask_address_high
				LDA #>sprite_player_one_weapon_0_odd   	; $2e
				STA $09   								; sprite_address_high
				LDA #<sprite_player_one_weapon_0_odd    ; $48  ; $2e48 = sprite_player_one_weapon_0_odd
				CPY #$00
				BEQ not_player_two2
								
				LDA #<sprite_player_two_weapon_0_odd    ; $58  ; $2e58 = sprite_player_two_weapon_0_odd

not_player_two2
				STA $08 								; sprite_address_low
plot_player_weapon
				LDA $000e,Y 							; players_selected_weapon 
				LSR @									; *4
				LSR @
				STA $73 								; weapon
				CLC
				ADC $09 								; sprite_address_high
				STA $09 								; sprite_address_high
				LDA $73 								; weapon
				ADC $07 								; mask_address_high
				STA $07 								; mask_address_high
				
				LDA $0002,Y 							; players_firing_cooldown
				BEQ is_ready_to_fire
				
not_ready_to_fire
				LDA $06 								; mask_address_low
				ADC #$30                               	; Use inactive sprites if player is not ready to fire
				STA $06 								; mask_address_low
				LDA $08 								; sprite_address_low
				ADC #$30                               	; Add $30 to sprite and mask addresses if so
				STA $08 								; sprite_address_low

is_ready_to_fire
				LDA $0010,Y 						   	; players_or_enemies_x - position X of player 0 or 1, move 2 pixels (4 bits)
				AND #$01
				BNE is_odd1								; if position X is odd then skip
;is_even
				LDA $07 								; mask_address_high
				ADC #$04                               	; Add $400 to sprite and mask addresses for even x
				STA $07 								; mask_address_high
				LDA $09 								; sprite_address_high
				ADC #$04
				STA $09 								; sprite_address_high

; start calculate address on screen				
is_odd1			jsr calculate_weapon_screen_address
			
				lda $0010,y 							; players_or_enemies_x
;				sub #$1c
				and #$01
				beq is_even_x1
		
				adw $00 #4	
				
is_even_x1		lda $0018,y 							; players_or_enemies_y
				and #$01
				beq is_even2
				
;is_odd2
				LDA #6 ;$68
				bne set_screen_address_low2           	; Always branches
			
; plot all bytes of weapon
plot_player_weapon_group_loop
				clc										; set screen_address for next row
				lda $00 								; screen_address_low
				sty reg_Y
				ldy sprite_row
				adc tab_next_row313_lo+1,y
				sta $00 								; screen_address_low
				lda $01 								; screen_address_high
				adc tab_next_row313_hi+1,y
				ldy reg_Y
				sta $01 								; screen_address_high
				bne dex_then_to_plot_player_weapon_byte_loop ; Always branches

is_even2		LDA #2 ;$64

set_screen_address_low2	
				CLC
				ADC $00 								; screen_address_low
				STA $00 								; screen_address_low
				LDA $01 								; screen_address_high
				ADC #0 ;#$01
				STA $01 								; screen_address_high
			
				LDA $0010,Y 							; players_or_enemies_x - position X of player 0 or 1, move 2 pixels (4 bits)
				CMP #$1c-4                                ; If the player crosses the left of the screen,
				BPL skip_adjusting_weapon_screen_address
				
				CMP #$18-4
				BMI skip_plotting_player_weapon
				bpl set_tmp_y                      		; Always branches
  
skip_adjusting_weapon_screen_address
				CMP #$61+2+1
				BPL skip_plotting_player_weapon       	; Don't plot weapon if beyond right of screen

set_tmp_y		STY $73 								; tmp_y
								
				LDX #$07

; plot 8 bytes of weapon (one char)
plot_player_weapon_byte_loop
				LDY #$00
				LDA ($00),Y 							; screen_address
				AND ($06),Y 							; mask_address
				ORA ($08),Y 							; sprite_address
				STA ($00),Y 							; screen_address
				LDY #$08
				LDA ($00),Y 							; screen_address
				AND ($06),Y 							; mask_address
				ORA ($08),Y 							; sprite_address
				STA ($00),Y								; screen_address
				
				INC $06 								; mask_address_low
				INC $08 								; sprite_address_low

				LDA $00 								; screen_address_low
				AND #$07
				CMP #$07
				BEQ plot_player_weapon_group_loop
				
				INC $00 								; screen_address_low

dex_then_to_plot_player_weapon_byte_loop
				DEX
				BPL plot_player_weapon_byte_loop

				LDY $73 								; tmp_y
		
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; plot shoots of weapon
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
skip_plotting_player_weapon
				LDA $000e,Y 										; players_selected_weapon
				AND #$0c
				STA $73 											; weapon_type
				LSR @
				LSR @
				TAX
				LDA weapon_damages,X
				STA $9a 											; laser_damage
				LDA $0004,Y 										; players_firing_intent
				bne *+5
				jmp consider_changing_laser_damage
				
				LDA $70 											; frame_counter
				AND #$01                                            ; Players fire alternately
				STA $74 											; player_to_fire
				CPY $74 											; player_to_fire
				beq *+5
				jmp consider_changing_laser_damage
				
				LDA #$00
				STA $0004,Y 										; players_firing_intent        ; Set to zero to indicate not wanting to fire
				LDA $0002,Y 										; players_firing_cooldown
				beq *+5
				jmp consider_changing_laser_damage
			
				lda $20,y										
				bpl *+5
				jmp consider_changing_laser_damage					; is player exploding?
				
				lda $10,y
				cmp #$1c
				bpl *+5
				jmp consider_changing_laser_damage					; is player outside the screen? on the left margin
				
				LDA weapon_cooldowns,X
				STA $0002,Y 										; players_firing_cooldown		
				
				LDX first_laser_offsets,Y
				
				LDA $73 											; weapon_type
				BEQ add_standard_laser
				
				CMP #$04 											; WEAPON_MULTIDIRECTIONAL
				BNE consider_adding_torpedo
				
				JMP add_multidirectional_laser
				
consider_adding_torpedo
				CMP #$08 											; WEAPON_TORPEDO
				BNE activate_smart_bomb

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; add torpedo
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
add_torpedo
				LDA $42,X 											 	 ; lasers_x
				BEQ found_slot_for_torpedo                   			 ; Is the first laser slot empty?
				INX
				INX
				INX
				INX
				LDA $42,X 												 ; lasers_x
				BNE to_consider_changing_laser_damage1        			 ; If not, is the second laser slot empty?

found_slot_for_torpedo
				JSR add_laser
				
to_consider_changing_laser_damage1
				JMP consider_changing_laser_damage

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; active smart bomb
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
activate_smart_bomb	TYA
					TAX
					DEC $c6,X 											; players_maximum_weapon       ; Remove smart bomb
					LDA #$00 											; WEAPON_STANDARD
					STA $0e,X 											; players_selected_weapon      ; Set player using standard laser
			
					mva #$00 number_bombs,x								
					bank_jsr plot_number_bombs
					
					bank_jsr replot_weapon_selector                     ; Leaves with A = $ff
					lda #$ff
					STA $c5 											; smart_bomb_timer             ; Set to $ff to start smart bomb on next frame
					LDA #$ff
					STA $72 											; smart_bomb_or_boss_active    ; Set to negative to indicate smart bomb is active
					TXA
					TAY
					bank_jsr plot_weapon_slots
					rts
					
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; add standard laser
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
add_standard_laser
				CLC
				LDA #$05
				STA $79 												 ; count
				
find_slot_for_standard_laser
				LDA $42,X 												 ; lasers_x
				BEQ found_slot_for_standard_laser                    	 ; Is this slot empty?
				
				TXA
				ADC #$04                                             	 ; If not, move to next laser slot
				TAX
				DEC $79 												 ; count
				BPL find_slot_for_standard_laser
				BMI consider_changing_laser_damage
				
found_slot_for_standard_laser
				JSR add_laser

consider_changing_laser_damage
				LDA $9b 									 ; level_number
				CMP #$04
				BMI skip_changing_laser_damage               ; On levels 1 - 4, lasers do regular damage
				CMP #$07
				BEQ double_laser_damage                      ; On level 8, lasers do double damage
				BPL halve_laser_damage                       ; On level 9 onwards, lasers do half damage
				BIT $92 									 ; current_wave_type              ; On levels 5 - 7,
				BVC skip_changing_laser_damage               ; If $40 set, lasrs do double damage

double_laser_damage
				ASL $9a 									 ; laser_damage
				BNE skip_changing_laser_damage               ; Always branches

halve_laser_damage
				LSR $9a 									 ; laser_damage
				
skip_changing_laser_damage
		
				LDA first_laser_offsets,Y
				STA $73 									 ; first_laser
				
				LDX last_laser_offsets,Y
				
				LDA $000e,Y 								 ; players_selected_weapon
				AND #$0c
				
				BEQ plot_standard_lasers
				
				CMP #$04 								  	 ; WEAPON_MULTIDIRECTIONAL
				BNE consider_plotting_torpedo
					
				JMP plot_multidirectional_lasers
				
consider_plotting_torpedo
				CMP #$08 								 	 ; WEAPON_TORPEDO
				BNE plot_standard_lasers
				
				JMP plot_antimatter_torpedoes

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; plot standard laser on screen, player 0/1
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
plot_standard_lasers
				LDA $42,X 											; lasers_x
				BEQ consider_next_standard_laser
		
				jsr correct_laser_screen_address
			
				LDA #%01010101   									; $0f ; 1111
				LDY #$01
				STA ($00),Y 										; screen_address
				LDY #$09
				STA ($00),Y 										; screen_address
				
				adb $42,x #$04										; lasers_x
				CMP #$68
				BMI standard_laser_is_on_screen
		
				LDA #$00
				STA $42,X 											; lasers_x
				BEQ consider_next_standard_laser             		; Always branches

standard_laser_is_on_screen
				JSR check_for_collision_with_laser
				ADW $40,X #$10										; lasers_screen_offset_low/hi

consider_next_standard_laser
				DEX                                                 ; Move to previous slot
				DEX
				DEX
				DEX
				CPX $73 											; first_laser
				BPL plot_standard_lasers
				
				RTS

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; draw multidirectional laser
; on ATARI screen we have to correct the offset of laser from BBC Micro
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
correct_laser_screen_address .proc
				stx reg_x
				sty reg_y	
				LDA $43,X 											; lasers_y / 4
			    lsr @												; *4 /8 for calculate row
			    tay				    			
  
    			lda #0
   			    sta correct_pos1+1
   			    sta correct_pos2+1 
   			     				
   				LDA $43,X
   				and #$01
   				bne cont_2
   			    dey
   			    lda #4
   			    sta correct_pos1+1
   			    sta correct_pos2+1 
   			    
cont_2		    LDA $94 											 ; buffer_to_use     		; Zero for buffer one, non-zero for buffer two
				BEQ use_buffer_one

use_buffer_two  clc
				lda tab_address_buff2_lo,y
correct_pos1	adc #0
				sta $00
				lda tab_address_buff2_hi,y
				adc #0
				sta $01
				jmp cont_1

use_buffer_one	clc
				lda tab_address_buff1_lo,y
correct_pos2	adc #0
				sta $00
				lda tab_address_buff1_hi,y
				adc #0
				sta $01

cont_1			LDA $42,X 											; lasers_x / 2
		    	ora #$01
		        sub #24+5
		        asl @
			    asl @												; *2 /4	*8
			    bcc *+4
			    
			    inc $01
			    
			    add $00
			    sta $00 
			    lda $01
				adc #0
				sta $01
			
				ldx reg_x
				ldy reg_y
				
				rts		

.endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------

plot_multidirectional_lasers
				LDA $42,X 														; lasers_x
				BEQ consider_second_multidirectional_laser
					
				sbb $43,x #$02													; lasers_y = lasers_y+2
				CMP #$02+2
				BMI remove_first_multidirectional_laser
				
				adb $42,x #$02													; lasers_x = lasers_x+2
				CMP #$68+2
				BMI first_multidirectional_laser_is_on_screen

remove_first_multidirectional_laser		
				LDA #$00 	 													; lasers_x
				STA $42,X
				BEQ consider_second_multidirectional_laser   					; Always branches

; first LASER
first_multidirectional_laser_is_on_screen
				JSR check_for_collision_with_laser
				LDA $42,X 														; lasers_x
				BEQ consider_second_multidirectional_laser
					
				jsr correct_laser_screen_address
						
				LDA #%01010101 													; $0f ; 1111
				LDY #$01
				STA ($00),Y 													; screen_address
				INY
				STA ($00),Y 													; screen_address
				
				SBW $40,X #$0138	
			    
; second LASER				
consider_second_multidirectional_laser
				DEX                                                  			 ; Move to previous slot
				DEX
				DEX
				DEX
				LDA $42,X 														 ; lasers_x
				BEQ consider_third_multidirectional_laser
				
				jsr correct_laser_screen_address		
				
				LDA #%01010101 													 ; $0f ; 1111
				LDY #$01
				STA ($00),Y 													 ; screen_address
				INY
				STA ($00),Y 													 ; screen_address
				LDY #$09
				STA ($00),Y 													 ; screen_address
				INY
				STA ($00),Y 													 ; screen_address
				
				ADW $40,X #$10
				
	            ADB $42,X #$04													 ; lasers_x
				CMP #$68
				BMI second_multidirectional_laser_is_on_screen

; remove second multidirectional laser				
				LDA #$00
				STA $42,X 														 ; lasers_x
				BEQ consider_third_multidirectional_laser    					 ; Always branches
				
second_multidirectional_laser_is_on_screen
				JSR check_for_collision_with_laser
								
consider_third_multidirectional_laser
				DEX                                                  			  ; Move to previous slot
				DEX
				DEX
				DEX

				LDA $42,X 														  ; lasers_x
				BEQ consider_next_multidirectional_laser
				
				ADB $43,X #$02													  ; lasers_y		
				CMP #$22-2
				BPL remove_third_multidirectional_laser
				
				ADB $42,x #$02													  ; lasers_x
				CMP #$68+2
				BMI third_multidirectional_laser_is_on_screen
				
remove_third_multidirectional_laser
				LDA #$00
				STA $42,X 														  ; lasers_x
				BEQ consider_next_multidirectional_laser     					  ; Always branches

; third LASER				
third_multidirectional_laser_is_on_screen
				JSR check_for_collision_with_laser
			LDA $42,X 														; lasers_x
			BEQ consider_next_multidirectional_laser
							
				jsr correct_laser_screen_address
			    	
				LDA #%01010101 													  ;$0f ; 1111
				LDY #$00
				STA ($00),Y 													  ; screen_address
				INY
				STA ($00),Y 													  ; screen_address

				ADW $40,X #328	
				
consider_next_multidirectional_laser
				DEX                                                  			  ; Move to previous slot
				DEX
				DEX
				DEX

				CPX $73 														  ; first_laser
				BMI leave_3
				
;to_plot_multidirectional_lasers
				JMP plot_multidirectional_lasers

leave_3         RTS

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; check collisions every enemy(bonus) with laser 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
check_for_collision_with_laser
				STA $74 												; laser_x
				LDY #$05

check_for_collision_with_laser_loop                               		; For each enemy,
				LDA $0012,Y 											; player_or_enemies_x + 2
				CMP $74 												; laser_x            	; Has the enemy collided with the laser?
				bmi *+5
				jmp consider_next_enemy2
			
				add #$08
				CMP $74 												; laser_x
				bpl *+5
				jmp consider_next_enemy2
				
				LDA $001a,Y 											; player_or_enemies_y + 2
				CMP $43,X 
				bmi *+5													; lasers_y
				jmp consider_next_enemy2
				
				add $003a,Y 											; enemies_height
				CMP $43,X 												; lasers_y
				bpl *+5
				jmp consider_next_enemy2
			
				lda $2a,Y											    ; players_or_enemies_type + 2, Has the bonus collided with laser? If YES then don't explode the bonus 
				cmp #$20
				bne *+5
				jmp consider_next_enemy2								; BONUS_PLAYER_ONE
				
				cmp #$24
				bne *+5
				jmp consider_next_enemy2								; BONUS_PLAYER_TWO
			 
laser_collided_with_enemy	
				LDA #$00                                             	; If so, set to zero to remove laser
				STA $42,X 												; lasers_x
					
				LDA $0022,Y 											; players_or_enemies_energy + 2
				BMI leave_6                                    			; Leave if the enemy is already exploding
				
				CMP #$7f 												; ENERGY_INDESTRUCTIBLE
				BEQ leave_6                                    			; Leave if the enemy is indestructible
				
				SEC
				SBC $9a 												; laser_damage     ; Damage enemy
				STA $0022,Y 											; players_or_enemies_energy + 2
				BPL leave_6                                    			; Has the enemy been destroyed?
				
				LDA $72 												; smart_bomb_or_boss_active
				BEQ explode_enemy                            			; Zero if no boss or smart bomb active
				BMI leave_6                                    			; Negative if smart bomb active or boss exploding

consider_exploding_boss
				CPY #$05
				BEQ explode_enemy                            			; Only one part of boss counts towards boss damage
				LDA #$ff
				STA $72 												; smart_bomb_or_boss_active   ; Set to negative to indicate boss is exploding
				STA $c5 												; smart_bomb_timer            ; Set to $ff to start smart bomb on next frame

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; explosion of enemy, player 0/1 destroys
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
explode_enemy   LDA #$00                                             ; Add to player one's score
				STX $74 											 ; tmp_x
				CPX #$15
				BMI not_player_two1
				
explode_enemy_by_player_two
				LDA #$07                                             ; Add to player two's score

not_player_two1	STA $73 											 ; player_score_offset
				LDA #$ff                                             ; Set to negative to indicate enemy is exploding
				STA $0022,Y 										 ; players_or_enemies_energy + 2
				LDX $2a,Y 											 ; players_or_enemies_type + 2
addr_sprite_sizes_and_data6
				LDA sprite_sizes_and_data,X                  		 ; Top three bits of first byte set score
				LSR @
				LSR @
				LSR @
				LSR @
				LSR @
				TAY
				LDA score_for_destroying_enemy_digits,Y
				CLC
				ADC $73 											 ; player_score_offset
				TAX
				LDA score_for_destroying_enemy_values,Y
				JSR increase_score
				JSR play_explosion_sound                             ; Play sound for destroying enemy
				LDX $74 											 ; tmp_x

leave_6			RTS

consider_next_enemy2
				DEY
				BMI *+5
				JMP check_for_collision_with_laser_loop

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; calculate address of laser on screen
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
set_laser_screen_address .proc
				ADB $40,X #4*8 $00   		 ;$d8					; lasers_screen_offset_low
				
				LDA $94 											; buffer_to_use           ; Zero for buffer one, non-zero for buffer two
				BNE use_buffer_two

use_buffer_one	LDA #>buff1_charset0         ;$4e
				ADC $41,X 											; lasers_screen_offset_high
				STA $01 											; screen_address_high
				RTS

use_buffer_two  LDA #>buff2_charset0         ;$67
				ADC $41,X 											; lasers_screen_offset_high
				STA $01 											; screen_address_high
				RTS				
.endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; add multidirectional laser
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
add_multidirectional_laser
				LDA $42,X ; lasers_x                                 ; Find two consecutive empty slots
				ORA $46,X ; lasers_x + 4
				ORA $4A,X ; lasers_x + 8
				BEQ found_slots_for_multidirectional_laser
				
				TXA
				CLC
				ADC #$08-4
				TAX
				LDA $42,X ; lasers_x
				ORA $46,X ; lasers_x + 4
				ORA $4A,X ; lasers_x + 8
				BEQ found_slots_for_multidirectional_laser
				
				TXA
				CLC
				ADC #$08-4
				TAX
				LDA $42,X ; lasers_x
				ORA $46,X ; lasers_x + 4
				ORA $4A,X ; lasers_x + 8
				BEQ found_slots_for_multidirectional_laser

				TXA
				CLC
				ADC #$08-4
				TAX
				LDA $42,X ; lasers_x
				ORA $46,X ; lasers_x + 4
				ORA $4A,X ; lasers_x + 8
				BNE to_consider_changing_laser_damage2

found_slots_for_multidirectional_laser
				JSR add_laser                                ; Add laser to first slot
				TXA
				CLC
				ADC #$04
				TAX
				JSR add_laser                                ; Add laser to second slot
				TXA
				CLC
				ADC #$04
				TAX
				JSR add_laser                                ; Add laser to third slot

to_consider_changing_laser_damage2
				JMP consider_changing_laser_damage

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; animated torpedoes
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
plot_antimatter_torpedoes
				LDA $42,X 											; lasers_x
				BEQ consider_next_antimatter_torpedo
				
				CLC
				LDA $40,X 											; lasers_screen_offset_low
				ADC #$08
				STA $40,X 											; lasers_screen_offset_low
				BCC skip_page6
				INC $41,X 											; lasers_screen_offset_high
skip_page6
				LDA $42,X 											; lasers_x
				CLC
				ADC #$02
				STA $42,X 											; lasers_x
				CMP #$66
				BMI antimatter_torpedo_is_on_screen
				
				LDA #$00                                            ; Set to zero to remove torpedo
				STA $42,X 											; lasers_x
				BEQ consider_next_antimatter_torpedo         		; Always branches

antimatter_torpedo_is_on_screen
				JSR check_for_collision_with_laser
				
				JSR set_laser_screen_address
								
				LDA #%01010101 										;$0f ; 1111
				LDY #$00
				STA ($00),Y 										; screen_address
				INY
				STA ($00),Y 										; screen_address
				INY
				STA ($00),Y 										; screen_address
				INY
				STA ($00),Y 										; screen_address
				LDY #$09
				STA ($00),Y 										; screen_address
				INY
				STA ($00),Y 										; screen_address
				
consider_next_antimatter_torpedo
				DEX                                                 ; Move to previous slot
				DEX
				DEX
				DEX
				CPX $73 											; first_laser_offset
				BPL plot_antimatter_torpedoes
				RTS

remove_explosion
				LDA #$00                                            ; Set to zero to remove explosion
				STA $10,X 											; players_or_enemies_x
				
leave_5			rts

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; plot explosion on screen
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
explosion_sprites       dta $00,$00,$00,$00,$00,$00,$28,$24,$20,$1c,$18,$14,$14,$10,$0c,$08
is_explosion		 	dta $00

plot_explosion	
; set address of sprite_sizes_and_data2 
				lda #>sprite_sizes_and_data2				
				sta addr_sprite_sizes_and_data1+2
				sta addr_sprite_sizes_and_data2+2
				sta addr_sprite_sizes_and_data3+2
				sta addr_sprite_sizes_and_data4+2
				sta addr_sprite_sizes_and_data5+2
				sta addr_sprite_sizes_and_data6+2
				sta addr_sprite_sizes_and_data7+2
				sta addr_sprite_sizes_and_data8+2
				sta addr_sprite_sizes_and_data9+2

; set address of sprite_and_mask_addresses2 	
				lda #>sprite_and_mask_addresses2				
				sta addr_sprite_and_mask_addresses1+2
				sta addr_sprite_and_mask_addresses2+2
				sta addr_sprite_and_mask_addresses3+2
				sta addr_sprite_and_mask_addresses4+2
				
				lda $20,x 											; players_or_enemies_energy
				and #$0f  ;$07
			;	lsr @
				tay
				lda explosion_sprites,y
				tay
				
				//LDX $75 											; sprite_to_update
				mva #1 is_explosion

				JSR plot_sprite_Y		
				
				mva #0 is_explosion
				
				LDX $75 											; sprite_to_update
				DEC $20,X 											; players_or_enemies_energy
		
				LDA $20,X 											; players_or_enemies_energy
				CMP #$f8-2
				bpl leave_4
				
				mva #2 tab_remove_explosion,x						; active remove 5th color because the explosion is finished
						
				CPX #$00
				BNE not_player_one

remove_player_one		
				jsr clear_PMG_player0
			    mva #0 old_player0_y
			    sta    old_player0_y+1
			
				LDA #$0f
				LDX #$00
				STX $10   											; players_or_enemies_x

remove_player	STA $18,X 											; players_or_enemies_y
				STA $20,X 											; players_or_enemies_energy
				
				LDA #$a0                                            ; Set to negative to set player moving onto screen
				STA $30,X 											; players_or_enemies_timer
				
leave_4			rts

;---------------------------------------------------------------------------------------------------------------------------------------------------
not_player_one  CPX #$01
                beq *+5
                jmp remove_explosion

remove_player_two
			    jsr clear_PMG_player1
			    mva #0 old_player1_y
			    sta    old_player1_y+1
			    
                LDA #$0a
                STA $11 											 ; players_or_enemies_x + 1
                LDX #$01
                BNE remove_player                                    ; Always branches

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; plot player or enemy
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
plot_player_or_enemy

; check if we need to remove 5th color from the explosion frame
				lda tab_remove_explosion,x
				beq plot_player_or_enemy2
				dec tab_remove_explosion,x		
				cmp #1
				beq plot_player_or_enemy1
				bne plot_player_or_enemy2							; always branches!
 
; remove 5th color from explosion frame								
plot_player_or_enemy1		
				mva tab_addr_explosion_lo,x	exp1					; address of explosion
			 	mva tab_addr_explosion_hi,x	exp1+1					; address of explosion
			    ldy #0  \ jsr clr_bit7_row_exp			
				ldy #40 \ jsr clr_bit7_row_exp
				ldy #80 \ jsr clr_bit7_row_exp				
   
plot_player_or_enemy2
				lda $10,x 											; players_or_enemies_x
				bne *+3
				rts
				
; set address of sprite_sizes_and_data 
				lda #>sprite_sizes_and_data				
				sta addr_sprite_sizes_and_data1+2
				sta addr_sprite_sizes_and_data2+2
				sta addr_sprite_sizes_and_data3+2
				sta addr_sprite_sizes_and_data4+2
				sta addr_sprite_sizes_and_data5+2
				sta addr_sprite_sizes_and_data6+2
				sta addr_sprite_sizes_and_data7+2
				sta addr_sprite_sizes_and_data8+2
				sta addr_sprite_sizes_and_data9+2				

; set address of sprite_and_mask_addresses 	
				lda #>sprite_and_mask_addresses				
				sta addr_sprite_and_mask_addresses1+2
				sta addr_sprite_and_mask_addresses2+2
				sta addr_sprite_and_mask_addresses3+2
				sta addr_sprite_and_mask_addresses4+2
				
				lda #$00											; pass pixels of position X to clip sprite on maximum left
				sta left_clip1
				sta right_clip1
							
				LDA $18,X 											; players_or_enemies_y        ; multiply * 40 but align to 8  etc.  56=56, 60=56, 64=64
		    	AND #$fe
				STA $73 											; tmp                                     
				ASL @
				ASL @
				ADC $73 											; tmp
				ASL @
				STA $00 											; screen_address_low
				LDA #$00
				ROL @
				ASL $00 											; screen_address_low
				ROL @
				ASL $00 											; screen_address_low
				ROL @
				STA $01 											; screen_address_high
				
				LDA $10,X 											; players_or_enemies_x		; multiply * 4 but align to 4
				AND #$fe
				STA $74 											; x_column
				CMP #$1c
				BPL skip_floor
			
				LDA #$1c

skip_floor		CLC
				ADC $00 											; screen_address_low
				BCC skip_page
				
				INC $01 											; screen_address_high
				
skip_page		ASL @
				ROL $01 											; screen_address_high
				ASL @
				STA $00 											; screen_address_low
				STA $0c 											; player_screen_offset_low
				LDA $01 											; screen_address_high
				ROL @
				STA $01 											; screen_address_high
				STA $0d 											; player_screen_offset_high
	
				sbw $00 #13*8 
				mwa $00 $0c
			
				LDA $20,X 											; players_or_enemies_energy      ; Negative if player or enemy is exploding
				BPL plot_sprite_Y0
		
				lda $10,x											; if explosion the align X 
				and #$fe
				sta $10,x
				lda $18,x											; if explosion the align Y 
				and #$fe
				sta $18,x
				jmp plot_explosion
			
plot_sprite_Y0	LDY $28,X 											; players_or_enemies_type
				jmp plot_explosion3

; add 5th color for exploding frame	
plot_sprite_Y	lda is_explosion
				bne *+5
				jmp plot_explosion3

					
				stx reg_xx
				sty reg_yy
				
plot_explosion0	ldx $75 											; sprite_to_update
				lda $18,x											; players_or_enemies_y
	        	lsr @
	        	tay
	        	
	        	lda $99 											; game_over_timer
	        	bne plot_exp3										; if game over don't set 5th color!
	        	        	
	        	lda #color_explosion	        	
	        	
	        	lda bonus_tab_dli_COLPF3+0,y
	        	cmp #color_bonus1
	        	beq plot_exp1
	        	cmp #color_bonus2
	        	beq plot_exp1
	        	
	        	sta	tab_dli_COLPF3+0,y
	        	sta bonus_tab_dli_COLPF3+0,y
				
plot_exp1		lda bonus_tab_dli_COLPF3+1,y
	        	cmp #color_bonus1
	        	beq plot_exp2
	        	cmp #color_bonus2
	        	beq plot_exp2

				sta tab_dli_COLPF3+1,y
				sta bonus_tab_dli_COLPF3+1,y
				
plot_exp2		lda bonus_tab_dli_COLPF3+1,y
	        	cmp #color_bonus1
	        	beq plot_exp3
	        	cmp #color_bonus2
	        	beq plot_exp3

           		sta tab_dli_COLPF3+2,y
				sta bonus_tab_dli_COLPF3+2,y
		        
plot_exp3       mva tab_screen_chars_lo,y   exp1 
                mva tab_screen_chars_hi,y   exp1+1		
				
				lda $10,x 											; players_or_enemies_x
				sub #26
				lsr @												; current x column	
				add exp1
				sta exp1
				sta tab_addr_explosion_lo,x							; save for later LOW ADDRESS of explosion
				lda exp1+1
				adc #0
				sta exp1+1
				sta tab_addr_explosion_hi,x							; save for later HIGH ADDRESS of explosion
			
				cpy #13-1										  	; is row = 13+1?
				beq exp_skip1 
				bpl plot_explosion2
	            cpy #12-1											; is row = 12+1?
	            beq exp_skip0
			
				ldy #80 \ jsr set_bit7_row_exp
exp_skip0		ldy #40 \ jsr set_bit7_row_exp
exp_skip1	    ldy #0  \ jsr set_bit7_row_exp			
 
plot_explosion2	ldx reg_xx
				ldy reg_yy

plot_explosion3	
addr_sprite_and_mask_addresses1
				LDA sprite_and_mask_addresses + 1,Y
				STA $09 											; sprite_address_high
addr_sprite_and_mask_addresses2
				LDA sprite_and_mask_addresses,Y
				STA $08 											; sprite_address_low
addr_sprite_and_mask_addresses3
				LDA sprite_and_mask_addresses + 3,Y
				STA $07 											; mask_address_high
addr_sprite_and_mask_addresses4
				LDA sprite_and_mask_addresses + 2,Y
				STA $06 											; mask_address_low
addr_sprite_sizes_and_data7
				LDA sprite_sizes_and_data + 1,Y
				STA sprite_width_in_bytes_aligned+1
				STA plot_sprite_aligned_player.sprite_width_in_bytes_aligned+1
				STA sprite_width_in_bytes_unaligned+1
				STA plot_sprite_unaligned_player.sprite_width_in_bytes_unaligned+1
				CLC
				ADC #$01
				LSR @
				LSR @
				STA $c0 											; sprite_width
addr_sprite_sizes_and_data8
				LDA sprite_sizes_and_data,Y                  	  	; Low two bits of first byte are height
				AND #$03
				STA sprite_height_in_groups+1     	
				
				LDA $10,X 											; players_or_enemies_x
				CMP #$68
				bmi *+3
				rts                                                 ; Leave if sprite starts beyond right of screen
				
				CLC
				ADC $c0 											; sprite_width
				CMP #$6a                                            ; Does the sprite cross the right of the screen?
				BMI skip_clipping_to_right
				
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; sprite ENEMY on maximum right position should be clipped
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------			
				lda #$68+2
				cpx #0
				beq plot_clip_right1								; is player 0?
				cpx #1 
			    beq plot_clip_right1								; is player 1?
				
				lda #$68 											; 104 for enemy	
								
plot_clip_right1				
				sec
				SBC $74 											; x_column
				sta right_clip1
				ASL @
				ASL @
				SEC
				SBC #$01
				STA sprite_width_in_bytes_unaligned+1
				STA plot_sprite_unaligned_player.sprite_width_in_bytes_unaligned+1
				STA sprite_width_in_bytes_aligned+1
				STA plot_sprite_aligned_player.sprite_width_in_bytes_aligned+1
				jmp plot_full_sprite                         		; Always branches

skip_clipping_to_right

				mva #$18 margin_x1
				mva #$1c margin_x2

				cpx #2												; test if 0-1 the player 1-2
				bpl skip_clipping_to_right2

				mva #$18-2 margin_x1
				mva #$1c-2 margin_x2
				
skip_clipping_to_right2							
				lda $0010,x 										; players_or_enemies_x - position X of player 0 or 1, move 2 pixels (4 bits)
				cmp margin_x2                            			; If the player crosses the left of the screen,
				bmi *+5
				jmp plot_full_sprite
   
; check is BONUS on the left (behind the screen)
				lda $28,x 											; players_or_enemies_type ;+ 2
				cmp #$20											; BONUS_PLAYER_ONE
				beq _clr_bonus1
				cmp #$24											; BONUS_PLAYER_TWO
				beq _clr_bonus2	
				bne _clr_bonus_con1									; always branches!

_clr_bonus1		bank_jsr clr_bit7_left_margin						; clear 5th color on left
				lda #0												; clear bonus
				sta $10,x
				sta active_bonus1
				sta is_active_bonus1
				inc index_tab_bonus_player1	
				rts
		
_clr_bonus2		bank_jsr clr_bit7_left_margin						; clear 5th color on left	
				lda #0												; clear bonus
				sta $10,x
				sta active_bonus2
				sta is_active_bonus2
				inc index_tab_bonus_player2	
				rts
		
_clr_bonus_con1	lda $10,x 											; players_or_enemies_x - position X of player 0 or 1, move 2 pixels (4 bits)
				cmp margin_x1
				bpl plot_sprite_clipped_to_left
				rts                                                 ; Leave if sprite ends before left of screen
				
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; sprite PLAYER on maximum left position should be clipped
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
plot_sprite_clipped_to_left
				lda margin_x2											
				sec
				SBC $74 											; x_column
				sta left_clip1
               	ASL @												; *4/*8
				ASL @
				STA $73 											; columns_to_skip

				add $08 											; sprite_address_low
				STA $08 											; sprite_address_low
				LDA $73 											; columns_to_skip
				ADC $06 											; mask_address_low
				STA $06 											; mask_address_low
			
				sec

addr_sprite_sizes_and_data9
				LDA sprite_sizes_and_data + 1,Y
				SBC $73 											; columns_to_skip
				STA sprite_width_in_bytes_aligned+1
				STA plot_sprite_aligned_player.sprite_width_in_bytes_aligned+1
				STA sprite_width_in_bytes_unaligned+1
				STA plot_sprite_unaligned_player.sprite_width_in_bytes_unaligned+1
				
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; draw sprite on screen buff 1/2
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
plot_full_sprite
				LDA $10,X 											; players_or_enemies_x
				sub #26
				lsr @
				sta sprite_col										; current x column

				lda $10,x
				AND #$01
				BEQ is_even3
;is_odd3
				CLC
				LDA $07 											; mask_address_high
				ADC #$04                                            ; Add $400 to sprite and mask addresses for odd x
				STA $07 											; mask_address_high
				LDA $09 											; sprite_address_high
				ADC #$04
				STA $09 											; sprite_address_high
				
is_even3		lda $18,x											; players_or_enemies_y
	        	lsr @
	        	sta sprite_row
				tay

				mva tab_offset_buff_lo+1,y lo_offset_row1			; offset screen		 
				mva tab_offset_buff_hi+1,y hi_offset_row1
				mva tab_offset_buff_lo+2,y lo_offset_row2			; offset screen		 
				mva tab_offset_buff_hi+2,y hi_offset_row2
				
				LDA #>buff1_charset0    
				
				LDY $94 											; buffer_to_use       ; Zero for buffer one, non-zero for buffer two
				BEQ use_buffer_one

				LDA #>buff2_charset0   								; use_buffer_two 

use_buffer_one	ADD $01 											; screen_address_high
				STA $01 											; screen_address_high		
	
				cpx #2												; if player 1 or 2?
				bmi plot_player_or_enemy3
				
				lda $10,x											; player 1/2 behind the screen? (on the left)
				cmp #$1c                           			
				bpl plot_player_or_enemy3
				cmp #$18+2
				bpl plot_player_or_enemy3
				rts
					
plot_player_or_enemy3						
				lda $18,x 											; players_or_enemies_y
		
sprite_height_in_groups
				LDX #$00
;     actually LDX sprite_height_in_groups
				CPX #$02
				BMI skip_clipping_to_bottom
				
				CMP #$19
				BMI skip_clipping_to_bottom
				BEQ skip_one_group
				
				CMP #$1b
				BMI skip_one_group			
	
skip_two_groups	DEX

skip_one_group	DEX
				
skip_clipping_to_bottom
				AND #$01
				BEQ *+5
				JMP plot_sprite_unaligned

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------								
				mwa $00 save_00
				jsr calculate_screen_address_SPRITE
				
				LDA $75 												; sprite_to_update
				cmp #1+1												; is plot player 0 or 1?
				bcs plot_sprite_aligned_group_loop0
				jmp plot_sprite_aligned_player							; yes so jump to faster version of plot
								
plot_sprite_aligned_group_loop0				 
				ldy $75
				lda $28,y 												; players_or_enemies_type ;+ 2
				cmp #$20												; BONUS_PLAYER_ONE
				beq _skip1
				cmp #$24												; BONUS_PLAYER_TWO
				beq _skip2
				bne plot_sprite_aligned_group_loop
			
_skip1			mva #1 is_bit7_BONUS1
				mva sprite_row bonus1_row
				mva sprite_col bonus1_col
				jmp plot_sprite_aligned_group_loop
		
_skip2  		mva #1 is_bit7_BONUS2
				mva sprite_row bonus2_row
				mva sprite_col bonus2_col

plot_sprite_aligned_group_loop
sprite_width_in_bytes_aligned			
				LDY #$00
;     actually LDY sprite_width_in_bytes_aligned

plot_sprite_aligned_byte_loop
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				ORA ($08),Y 										; sprite_address	
				STA ($00),Y 										; screen_address
				DEY
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				ORA ($08),Y 										; sprite_address	
				STA ($00),Y 										; screen_address
				DEY
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				ORA ($08),Y 										; sprite_address	
				STA ($00),Y 										; screen_address
				DEY
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				ORA ($08),Y 										; sprite_address	
				STA ($00),Y 										; screen_address
				DEY
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				ORA ($08),Y 										; sprite_address	
				STA ($00),Y 										; screen_address
				DEY
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				ORA ($08),Y 										; sprite_address	
				STA ($00),Y 										; screen_address
				DEY
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				ORA ($08),Y 										; sprite_address	
				STA ($00),Y 										; screen_address
				DEY
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				ORA ($08),Y 										; sprite_address	
				STA ($00),Y 										; screen_address
				DEY
				BPL plot_sprite_aligned_byte_loop
				
				INC $09 											; sprite_address_high
				INC $07 											; mask_address_high
 
				ldy sprite_row										; Move down a group
				lda $00
		    	add tab_next_row320_lo,y
	        	sta $00
	        	lda $01
	        	adc tab_next_row320_hi,y
				sta $01
	
				inc sprite_row
									
				DEX
				BPL plot_sprite_aligned_group_loop
				
				RTS

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------				
; only for player 0 and 1 (not for enemy), fast drawing version
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------				
plot_sprite_aligned_player .proc
				lda is_explosion		
				beq *+5
				jmp plot_sprite_aligned_group_loop
		
				mwa #fast_plot_aligned_player_and plot_sprite_aligned_byte_loop+1	

_plot_sprite_aligned_group_loop
sprite_width_in_bytes_aligned
				LDY #$00
;     actually LDY sprite_width_in_bytes_aligned

plot_sprite_aligned_byte_loop
				jmp $ffff
				BPL plot_sprite_aligned_byte_loop
				
				INC $09 											; sprite_address_high
				INC $07 											; mask_address_high

				ldy sprite_row										; Move down a group
				lda $00
		    	add tab_next_row320_lo,y
	        	sta $00
	        	lda $01
	        	adc tab_next_row320_hi,y
				sta $01
	
	     		inc sprite_row 				
 
				lda #<fast_plot_aligned_player_and
				
				cpx #3
				bne *+4
				lda #<fast_plot_aligned_player_and_ora

    			sta plot_sprite_aligned_byte_loop+1

			    DEX
				BPL _plot_sprite_aligned_group_loop
				
				RTS

 	.align $0100
	
fast_plot_aligned_player_and
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				STA ($00),Y 										; screen_address
				DEY	
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				STA ($00),Y 										; screen_address
				DEY	
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				STA ($00),Y 										; screen_address
				DEY	
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				STA ($00),Y 										; screen_address
				DEY	
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				STA ($00),Y 										; screen_address
				DEY	
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				STA ($00),Y 										; screen_address
				DEY	
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				STA ($00),Y 										; screen_address
				DEY	
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				STA ($00),Y 										; screen_address
				DEY	
				JMP plot_sprite_aligned_byte_loop+3

fast_plot_aligned_player_and_ora
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				ORA ($08),Y 										; sprite_address	
				STA ($00),Y 										; screen_address
				DEY	
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				ORA ($08),Y 										; sprite_address	
				STA ($00),Y 										; screen_address
				DEY	
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				ORA ($08),Y 										; sprite_address	
				STA ($00),Y 										; screen_address
				DEY	
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				ORA ($08),Y 										; sprite_address	
				STA ($00),Y 										; screen_address
				DEY	
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				ORA ($08),Y 										; sprite_address	
				STA ($00),Y 										; screen_address
				DEY	
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				ORA ($08),Y 										; sprite_address	
				STA ($00),Y 										; screen_address
				DEY	
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				ORA ($08),Y 										; sprite_address	
				STA ($00),Y 										; screen_address
				DEY	
				LDA ($00),Y 										; screen_address
				AND ($06),Y 										; mask_address
				ORA ($08),Y 										; sprite_address	
				STA ($00),Y 										; screen_address
				DEY	
				JMP plot_sprite_aligned_byte_loop+3
.endp
				
plot_sprite_unaligned
				ADW $00 #$04 save_00								    ; screen_address				; +4 lines			
				jsr calculate_screen_address_SPRITE
				ADW $00 #$04 									 		; screen_address				; +4 lines 

				ldy $75
				lda $28,y 												; players_or_enemies_type ;+ 2
				cmp #$20												; BONUS_PLAYER_ONE
				beq _skip11
				cmp #$24												; BONUS_PLAYER_TWO
				beq _skip22
				bne _skip33
			
_skip11			mva #1 is_bit7_BONUS1
				mva sprite_row bonus1_row
				mva sprite_col bonus1_col
				jmp _skip33	
		
_skip22 		mva #1 is_bit7_BONUS2
				mva sprite_row bonus2_row
				mva sprite_col bonus2_col

		
_skip33		    ldy sprite_row											; next 4 lines, next row. +312 bytes
				dey
				
				LDA $75 												; sprite_to_update
				cmp #1+1												; is plot player 0 or 1?
				bcs plot_sprite_unaligned_group_loop
				jmp plot_sprite_unaligned_player						; yes so jump to faster version of plot
					
plot_sprite_unaligned_group_loop
				lda $00
		    	add tab_next_row312_lo+1,y
	        	sta $0a
	        	lda $01
	        	adc tab_next_row312_hi+1,y
				sta $0b			
		
				LDY #$00
plot_sprite_unaligned_byte_loop
				LDA ($00),Y ; screen_address                         	; Plot four bytes in top group
				AND ($06),Y ; mask_address
				ORA ($08),Y ; sprite_address
				STA ($00),Y ; screen_address
				INY
				LDA ($00),Y ; screen_address
				AND ($06),Y ; mask_address
				ORA ($08),Y ; sprite_address
				STA ($00),Y ; screen_address
				INY
				LDA ($00),Y ; screen_address
				AND ($06),Y ; mask_address
				ORA ($08),Y ; sprite_address
				STA ($00),Y ; screen_address
				INY
				LDA ($00),Y ; screen_address
				AND ($06),Y ; mask_address
				ORA ($08),Y ; sprite_address
				STA ($00),Y ; screen_address
				INY
				LDA ($0a),Y ; lower_screen_address                   	; Plot four bytes in bottom group
				AND ($06),Y ; mask_address
				ORA ($08),Y ; sprite_address
				STA ($0a),Y ; lower_screen_address
				INY
				LDA ($0a),Y ; lower_screen_address
				AND ($06),Y ; mask_address
				ORA ($08),Y ; sprite_address
				STA ($0a),Y ; lower_screen_address
				INY
				LDA ($0a),Y ; lower_screen_address
				AND ($06),Y ; mask_address
				ORA ($08),Y ; sprite_address
				STA ($0a),Y ; lower_screen_address
				INY
				LDA ($0a),Y ; lower_screen_address
				AND ($06),Y ; mask_address
				ORA ($08),Y ; sprite_address
				STA ($0a),Y ; lower_screen_address
				INY
	
sprite_width_in_bytes_unaligned				
				CPY #$00
;     actually CPY sprite_width_in_bytes_unaligned
				BMI plot_sprite_unaligned_byte_loop
				
				INC $09 													; sprite_address_high
				INC $07 													; mask_adress_high
											
				ldy sprite_row												; Move down a group
				
				lda $00
		    	add tab_next_row320_lo,y
	        	sta $00
	        	lda $01
	        	adc tab_next_row320_hi,y
				sta $01

	     		inc sprite_row 				
				
				DEX
				BMI *+5
				JMP plot_sprite_unaligned_group_loop

				RTS

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------				
; calculate screen address for SPRITE (ATARI)
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------				
calculate_screen_address_SPRITE .proc
				sty reg_y
				
		;		ldy sprite_row
				ldy $75													; sprite_to_update
				lda $18,y												; players_or_enemies_y
				lsr @
				tay
								
				LDA $94 												; buffer_to_use     ; Zero for buffer one, non-zero for buffer two
				BEQ use_buffer_one3
				
				mva tab_address_buff2_lo,y $00
				mva tab_address_buff2_hi,y $01
				jmp _skip1

use_buffer_one3	mva tab_address_buff1_lo,y $00
				mva tab_address_buff1_hi,y $01

_skip1			ldy $75													; sprite_to_update
				lda $10,y												; players_or_enemies_x
		  		add left_clip1  			    	
		    	lsr @                      								; / 2		    	
		    	sec
		    	sbc #13	    
		    	asl @					   								; * 8
		    	asl @
		    	asl @		    
		    	bcc skip_plot_sprite1
		    
		    	inc $01

skip_plot_sprite1		   	    
				add $00          
		    	sta $00	
				lda $01
				adc #0
				sta $01
				
				ldy reg_y
				rts

.endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------				
; only for player 0 and 1 (not for enemy), fast drawing version
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------				
plot_sprite_unaligned_player .proc
				lda is_explosion		
				beq *+5
				jmp plot_sprite_unaligned_group_loop
				
				mwa #fast_plot_unaligned_player_and plot_sprite_unaligned_byte_loop+1	

_plot_sprite_unaligned_group_loop
				lda $00
		    	add tab_next_row312_lo+1,y
	        	sta $0a
	        	lda $01
	        	adc tab_next_row312_hi+1,y
				sta $0b			
		
				LDY #$00

plot_sprite_unaligned_byte_loop
				jmp $ffff
								
sprite_width_in_bytes_unaligned				
				CPY #$00
;     actually CPY sprite_width_in_bytes_unaligned
				BMI plot_sprite_unaligned_byte_loop
				
				INC $09 									; sprite_address_high
				INC $07 									; mask_adress_high
											
				ldy sprite_row								; Move down a group
				
				lda $00
		    	add tab_next_row320_lo,y
	        	sta $00
	        	lda $01
	        	adc tab_next_row320_hi,y
				sta $01

	     		inc sprite_row 				
	     							
				lda #<fast_plot_unaligned_player_and
				
				cpx #3
				bne *+4
				lda #<fast_plot_unaligned_player_and_ora

    			sta plot_sprite_unaligned_byte_loop+1
    							
				DEX
				BMI *+5
				JMP _plot_sprite_unaligned_group_loop

				RTS

		.align $0100
		
fast_plot_unaligned_player_and 
				LDA ($00),Y ; screen_address                         ; Plot four bytes in top group
				AND ($06),Y ; mask_address
				STA ($00),Y ; screen_address
				INY
				LDA ($00),Y ; screen_address
				AND ($06),Y ; mask_address
				STA ($00),Y ; screen_address
				INY
				LDA ($00),Y ; screen_address
				AND ($06),Y ; mask_address
				STA ($00),Y ; screen_address
				INY
				LDA ($00),Y ; screen_address
				AND ($06),Y ; mask_address
				STA ($00),Y ; screen_address
				INY
				LDA ($0a),Y ; lower_screen_address                   ; Plot four bytes in bottom group
				AND ($06),Y ; mask_address
				STA ($0a),Y ; lower_screen_address
				INY
				LDA ($0a),Y ; lower_screen_address
				AND ($06),Y ; mask_address
				STA ($0a),Y ; lower_screen_address
				INY
				LDA ($0a),Y ; lower_screen_address
				AND ($06),Y ; mask_address
				STA ($0a),Y ; lower_screen_address
				INY
				LDA ($0a),Y ; lower_screen_address
				AND ($06),Y ; mask_address
				STA ($0a),Y ; lower_screen_address
				INY
				JMP sprite_width_in_bytes_unaligned	

fast_plot_unaligned_player_and_ora 
				LDA ($00),Y ; screen_address                         ; Plot four bytes in top group
				AND ($06),Y ; mask_address
				ORA ($08),Y ; sprite_address
				STA ($00),Y ; screen_address
				INY
				LDA ($00),Y ; screen_address
				AND ($06),Y ; mask_address
				ORA ($08),Y ; sprite_address
				STA ($00),Y ; screen_address
				INY
				LDA ($00),Y ; screen_address
				AND ($06),Y ; mask_address
				ORA ($08),Y ; sprite_address
				STA ($00),Y ; screen_address
				INY
				LDA ($00),Y ; screen_address
				AND ($06),Y ; mask_address
				ORA ($08),Y ; sprite_address
				STA ($00),Y ; screen_address
				INY
				LDA ($0a),Y ; lower_screen_address                   ; Plot four bytes in bottom group
				AND ($06),Y ; mask_address
				ORA ($08),Y ; sprite_address
				STA ($0a),Y ; lower_screen_address
				INY
				LDA ($0a),Y ; lower_screen_address
				AND ($06),Y ; mask_address
				ORA ($08),Y ; sprite_address
				STA ($0a),Y ; lower_screen_address
				INY
				LDA ($0a),Y ; lower_screen_address
				AND ($06),Y ; mask_address
				ORA ($08),Y ; sprite_address
				STA ($0a),Y ; lower_screen_address
				INY
				LDA ($0a),Y ; lower_screen_address
				AND ($06),Y ; mask_address
				ORA ($08),Y ; sprite_address
				STA ($0a),Y ; lower_screen_address
				INY
				JMP sprite_width_in_bytes_unaligned	
				
.endp
		
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------

calculate_weapon_screen_address .proc
				stx reg_x
				
				mva #0 result+1
				
				lda $10,y									; pos.X
				sub #$1c-6
				asl @
				rol result+1
				asl @
				rol result+1
				sta result

				lda $18,y	 	 							; pos.Y
				lsr @
				tax
				stx sprite_row
				
				clc
								
				LDA $94 									; buffer_to_use     ; Zero for buffer one, non-zero for buffer two
				BEQ use_buffer_one
				
use_buffer_two	lda tab_address_buff2_lo+1,x
				adc result  
				sta $00
				lda tab_address_buff2_hi+1,x
				adc result+1 
				sta $01
			
     			ldx reg_x
				rts				
				
use_buffer_one	lda tab_address_buff1_lo+1,x
				adc result  
				sta $00
				lda tab_address_buff1_hi+1,x
				adc result+1 
				sta $01

				ldx reg_x
				rts
 				
result 	.ds 2			
 
.endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; add laser, X - number of free slot, every slot have 4 bytes 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
add_laser   	CLC
				LDA $0018,Y 										; players_or_enemies_y
				AND #$01
				BEQ is_aligned

				mva lo_offset_row2 $40,x
				mva hi_offset_row2 $41,x
				jmp	set_laser_screen_offset_high		
			
is_aligned		lda lo_offset_row1
				add #4	
				sta $40,x
				lda hi_offset_row1
				adc #0
				sta $41,x	

set_laser_screen_offset_high	
				lda $10,y											; players_or_enemies_x	
		    	lsr @                      							; / 2		    	
		    	sub #13	    
		    	asl @					   							; * 8
		    	asl @
		    	asl @		    
				add $40,x
				sta $40,x
				lda $41,x
				adc #0
				sta $41,x   	    

                LDA $0018,Y	
				ADD #$04
				STA $43,X 											 ; lasers_y
			    	
				LDA $0010,Y 										 ; players_or_enemies_x
				ADD #$0a	
				STA $42,X 											 ; lasers_x
				
				LDA $000e,Y 										 ; players_selected_weapon
				LSR @
				LSR @
				CLC
				ADC #$01                                    		 ; Use envelope 1 for standard, 2 for multidirectional
				STY $73 											 ; tmp_y	
				STX $74 											 ; tmp_x
				CMP #$03
				BPL play_sound_for_torpedo
				
play_sound_for_laser
				jmp play_laser_sound

play_sound_for_torpedo
				jmp play_torpedo_sound
				
; unused
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 

score_for_destroying_enemy_values                                            ; 0: 1
;         0   1   2   3   4   5   6                                          ; 1: 5
	dta $10,$28,$08,$28,$08,$28,$08                                          ; 2: 10

score_for_destroying_enemy_digits                                            ; 3: 50
;         0   1   2   3   4   5   6                                          ; 4: 100
	dta $06,$06,$05,$05,$04,$04,$03                                          ; 5: 500
                                                                             ; 6: 1000 (unused)
explosion_and_firing_sound
;      chan vol  pitch dur
	dta $12,$00,$00,$00,$00,$00,$00,$00

bonus_sound
;       chan  vol   pitch dur
	dta $13,$00,$04,$00,$64,$00,$05,$00                                       ; Use channel 3 for bonus
	                    
to_consider_spawning_enemies ;$2248 
			   JMP consider_spawning_enemies

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; increase score
; input: 
;      reg.X - offset, PLAYER ONE or PLAYER TWO
;      reg.A - score to add
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
increase_score LDY $9b 												; level_number
               CPY #$04
               BMI skip_multiplication

               DEX                                                  ; Score ten times as much on level 5 onwards

skip_multiplication
               LDY #$06
increase_score_loop
			   CLC
			   ADC $82,X 											; players_score
			   STA $82,X 											; players_score
			   CMP #$50 											; 8 * 10
			   BMI increase_score_rts
			   
			   SEC
			   SBC #$50 											; 8 * 10
			   STA $82,X 											; players_score
			   LDA #$08 											; 8 * 1
			   DEX
			   DEY
			   BPL increase_score_loop
			   
increase_score_rts
			   RTS
 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; BBC Procedure OSWORD  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
OSWORD		    cmp #$0a 
			    beq OSWORD_READ_CHAR
			    rts	
			    
; read pattern of char
OSWORD_READ_CHAR
                stx address1
                sty address1+1

                ldy #0						; address2 = 0
                sty address2
                sty address2+1
				lda (address1),y
			    asl @						; calculate address of char, multiply by 8
			    ROL address2+1
			    asl @
			    ROL address2+1
			    asl @
			    ROL address2+1
			    sta address2
			    adw address2 #atari_font1 
			    
			    lda (address2),y			; get 8 bytes of char
			    iny 
			    sta (address1),y
			    lda (address2),y			
			    iny 
			    sta (address1),y
			    lda (address2),y			
			    iny 
			    sta (address1),y
			    lda (address2),y			
			    iny 
			    sta (address1),y
			    lda (address2),y			
			    iny 
			    sta (address1),y
			    lda (address2),y			
			    iny 
			    sta (address1),y
			    lda (address2),y			
			    iny 
			    sta (address1),y
			    lda (address2),y			
			    iny 
			    sta (address1),y
	 	    
			    rts
								      
tab_char_col1 dta %00000000,%00000001,%00000100,%00000101,%00010000,%00010001,%00010100,%00010101,%01000000,%01000001,%01000100,%01000101,%01010000,%01010001,%01010100,%01010101
tab_char_col2 dta %00000000,%00000010,%00001000,%00001010,%00100000,%00100010,%00101000,%00101010,%10000000,%10000010,%10001000,%10001010,%10100000,%10100010,%10101000,%10101010
tab_char_col3 dta %00000000,%00000011,%00001100,%00001111,%00110000,%00110011,%00111100,%00111111,%11000000,%11000011,%11001100,%11001111,%11110000,%11110011,%11111100,%11111111
tab_char_mask dta %11111111,%11111100,%11110011,%11110000,%11001111,%11001100,%11000011,%11000000,%00111111,%00111100,%00110011,%00110000,%00001111,%00001100,%00000011,%00000000
tab_colors    dta a($0000),a(tab_char_col1),a(tab_char_col2),a(tab_char_col3),a(tab_char_col3)

plot_character_and_ora 
			   ldx #$b1 											; lda ($00),y
			   stx plot_character_internal.lda1 
			   stx plot_character_internal.lda2 
			 ;  tax
			   jsr convert_ATASCII_DISPLAY
			   jmp plot_character_internal.start
			   			   
plot_character; tax
			   jsr convert_ATASCII_DISPLAY                          ; S = $53 -> $33   

plot_character_internal .proc           
			   ldx #$a9 											;  lda #$00
			   stx plot_character_internal.lda1 
			   stx plot_character_internal.lda2 
			   			   
start          STA $a8      										; character_data
               LDX #$a8     										; $a8 = character_data
               LDY #$00
               LDA #$0a 											; Read character definition
               JSR OSWORD
               
               ldx #$07
               ldy #$07
               
plot_character_loop               
               lda $a9,x    											    ; character_data + 1
               stx reg_x
               lsr @
               lsr @
               lsr @
               lsr @
        	   tax
           
lda1       	   lda ($00),y
               and tab_char_mask,x    	   
col1      	   ora tab_char_col1,x
               eor $74      												; text_eor, highlight on/off
               sta ($00),Y  												; screen_address
               
               tya
               add #$08
               tay  
               
               ldx reg_x
               lda $a9,x    												; character_data + 1
               and #$0f
        	   tax
        	   
lda2       	   lda ($00),y
               and tab_char_mask,x 
col2     	   ora tab_char_col1,x
               eor $74      												; text_eor, highlight on/off
               sta ($00),Y  												; screen_address
        
        	   ldx reg_x
        	   
               tya
               sub #$08
               tay  
               
               dey
               dex
               bpl plot_character_loop
               
               lda $00 														; screen_address_low
               add #$10
               sta $00 														; screen_address_low
               bcc plot_character_leave
           
               inc $01 														; screen_address_high

plot_character_leave
               RTS

.endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; show title screen 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
plot_cyborg_buff1 .proc
  	    		lda @TAB_MEM_BANKS+=cw_logo \ and #$fe \ sta PORTB 
    			draw_char_buff1 #0 #0 #cw_logo #len_cw_logo
   				lda @TAB_MEM_BANKS \ and #$fe \ sta PORTB 
           	    bank_jsr buff1_plot_stars_ora
   				ldx #0
   				stx $94													; buffer_to_use  		; Zero if buffer two, non-zero if buffer one
				rts
.endp

plot_cyborg_buff2 .proc
				lda @TAB_MEM_BANKS+=cw_logo \ and #$fe \ sta PORTB 
    			draw_char_buff2 #0 #0 #cw_logo #len_cw_logo
   				lda @TAB_MEM_BANKS \ and #$fe \ sta PORTB 	
           	    bank_jsr buff2_plot_stars_ora 
 				ldx #1
 				stx $94													; buffer_to_use  		; Zero if buffer two, non-zero if buffer one
 				rts
.endp

title_screen_after_checking_for_high_score   
 				ldx #12
				stx no_stars 											; number of animated stars (1-17)
				
                mva #$ff cloc  
               	jsr check_for_high_score

title_screen   	screen_off
				
; copy colors for DLI          
				ldx #len_tab_dli
				
loop_copy_titl1	lda title_tab_dli_COLPF0-1,x
				sta tab_dli_COLPF0-1,x
				dex
				bne loop_copy_titl1
				              	
               	JSR reset_screen
				jsr write_conversion_text_on_bottom
               	jsr plot_cyborg_buff1
               	jsr plot_cyborg_buff2
               	lda #1
               	ldx #<txt_title4									; "FIRE TO PLAY"
               	ldy #>txt_title4
               	jsr plot_string2
               	lda maximum_level_reached
               	beq title_screen2          					    	; If the first level hasn't been completed,
                
                lda #1
                ldx #<txt_title5									; "L TO LAST LEVEL"
               	ldy #>txt_title5
               	jsr plot_string2
               	
title_screen2  	mva #$00 is_music
               	sta      game_type
                     
title_screen_loop        
                lda cloc
               	BNE not_high_score_screen
               
               	JMP high_score_screen
               
not_high_score_screen       
               	ldx #$03											
   		
write_title_screen_strings_loop
               	stx $79 											; string_id
	           
start_level    	ldy #$00                                     		; Start on level 1 by default
	           	sty $9b 											; level_number
                           
               	ldx $79 											; string_id
               	lda tab_option_lo-1,x								; lo address of string
               	ldy tab_option_hi-1,x 								; hi address of string
               	tax
               
 			   	lda game_type
               	lsr @
               	adc #$01 											; "PLAYER ONE"
               	cmp $79 											; string_id
               	bne skip_highlighting
               
               	lda #1                            	         		; Highlight selected game type
               	jsr plot_string_eor
               	jmp skip_highlighting2

skip_highlighting              
               	lda #1
               	JSR plot_string2
              
skip_highlighting2
               	ldx $79 											; string_id
               	dex
                bne write_title_screen_strings_loop
  
finishing_writing_strings           	   
           	   	ldx $94 										    ; buffer_to_use  		; Zero if buffer two, non-zero if buffer one
           	 	beq fini_buff2
           	   	  	
				jsr plot_cyborg_buff1
           	   	jmp fini_buff
           	   		           	 
fini_buff2    	jsr plot_cyborg_buff2
 
fini_buff  	 	lda is_shield										; is immortality ON?
           	    bpl write_title1
           	    
           	    lda #$03
           	    ldx #<txt_shield1
           	    ldy #>txt_shield1
           	    jsr plot4x8_string
           	    
write_title1   	lda is_all_weapon									; is all weapon ON?
           	    bpl write_title2
           	    
           	    lda #$03
           	    ldx #<txt_weapon1
           	    ldy #>txt_weapon1
           	    jsr plot4x8_string
           	    
write_title2   	lda is_x_level 								    	; is x level ON?
           	    bpl write_title3 
           	    
           	    lda #$03
           	    ldx #<txt_level1 
           	    ldy #>txt_level1
           	    jsr plot4x8_string
           	    
write_title3	lda rmt_actual_song
				cmp #song_title
				beq title_song1
				         										 		   
				lda #song_title
				jsr rmt_init2
			
title_song1    	mva #1 is_music
				
				ldx $94
				lda tab_buff_addr_hi,x
				sta buff_addr_hi
               	screen_on
				
check_for_game_type_keys_loop
               	lda PORTA
               	lsr @
               	lsr @
               	lsr @
               	lsr @
               	sta PORTA_JOY2
               	cmp #$0f
               	beq *+6
               	lda #$ff 
               	sta cloc

               	lda PORTA
               	and #$0f
               	sta PORTA_JOY1
               	cmp #$0f
               	beq *+6
               	lda #$ff 
               	sta cloc
               	               	
               	jsr title_test_joy
               	
               	ldx kbcodes
               
                cpx #0      										; L?	  	
				bne check_if_space_pressed1
				
                mva #$ff cloc
             		          
               	lda maximum_level_reached
                beq check_if_space_pressed1
               
                jsr start_from_maximum_level_reached         		; start from maximum level reached, if set
				jmp title_next2

check_if_space_pressed1
				cpx #62+64											; SHIFT+S?
				bne *+5
				jmp press_SHIFT_S
               	
				cpx #46+64											; SHIFT+W?
				bne *+5
				jmp press_SHIFT_W
				
				lda #1
				cpx #31+64											; SHIFT+1?
				bne *+5
				jmp press_SHIFT_x									
				
				lda #2
				cpx #30+64											; SHIFT+2?
				bne *+5
				jmp press_SHIFT_x									
				
				lda #3
				cpx #26+64											; SHIFT+3?
				bne *+5
				jmp press_SHIFT_x									

				lda #4
				cpx #24+64											; SHIFT+4?
				bne *+5
				jmp press_SHIFT_x									
				
				lda #5
				cpx #29+64											; SHIFT+5?
				bne *+5
				jmp press_SHIFT_x									

				lda #6
				cpx #27+64											; SHIFT+6?
				bne *+5
				jmp press_SHIFT_x									

				lda #7
				cpx #51+64											; SHIFT+7?
				bne *+5
				jmp press_SHIFT_x									
				
				lda #8				
				cpx #53+64											; SHIFT+8?
				beq press_SHIFT_x									
								
check_trig1    	lda trig0
               	beq title_next2
               	lda trig1
               	beq title_next2
               
                jmp title_screen_loop                        		; If SPACE pressed,
             
title_next2    	lda is_all_weapon
				bmi title_next3
				
				LDA #$00                                     		; Players start with only standard laser
               	STA $c6 											; players_maximum_weapon
               	STA $c7 											; players_maximum_weapon + 1
               
title_next3    	LDX game_type
               	LDA lives_by_game_type,X                     		; Set player lives depending on game type
               	STA $9c 											; players_lives
               	LDA lives_by_game_type + 1,X
               	STA $9d 											; players_lives + 1
				
				rts

press_SHIFT_S .proc
				lda is_shield										; active SHIELD ON
				eor #$ff
				sta is_shield
				
cont1			lda skstat											; if key still press?
				and #$04
 				beq cont1
				
				mvx #$ff kbcodes
				stx      cloc
				jmp check_trig1
.endp
				
press_SHIFT_W .proc
				mva #$ff cloc
				
				lda is_all_weapon									; active ALL WEAPON
				eor #$ff
				sta is_all_weapon
				
				and #3
				sta $c6
				sta $c7
				and #1
				sta number_bombs
				sta number_bombs+1
				jmp press_SHIFT_S.cont1
.endp

press_SHIFT_x .proc
				tax
				add #'0'
				sta txt_level1+8
				dex
				stx $9b
				stx start_level+1
				
				lda is_x_level				 						; active LEVEL x
				eor #$ff
				sta is_x_level
				bmi press_SHIFT_S.cont1
				
				ldx #0
				stx $9b	
				stx start_level+1			
				
				jmp press_SHIFT_S.cont1
.endp

title_test_joy 	lda PORTA_JOY1
				and #joystick_down
               	beq title_dn
			   	lda PORTA_JOY1
			   	and #joystick_up
       		   	beq title_up
			
				lda PORTA_JOY2
				and #joystick_down
               	beq title_dn
			   	lda PORTA_JOY2
			   	and #joystick_up
       		   	beq title_up
       		   	
				rts

title_dn .proc
				lda game_type
				cmp #2*2
				beq skip1

				inc game_type
				inc game_type
				
skip1			rts
.endp

title_up .proc
				lda game_type
				beq skip1

				dec game_type
				dec game_type
								
skip1			rts
.endp

write_conversion_text_on_bottom .proc
          	    lda #1
           	    ldx #<txt_conversion1
           	    ldy #>txt_conversion1
           	    jsr plot4x8_string
           	    lda #2
           	    ldx #<txt_conversion11
           	    ldy #>txt_conversion11
           	    jsr plot4x8_string
           	    lda #1
           	    ldx #<txt_conversion2
           	    ldy #>txt_conversion2
           	    jsr plot4x8_string
           	    lda #2
           	    ldx #<txt_conversion22
           	    ldy #>txt_conversion22
           	    jmp plot4x8_string
.endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; show high score screen 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
high_score_screen 
               mva #$ff cloc
               screen_off
               jsr clr_2_last_rows
               jsr plot_high_score_screen
               screen_on

high_score_screen_loop
               lda cloc
               bne *+5
			   jmp show_picture										; time is over, skip to SHOW PICTURE
			
			   ldx #1												
               jsr delay											; wait one frame
               jsr delay											; wait one frame
               
               lda trig0
               beq to_title_screen
               lda trig1
               bne high_score_screen_loop                   		
               
to_title_screen jmp title_screen 

plot_high_score_screen 
				ldx #len_tab_dli
				
loop_copy_scor1	lda score_tab_dli_COLPF0-1,x						; copy colors to DLI table (which using on DLI interrupt)
				sta tab_dli_COLPF0-1,x
				dex
				bne loop_copy_scor1               
               
                jsr reset_screen
        	   
        	   	mva #>buff1_charset0 buff_addr_hi
        	   	lda #1												; buffer_to_use
               	sta $94
               	ldx #<txt_HIGH_SCORE
               	ldy #>txt_HIGH_SCORE
               	jsr plot_string2
               	jsr clear_5th_color
               	jsr write_conversion_text_on_bottom         
               	jmp write_high_scores
  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; SPAWN cooldown
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
leave_after_decreasing_spawn_cooldown
               DEC spawn_cooldown
               
leave_7        RTS

spawn_cooldown dta $00

start_from_maximum_level_reached
               LDA maximum_level_reached
               STA $9b 												; level_number
               LDA initial_players_lives
               BEQ skip_player_one                          		; If player one completed level,
               LDA initial_players_maximum_weapon
               STA $c6 												; players_maximum_weapon
               LDA #$04                                             ; Player one starts with four lives
skip_player_one
               STA $9c 												; players_lives
               LDA initial_players_lives + 1
               BEQ skip_player_two                          		; If player two completed level,
               LDA initial_players_maximum_weapon + 1
               STA $c7 												; players_maximum_weapon + 1
               LDA #$04                                             ; Player two starts with four lives
               STA $9d 												; players_lives + 1
skip_player_two
               RTS

consider_spawning_enemies                                           ; Called with X = enemy for each active enemy
				LDA $12,X 											; player_or_enemies_x + 2
				CMP #$1c
				BMI leave_7        		                            ; Leave if enemy if beyond left of screen
				CMP #$5e
				BPL leave_7              	                        ; Leave if enemy if beyond right of screen
				LDA $7c,X 											; enemies_spawn_type
				BEQ leave_7                    		                ; Leave if enemy doesn't spawn
				LDA $70   											; frame_counter
				AND #$03
				CLC
				ADC $7c,X 											; enemies_spawn_type
				TAY
				LDA type_of_enemy_to_spawn_table - 4,Y
				STA $73 											; spawn_type
				LDA spawn_cooldown
				BNE leave_after_decreasing_spawn_cooldown
				LDA #$10
				STA spawn_cooldown
				LDY #$05
find_slot_for_spawn
				LDA $0012,Y 										; player_or_enemies_x + 2             ; Zero if slot is empty
				BEQ found_slot_for_spawn
				DEY
				BPL find_slot_for_spawn
				RTS
				
found_slot_for_spawn
				LDA $1a,X 											; players_or_enemies_y + 2
				CLC
				ADC #$02
				STA $001a,Y 										; player_or_enemies_y + 2
				LDA $12,X 											; player_or_enemies_x + 2
				SBC #$01
				AND #$fe
				STA $0012,Y 										; player_or_enemies_x + 2
				LDA $73 											; spawn_type
				STA $002a,Y 										; players_or_enemies_type + 2
				CMP #$2c 											; SPRITE_ROCKET
				BEQ not_rocket
				LDA $0012,Y 										; player_or_enemies_x + 2
				ADC #$04
				STA $0012,Y 										; player_or_enemies_x + 2
not_rocket
				LDA #$01
				STA $0022,Y 										; players_or_enemies_energy + 2
				LDA #$04
				STA $003a,Y 										; enemies_height
				LDA #$00
				STA $007c,Y 										; enemies_spawn_type
				
				RTS

number_keys  ;$2720
	dta $cf,$00 ; 1
	dta $ce,$00 ; 2
	dta $ee,$00 ; 3

type_of_enemy_to_spawn_table
	dta $2c,$2c,$2c,$2c ; $04                                       ; Rockets
	dta $88,$80,$84,$7c ; $08                                       ; Balls
	dta $d8,$d8,$d8,$d8 ; $0c                                       ; Sparks

grouped_enemies_x_positions
	dta $68,$68,$6e,$6e,$72,$68 ; $06                               ; End of odd levels boss
	dta $68,$68,$68,$68,$6e,$6e ; $0c                               ; End of even levels boss

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; clear buffor screen 1
; clear all acreen without 1st row and the last 3th rows 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
reset_screen    fill_mem #buff1_charset0 #16*1024 #$00
				jsr clear_PMG
    		    jsr clear_5th_color
                rts
                
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; plot string on screen buffor 1 & 2
; 4x8 font, 40x24 screen  
; reg. A  - color of text ( bits 0-3 ), +bit7=1 - lda/sta, +bit7=0 lda/and/ora/sta 
; reg. XY - address of source text
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
tmp_dst2_message 	.ds 2
tmp_len_message  	.ds 1
tmp_src1       	 	.ds 2
tmp_color      	 	.ds 1
len_src1       		.ds 1

plot4x8_string .proc				
				sta tmp_color
				bank_jsr bank_plot4x8_string
				rts
.endp
				
calculate_offset_on_screen .proc
               ldy #1
               lda (src1),y
               tay
               mva tab_offset_buff_lo,y $00
               mva tab_offset_buff_hi,y $01
               ldy #0
               sty result
               lda (src1),y
               asl @													; *8
               rol result												
               asl @
               rol result
               asl @
               rol result
               add $00
               sta $00
               lda $01
               adc result
               sta $01           
			   
			   rts
			   
result .ds 1
			   	
.endp
 			
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; plot string on screen buffor 1 & 2 
; reg. A  - color of text, $ff - EOR
; reg. XY - address of source text
; $00,$01 - address on screen
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
plot_string_and_ora
			   pha
               mwa #plot_character_and_ora plot_string2.plot_char_addr+1
               pla
               jmp plot_string2.plot_string3
               
plot_string_eor
               lda #1
               sta plot_string2.tmp_color
               lda #$ff
               bne plot_string2.skip1
                
plot_string2 .proc
			   pha
               mwa #plot_character plot_char_addr+1
               pla

plot_string3   sta tmp_color										; set color 0-4

               lda #0												; text_eor               
skip1          sta $74	
                
               ;pha
               stx src1												; low_address_of_source_text
               sty src1+1											; hi_address_of_source_text               
     
			   lda tmp_color										; set color 0-4
               jsr set_color_plot            
               jsr calculate_offset_on_screen
                                              
               mva $00 tmp_00  										; plot on buffor 0
               mva $01 tmp_01
               
               adw $00 #buff1_charset0
               ldy #1 
               jsr plot_string_skip2       
              
               mva tmp_00 $00  										; plot on buffor 1
               mva tmp_01 $01
                      
               adw $00 #buff2_charset0
               ldy #1
               jsr plot_string_skip2  
         	
         	   jmp plot_string_skip3
         
plot_string_loop2               
               sty $73
plot_char_addr jsr plot_character
               ldy $73
plot_string_skip2                              
               iny
               lda (src1),y
               cmp #$9b												; is return?
               bne plot_string_loop2
               
               tya
               sub #2
               sta tmp_index
               rts
               
plot_string_skip3         
               lda #<tab_char_col1									; set color 1
               sta plot_character_internal.col1+1 
               sta plot_character_internal.col2+1 
               lda #>tab_char_col1
               sta plot_character_internal.col1+2 
               sta plot_character_internal.col2+2 
            
               lda tmp_color										; is color 4? (color=3 and bit7=1)
               cmp #4
               bne plot_string_skip4
                       
set_5th_color  ldy #1
               lda (src1),y
               tax
               mva tab_screen_chars_lo,x $00 
               mva tab_screen_chars_hi,x $01
       		   dey
               lda (src1),y
               add $00
               sta $00
               bcc *+4
               inc $01   
            
               lda tmp_index
               asl @												; *2
               tax
                                
               ldy #$00
              
plot_string_loop3  
               lda ($00),y
               ora #128												; bit7 = 128
               sta ($00),y              
               iny
			   dex	
               bne plot_string_loop3    	
	  	
plot_string_skip4                                          
               rts
               
tmp_00     dta $00
tmp_01     dta $00
tmp_color  dta $00													; save length of text for later
tmp_index  dta $00
               
.endp

set_color_plot .proc
               asl @
               tay
               lda tab_colors,y 
               sta plot_character_internal.col1+1 
               sta plot_character_internal.col2+1 
               lda tab_colors+1,y 
               sta plot_character_internal.col1+2 
               sta plot_character_internal.col2+2 
               rts
.endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; clear the last 2 rows on the screen
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
clr_2_last_rows .proc
				ldx #79	
				lda #0
run_game_loop2	sta screen_chars1+24*40,x
				dex
				bpl run_game_loop2
				rts
.endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; wait value register X, 1/50 frames (VBL)
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
delay          STX v_pending
wait_for_vsyncs
               LDA v_pending
               BNE wait_for_vsyncs
               
               RTS
	
lives_by_game_type
;      p1 p2
	dta $04,$00 ; 1
	dta $00,$04 ; 2
	dta $04,$04 ; 3

game_type ;$2a01
    dta $00

maximum_level_reached  ;$2a02
	dta $00

; colors for ground & horizon for every 8 levels
level_colours
	dta $c6 ; $00 (level 1) : set colour 3 to green
	dta $1c ; $01 (level 2) : set colour 3 to yellow
	dta $36 ; $02 (level 3) : set colour 3 to red
	dta $66 ; $03 (level 4) : set colour 3 to blue
	dta $0f ; $04 (level 5) : set colour 3 to white 
	dta $36 ; $05 (level 6) : set colour 3 to red
	dta $1c ; $06 (level 7) : set colour 3 to yellow
	dta $c6 ; $07 (level 8) : set colour 3 to green
    
; uses for blink colors after killing the boss or using weapon no.4	
; 10 bytes
smart_bomb_colours 
	dta $0f ; set colour 0 
	dta $0f ; set colour 0 
	dta $06 ; set colour 0 
	dta $06 ; set colour 0
	dta $0f ; set colour 0 
	dta $0f ; set colour 0
	dta $06 ; set colour 0 
	dta $06 ; set colour 0 
	dta $0f ; set colour 0 
	dta $0f ; set colour 0 
	dta $06 ; set colour 0

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; get your name for HIGH SCORE screen
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
get_name .proc			   	
				lda #'1'
				ldx $9c 										; player
				beq skip_name1
				
				lda #'2'
				
skip_name1		sta txt_ENTER_NAME+20
				
				jsr clear_5th_color
				lda #1
				ldx #<txt_ENTER_NAME
				ldy #>txt_ENTER_NAME
				jsr plot4x8_string
				jsr write_conversion_text_on_bottom
				lda #1
				jsr set_color_plot 

				screen_on

				jsr input_string
															   
			    lda #song_enter_name
			    jsr rmt_init2
			   		
				ldx #50
wait1			jsr wait_one_frame
				dex
				bne wait1
				
				screen_off
				
				LDY #$00
				LDX $76 										; high_score_offset

copy_name_loop	lda string,Y									; name
				stx reg_x		
				;tax	
				jsr convert_DISPLAY_ATASCII 
				ldx reg_x		
				STA high_score_names,X
	
				INX
				INY
				CPY #$08
				BMI copy_name_loop
				
			    rts
.endp 

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; draw one char on screen buffor 1/2
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------

; Converting ATASCII Code To Screen Code
;
;                           OPERATION NEEDED
;    ATASCII VALUES         FOR CONVERSION
;    ______________         ________________
;
;      0 to 31              Add 64
;     32 to 95              Subtract 32
;     96 to 127             None
;    128 to 159             Add 64
;    160 to 223             Subtract 32
;    224 to 255             None
;
convert_ATASCII_DISPLAY 
                tax
               	lda @TAB_MEM_BANKS+=:tab_convert_ATASCII_DISPLAY \ and #$fe \ sta PORTB 
                lda tab_convert_ATASCII_DISPLAY,x                
                tax
                lda @TAB_MEM_BANKS \ and #$fe \ sta PORTB
				txa
				rts             
				
convert_DISPLAY_ATASCII 
                tax
               	lda @TAB_MEM_BANKS+=:tab_convert_DISPLAY_ATASCII \ and #$fe \ sta PORTB 
                lda tab_convert_DISPLAY_ATASCII,x                
                tax
                lda @TAB_MEM_BANKS \ and #$fe \ sta PORTB
				txa
				rts   
									    
;            		col row                 text 
row_PAUSE        = 9
row_DEL          = 12
txt_PAUSE		 dta  15,  9,               'PAUSE',$9b
txt_RESUME_GAME	 dta  12, 10,   'DEL - RESUME GAME',$9b
txt_NEW_GAME	 dta  12, 11,   'ESC - NEW GAME   ',$9b
txt_GAME_OVER  	 dta  11,  9,           'GAME OVER',$9b						                      					
txt_LEVEL    	 dta  13,  9,             'LEVEL x',$9b
txt_HIGH_SCORE   dta  10,  3,          'HIGH SCORE',$9b
txt_ENTER_NAME   dta  11, 20, 'ENTER NAME PLAYER x',$9b
														
txt_title1		 dta  10, 11,          ' PLAYER 1 ',$9b														
txt_title2		 dta  10, 13,          ' PLAYER 2 ',$9b														
txt_title3		 dta  10, 15,         ' 2 PLAYERS ',$9b														
txt_title4		 dta   7, 18,      ' FIRE TO PLAY ',$9b         											
txt_title5		 dta   4, 20,   ' L TO LAST LEVEL ',$9b     												

txt_conversion1  dta  10, 22,'2024                  ',$9b
txt_conversion11 dta  10, 22,'     GAME CONVERTED BY',$9b
txt_conversion2  dta   0, 23,'VEGA        KAZ            MIKER        ',$9b 
txt_conversion22 dta   0, 23,'     (CODE)     (GRAPHICS)       (SOUND)',$9b 
    
txt_shield1      dta  34, 0,             'SHIELD',$9b
txt_shield2      dta  34, 0,             '      ',$9b       
txt_weapon1      dta  29, 1,        'ALL WEAPONS',$9b
txt_weapon2      dta  29, 1,         '          ',$9b            
txt_level1       dta  33, 2,            'LEVEL x',$9b
txt_level2       dta  33, 2,            '       ',$9b       

txt_new_weapon1	 dta   1, 0, d'        PLAYER ONE - NEW ARMS!        ',$9b
txt_new_weapon2	 dta   1, 1, d'        PLAYER TWO - NEW ARMS!        ',$9b
txt_new_life1	 dta   1, 0, d'       PLAYER ONE - EXTRA LIFE!       ',$9b
txt_new_life2	 dta   1, 1, d'       PLAYER TWO - EXTRA LIFE!       ',$9b
txt_new_bonus1   dta   1, 0, d'      PLAYER ONE - EXTRA POINTS!      ',$9b
txt_new_bonus2   dta   1, 1, d'      PLAYER TWO - EXTRA POINTS!      ',$9b
          										
tab_option_lo    dta <txt_title1,<txt_title2,<txt_title3,<txt_title4,<txt_title5 
tab_option_hi    dta >txt_title1,>txt_title2,>txt_title3,>txt_title4,>txt_title5 

tab_offset_buff_lo   dta <( 0*40*8    ),<( 1*40*8    ),<( 2*40*8    )
					 dta <( 3*40*8+ 64),<( 4*40*8+64 ),<( 5*40*8+64 )
					 dta <( 6*40*8+128),<( 7*40*8+128),<( 8*40*8+128)
					 dta <( 9*40*8+192),<(10*40*8+192),<(11*40*8+192)
					 dta <(12*40*8+256),<(13*40*8+256),<(14*40*8+256)
					 dta <(15*40*8+320),<(16*40*8+320),<(17*40*8+320)
					 dta <(18*40*8+384),<(19*40*8+384),<(20*40*8+384)
					 dta <(21*40*8+448),<(22*40*8+448),<(23*40*8+448)

tab_offset_buff_hi   dta >( 0*40*8    ),>( 1*40*8    ),>( 2*40*8    )
					 dta >( 3*40*8+ 64),>( 4*40*8+64 ),>( 5*40*8+64 )
					 dta >( 6*40*8+128),>( 7*40*8+128),>( 8*40*8+128)
					 dta >( 9*40*8+192),>(10*40*8+192),>(11*40*8+192)
					 dta >(12*40*8+256),>(13*40*8+256),>(14*40*8+256)
					 dta >(15*40*8+320),>(16*40*8+320),>(17*40*8+320)
					 dta >(18*40*8+384),>(19*40*8+384),>(20*40*8+384)
					 dta >(21*40*8+448),>(22*40*8+448),>(23*40*8+448)
					 
.print 'main code = $1000 - ', *-1	
 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; $4000-$7FFF 16KB datas of sprites, shapes and masks (shift by 4bits, 2pixels)
; Bank #0 RAM
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
	org $4000
	 
sprite_data0 = *

sprite_player_one_even_group_0       											;$2e00
	dta $00,$00,$00,$11,$01,$23,$23,$03,$00,$00,$8f,$08,$60,$f0,$78,$0f
	dta $00,$00,$00,$00,$00,$00,$00,$00 

sprite_player_two_even_group_0 
	dta $00,$00,$00,$11,$10,$32,$30,$30,$00,$00,$f8,$80,$06,$0f,$87,$f0
	dta $00,$00,$00,$00,$00,$00,$00,$00 

mask_player_even_group_0
	dta $ff,$ff,$ee,$cc,$cc,$88,$88,$88,$ff,$00,$00,$00,$00,$00,$00,$00
	dta $ff,$ff,$77,$ff,$77,$77,$77,$77 

; weapon no.1 for player 0 (odd, active)
sprite_player_one_weapon_0_odd
	dta $00,$00,$ff,$f0,$c0,$80,$80,$00,$00,$00,$88,$80,$00,$00,$00,$00

sprite_player_two_weapon_0_odd
	dta $00,$00,$ff,$0f,$0c,$08,$80,$00,$00,$00,$88,$08,$00,$00,$00,$00
	
mask_player_weapon_0_odd
	dta $ff,$00,$00,$00,$00,$33,$77,$77,$ff,$77,$77,$77,$77,$ff,$ff,$ff
	
sprite_player_one_weapon_0_inactive_odd
	dta $00,$00,$fb,$b0,$c0,$80,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00

sprite_player_two_weapon_0_inactive_odd
	dta $00,$00,$ff,$0b,$0c,$08,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00
	
mask_player_weapon_0_inactive_odd
	dta $ff,$00,$00,$00,$00,$33,$77,$77,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	
sprite_alien_even_group_0
	dta $00,$11,$32,$20,$56,$07,$8f,$0f,$ce,$0f,$0f,$87,$0f,$0e,$0e,$0c
	dta $00,$00,$00,$00,$00,$00,$00,$00
	
mask_alien_even_group_0
	dta $ee,$cc,$88,$88,$88,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$11
	dta $ff,$77,$77,$77,$77,$ff,$ff,$ff
	
sprite_ball_one_even_group_0
	dta $00,$00,$30,$70,$72,$f4,$f4,$f0,$00,$00,$00,$80,$80,$c0,$c0,$c0
	
mask_ball_even_group_0
	dta $ff,$cc,$88,$88,$00,$00,$00,$00,$ff,$ff,$77,$77,$33,$33,$33,$33
	
sprite_sparks_group_0
	dta $99,$aa,$aa,$44,$44,$55,$22,$22
	
sprite_player_one_even_group_1
	dta $03,$33,$47,$07,$8f,$0d,$1b,$07,$0e,$07,$08,$1d,$3a,$60,$d0,$f8
	dta $00,$00,$00,$44,$c8,$80,$40,$c0
	
sprite_player_two_even_group_1
	dta $30,$33,$74,$70,$f8,$d0,$b1,$70,$e0,$70,$80,$d1,$a3,$06,$0d,$8f
	dta $00,$00,$00,$44,$8c,$08,$04,$0c
	
mask_player_even_group_1
	dta $88,$88,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $77,$77,$ff,$33,$33,$33,$33,$33
	
sprite_player_one_weapon_1_odd
	dta $20,$20,$ec,$d1,$d0,$a0,$a0,$00,$00,$00,$00,$00,$00,$00,$00,$00

sprite_player_two_weapon_1_odd
	dta $02,$02,$ce,$1d,$0d,$0a,$82,$00,$00,$00,$00,$00,$00,$00,$00,$00
	
mask_player_weapon_1_odd
	dta $dd,$11,$00,$00,$00,$11,$55,$77,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	
sprite_player_one_weapon_1_inactive_odd
	dta $00,$00,$cc,$a2,$a0,$c0,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00
	
sprite_player_two_weapon_1_inactive_odd
	dta $00,$00,$cc,$2a,$0a,$0c,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00
	
mask_player_weapon_1_inactive_odd
	dta $ff,$33,$11,$11,$11,$33,$33,$77,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	
sprite_alien_even_group_1
	dta $08,$00,$04,$83,$c0,$e0,$a6,$1f,$0a,$15,$0d,$2b,$03,$47,$07,$07
	dta $00,$00,$08,$08,$08,$08,$08,$04
	
mask_alien_even_group_1
	dta $00,$ff,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $ff,$77,$77,$77,$77,$77,$33,$33
	
sprite_ball_one_even_group_1
	dta $f0,$f0,$f0,$60,$60,$30,$00,$00,$c0,$40,$40,$80,$80,$00,$00,$00
	
mask_ball_even_group_1
	dta $00,$00,$00,$00,$88,$88,$cc,$ff,$33,$33,$33,$33,$77,$77,$ff,$ff
	
sprite_sparks_group_1
	dta $aa,$44,$44,$44,$55,$22,$22,$22
	
sprite_player_one_even_group_2
	dta $0f,$0f,$07,$00,$03,$01,$00,$00,$4e,$0f,$12,$0c,$2e,$1f,$0f,$07
	dta $80,$84,$00,$00,$00,$00,$88,$08

sprite_player_two_even_group_2
	dta $f0,$f0,$70,$00,$30,$10,$00,$00,$f4,$f0,$21,$c0,$e2,$f1,$f0,$70
	dta $48,$48,$00,$00,$00,$00,$88,$80
	
mask_player_even_group_2
	dta $00,$00,$00,$88,$cc,$ee,$ff,$ff,$00,$00,$00,$00,$00,$00,$00,$00
	dta $33,$33,$33,$ff,$ff,$77,$33,$33
	
sprite_player_one_weapon_2_odd
	dta $00,$00,$ff,$f0,$a0,$f0,$80,$00,$00,$88,$80,$80,$80,$80,$00,$00
	
sprite_player_two_weapon_2_odd
	dta $00,$00,$ff,$0f,$0a,$0f,$80,$00,$00,$88,$08,$08,$08,$08,$00,$00
	
mask_player_weapon_2_odd
	dta $ff,$00,$00,$00,$00,$00,$00,$77,$77,$77,$77,$77,$77,$77,$77,$ff
	
sprite_player_one_weapon_2_inactive_odd
	dta $00,$22,$ec,$60,$a0,$60,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00
	
sprite_player_two_weapon_2_inactive_odd
	dta $00,$22,$ce,$06,$0a,$06,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00
	
mask_player_weapon_2_inactive_odd
	dta $dd,$11,$11,$11,$11,$11,$11,$77,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	
sprite_alien_even_group_2
	dta $8b,$c9,$64,$12,$07,$45,$64,$32,$8b,$0c,$0e,$06,$91,$2b,$0d,$06
	dta $04,$04,$0c,$0c,$0c,$08,$08,$00
	
mask_alien_even_group_2
	dta $00,$00,$00,$00,$00,$00,$00,$88,$00,$00,$00,$00,$00,$00,$00,$00
	dta $33,$33,$33,$33,$33,$33,$33,$33
	
sprite_ball_two_even_group_0
	dta $00,$03,$07,$27,$4f,$4f,$0f,$0f,$00,$00,$08,$08,$0c,$0c,$0c,$0c
	
mask_player_bonus_even_group_0
	dta $88,$00,$00,$00,$00,$00,$00,$00,$77,$33,$33,$33,$33,$33,$33,$33
	
sprite_sparks_group_2
	dta $22,$aa,$44,$44,$44,$55,$22,$22
	
sprite_player_one_even_group_3
	dta $00,$00,$00,$00,$11,$00,$00,$00,$02,$23,$47,$8f,$0a,$0c,$06,$00
	dta $08,$00,$08,$00,$00,$00,$00,$00
	
sprite_player_two_even_group_3
	dta $00,$00,$00,$00,$11,$00,$00,$00,$20,$32,$74,$f8,$a0,$c0,$60,$00
	dta $80,$00,$80,$00,$00,$00,$00,$00
	
mask_player_even_group_3
	dta $ff,$ff,$ff,$ee,$ee,$ee,$ff,$ff,$88,$88,$00,$00,$00,$11,$00,$88
	dta $33,$33,$33,$77,$ff,$ff,$ff,$ff
	
sprite_player_one_weapon_3_odd
	dta $00,$00,$9b,$a7,$97,$a7,$1b,$00,$00,$00,$00,$88,$4c,$88,$00,$00
	
sprite_player_two_weapon_3_odd
	dta $00,$00,$9b,$2f,$1f,$2f,$93,$00,$00,$00,$00,$88,$4c,$88,$00,$00
	
mask_player_weapon_3_odd
	dta $ff,$44,$00,$00,$00,$00,$00,$44,$ff,$ff,$77,$33,$33,$33,$77,$ff
	
sprite_player_one_weapon_3_inactive_odd
	dta $00,$00,$a9,$96,$a5,$96,$29,$00,$00,$00,$00,$08,$84,$08,$00,$00
	
sprite_player_two_weapon_3_inactive_odd
	dta $00,$00,$a9,$1e,$2d,$1e,$a1,$00,$00,$00,$00,$08,$84,$08,$00,$00
	
mask_player_weapon_3_inactive_odd
	dta $ff,$44,$00,$00,$00,$00,$00,$44,$ff,$ff,$77,$33,$33,$33,$77,$ff
	
sprite_alien_even_group_3
	dta $01,$03,$22,$32,$11,$00,$00,$00,$80,$59,$0d,$06,$83,$e0,$c0,$80
	dta $8c,$0c,$0c,$08,$00,$00,$00,$00
	
mask_alien_even_group_3
	dta $88,$88,$88,$88,$cc,$ee,$ff,$ff,$00,$00,$00,$00,$00,$00,$11,$33
	dta $33,$33,$33,$33,$77,$ff,$ff,$ff
	
sprite_ball_two_even_group_1
	dta $0f,$0f,$06,$06,$03,$00,$00,$00,$04,$04,$08,$08,$00,$00,$00,$00
	
mask_player_bonus_even_group_1
	dta $00,$00,$00,$00,$00,$00,$00,$88,$33,$33,$33,$33,$33,$33,$33,$77
	
sprite_sparks_group_3
	dta $22,$aa,$44,$44,$44,$44,$44,$00
	
sprite_player_one_odd_group_0
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$23,$46,$14,$bc,$9e,$0f
	dta $00,$00,$0c,$00,$80,$c0,$c0,$0c              
	
sprite_player_two_odd_group_0
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$32,$64,$41,$cb,$e1,$f0
	dta $00,$00,$c0,$00,$08,$0c,$0c,$c0
	
mask_player_odd_group_0
	dta $ff,$ff,$ff,$ff,$ff,$ee,$ee,$ee,$ff,$cc,$88,$00,$00,$00,$00,$00
	dta $ff,$33,$11,$33,$11,$11,$11,$11
	
sprite_player_one_weapon_0_even
	dta $00,$00,$33,$30,$30,$20,$20,$00,$00,$00,$ee,$e0,$00,$00,$00,$00
	
sprite_player_two_weapon_0_even
	dta $00,$00,$33,$03,$03,$02,$20,$00,$00,$00,$ee,$0e,$00,$00,$00,$00
	
mask_player_weapon_0_even
	dta $ff,$cc,$cc,$cc,$cc,$cc,$dd,$dd,$ff,$11,$11,$11,$11,$ff,$ff,$ff
	
sprite_player_one_weapon_0_inactive_even
	dta $00,$00,$32,$20,$30,$20,$20,$00,$00,$00,$cc,$c0,$00,$00,$00,$00
	
sprite_player_two_weapon_0_inactive_even
	dta $00,$00,$33,$02,$03,$02,$20,$00,$00,$00,$cc,$0c,$00,$00,$00,$00
	
mask_player_weapon_0_inactive_even
	dta $ff,$cc,$cc,$cc,$cc,$cc,$dd,$dd,$ff,$33,$33,$33,$33,$ff,$ff,$ff
	
sprite_alien_odd_group_0
	dta $00,$00,$00,$00,$11,$01,$23,$03,$33,$47,$cb,$a1,$4b,$0f,$0f,$0f
	dta $08,$0c,$0c,$0c,$0c,$08,$08,$00
	
mask_alien_odd_group_0
	dta $ff,$ff,$ee,$ee,$ee,$cc,$cc,$cc,$88,$00,$00,$00,$00,$00,$00,$00
	dta $33,$11,$11,$11,$11,$33,$33,$77
	
sprite_ball_one_odd_group_0
	dta $00,$00,$00,$10,$10,$31,$31,$30,$00,$00,$c0,$e0,$e8,$f0,$f0,$f0
	
mask_ball_odd_group_0
	dta $ff,$ff,$ee,$ee,$cc,$cc,$cc,$cc,$ff,$33,$11,$11,$00,$00,$00,$00
	
mask_sparks_group_0
	dta $44,$44,$11,$11,$88,$88,$88,$11
	
sprite_player_one_odd_group_1
	dta $00,$00,$11,$01,$23,$03,$02,$01,$0f,$cd,$0e,$0f,$0e,$14,$7c,$3e
	dta $08,$0c,$00,$55,$fa,$a0,$50,$f0
	
sprite_player_two_odd_group_1
	dta $00,$00,$11,$10,$32,$30,$20,$10,$f0,$dc,$e0,$f0,$e0,$41,$c7,$e3
	dta $80,$c0,$00,$55,$af,$0a,$05,$0f
	
mask_player_odd_group_1
	dta $ee,$ee,$cc,$cc,$cc,$cc,$cc,$cc,$00,$00,$00,$00,$00,$00,$00,$00
	dta $11,$11,$33,$00,$00,$00,$00,$00
	
sprite_player_one_weapon_1_even
	dta $00,$00,$33,$30,$30,$20,$20,$00,$80,$80,$80,$44,$40,$80,$80,$00	

sprite_player_two_weapon_1_even
	dta $00,$00,$33,$03,$03,$02,$20,$00,$08,$08,$08,$44,$04,$08,$08,$00
	
mask_player_weapon_1_even
	dta $ff,$cc,$cc,$cc,$cc,$cc,$dd,$dd,$77,$77,$33,$33,$33,$77,$77,$ff
	
sprite_player_one_weapon_1_inactive_even
	dta $00,$00,$33,$20,$20,$30,$20,$00,$00,$00,$00,$88,$80,$00,$00,$00
	
sprite_player_two_weapon_1_inactive_even
	dta $00,$00,$33,$02,$02,$03,$20,$00,$00,$00,$00,$88,$08,$00,$00,$00
	
mask_player_weapon_1_inactive_even
	dta $ff,$cc,$cc,$cc,$cc,$cc,$cc,$dd,$ff,$ff,$77,$77,$77,$77,$ff,$ff
	
sprite_alien_odd_group_1
	dta $02,$00,$01,$20,$30,$30,$21,$03,$02,$01,$03,$0e,$00,$91,$89,$4d
	dta $08,$44,$06,$8e,$0e,$0e,$0e,$0d
	
mask_alien_odd_group_1
	dta $cc,$ff,$cc,$cc,$cc,$cc,$cc,$cc,$00,$cc,$00,$00,$00,$00,$00,$00
	dta $33,$11,$11,$11,$11,$11,$00,$00
	
sprite_ball_one_odd_group_1
	dta $30,$30,$30,$10,$10,$00,$00,$00,$f0,$d0,$d0,$a0,$a0,$c0,$00,$00
	
mask_ball_odd_group_1
	dta $cc,$cc,$cc,$cc,$ee,$ee,$ff,$ff,$00,$00,$00,$00,$11,$11,$33,$ff
	
mask_sparks_group_1
	dta $11,$11,$99,$88,$88,$88,$99,$99
	
sprite_player_one_odd_group_2
	dta $03,$03,$01,$00,$00,$00,$00,$00,$1f,$0f,$0c,$03,$0f,$07,$03,$01
	dta $28,$2d,$48,$00,$88,$4c,$2e,$0e
	
sprite_player_two_odd_group_2
	dta $30,$30,$10,$00,$00,$00,$00,$00,$f1,$f0,$c0,$30,$f0,$70,$30,$10
	dta $d2,$d2,$84,$00,$88,$c4,$e2,$e0
	
mask_player_odd_group_2
	dta $cc,$cc,$cc,$ee,$ff,$ff,$ff,$ff,$00,$00,$00,$00,$00,$88,$cc,$cc
	dta $00,$00,$00,$33,$33,$11,$00,$00
	
sprite_player_one_weapon_2_even
	dta $00,$00,$33,$30,$20,$30,$20,$00,$00,$22,$ec,$e0,$a0,$e0,$00,$00
	
sprite_player_two_weapon_2_even
	dta $00,$00,$33,$03,$02,$03,$20,$00,$00,$22,$ce,$0e,$0a,$0e,$00,$00
	
mask_player_weapon_2_even
	dta $ff,$cc,$cc,$cc,$cc,$cc,$cc,$dd,$dd,$11,$11,$11,$11,$11,$11,$ff
	
sprite_player_one_weapon_2_inactive_even
	dta $00,$00,$33,$10,$20,$10,$20,$00,$00,$88,$80,$80,$80,$80,$00,$00
	
sprite_player_two_weapon_2_inactive_even
	dta $00,$00,$33,$01,$03,$01,$20,$00,$00,$88,$08,$08,$08,$08,$00,$00
	
mask_player_weapon_2_inactive_even
	dta $ff,$cc,$cc,$cc,$cc,$cc,$cc,$dd,$77,$77,$77,$77,$77,$77,$77,$ff
	
sprite_alien_odd_group_2
	dta $22,$32,$11,$00,$01,$11,$11,$00,$2e,$07,$83,$49,$2c,$06,$83,$c9
	dta $0d,$01,$0b,$0b,$47,$8e,$06,$08
	
mask_alien_odd_group_2
	dta $cc,$cc,$cc,$cc,$cc,$cc,$cc,$ee,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00
	
sprite_ball_two_odd_group_0
	dta $00,$00,$01,$01,$13,$13,$03,$03,$00,$0c,$0e,$8e,$0f,$0f,$0f,$0f
	
mask_player_bonus_odd_group_0
	dta $ee,$cc,$cc,$cc,$cc,$cc,$cc,$cc,$11,$00,$00,$00,$00,$00,$00,$00
	
mask_sparks_group_2
	dta $11,$11,$11,$99,$88,$88,$88,$99
	
sprite_player_one_odd_group_3
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$11,$23,$46,$03,$01,$00
	dta $0a,$8c,$0e,$0c,$08,$00,$08,$00
	
sprite_player_two_odd_group_3
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$11,$32,$64,$30,$10,$00
	dta $a0,$c8,$e0,$c0,$80,$00,$80,$00
	
mask_player_odd_group_3
	dta $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ee,$ee,$cc,$88,$88,$88,$cc,$ee
	dta $00,$00,$00,$11,$33,$77,$33,$33
	
sprite_player_one_weapon_3_even
	dta $00,$00,$22,$21,$21,$21,$20,$00,$00,$00,$4c,$ae,$5f,$ae,$4c,$00
	
sprite_player_two_weapon_3_even
	dta $00,$00,$22,$03,$03,$03,$20,$00,$00,$00,$4c,$ae,$5f,$ae,$4c,$00
	
mask_player_weapon_3_even
	dta $ff,$dd,$cc,$cc,$cc,$cc,$cc,$dd,$ff,$33,$11,$00,$00,$00,$11,$33
	
sprite_player_one_weapon_3_inactive_even
	dta $00,$00,$22,$21,$21,$21,$20,$00,$00,$00,$84,$4a,$a5,$4a,$84,$00
	
sprite_player_two_weapon_3_inactive_even
	dta $00,$00,$22,$03,$03,$03,$20,$00,$00,$00,$84,$4a,$a5,$4a,$84,$00
	
mask_player_weapon_3_inactive_even
	dta $ff,$dd,$cc,$cc,$cc,$cc,$cc,$dd,$ff,$33,$11,$00,$00,$00,$11,$33
	
sprite_alien_odd_group_3
	dta $00,$00,$00,$00,$00,$00,$00,$00,$24,$1e,$8b,$c9,$64,$30,$30,$20
	dta $23,$47,$07,$0a,$0c,$80,$00,$00
	
mask_alien_odd_group_3
	dta $ee,$ee,$ee,$ee,$ff,$ff,$ff,$ff,$00,$00,$00,$00,$00,$88,$cc,$cc
	dta $00,$00,$00,$00,$11,$33,$77,$ff
	
sprite_ball_two_odd_group_1
	dta $03,$03,$01,$01,$00,$00,$00,$00,$0d,$0d,$0a,$0a,$0c,$00,$00,$00
	
mask_player_bonus_odd_group_1
	dta $cc,$cc,$cc,$cc,$cc,$cc,$cc,$ee,$00,$00,$00,$00,$00,$00,$00,$11
	
mask_sparks_group_3
	dta $11,$11,$11,$99,$99,$99,$99,$99
	
sprite_player_one_bonus_even_group_0
	dta $00,$07,$0f,$f0,$ff,$ff,$33,$33,$00,$08,$0c,$c0,$cc,$cc,$00,$00
	
sprite_diamond_even_group_0
	dta $00,$00,$00,$00,$11,$11,$01,$23,$00,$88,$88,$88,$48,$48,$84,$a4
	dta $00,$00,$00,$00,$00,$00,$00,$00
	
sprite_claw_even_group_0
	dta $00,$00,$11,$32,$21,$47,$42,$05,$00,$00,$0e,$2d,$0f,$03,$0d,$02
	dta $00,$00,$00,$08,$84,$4a,$2d,$0f,$00,$00,$00,$00,$00,$00,$00,$00
	
mask_claw_even_group_0
	dta $ff,$ee,$cc,$cc,$88,$88,$88,$00,$ff,$11,$00,$00,$00,$00,$00,$00
	dta $ff,$ff,$77,$33,$11,$00,$00,$00,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$77
	
sprite_segment_one_even_group_0
	dta $00,$23,$56,$27,$5e,$9f,$2f,$8f,$00,$00,$08,$84,$4a,$86,$2d,$4b
	dta $00,$00,$00,$00,$00,$00,$00,$00
	
mask_segment_one_even_group_0
	dta $cc,$88,$88,$88,$00,$00,$00,$00,$ff,$77,$33,$11,$11,$00,$00,$00
	dta $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	
sprite_segment_two_even_group_0
	dta $00,$00,$00,$00,$00,$11,$01,$23,$00,$32,$47,$9e,$4f,$1e,$ad,$0f
	dta $00,$00,$80,$08,$84,$48,$84,$0c
	
mask_segment_two_even_group_0
	dta $ff,$ff,$ff,$ee,$ee,$cc,$cc,$cc,$cc,$88,$00,$00,$00,$00,$00,$00
	dta $ff,$77,$77,$33,$33,$33,$33,$33
	
sprite_legs_even_group_0
	dta $00,$46,$cf,$8f,$8a,$89,$00,$00,$00,$11,$33,$2b,$2a,$04,$0c,$0e
	dta $00,$08,$0c,$04,$0a,$06,$01,$03,$00,$00,$00,$00,$00,$00,$00,$00
	
mask_diamond_even_group_0
	dta $ff,$ff,$ff,$ee,$ee,$ee,$cc,$cc,$77,$77,$77,$33,$33,$33,$11,$11
	dta $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	
sprite_player_one_bonus_even_group_1
	dta $3f,$3f,$3f,$3f,$3f,$0c,$07,$00,$04,$04,$04,$04,$04,$04,$08,$00
	
sprite_diamond_even_group_1
	dta $23,$13,$57,$57,$27,$af,$af,$5f,$a4,$4a,$5a,$5a,$a5,$a5,$a5,$5f
	dta $00,$00,$00,$00,$00,$80,$80,$08
	
sprite_claw_even_group_1
	dta $8a,$84,$00,$08,$00,$00,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00
	dta $16,$0f,$0b,$07,$05,$12,$00,$02,$08,$08,$08,$0c,$84,$40,$80,$80
	
mask_claw_even_group_1
	dta $00,$11,$33,$77,$77,$ff,$ff,$ff,$cc,$ee,$ff,$ff,$ff,$ff,$ff,$ff
	dta $00,$00,$00,$00,$88,$88,$cc,$cc,$77,$77,$33,$33,$33,$33,$33,$33
	
sprite_segment_one_even_group_1
	dta $1e,$0f,$8f,$0f,$0b,$07,$07,$05,$2d,$5a,$2d,$1e,$0f,$0f,$0f,$0f
	dta $00,$08,$08,$08,$08,$84,$0c,$0c
	
mask_segment_one_even_group_1
	dta $00,$00,$00,$00,$00,$00,$88,$88,$00,$00,$00,$00,$00,$00,$00,$00
	dta $77,$77,$77,$77,$33,$33,$33,$33
	
sprite_segment_two_even_group_1
	dta $13,$03,$03,$47,$27,$17,$07,$8f,$1e,$8f,$1e,$0f,$0f,$1e,$2d,$0e
	dta $48,$84,$0c,$48,$84,$08,$04,$08
	
mask_segment_two_even_group_1
	dta $cc,$88,$88,$88,$88,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $33,$33,$33,$33,$33,$33,$33,$33
	
sprite_legs_even_group_1
	dta $00,$22,$46,$07,$07,$8f,$0f,$0f,$06,$0e,$0f,$05,$0b,$0d,$0f,$0f
	dta $03,$47,$07,$8e,$05,$0b,$05,$0f,$00,$00,$00,$00,$00,$88,$4c,$0c
	
mask_diamond_even_group_1
	dta $cc,$88,$88,$88,$00,$00,$00,$00,$11,$00,$00,$00,$00,$00,$00,$00
	dta $ff,$ff,$ff,$ff,$77,$77,$77,$77
	
sprite_player_two_bonus_even_group_0
	dta $00,$70,$f0,$0f,$ff,$ff,$33,$f3,$00,$80,$c0,$0c,$cc,$cc,$00,$40
	
sprite_diamond_even_group_2
	dta $5f,$a5,$a5,$25,$52,$52,$12,$21,$5f,$a7,$a7,$a7,$5f,$5f,$4e,$a6
	dta $08,$88,$88,$00,$00,$00,$00,$00
	
sprite_claw_even_group_2
	dta $00,$00,$88,$00,$0c,$4a,$25,$07,$00,$00,$00,$00,$00,$11,$32,$cf
	dta $12,$65,$07,$cb,$0f,$86,$0f,$0d,$40,$84,$0c,$08,$00,$08,$00,$00
	
mask_claw_even_group_2
	dta $ff,$77,$77,$33,$11,$00,$00,$88,$ff,$ff,$ff,$ff,$ee,$cc,$00,$00
	dta $88,$88,$00,$00,$00,$00,$00,$00,$33,$33,$33,$33,$77,$77,$77,$ff
	
sprite_segment_one_even_group_2
	dta $03,$02,$01,$01,$00,$00,$00,$00,$0f,$0e,$0f,$07,$0b,$05,$02,$01
	dta $08,$0c,$08,$04,$08,$04,$08,$00
	
mask_segment_one_even_group_2
	dta $88,$cc,$cc,$ee,$ee,$ff,$ff,$ff,$00,$00,$00,$00,$00,$00,$88,$cc
	dta $33,$33,$33,$33,$33,$33,$33,$77
	
sprite_segment_two_even_group_2
	dta $4f,$2f,$0f,$1e,$0f,$0e,$05,$0a,$0d,$4a,$0d,$0a,$05,$0a,$04,$08
	dta $00,$08,$00,$00,$00,$00,$00,$00
	
mask_segment_two_even_group_2
	dta $00,$00,$00,$00,$00,$00,$00,$88,$00,$00,$00,$00,$00,$00,$11,$33
	dta $33,$77,$77,$77,$ff,$ff,$ff,$ff
	
sprite_legs_even_group_2
	dta $4b,$2d,$4b,$25,$07,$24,$02,$00,$0f,$0f,$8d,$0a,$05,$0d,$0e,$04
	dta $0e,$0d,$02,$0d,$06,$0f,$07,$03,$08,$04,$08,$00,$00,$00,$00,$00
	
mask_diamond_even_group_2
	dta $00,$00,$00,$00,$88,$88,$88,$cc,$00,$00,$00,$00,$00,$00,$00,$11
	dta $77,$77,$77,$77,$ff,$ff,$ff,$ff
	
sprite_player_two_bonus_even_group_1
	dta $f3,$f3,$f3,$f3,$f3,$c0,$70,$00,$40,$40,$40,$40,$40,$40,$80,$00
	
sprite_diamond_even_group_3
	dta $21,$01,$10,$10,$00,$00,$00,$00,$a6,$84,$4c,$4c,$88,$88,$88,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00
	
sprite_claw_even_group_3
	dta $03,$02,$01,$00,$00,$00,$00,$00,$0f,$0f,$01,$0f,$00,$00,$00,$00
	dta $0a,$04,$08,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	
mask_claw_even_group_3
	dta $88,$cc,$cc,$ee,$ff,$ff,$ff,$ff,$00,$00,$00,$00,$00,$ff,$ff,$ff
	dta $00,$11,$33,$77,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	
sprite_platform_group_0
	dta $00,$77,$ff,$f8,$f0,$f0,$60,$30,$00,$ff,$ff,$f0,$f0,$70,$e0,$30
	dta $00,$ff,$ff,$f0,$f0,$70,$e0,$30,$00,$ff,$ff,$f0,$f0,$70,$e0,$30
	dta $00,$ff,$ff,$f0,$f0,$70,$e0,$30,$00,$ff,$ff,$f0,$f0,$70,$e0,$30
	dta $00,$ff,$ff,$f0,$f0,$70,$e0,$30,$00,$ff,$ff,$f0,$f0,$70,$e0,$30
	dta $00,$ff,$ff,$f0,$f0,$70,$e0,$30,$00,$ff,$ff,$f0,$f0,$70,$e0,$30
	dta $00,$ff,$ff,$f0,$f0,$70,$e0,$30,$00,$ee,$ff,$f1,$f0,$50,$e0,$80
	
sprite_legs_even_group_3
	dta $00,$00,$99,$ab,$8e,$cf,$ce,$00,$0e,$0c,$26,$2a,$2b,$33,$11,$00
	dta $03,$45,$06,$8a,$0c,$4c,$08,$00,$00,$00,$00,$00,$00,$00,$00,$00
	
mask_diamond_even_group_3
	dta $cc,$cc,$ee,$ee,$ee,$ff,$ff,$ff,$11,$11,$33,$33,$33,$77,$77,$77
	dta $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	
sprite_player_one_bonus_odd_group_0
	dta $00,$01,$03,$30,$33,$33,$00,$00,$00,$0e,$0f,$f0,$ff,$ff,$cc,$cc
	
sprite_diamond_odd_group_0
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$22,$22,$22,$53,$53,$25,$a5
	dta $00,$00,$00,$00,$00,$00,$00,$88
	
sprite_claw_odd_group_0
	dta $00,$00,$00,$00,$00,$11,$10,$01,$00,$00,$47,$cb,$87,$0c,$0b,$04
	dta $00,$00,$08,$86,$2d,$1e,$07,$0b,$00,$00,$00,$00,$00,$08,$84,$0c
	
mask_claw_odd_group_0
	dta $ff,$ff,$ff,$ff,$ee,$ee,$ee,$cc,$ff,$88,$00,$00,$00,$00,$00,$00
	dta $ff,$77,$11,$00,$00,$00,$00,$00,$ff,$ff,$ff,$ff,$77,$33,$33,$11
	
sprite_segment_one_odd_group_0
	dta $00,$00,$11,$01,$13,$23,$03,$23,$00,$8c,$4a,$ad,$5a,$6d,$8f,$1e
	dta $00,$00,$00,$00,$08,$08,$84,$0c
	
mask_segment_one_odd_group_0
	dta $ff,$ee,$ee,$ee,$cc,$cc,$cc,$cc,$33,$11,$00,$00,$00,$00,$00,$00
	dta $ff,$ff,$ff,$77,$77,$33,$33,$33
	
sprite_segment_two_odd_group_0
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$11,$23,$13,$47,$27,$8f
	dta $00,$c8,$2c,$4a,$2d,$5a,$a5,$0f
	
mask_segment_two_odd_group_0
	dta $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ee,$cc,$88,$88,$00,$00,$00
	dta $33,$11,$11,$00,$00,$00,$00,$00
	
sprite_legs_odd_group_0
	dta $00,$00,$00,$00,$00,$00,$00,$00,$46,$cf,$8d,$8a,$89,$00,$00,$11
	dta $00,$11,$19,$19,$15,$0c,$0c,$0c,$8c,$8e,$8a,$05,$03,$01,$03,$47
	
mask_diamond_odd_group_0
	dta $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$dd,$dd,$dd,$88,$88,$88,$00,$00
	dta $ff,$ff,$ff,$ff,$ff,$ff,$77,$77
	
sprite_player_one_bonus_odd_group_1
	dta $03,$03,$03,$03,$03,$03,$01,$00,$cd,$cd,$cd,$cd,$cd,$01,$0e,$00
	
sprite_diamond_odd_group_1
	dta $00,$00,$10,$10,$01,$21,$21,$13,$a5,$5b,$5b,$5b,$a5,$a5,$a5,$5f
	dta $88,$08,$4c,$4c,$8c,$ae,$ae,$4e
	
sprite_claw_odd_group_1
	dta $22,$21,$00,$02,$00,$00,$00,$00,$08,$00,$00,$00,$00,$00,$00,$00
	dta $05,$03,$02,$01,$01,$00,$00,$00,$4a,$0e,$0e,$0f,$25,$58,$20,$28
	
mask_claw_odd_group_1
	dta $cc,$cc,$cc,$dd,$dd,$ff,$ff,$ff,$33,$77,$ff,$ff,$ff,$ff,$ff,$ff
	dta $00,$88,$cc,$cc,$ee,$ee,$ff,$ff,$11,$11,$00,$00,$00,$00,$00,$00
	
sprite_segment_one_odd_group_1
	dta $03,$03,$23,$03,$02,$01,$01,$01,$4b,$1e,$0f,$0f,$0f,$0f,$0f,$07
	dta $84,$4a,$86,$4a,$0e,$2d,$0f,$0f
	
mask_segment_one_odd_group_1
	dta $cc,$cc,$cc,$cc,$cc,$cc,$ee,$ee,$00,$00,$00,$00,$00,$00,$00,$00
	dta $11,$11,$11,$11,$00,$00,$00,$00
	
sprite_segment_two_odd_group_1
	dta $00,$00,$00,$11,$01,$01,$01,$23,$4f,$2f,$0f,$0f,$8f,$4f,$0f,$0f
	dta $5a,$2d,$4b,$1e,$2d,$4a,$85,$0a
	
mask_segment_two_odd_group_1
	dta $ff,$ee,$ee,$ee,$ee,$cc,$cc,$cc,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00
	
sprite_legs_odd_group_1
	dta $00,$00,$11,$01,$01,$23,$03,$03,$23,$cf,$0f,$0d,$0e,$0f,$0f,$0f
	dta $08,$0c,$2e,$07,$0d,$06,$0d,$0f,$8e,$0e,$0e,$0c,$04,$2e,$17,$0f
	
mask_diamond_odd_group_1
	dta $ff,$ee,$ee,$ee,$cc,$cc,$cc,$cc,$00,$00,$00,$00,$00,$00,$00,$00
	dta $77,$33,$33,$33,$11,$11,$11,$11
	
sprite_player_two_bonus_odd_group_0
	dta $00,$10,$30,$03,$33,$33,$00,$30,$00,$e0,$f0,$0f,$ff,$ff,$cc,$dc
	
sprite_diamond_odd_group_2
	dta $13,$23,$23,$01,$11,$11,$00,$00,$5f,$ad,$ad,$ad,$5e,$5e,$5e,$ad
	dta $4e,$a4,$a4,$84,$48,$48,$08,$80
	
sprite_claw_odd_group_2
	dta $00,$00,$22,$00,$03,$12,$01,$01,$00,$00,$00,$00,$00,$08,$84,$3f
	dta $00,$11,$01,$32,$03,$65,$cb,$0f,$58,$a5,$0f,$0e,$0c,$0a,$0c,$04
	
mask_claw_odd_group_2
	dta $ff,$dd,$dd,$cc,$cc,$cc,$cc,$ee,$ff,$ff,$ff,$ff,$77,$33,$00,$00
	dta $ee,$ee,$cc,$cc,$88,$00,$00,$00,$00,$00,$00,$00,$11,$11,$11,$33
	
sprite_segment_one_odd_group_2
	dta $00,$00,$00,$00,$00,$00,$00,$00,$0f,$0b,$07,$05,$02,$01,$00,$00
	dta $0e,$0b,$0e,$0d,$0e,$05,$0a,$04
	
mask_segment_one_odd_group_2
	dta $ee,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$00,$00,$00,$88,$88,$cc,$ee,$ff
	dta $00,$00,$00,$00,$00,$00,$00,$11
	
sprite_segment_two_odd_group_2
	dta $13,$03,$03,$03,$03,$03,$01,$00,$0f,$9e,$0f,$4a,$0d,$0a,$07,$0c
	dta $04,$0a,$04,$08,$04,$08,$00,$00
	
mask_segment_two_odd_group_2
	dta $cc,$cc,$cc,$cc,$cc,$cc,$cc,$ee,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$11,$11,$11,$33,$33,$77,$ff
	
sprite_legs_odd_group_2
	dta $12,$03,$12,$01,$01,$01,$00,$00,$0f,$87,$2f,$86,$0d,$87,$0f,$02
	dta $0f,$0f,$04,$0b,$05,$07,$0b,$08,$0a,$05,$0a,$04,$08,$0c,$06,$0a
	
mask_diamond_odd_group_2
	dta $cc,$cc,$cc,$cc,$ee,$ee,$ee,$ff,$00,$00,$00,$00,$00,$00,$00,$00
	dta $11,$11,$11,$11,$33,$33,$33,$77
	
sprite_player_two_bonus_odd_group_1
	dta $30,$30,$30,$30,$30,$30,$10,$00,$dc,$dc,$dc,$dc,$dc,$10,$e0,$00
	
sprite_diamond_odd_group_3
	dta $00,$00,$00,$00,$00,$00,$00,$00,$ad,$25,$56,$56,$22,$22,$22,$00
	dta $80,$00,$00,$00,$00,$00,$00,$00
	
sprite_claw_odd_group_3
	dta $00,$00,$00,$00,$00,$00,$00,$00,$0f,$0b,$04,$03,$00,$00,$00,$00
	dta $0e,$0d,$06,$0c,$00,$00,$00,$00,$08,$00,$00,$00,$00,$00,$00,$00
	
mask_claw_odd_group_3
	dta $ee,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$00,$00,$00,$88,$cc,$ff,$ff,$ff
	dta $00,$00,$00,$11,$33,$ff,$ff,$ff,$33,$77,$ff,$ff,$ff,$ff,$ff,$ff
	
mask_platform_group_0
	dta $cc,$88,$00,$00,$00,$00,$88,$cc,$00,$00,$00,$00,$00,$00,$00,$00
	dta $44,$00,$00,$00,$00,$00,$00,$44,$cc,$00,$00,$00,$00,$00,$00,$cc
	dta $cc,$00,$00,$00,$00,$00,$00,$cc,$cc,$00,$00,$00,$00,$00,$00,$cc
	dta $ff,$00,$00,$00,$00,$00,$00,$cc,$cc,$00,$00,$00,$00,$00,$00,$cc
	dta $cc,$00,$00,$00,$00,$00,$00,$cc,$cc,$00,$00,$00,$00,$00,$00,$cc
	dta $cc,$00,$00,$00,$00,$00,$00,$cc,$ff,$11,$00,$00,$00,$00,$11,$77
	
sprite_legs_odd_group_3
	dta $00,$00,$00,$00,$00,$00,$00,$00,$01,$00,$00,$11,$ab,$8e,$cd,$46
	dta $04,$0c,$0c,$15,$19,$19,$00,$00,$05,$03,$01,$22,$03,$8d,$8e,$00
	
mask_diamond_odd_group_3
	dta $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$00,$00,$88,$88,$88,$dd,$dd,$dd
	dta $77,$77,$ff,$ff,$ff,$ff,$ff,$ff
	
mask_legs_even_group_0
	dta $99,$00,$00,$00,$44,$66,$77,$ff,$ee,$cc,$44,$00,$00,$11,$11,$11
	dta $77,$33,$33,$11,$11,$00,$88,$88,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	
sprite_balls_even_group_0
	dta $00,$30,$70,$72,$f4,$f4,$f0,$f0,$00,$00,$90,$91,$e2,$c3,$87,$a7
	dta $00,$00,$80,$80,$c0,$40,$48,$08
	
mask_balls_even_group_0
	dta $cc,$88,$88,$00,$00,$00,$00,$00,$ff,$66,$44,$00,$00,$00,$00,$00
	dta $ff,$77,$77,$33,$33,$33,$33,$33
	
sprite_pillar_even_group_0
	dta $00,$76,$76,$76,$76,$76,$76,$00,$00,$e0,$f0,$e0,$f0,$e0,$f0,$00
	dta $00,$80,$00,$80,$00,$80,$00,$00
	
mask_pillar_even_group_0
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $33,$33,$33,$33,$33,$33,$33,$33
	
sprite_ball_three_even_group_0
	dta $00,$00,$30,$07,$34,$b4,$f0,$80,$00,$00,$00,$80,$08,$c0,$c0,$c0
	
sprite_head_even_group_0
	dta $00,$00,$00,$11,$23,$03,$46,$06,$00,$00,$8f,$0f,$0c,$0f,$03,$00
	dta $00,$00,$00,$08,$0c,$06,$0e,$0f,$00,$00,$00,$00,$00,$00,$00,$00
	
mask_head_even_group_0
	dta $ff,$ff,$ee,$cc,$cc,$88,$88,$88,$ff,$00,$00,$00,$00,$00,$00,$00
	dta $ff,$ff,$77,$33,$11,$11,$00,$00,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	
sprite_mound_group_0
	dta $00,$00,$00,$00,$00,$30,$00,$70,$00,$00,$00,$70,$00,$f0,$00,$f0
	dta $00,$f0,$00,$f0,$00,$f0,$00,$f0,$00,$f0,$00,$f0,$00,$f0,$00,$f0
	dta $00,$00,$00,$e0,$00,$f0,$00,$f0,$00,$00,$00,$00,$00,$c0,$00,$e0
	
mask_legs_even_group_1
	dta $cc,$88,$88,$00,$00,$00,$00,$00,$11,$00,$00,$00,$00,$00,$00,$00
	dta $88,$00,$00,$00,$00,$00,$00,$00,$ff,$ff,$ff,$ff,$77,$33,$33,$33
	
sprite_balls_even_group_1
	dta $f0,$f0,$60,$60,$30,$00,$13,$23,$4f,$4f,$0f,$0f,$0f,$0f,$06,$06
	dta $0c,$0c,$0c,$0c,$04,$04,$08,$08
	
mask_balls_even_group_1
	dta $00,$00,$00,$00,$88,$88,$cc,$88,$00,$00,$00,$00,$00,$00,$00,$00
	dta $33,$33,$33,$33,$33,$33,$33,$77
	
sprite_pillar_even_group_1
	dta $33,$33,$33,$33,$00,$11,$11,$11,$f0,$e0,$d0,$e0,$00,$e8,$c8,$a8
	dta $00,$00,$00,$00,$00,$00,$00,$00
	
mask_pillar_even_group_1
	dta $88,$88,$88,$88,$88,$cc,$cc,$cc,$00,$00,$00,$00,$00,$00,$00,$00
	dta $77,$77,$77,$77,$77,$ff,$ff,$ff
	
sprite_ball_three_even_group_1
	dta $00,$10,$b0,$70,$60,$30,$00,$00,$80,$c0,$40,$80,$80,$00,$00,$00
	
sprite_head_even_group_1
	dta $8f,$0d,$27,$af,$ae,$aa,$aa,$aa,$0f,$05,$af,$af,$ab,$ab,$88,$00
	dta $0f,$0f,$08,$03,$16,$24,$14,$3c,$00,$08,$00,$08,$0c,$84,$04,$84
	
mask_head_even_group_1
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$77
	dta $00,$00,$00,$00,$00,$00,$00,$00,$77,$77,$33,$33,$33,$33,$33,$33
	
sprite_cigar_group_0
	dta $00,$00,$01,$05,$05,$01,$00,$00,$01,$05,$05,$05,$05,$05,$05,$01
	dta $07,$37,$37,$37,$04,$04,$04,$07,$0e,$02,$02,$02,$ce,$ce,$ce,$0e
	dta $08,$0a,$0a,$0a,$0a,$0a,$0a,$08,$00,$00,$08,$0a,$0a,$08,$00,$00
	
mask_legs_even_group_2	;$4000
	dta $00,$00,$00,$00,$88,$88,$cc,$ff,$00,$00,$00,$00,$00,$00,$11,$11
	dta $00,$00,$00,$00,$00,$00,$00,$88,$33,$33,$33,$77,$ff,$ff,$ff,$ff
	
sprite_balls_even_group_2
	dta $27,$07,$07,$07,$07,$03,$03,$05,$0b,$c4,$f4,$f0,$f0,$f0,$f0,$60
	dta $00,$80,$c0,$c0,$c0,$40,$40,$80
	
mask_balls_even_group_2
	dta $88,$88,$88,$88,$88,$88,$88,$88,$00,$00,$00,$00,$00,$00,$00,$00
	dta $33,$33,$33,$33,$33,$33,$33,$33
	
sprite_pillar_even_group_2
	dta $11,$11,$11,$00,$33,$33,$33,$33,$c8,$a8,$c8,$00,$f0,$e0,$d0,$e0
	dta $00,$00,$00,$00,$00,$00,$00,$00
	
mask_pillar_even_group_2
	dta $cc,$cc,$cc,$88,$88,$88,$88,$88,$00,$00,$00,$00,$00,$00,$00,$00
	dta $ff,$ff,$ff,$77,$77,$77,$77,$77
	
sprite_drone_even_group_0
	dta $00,$03,$06,$87,$e0,$e5,$e4,$e1,$00,$00,$08,$04,$08,$04,$08,$04
	
sprite_head_even_group_2
	dta $88,$00,$00,$aa,$aa,$2f,$05,$06,$00,$00,$00,$aa,$aa,$af,$04,$0f
	dta $1c,$2c,$1c,$06,$0b,$05,$0a,$05,$04,$84,$04,$0c,$0c,$04,$08,$00
	
mask_head_even_group_2
	dta $11,$77,$11,$00,$00,$00,$00,$88,$ff,$ff,$ff,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00,$33,$33,$33,$33,$33,$33,$33,$77
	
sprite_ball_four_even_group_0
	dta $00,$03,$27,$27,$4f,$4f,$0e,$0e,$00,$00,$08,$08,$40,$40,$c0,$c0
	
sprite_ball_five_even_group_0
	dta $00,$03,$17,$17,$83,$83,$c1,$c1,$00,$00,$08,$08,$8c,$8c,$0c,$0c
	
sprite_ball_six_even_group_0
	dta $00,$30,$50,$50,$a0,$a0,$c1,$c1,$00,$00,$80,$00,$0c,$0c,$0c,$0c
	
mask_legs_even_group_3  ;$4100
	dta $77,$66,$44,$00,$00,$00,$00,$99,$11,$11,$11,$00,$44,$44,$cc,$ee
	dta $88,$88,$00,$11,$11,$33,$33,$77,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
		
sprite_balls_even_group_3
	dta $06,$07,$07,$03,$03,$01,$00,$00,$60,$38,$0a,$04,$04,$08,$00,$00
	dta $80,$00,$00,$00,$00,$00,$00,$00
	
mask_balls_even_group_3
	dta $88,$88,$88,$88,$cc,$cc,$ee,$ff,$00,$00,$00,$11,$33,$33,$77,$ff
	dta $77,$77,$ff,$ff,$ff,$ff,$ff,$ff
	
sprite_pillar_even_group_3
	dta $00,$76,$76,$76,$76,$76,$76,$00,$00,$f0,$f0,$e0,$f0,$e0,$f0,$00
	dta $00,$80,$00,$80,$00,$80,$00,$00
	
mask_pillar_even_group_3
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $33,$33,$33,$33,$33,$33,$33,$33
	
sprite_drone_even_group_1
	dta $70,$e0,$10,$10,$f0,$70,$30,$00,$08,$04,$c0,$40,$c0,$c0,$80,$00
	
sprite_head_even_group_3
	dta $01,$02,$01,$00,$00,$00,$00,$00,$00,$0f,$00,$0f,$00,$00,$00,$00
	dta $0a,$04,$08,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	
mask_head_even_group_3
	dta $88,$88,$cc,$ee,$ff,$ff,$ff,$ff,$00,$00,$00,$00,$00,$ff,$ff,$ff
	dta $00,$11,$33,$77,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	
sprite_ball_four_even_group_1
	dta $1c,$1c,$20,$60,$30,$00,$00,$00,$40,$40,$80,$80,$00,$00,$00,$00
	
sprite_ball_five_even_group_1
	dta $a0,$a0,$50,$50,$30,$00,$00,$00,$0c,$0c,$00,$80,$00,$00,$00,$00
	
sprite_ball_six_even_group_1
	dta $83,$83,$17,$17,$03,$00,$00,$00,$8c,$8c,$08,$08,$00,$00,$00,$00
	
mask_legs_odd_group_0
	dta $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$99,$00,$00,$00,$44,$66,$ee,$ee
	dta $ff,$ee,$66,$66,$22,$22,$33,$33,$33,$11,$11,$00,$88,$cc,$88,$88
	
sprite_balls_odd_group_0
	dta $00,$00,$00,$00,$00,$00,$00,$10,$00,$00,$01,$13,$13,$27,$e3,$e8
	dta $00,$00,$08,$0c,$0c,$0e,$0e,$06
	
mask_balls_odd_group_0
	dta $ff,$ff,$ff,$ff,$ff,$ff,$ee,$ee,$ff,$ee,$cc,$cc,$88,$00,$00,$00
	dta $ff,$77,$33,$33,$11,$11,$11,$11
	
sprite_pillar_odd_group_0
	dta $00,$11,$11,$11,$11,$11,$11,$00,$00,$f8,$f8,$f8,$f8,$f8,$f8,$00
	dta $00,$a0,$c0,$a0,$c0,$a0,$c0,$00
	
mask_pillar_odd_group_0
	dta $cc,$cc,$cc,$cc,$cc,$cc,$cc,$cc,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00
	
sprite_ball_three_odd_group_0
	dta $00,$00,$00,$01,$01,$21,$30,$20,$00,$00,$c0,$2c,$c2,$f0,$f0,$30
	
sprite_head_odd_group_0
	dta $00,$00,$00,$00,$00,$00,$11,$01,$00,$00,$23,$47,$8f,$0f,$08,$08
	dta $00,$00,$0c,$0e,$03,$0d,$0f,$03,$00,$00,$00,$00,$00,$08,$08,$0c
	
mask_head_odd_group_0
	dta $ff,$ff,$ff,$ff,$ff,$ee,$ee,$ee,$ff,$cc,$88,$00,$00,$00,$00,$00
	dta $ff,$33,$11,$00,$00,$00,$00,$00,$ff,$ff,$ff,$ff,$77,$77,$33,$33
	
mask_mound_group_0
	dta $ff,$ff,$ff,$ff,$ee,$cc,$88,$00,$ff,$ee,$88,$00,$00,$00,$00,$00
	dta $88,$00,$00,$00,$00,$00,$00,$00,$11,$00,$00,$00,$00,$00,$00,$00
	dta $ff,$77,$11,$00,$00,$00,$00,$00,$ff,$ff,$ff,$ff,$77,$33,$11,$00
	
mask_legs_odd_group_1
	dta $ff,$ff,$ff,$ee,$ee,$cc,$cc,$cc,$cc,$cc,$00,$00,$00,$00,$00,$00
	dta $77,$22,$00,$00,$00,$00,$00,$00,$00,$11,$11,$11,$33,$11,$00,$00
	
sprite_balls_odd_group_1
	dta $10,$31,$31,$30,$30,$30,$30,$00,$e9,$e0,$f0,$f0,$f0,$d0,$30,$0c
	dta $0a,$0c,$0c,$0e,$0e,$0e,$0e,$0a
	
mask_balls_odd_group_1
	dta $cc,$cc,$cc,$cc,$cc,$cc,$cc,$cc,$00,$00,$00,$00,$00,$00,$00,$00
	dta $11,$11,$33,$11,$11,$11,$11,$11
	
sprite_pillar_odd_group_1
	dta $00,$00,$00,$00,$00,$00,$00,$00,$fc,$fc,$fc,$fc,$00,$76,$76,$66
	dta $c0,$80,$40,$80,$00,$80,$00,$80
	
mask_pillar_odd_group_1
	dta $ee,$ee,$ee,$ee,$ee,$ff,$ff,$ff,$00,$00,$00,$00,$00,$00,$00,$00
	dta $11,$11,$11,$11,$11,$33,$33,$33
	
sprite_ball_three_odd_group_1
	dta $00,$00,$20,$10,$10,$00,$00,$00,$20,$70,$d0,$e0,$a0,$c0,$00,$00
	
sprite_head_odd_group_1
	dta $23,$03,$01,$23,$23,$22,$22,$22,$0f,$05,$af,$af,$aa,$aa,$aa,$88
	dta $0f,$07,$8e,$8c,$8d,$8d,$01,$03,$0c,$0e,$00,$0e,$4b,$a1,$41,$e1
	
mask_head_odd_group_1
	dta $cc,$cc,$cc,$cc,$cc,$cc,$cc,$cc,$00,$00,$00,$00,$00,$00,$00,$11
	dta $00,$00,$00,$00,$00,$00,$00,$cc,$00,$00,$00,$00,$00,$00,$00,$00
	
mask_cigar_group_0
	dta $ff,$ee,$88,$00,$00,$88,$ee,$ff,$88,$00,$00,$00,$00,$00,$00,$88
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $11,$00,$00,$00,$00,$00,$00,$11,$ff,$77,$11,$00,$00,$11,$77,$ff
	
mask_legs_odd_group_2
	dta $cc,$cc,$cc,$cc,$ee,$ee,$ff,$ff,$00,$00,$00,$00,$00,$00,$00,$88
	dta $00,$00,$00,$00,$00,$00,$00,$44,$00,$00,$11,$33,$77,$33,$11,$00
	
sprite_balls_odd_group_2
	dta $01,$01,$13,$13,$03,$03,$03,$03,$8f,$8e,$0f,$0f,$0f,$0f,$0d,$0d
	dta $0a,$0c,$00,$c0,$e8,$e8,$f0,$f0
	
mask_balls_odd_group_2
	dta $ee,$cc,$cc,$cc,$cc,$cc,$cc,$cc,$00,$00,$00,$00,$00,$00,$00,$00
	dta $11,$33,$77,$33,$11,$11,$00,$00
	
sprite_pillar_odd_group_2
	dta $00,$00,$00,$00,$00,$00,$00,$00,$76,$66,$76,$00,$fc,$fc,$fc,$fc
	dta $00,$80,$00,$00,$c0,$80,$40,$80
	
mask_pillar_odd_group_2
	dta $ff,$ff,$ff,$ee,$ee,$ee,$ee,$ee,$00,$00,$00,$00,$00,$00,$00,$00
	dta $33,$33,$33,$11,$11,$11,$11,$11
	
sprite_droid_odd_group_0
	dta $00,$00,$01,$21,$30,$31,$31,$30,$00,$0c,$0a,$0d,$82,$85,$82,$85
	
sprite_head_odd_group_2
	dta $22,$00,$00,$22,$22,$03,$01,$01,$00,$00,$00,$aa,$aa,$af,$05,$0b
	dta $03,$03,$03,$89,$8a,$8d,$02,$0d,$41,$a1,$41,$0b,$0f,$05,$0a,$04
	
mask_head_odd_group_2
	dta $cc,$dd,$cc,$cc,$cc,$cc,$cc,$ee,$77,$ff,$77,$00,$00,$00,$00,$00
	dta $cc,$cc,$cc,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$11
	
sprite_ball_four_odd_group_0
	dta $00,$10,$10,$00,$03,$03,$03,$03,$00,$c0,$a0,$a0,$50,$50,$38,$38
	
sprite_ball_five_odd_group_0
	dta $00,$00,$01,$01,$20,$20,$30,$30,$00,$0c,$4e,$4e,$2f,$2f,$07,$07
	
sprite_ball_six_odd_group_0
	dta $00,$00,$10,$10,$20,$20,$30,$30,$00,$e0,$60,$40,$83,$83,$07,$07
	
mask_legs_odd_group_3
	dta $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$cc,$66,$66,$22,$00,$00,$00,$88
	dta $22,$33,$33,$22,$22,$66,$66,$ff,$00,$00,$88,$cc,$88,$00,$11,$11
	
sprite_balls_odd_group_3
	dta $01,$21,$20,$30,$10,$10,$00,$00,$0a,$1e,$1c,$30,$90,$90,$00,$00
	dta $f0,$f0,$d0,$d0,$a0,$a0,$c0,$00
	
mask_balls_odd_group_3
	dta $cc,$cc,$cc,$cc,$cc,$ee,$ee,$ff,$00,$00,$00,$00,$00,$66,$66,$ff
	dta $00,$00,$00,$00,$00,$11,$11,$33
	
sprite_pillar_odd_group_3
	dta $00,$11,$11,$11,$11,$11,$11,$00,$00,$f8,$f8,$f8,$f8,$f8,$f8,$00
	dta $00,$e0,$c0,$a0,$c0,$a0,$c0,$00

mask_pillar_odd_group_3
	dta $cc,$cc,$cc,$cc,$cc,$cc,$cc,$cc,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00
	
sprite_droid_odd_group_1
	dta $10,$30,$00,$00,$30,$10,$00,$00,$c2,$81,$70,$50,$f0,$f0,$e0,$00
	
sprite_head_odd_group_3
	dta $00,$00,$00,$00,$00,$00,$00,$00,$04,$0b,$04,$03,$00,$00,$00,$00
	dta $02,$0d,$02,$0c,$00,$00,$00,$00,$08,$00,$00,$00,$00,$00,$00,$00
	
mask_head_odd_group_3
	dta $ee,$ee,$ff,$ff,$ff,$ff,$ff,$ff,$00,$00,$00,$88,$cc,$ff,$ff,$ff
	dta $00,$00,$00,$11,$33,$ff,$ff,$ff,$33,$77,$ff,$ff,$ff,$ff,$ff,$ff
	
sprite_ball_four_odd_group_1
	dta $13,$13,$01,$01,$00,$00,$00,$00,$1c,$1c,$8e,$8e,$0c,$00,$00,$00
	
sprite_ball_five_odd_group_1
	dta $20,$20,$10,$10,$00,$00,$00,$00,$83,$83,$40,$60,$c0,$00,$00,$00
	
sprite_ball_six_odd_group_1
	dta $20,$20,$01,$01,$00,$00,$00,$00,$2f,$2f,$4e,$4e,$0c,$00,$00,$00
    		
sprite_fireball_group_0
	dta $00,$33,$67,$cf,$df,$67,$33,$00,$cc,$5f,$af,$5f,$1f,$af,$4f,$dd
	dta $10,$0a,$8e,$6c,$9e,$5d,$aa,$01,$10,$04,$6c,$88,$26,$18,$02,$50 

end_sprite_data0 = *

sprite_explosion_one_group_0	ins 'DATA\graphics\exp01.ora', 0,24
mask_explosion_one_group_0		ins 'DATA\graphics\exp01.msk', 0,24
sprite_explosion_two_group_0	ins 'DATA\graphics\exp02.ora', 0,24
mask_explosion_two_group_0		ins 'DATA\graphics\exp02.msk', 0,24
sprite_explosion_three_group_0	ins 'DATA\graphics\exp03.ora', 0,24
mask_explosion_three_group_0	ins 'DATA\graphics\exp03.msk', 0,24

sprite_data1 = *

sprite_rocket_group_0
	dta $00,$00,$00,$00,$00,$00,$11,$fe,$00,$00,$00,$00,$00,$00,$ff,$f0
	dta $00,$00,$00,$00,$11,$10,$ee,$f0,$00,$33,$47,$8f,$0f,$f0,$50,$f0
	
mask_rocket_group_0
	dta $ff,$ff,$ff,$ff,$ff,$ee,$88,$00,$ff,$ff,$ff,$ff,$ff,$00,$00,$00
	dta $ff,$ff,$ff,$ee,$cc,$00,$00,$00,$cc,$88,$00,$00,$00,$00,$00,$00 

end_sprite_data1 = *	

; unused
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	
sprite_explosion_one_group_1	ins 'DATA\graphics\exp01.ora',24,24
mask_explosion_one_group_1		ins 'DATA\graphics\exp01.msk',24,24
sprite_explosion_two_group_1	ins 'DATA\graphics\exp02.ora',24,24
mask_explosion_two_group_1		ins 'DATA\graphics\exp02.msk',24,24
sprite_explosion_three_group_1	ins 'DATA\graphics\exp03.ora',24,24
mask_explosion_three_group_1	ins 'DATA\graphics\exp03.msk',24,24

sprite_data2 = *

sprite_rocket_group_1
	dta $e0,$10,$00,$00,$00,$00,$00,$00,$70,$f0,$00,$00,$00,$00,$00,$00
	dta $f0,$e0,$10,$01,$00,$00,$00,$00,$f0,$50,$f0,$0f,$0f,$07,$03,$00 

mask_rocket_group_1
	dta $00,$88,$ee,$ff,$ff,$ff,$ff,$ff,$00,$00,$00,$ff,$ff,$ff,$ff,$ff
	dta $00,$00,$00,$cc,$ee,$ff,$ff,$ff,$00,$00,$00,$00,$00,$00,$88,$cc 

end_sprite_data2 = *

; unused
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	
			
sprite_explosion_one_group_2	ins 'DATA\graphics\exp01.ora',48,24
mask_explosion_one_group_2		ins 'DATA\graphics\exp01.msk',48,24
sprite_explosion_two_group_2	ins 'DATA\graphics\exp02.ora',48,24
mask_explosion_two_group_2		ins 'DATA\graphics\exp02.msk',48,24
sprite_explosion_three_group_2	ins 'DATA\graphics\exp03.ora',48,24
mask_explosion_three_group_2	ins 'DATA\graphics\exp03.msk',48,24

	.align $0100
sprite_explosion_four_group_0   ins 'DATA\graphics\exp04.ora', 0,24
mask_explosion_four_group_0		ins 'DATA\graphics\exp04.msk', 0,24
sprite_explosion_five_group_0   ins 'DATA\graphics\exp05.ora', 0,24
mask_explosion_five_group_0		ins 'DATA\graphics\exp05.msk', 0,24
sprite_explosion_six_group_0    ins 'DATA\graphics\exp06.ora', 0,24
mask_explosion_six_group_0		ins 'DATA\graphics\exp06.msk', 0,24

	.align $0100
sprite_explosion_four_group_1   ins 'DATA\graphics\exp04.ora',24,24
mask_explosion_four_group_1		ins 'DATA\graphics\exp04.msk',24,24
sprite_explosion_five_group_1   ins 'DATA\graphics\exp05.ora',24,24
mask_explosion_five_group_1		ins 'DATA\graphics\exp05.msk',24,24
sprite_explosion_six_group_1    ins 'DATA\graphics\exp06.ora',24,24
mask_explosion_six_group_1		ins 'DATA\graphics\exp06.msk',24,24

	.align $0100
sprite_explosion_four_group_2   ins 'DATA\graphics\exp04.ora',48,24
mask_explosion_four_group_2		ins 'DATA\graphics\exp04.msk',48,24
sprite_explosion_five_group_2   ins 'DATA\graphics\exp05.ora',48,24
mask_explosion_five_group_2		ins 'DATA\graphics\exp05.msk',48,24
sprite_explosion_six_group_2    ins 'DATA\graphics\exp06.ora',48,24
mask_explosion_six_group_2		ins 'DATA\graphics\exp06.msk',48,24

	.align $0100
sprite_explosion_seven_group_0  ins 'DATA\graphics\exp07.ora', 0,24
mask_explosion_seven_group_0  	ins 'DATA\graphics\exp07.msk', 0,24
sprite_explosion_eight_group_0  ins 'DATA\graphics\exp08.ora', 0,24
mask_explosion_eight_group_0	ins 'DATA\graphics\exp08.msk', 0,24
sprite_explosion_nine_group_0   ins 'DATA\graphics\exp08.ora', 0,24
mask_explosion_nine_group_0		ins 'DATA\graphics\exp08.msk', 0,24

	.align $0100
sprite_explosion_seven_group_1  ins 'DATA\graphics\exp07.ora',24,24
mask_explosion_seven_group_1  	ins 'DATA\graphics\exp07.msk',24,24
sprite_explosion_eight_group_1  ins 'DATA\graphics\exp08.ora',24,24
mask_explosion_eight_group_1	ins 'DATA\graphics\exp08.msk',24,24
sprite_explosion_nine_group_1   ins 'DATA\graphics\exp09.ora',24,24
mask_explosion_nine_group_1		ins 'DATA\graphics\exp09.msk',24,24

	.align $0100
sprite_explosion_seven_group_2  ins 'DATA\graphics\exp07.ora',48,24
mask_explosion_seven_group_2  	ins 'DATA\graphics\exp07.msk',48,24
sprite_explosion_eight_group_2  ins 'DATA\graphics\exp08.ora',48,24
mask_explosion_eight_group_2	ins 'DATA\graphics\exp08.msk',48,24
sprite_explosion_nine_group_2   ins 'DATA\graphics\exp09.ora',48,24
mask_explosion_nine_group_2		ins 'DATA\graphics\exp09.msk',48,24

;---------------------------------------------------------------------------------------------------------------------------------------------------

	.align $0100
sprite_score_bonus_even_group_0	ins 'DATA\graphics\bonus_score.ora', 0,16
mask_score_bonus_even_group_0	 	ins 'DATA\graphics\bonus_score.msk', 0,16
sprite_life_bonus_even_group_0    	ins 'DATA\graphics\bonus_life.ora', 0,16
mask_life_bonus_even_group_0    	ins 'DATA\graphics\bonus_life.msk', 0,16
sprite_arms_bonus_even_group_0    	ins 'DATA\graphics\bonus_arms.ora', 0,16
mask_arms_bonus_even_group_0    	ins 'DATA\graphics\bonus_arms.msk', 0,16
	
	.align $0100
sprite_score_bonus_even_group_1	ins 'DATA\graphics\bonus_score.ora',16,16
mask_score_bonus_even_group_1		ins 'DATA\graphics\bonus_score.msk',16,16
sprite_life_bonus_even_group_1    	ins 'DATA\graphics\bonus_life.ora',16,16
mask_life_bonus_even_group_1    	ins 'DATA\graphics\bonus_life.msk',16,16
sprite_arms_bonus_even_group_1    	ins 'DATA\graphics\bonus_arms.ora',16,16
mask_arms_bonus_even_group_1    	ins 'DATA\graphics\bonus_arms.msk',16,16

    org sprite_score_bonus_even_group_0+$400
sprite_score_bonus_odd_group_0		ins 'DATA\graphics\bonus_score_lsr2.ora', 0,16
mask_score_bonus_odd_group_0		ins 'DATA\graphics\bonus_score_lsr2.msk', 0,16
sprite_life_bonus_odd_group_0    	ins 'DATA\graphics\bonus_life_lsr2.ora', 0,16
mask_life_bonus_odd_group_0    		ins 'DATA\graphics\bonus_life_lsr2.msk', 0,16
sprite_arms_bonus_odd_group_0    	ins 'DATA\graphics\bonus_arms_lsr2.ora', 0,16
mask_arms_bonus_odd_group_0    		ins 'DATA\graphics\bonus_arms_lsr2.msk', 0,16

    .align $0100
sprite_score_bonus_odd_group_1		ins 'DATA\graphics\bonus_score_lsr2.ora',16,16
mask_score_bonus_odd_group_1		ins 'DATA\graphics\bonus_score_lsr2.msk',16,16
sprite_life_bonus_odd_group_1    	ins 'DATA\graphics\bonus_life_lsr2.ora',16,16
mask_life_bonus_odd_group_1    		ins 'DATA\graphics\bonus_life_lsr2.msk',16,16
sprite_arms_bonus_odd_group_1    	ins 'DATA\graphics\bonus_arms_lsr2.ora',16,16
mask_arms_bonus_odd_group_1    		ins 'DATA\graphics\bonus_arms_lsr2.msk',16,16

	.align $0100

sprite_and_mask_addresses   ;$2400
;                 sprite address                       mask address
	dta a(sprite_player_one_even_group_0      ),a(mask_player_even_group_0)       
	dta a(sprite_player_two_even_group_0      ),a(mask_player_even_group_0)
	dta a(sprite_explosion_one_group_0        ),a(mask_explosion_one_group_0)
	dta a(sprite_explosion_two_group_0        ),a(mask_explosion_two_group_0)
	dta a(sprite_explosion_three_group_0      ),a(mask_explosion_three_group_0)
	dta a(sprite_alien_even_group_0           ),a(mask_alien_even_group_0)
	dta a(sprite_alien_even_group_0           ),a(mask_alien_even_group_0)
	dta a(sprite_ball_one_even_group_0        ),a(mask_ball_even_group_0)

bonus_addr1
	dta a(sprite_score_bonus_even_group_0     ),a(mask_score_bonus_even_group_0)
bonus_addr2	
	dta a(sprite_score_bonus_even_group_0     ),a(mask_score_bonus_even_group_0)

	dta a(sprite_ball_two_even_group_0        ),a(mask_ball_even_group_0)
	dta a(sprite_rocket_group_0               ),a(mask_rocket_group_0)
	dta a(sprite_diamond_even_group_0         ),a(mask_diamond_even_group_0)
	dta a(sprite_diamond_even_group_0         ),a(mask_diamond_even_group_0)
	dta a(sprite_diamond_even_group_0         ),a(mask_diamond_even_group_0)
	dta a(sprite_ball_two_even_group_0        ),a(mask_ball_even_group_0)
	dta a(sprite_drone_even_group_0           ),a(mask_player_bonus_even_group_0)
	dta a(sprite_claw_even_group_0            ),a(mask_claw_even_group_0)
	dta a(sprite_segment_one_even_group_0     ),a(mask_segment_one_even_group_0)
	dta a(sprite_segment_two_even_group_0     ),a(mask_segment_two_even_group_0)
	dta a(sprite_legs_even_group_0            ),a(mask_legs_even_group_0)
	dta a(sprite_claw_even_group_0            ),a(mask_claw_even_group_0)
	dta a(sprite_diamond_even_group_0         ),a(mask_diamond_even_group_0)
	dta a(sprite_diamond_even_group_0         ),a(mask_diamond_even_group_0)
	dta a(sprite_claw_even_group_0            ),a(mask_claw_even_group_0)
	dta a(sprite_legs_even_group_0            ),a(mask_legs_even_group_0)
	dta a(sprite_mound_group_0                ),a(mask_mound_group_0)
	dta a(sprite_ball_one_even_group_0        ),a(mask_ball_even_group_0)
	dta a(sprite_diamond_even_group_2         ),a(mask_diamond_even_group_2)
	dta a(sprite_diamond_even_group_2         ),a(mask_diamond_even_group_2)
	dta a(sprite_diamond_even_group_2         ),a(mask_diamond_even_group_2)
	dta a(sprite_ball_six_even_group_0        ),a(mask_ball_even_group_0)
	dta a(sprite_ball_five_even_group_0       ),a(mask_ball_even_group_0)
	dta a(sprite_ball_four_even_group_0 - $400),a(mask_ball_even_group_0)
	dta a(sprite_ball_four_even_group_0       ),a(mask_ball_even_group_0)
	dta a(sprite_balls_even_group_0           ),a(mask_balls_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_alien_even_group_0           ),a(mask_alien_even_group_0)
	dta a(sprite_fireball_group_0             ),a(mask_platform_group_0)
	dta a(sprite_fireball_group_0             ),a(mask_platform_group_0)
	dta a(sprite_ball_three_even_group_0      ),a(mask_ball_even_group_0)
	dta a(sprite_ball_three_even_group_0      ),a(mask_ball_even_group_0)
	dta a(sprite_legs_even_group_0            ),a(mask_legs_even_group_0)
	dta a(sprite_legs_even_group_0            ),a(mask_legs_even_group_0)
	dta a(sprite_platform_group_0             ),a(mask_platform_group_0)
	dta a(sprite_sparks_group_0 - $400        ),a(mask_sparks_group_0 - $400)
	dta a(sprite_diamond_even_group_3         ),a(mask_diamond_even_group_3)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_platform_group_0             ),a(mask_platform_group_0)
	dta a(sprite_mound_group_0                ),a(mask_mound_group_0)
	dta a(sprite_cigar_group_0                ),a(mask_cigar_group_0)
	dta a(sprite_cigar_group_0                ),a(mask_cigar_group_0)
	dta a(sprite_head_even_group_0            ),a(mask_head_even_group_0)
	dta a(sprite_drone_even_group_0           ),a(mask_player_bonus_even_group_0)
 		
 	.align $0100

sprite_and_mask_addresses2
;                 sprite address                       mask address   
	dta a(sprite_player_one_even_group_0      ),a(mask_player_even_group_0)       
	dta a(sprite_player_two_even_group_0      ),a(mask_player_even_group_0)
	dta a(sprite_explosion_one_group_0        ),a(mask_explosion_one_group_0)
	dta a(sprite_explosion_two_group_0        ),a(mask_explosion_two_group_0)
	dta a(sprite_explosion_three_group_0      ),a(mask_explosion_three_group_0)
	dta a(sprite_explosion_four_group_0       ),a(mask_explosion_four_group_0)
	dta a(sprite_explosion_five_group_0       ),a(mask_explosion_five_group_0)
	dta a(sprite_explosion_six_group_0        ),a(mask_explosion_six_group_0)
	dta a(sprite_explosion_seven_group_0      ),a(mask_explosion_seven_group_0)
	dta a(sprite_explosion_eight_group_0      ),a(mask_explosion_eight_group_0)
	dta a(sprite_explosion_nine_group_0       ),a(mask_explosion_nine_group_0)
	
	dta a(sprite_rocket_group_0               ),a(mask_rocket_group_0)
	dta a(sprite_diamond_even_group_0         ),a(mask_diamond_even_group_0)
	dta a(sprite_diamond_even_group_0         ),a(mask_diamond_even_group_0)
	dta a(sprite_diamond_even_group_0         ),a(mask_diamond_even_group_0)
	dta a(sprite_ball_two_even_group_0        ),a(mask_ball_even_group_0)
	dta a(sprite_drone_even_group_0           ),a(mask_player_bonus_even_group_0)
	dta a(sprite_claw_even_group_0            ),a(mask_claw_even_group_0)
	dta a(sprite_segment_one_even_group_0     ),a(mask_segment_one_even_group_0)
	dta a(sprite_segment_two_even_group_0     ),a(mask_segment_two_even_group_0)
	dta a(sprite_legs_even_group_0            ),a(mask_legs_even_group_0)
	dta a(sprite_claw_even_group_0            ),a(mask_claw_even_group_0)
	dta a(sprite_diamond_even_group_0         ),a(mask_diamond_even_group_0)
	dta a(sprite_diamond_even_group_0         ),a(mask_diamond_even_group_0)
	dta a(sprite_claw_even_group_0            ),a(mask_claw_even_group_0)
	dta a(sprite_legs_even_group_0            ),a(mask_legs_even_group_0)
	dta a(sprite_mound_group_0                ),a(mask_mound_group_0)
	dta a(sprite_ball_one_even_group_0        ),a(mask_ball_even_group_0)
	dta a(sprite_diamond_even_group_2         ),a(mask_diamond_even_group_2)
	dta a(sprite_diamond_even_group_2         ),a(mask_diamond_even_group_2)
	dta a(sprite_diamond_even_group_2         ),a(mask_diamond_even_group_2)
	dta a(sprite_ball_six_even_group_0        ),a(mask_ball_even_group_0)
	dta a(sprite_ball_five_even_group_0       ),a(mask_ball_even_group_0)
	dta a(sprite_ball_four_even_group_0 - $400),a(mask_ball_even_group_0)
	dta a(sprite_ball_four_even_group_0       ),a(mask_ball_even_group_0)
	dta a(sprite_balls_even_group_0           ),a(mask_balls_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_alien_even_group_0           ),a(mask_alien_even_group_0)
	dta a(sprite_fireball_group_0             ),a(mask_platform_group_0)
	dta a(sprite_fireball_group_0             ),a(mask_platform_group_0)
	dta a(sprite_ball_three_even_group_0      ),a(mask_ball_even_group_0)
	dta a(sprite_ball_three_even_group_0      ),a(mask_ball_even_group_0)
	dta a(sprite_legs_even_group_0            ),a(mask_legs_even_group_0)
	dta a(sprite_legs_even_group_0            ),a(mask_legs_even_group_0)
	dta a(sprite_platform_group_0             ),a(mask_platform_group_0)
	dta a(sprite_sparks_group_0 - $400        ),a(mask_sparks_group_0 - $400)
	dta a(sprite_diamond_even_group_3         ),a(mask_diamond_even_group_3)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_pillar_even_group_0          ),a(mask_pillar_even_group_0)
	dta a(sprite_platform_group_0             ),a(mask_platform_group_0)
	dta a(sprite_mound_group_0                ),a(mask_mound_group_0)
	dta a(sprite_cigar_group_0                ),a(mask_cigar_group_0)
	dta a(sprite_cigar_group_0                ),a(mask_cigar_group_0)
	dta a(sprite_head_even_group_0            ),a(mask_head_even_group_0)
	dta a(sprite_drone_even_group_0           ),a(mask_player_bonus_even_group_0)
  
/*
; Wave data
; =========
; First six bytes are enemies:
;
;     84...... delay before next enemy
;     ..218421 type of enemy
;
; Seventh byte sets flags for wave:
;
;     $00      add new enemies when old enemies are destroyed
;     $01      don't add new enemies when old enemies are destroyed
;     $80      add fixed number of enemies at start of wave
;     $83      add fixed number of enemies at start of wave, consider as a group
;
; Eighth byte is zero if enemies are added individually
;                non-zero to set group used for positions for boss
*/
	.align $0100

wave_data  ;2800
;        e0  e1  e2  e3  e4  e5  fl  gr
	dta $40,$80,$40,$40,$80,$40,$00,$00 ; wave type $00                       # Bouncing aliens
	dta $41,$81,$c1,$41,$81,$81,$00,$00 ; wave type $01                       # Bouncing aliens
	dta $01,$40,$01,$40,$01,$40,$80,$00 ; wave type $02                       # Clustered aliens
	dta $42,$42,$42,$42,$42,$42,$80,$00 ; wave type $03                       # Circling balls
	dta $46,$86,$46,$c6,$46,$86,$00,$00 ; wave type $04                       # Rockets
	dta $47,$89,$c8,$89,$48,$87,$00,$00 ; wave type $05                       # Rising diamond bottoms
	dta $45,$8a,$85,$4a,$ca,$85,$00,$00 ; wave type $06                       # Bouncing balls
	dta $08,$59,$1f,$22,$20,$61,$80,$00 ; wave type $07                       # Vertical pillar gate, opening middle
	dta $10,$4c,$0d,$4e,$4f,$3b,$83,$06 ; wave type $08                       # End of odd levels boss
	dta $11,$d2,$11,$d2,$11,$52,$80,$00 ; wave type $09                       # Paired diamonds
	dta $46,$53,$54,$54,$54,$54,$83,$00 ; wave type $0a                       # Rocket and claw with many legs
	dta $56,$56,$56,$56,$56,$56,$80,$00 ; wave type $0b                       # Circling balls
	dta $02,$d6,$02,$d6,$02,$d6,$00,$00 ; wave type $0c                       # Paired circling balls
	dta $97,$58,$d7,$99,$59,$58,$00,$00 ; wave type $0d                       # Falling diamond tops
	dta $57,$c9,$08,$59,$47,$98,$00,$00 ; wave type $0e                       # Falling diamond tops and rising diamond bottoms
	dta $de,$fb,$de,$fb,$de,$fb,$00,$00 ; wave type $0f                       # Ball spawners
	dta $11,$92,$11,$92,$11,$52,$00,$00 ; wave type $10                       # Paired diamonds
	dta $7b,$7b,$7b,$7b,$7b,$7b,$00,$00 ; wave type $11                       # Paired diamonds
	dta $1f,$21,$23,$24,$3b,$3b,$83,$00 ; wave type $12                       # Horizontal pillar gate
	dta $25,$26,$27,$a8,$29,$3b,$83,$0c ; wave type $13                       # End of even levels boss
	dta $2a,$ab,$2a,$ab,$2a,$bb,$00,$00 ; wave type $14                       # Paired fireballs
	dta $6c,$6c,$6c,$6c,$6c,$7b,$80,$00 ; wave type $15                       # Wavy drones
	dta $6d,$6d,$6d,$6d,$6d,$7b,$80,$00 ; wave type $16                       # Wavy drones
	dta $2d,$6c,$2d,$6c,$2d,$2c,$01,$00 ; wave type $17                       # Erratic wavy drones
	dta $2f,$ae,$2f,$ae,$fb,$fb,$80,$00 ; wave type $18                       # Paired legs and rocket
	dta $08,$d8,$08,$d8,$08,$d8,$00,$00 ; wave type $19                       # Paired falling diamond tops and rising diamond bottoms
	dta $f2,$fb,$f2,$f2,$7b,$72,$00,$00 ; wave type $1a                       # Spark spawners
	dta $1f,$73,$ad,$34,$61,$2c,$80,$00 ; wave type $1b                       # Pillar chicane and drones
	dta $1f,$33,$f4,$33,$34,$21,$83,$00 ; wave type $1c                       # Pillar chicane
	dta $b0,$b0,$9f,$bb,$bb,$bb,$01,$00 ; wave type $1d                       # Top platform and pillar
	dta $34,$a1,$4a,$1f,$73,$05,$01,$00 ; wave type $1e                       # Pillars and bouncing ball
	dta $b5,$b5,$a1,$bb,$bb,$bb,$01,$00 ; wave type $1f                       # Bottom platform and pillar
	dta $35,$b0,$35,$b0,$33,$b4,$01,$00 ; wave type $20                       # Double platforms and middle pillar
	dta $35,$b0,$35,$b0,$1f,$a1,$01,$00 ; wave type $21                       # Double platforms and top and bottom pillars
	dta $b0,$b0,$33,$34,$a1,$bb,$01,$00 ; wave type $22                       # Platform and double bottom pillars
	dta $b5,$b5,$1f,$33,$b4,$bb,$01,$00 ; wave type $23                       # Platform and double top pillars
	dta $33,$34,$e1,$1f,$33,$34,$83,$00 ; wave type $24                       # Pillar chicane
	dta $1f,$33,$34,$e1,$3b,$3b,$83,$00 ; wave type $25                       # Pillars
	dta $1f,$a1,$30,$b5,$33,$34,$01,$00 ; wave type $26                       # Pillars and platforms
	dta $1f,$a1,$30,$b5,$1f,$21,$01,$00 ; wave type $27                       # Pillars and platforms
	dta $08,$58,$33,$22,$20,$74,$80,$00 ; wave type $28                       # Vertical pillar gate, opening top and bottom
	dta $46,$86,$46,$42,$42,$c2,$00,$00 ; wave type $29                       # Rockets and circling balls
	dta $45,$8a,$45,$56,$56,$d6,$00,$00 ; wave type $2a                       # Circling balls and bouncing balls
	dta $40,$81,$85,$c6,$48,$d6,$00,$00 ; wave type $2b                       # Aliens and bouncing balls
	dta $57,$8a,$80,$c2,$46,$d2,$00,$00 ; wave type $2c                       # Alien, balls and diamond top
	dta $f9,$b9,$f9,$f9,$b9,$f9,$00,$00 ; wave type $2d                       # Heads
	dta $4b,$4b,$4b,$4b,$4b,$4b,$80,$00 ; wave type $2e                       # Formation drones
	dta $7a,$7a,$7a,$7a,$7a,$7a,$80,$00 ; wave type $2f                       # Formation drones
	dta $3a,$4b,$3a,$4b,$3a,$4b,$00,$00 ; wave type $30                       # Double formation drones
	dta $55,$95,$55,$d5,$55,$55,$00,$00 ; wave type $31                       # Mounds
	dta $76,$b6,$76,$f6,$76,$76,$00,$00 ; wave type $32                       # Mounds
	dta $36,$55,$36,$55,$36,$55,$00,$00 ; wave type $33                       # Mounds
	dta $b7,$b7,$b7,$b7,$b7,$b7,$01,$00 ; wave type $34                       # Cigars
	dta $b8,$b8,$b8,$b8,$b8,$b8,$01,$00 ; wave type $35                       # Cigars
	dta $38,$b7,$38,$b7,$3b,$bb,$01,$00 ; wave type $36                       # Cigars
	dta $4b,$aa,$15,$6c,$f1,$bb,$00,$00 ; wave type $37                       # Assorted enemies
	dta $16,$71,$b6,$6a,$d2,$86,$00,$00 ; wave type $38                       # Assorted enemies
	dta $79,$88,$2e,$78,$cb,$bb,$00,$00 ; wave type $39                       # Assorted enemies
	dta $77,$97,$32,$55,$ed,$ab,$00,$00 ; wave type $3a                       # Assorted enemies
	dta $79,$ba,$2c,$45,$c0,$92,$00,$00 ; wave type $3b                       # Assorted enemies
	dta $79,$b7,$78,$6f,$c7,$ad,$00,$00 ; wave type $3c                       # Assorted enemies
	dta $72,$81,$46,$55,$eb,$98,$00,$00 ; wave type $3d                       # Assorted enemies
	dta $45,$95,$6b,$79,$6c,$9e,$00,$00 ; wave type $3e                       # Assorted enemies
	
/*  
; Sprite data
; ===========
;
; First byte (bit7-0):
; 
;     842..... score (offset into lookup table)
;     ...184.. type of enemy spawned (zero for no spawning)
;     ......21 height in groups (+1)
;
; Second byte is the width of the sprite in bytes.
;
; Third byte sets initial vertical position:
;
;     $01 -    use value to set position
;     $00      use low bits of frame counter to set position
;     $80      use low and high bits of frame counter to set position
;
; Fourth byte sets energy
*/
	.align $0100
	
sprite_sizes_and_data
;     sh w  y  st   spr en
	.he 03 17 00 00 ; $00     : player one
	.he 03 17 00 00 ; $04     : player two
	.he 02 17 00 00 ; $08     : explosion one
	.he 02 17 00 00 ; $0c     : explosion two
	.he 03 17 00 00 ; $10     : explosion three
	.he 23 17 16 02 ; $14 $00 : alien                 2 energy          score 5
	.he 23 17 06 02 ; $18 $01 : alien                 2 energy          score 5
	.he 41 0f 07 06 ; $1c $02 : ball one              6 energy          score 10
	.he 01 0f 0e 04 ; $20 $03 : player one bonus      4 energy          score 1
	.he 01 0f 14 04 ; $24 $04 : player two bonus      4 energy          score 1
	.he 41 0f 02 02 ; $28 $05 : ball two              2 energy          score 10
	.he 41 1f 80 02 ; $2c $06 : rocket                2 energy          score 10
	.he 41 17 1c 04 ; $30 $07 : diamond top           4 energy          score 10
	.he 41 17 1c 04 ; $34 $08 : diamond top           4 energy          score 10
	.he 41 17 1c 04 ; $38 $09 : diamond top           4 energy          score 10
	.he 41 0f 19 02 ; $3c $0a : ball two              2 energy          score 10
	.he 41 0f 07 04 ; $40 $0b : drone                 4 energy          score 10
	.he a7 1f 03 7f ; $44 $0c : claw                  indestructible    score 500     spawn type $04 (rockets)
	.he a2 17 07 7f ; $48 $0d : segment one           indestructible    score 500
	.he a2 17 0f 7f ; $4c $0e : segment two           indestructible    score 500
	.he a3 1f 0a 08 ; $50 $0f : legs                  8 energy          score 500
	.he a7 1f 11 7f ; $54 $10 : claw                  indestructible    score 500     spawn type $04 (rockets)
	.he 63 17 0e 06 ; $58 $11 : diamond               6 energy          score 50
	.he 63 17 0e 06 ; $5c $12 : diamond               6 energy          score 50
	.he 83 1f 08 10 ; $60 $13 : claw                  16 energy         score 100
	.he 83 1f 08 7f ; $64 $14 : legs                  indestructible    score 100
	.he 20 2f 00 00 ; $68 $15 : mound                 0 energy          score 5
	.he 41 0f 16 06 ; $6c $16 : ball one              6 energy          score 10
	.he 41 17 02 04 ; $70 $17 : diamond bottom        4 energy          score 10
	.he 41 17 02 04 ; $74 $18 : diamond bottom        4 energy          score 10
	.he 41 17 02 04 ; $78 $19 : diamond bottom        4 energy          score 10
	.he 41 0f 80 04 ; $7c $1a : ball six              4 energy          score 10      spawned enemy
	.he 41 0f 80 04 ; $80 $1b : ball five             4 energy          score 10      spawned enemy
	.he 41 0f 80 04 ; $84 $1c : ball four             4 energy          score 10      spawned enemy
	.he 41 0f 80 04 ; $88 $1d : ball four             4 energy          score 10      spawned enemy
	.he 8b 17 80 10 ; $8c $1e : balls                 16 energy         score 100     spawn type $08 (balls)

pillar01	.he a3 17 02 1f ; $90 $1f : pillar                indestructible    score 500
pillar02	.he a3 17 11 1f ; $94 $20 : pillar                indestructible    score 500
pillar03	.he a3 17 18 1f ; $98 $21 : pillar                indestructible    score 500
pillar04	.he a3 17 09 1f ; $9c $22 : pillar                indestructible    score 500
pillar05	.he a3 17 0d 1f ; $a0 $23 : pillar                indestructible    score 500
pillar06	.he a3 17 0d 1f ; $a4 $24 : pillar                indestructible    score 500
pillar07	.he a3 17 02 7f ; $a8 $25 : pillar                indestructible    score 500
pillar08	.he a3 17 18 7f ; $ac $26 : pillar                indestructible    score 500
pillar09	.he a3 17 09 7f ; $b0 $27 : pillar                indestructible    score 500
pillar10	.he a3 17 11 7f ; $b4 $28 : pillar                indestructible    score 500

	.he a7 17 14 04 ; $b8 $29 : alien                 4 energy          score 500
	.he 40 1f 00 01 ; $bc $2a : fireball              1 energy          score 10
	.he 40 1f 00 01 ; $c0 $2b : fireball              1 energy          score 10
	.he 41 0f 07 02 ; $c4 $2c : ball three            2 energy          score 10
	.he 41 0f 16 02 ; $c8 $2d : ball three            2 energy          score 10
	.he 87 1f 07 08 ; $cc $2e : legs                  8 energy          score 100
	.he 87 1f 13 08 ; $d0 $2f : legs                  8 energy          score 100

platform1	.he a0 5f 0a 1f ; $d4 $30 : platform              indestructible    score 500

	.he 63 07 00 04 ; $d8 $31 : sparks                4 energy          score 50      spawned enemy
	.he 8c 17 02 08 ; $dc $32 : diamond bottom tip    8 energy          score 100     spawn type $0c (sparks)

pillar11	.he a3 17 0a 1f ; $e0 $33 : pillar                indestructible    score 500
pillar12	.he a3 17 10 1f ; $e4 $34 : pillar                indestructible    score 500
platform2	.he a0 5f 16 1f ; $e8 $35 : platform              indestructible    score 500

	.he 20 2f 00 00 ; $ec $36 : mound                 0 energy          score 5
	.he 60 2f 04 00 ; $f0 $37 : cigar                 0 energy          score 50
	.he 60 2f 1c 00 ; $f4 $38 : cigar                 0 energy          score 50
	.he a2 1f 80 06 ; $f8 $39 : head                  6 energy          score 500
	.he 41 0f 16 04 ; $fc $3a : drone                 4 energy          score 10
 	
 	.align $0100

sprite_sizes_and_data2
;        sh   w   y  st   spr en
	dta $03,$17,$00,$00 ; $00     : player one
	dta $03,$17,$00,$00 ; $04     : player two
	dta $02,$17,$00,$00 ; $08     : explosion one
	dta $02,$17,$00,$00 ; $0c     : explosion two
	dta $02,$17,$00,$00 ; $10     : explosion three
	dta $02,$17,$00,$00 ; $14     : explosion four
	dta $02,$17,$00,$00 ; $18     : explosion five
	dta $02,$17,$00,$00 ; $1c     : explosion six
	dta $02,$17,$00,$00 ; $20     : explosion seven
	dta $02,$17,$00,$00 ; $24     : explosion eight
	dta $02,$17,$00,$00 ; $28     : explosion nine

	.he 41 1f 80 02 ; $2c $06 : rocket                2 energy          score 10
	.he 41 17 1c 04 ; $30 $07 : diamond top           4 energy          score 10
	.he 41 17 1c 04 ; $34 $08 : diamond top           4 energy          score 10
	.he 41 17 1c 04 ; $38 $09 : diamond top           4 energy          score 10
	.he 41 0f 19 02 ; $3c $0a : ball two              2 energy          score 10
	.he 41 0f 07 04 ; $40 $0b : drone                 4 energy          score 10
	.he a7 1f 03 7f ; $44 $0c : claw                  indestructible    score 500     spawn type $04 (rockets)
	.he a2 17 07 7f ; $48 $0d : segment one           indestructible    score 500
	.he a2 17 0f 7f ; $4c $0e : segment two           indestructible    score 500
	.he a3 1f 0a 08 ; $50 $0f : legs                  8 energy          score 500
	.he a7 1f 11 7f ; $54 $10 : claw                  indestructible    score 500     spawn type $04 (rockets)
	.he 63 17 0e 06 ; $58 $11 : diamond               6 energy          score 50
	.he 63 17 0e 06 ; $5c $12 : diamond               6 energy          score 50
	.he 83 1f 08 10 ; $60 $13 : claw                  16 energy         score 100
	.he 83 1f 08 7f ; $64 $14 : legs                  indestructible    score 100
	.he 20 2f 00 00 ; $68 $15 : mound                 0 energy          score 5
	.he 41 0f 16 06 ; $6c $16 : ball one              6 energy          score 10
	.he 41 17 02 04 ; $70 $17 : diamond bottom        4 energy          score 10
	.he 41 17 02 04 ; $74 $18 : diamond bottom        4 energy          score 10
	.he 41 17 02 04 ; $78 $19 : diamond bottom        4 energy          score 10
	.he 41 0f 80 04 ; $7c $1a : ball six              4 energy          score 10      spawned enemy
	.he 41 0f 80 04 ; $80 $1b : ball five             4 energy          score 10      spawned enemy
	.he 41 0f 80 04 ; $84 $1c : ball four             4 energy          score 10      spawned enemy
	.he 41 0f 80 04 ; $88 $1d : ball four             4 energy          score 10      spawned enemy
	.he 8b 17 80 10 ; $8c $1e : balls                 16 energy         score 100     spawn type $08 (balls)

	.he a3 17 02 1f ; $90 $1f : pillar                indestructible    score 500
	.he a3 17 11 1f ; $94 $20 : pillar                indestructible    score 500
	.he a3 17 18 1f ; $98 $21 : pillar                indestructible    score 500
	.he a3 17 09 1f ; $9c $22 : pillar                indestructible    score 500
	.he a3 17 0d 1f ; $a0 $23 : pillar                indestructible    score 500
	.he a3 17 0d 1f ; $a4 $24 : pillar                indestructible    score 500
	.he a3 17 02 1f ; $a8 $25 : pillar                indestructible    score 500
	.he a3 17 18 1f ; $ac $26 : pillar                indestructible    score 500
	.he a3 17 09 1f ; $b0 $27 : pillar                indestructible    score 500
	.he a3 17 11 1f ; $b4 $28 : pillar                indestructible    score 500

	.he a7 17 14 04 ; $b8 $29 : alien                 4 energy          score 500
	.he 40 1f 00 01 ; $bc $2a : fireball              1 energy          score 10
	.he 40 1f 00 01 ; $c0 $2b : fireball              1 energy          score 10
	.he 41 0f 07 02 ; $c4 $2c : ball three            2 energy          score 10
	.he 41 0f 16 02 ; $c8 $2d : ball three            2 energy          score 10
	.he 87 1f 07 08 ; $cc $2e : legs                  8 energy          score 100
	.he 87 1f 13 08 ; $d0 $2f : legs                  8 energy          score 100

	.he a0 5f 0a 1f ; $d4 $30 : platform              indestructible    score 500

	.he 63 07 00 04 ; $d8 $31 : sparks                4 energy          score 50      spawned enemy
	.he 8c 17 02 08 ; $dc $32 : diamond bottom tip    8 energy          score 100     spawn type $0c (sparks)

	.he a3 17 0a 1f ; $e0 $33 : pillar                indestructible    score 500
	.he a3 17 10 1f ; $e4 $34 : pillar                indestructible    score 500
	.he a0 5f 16 1f ; $e8 $35 : platform              indestructible    score 500

	.he 20 2f 00 00 ; $ec $36 : mound                 0 energy          score 5
	.he 60 2f 04 00 ; $f0 $37 : cigar                 0 energy          score 50
	.he 60 2f 1c 00 ; $f4 $38 : cigar                 0 energy          score 50
	.he a2 1f 80 06 ; $f8 $39 : head                  6 energy          score 500
	.he 41 0f 16 04 ; $fc $3a : drone                 4 energy          score 10
 
/*
; Level data
; ==========
; One byte per wave:
;
;     8....... invert vertical movement
;     .4...... apply horizontal movement to enemies
;              lasers do double damage on levels 5 - 7
;     ..218421 wave type
*/
 		.align $0100
level_waves_data
;        00  01  02  03  04  05  06  07  08  09  0a  0b  0c  0d  0e  0f  10  11  12  13  14  15  16  17  18  19  1a  1b  1c  1d  1e  1f  20  21  22  23
	dta $01,$00,$11,$02,$03,$11,$11,$04,$00,$11,$0b,$11,$05,$05,$11,$0c,$0c,$11,$04,$09,$10,$11,$11,$0c,$11,$11,$0d,$0d,$11,$06,$06,$06,$11,$0e,$0e,$08 ; level 1
	dta $0a,$04,$07,$14,$14,$15,$11,$8a,$04,$0f,$0f,$11,$16,$11,$12,$11,$51,$07,$14,$17,$11,$04,$0f,$0f,$04,$12,$04,$04,$11,$0a,$04,$17,$14,$04,$11,$13 ; level 2
	dta $04,$11,$5c,$5d,$62,$63,$47,$54,$04,$10,$10,$11,$04,$11,$64,$5f,$66,$51,$64,$62,$5d,$47,$51,$5a,$5a,$44,$59,$51,$64,$67,$66,$67,$5c,$63,$47,$48 ; level 3
	dta $00,$04,$17,$04,$0c,$06,$04,$0e,$14,$10,$17,$14,$04,$2a,$06,$29,$04,$11,$58,$51,$11,$04,$06,$1a,$2b,$2c,$2b,$2c,$2b,$2c,$0f,$2c,$04,$44,$47,$53 ; level 4
	dta $43,$51,$2e,$04,$2d,$46,$51,$4b,$51,$2f,$1a,$1a,$14,$11,$28,$04,$86,$86,$91,$30,$11,$2d,$31,$46,$59,$51,$71,$40,$41,$4c,$51,$42,$46,$6a,$46,$48 ; level 5
	dta $71,$44,$51,$5c,$62,$5b,$5f,$5d,$51,$60,$61,$5e,$5f,$66,$67,$5b,$5e,$52,$64,$66,$66,$62,$5b,$5c,$51,$61,$66,$65,$67,$62,$62,$5c,$51,$52,$47,$53 ; level 6	
	dta $6e,$51,$71,$72,$6f,$70,$51,$73,$51,$74,$51,$6a,$51,$75,$44,$51,$47,$4f,$4f,$51,$4a,$73,$57,$51,$76,$51,$51,$ca,$c4,$73,$70,$11,$73,$51,$76,$48 ; level 7	
	dta $29,$2a,$2b,$2c,$37,$38,$3e,$3a,$3c,$39,$3d,$3c,$3b,$3e,$2b,$3e,$33,$11,$47,$69,$6a,$6b,$77,$78,$79,$7a,$7b,$7c,$7d,$7e,$6b,$6a,$78,$7b,$7e,$53 ; level 8

; changes color for enemy during the game, $00 - don't change
				.align $0100
level_waves_COLPF1
;        00  01  02  03  04  05  06  07  08  09  0a  0b  0c  0d  0e  0f  10  11  12  13  14  15  16  17  18  19  1a  1b  1c  1d  1e  1f  20  21  22  23
	dta $36,$00,$00,$00,$1e,$46,$00,$08,$46,$00,$1a,$46,$14,$00,$46,$00,$00,$00,$08,$7e,$46,$00,$00,$00,$00,$00,$8c,$00,$46,$00,$00,$00,$00,$14,$00,$36 ; level 1
	dta $34,$46,$46,$00,$00,$00,$00,$3a,$08,$9a,$00,$46,$58,$00,$46,$00,$00,$00,$00,$00,$00,$08,$c8,$00,$08,$00,$08,$00,$46,$3a,$46,$46,$00,$00,$00,$aa ; level 2
	dta $08,$46,$00,$00,$00,$00,$00,$1e,$08,$1e,$00,$00,$08,$46,$00,$00,$08,$46,$00,$00,$00,$00,$00,$00,$00,$08,$46,$00,$00,$00,$00,$00,$00,$00,$00,$8a ; level 3
	dta $36,$1e,$00,$00,$00,$00,$00,$1a,$00,$00,$ca,$00,$00,$00,$00,$00,$00,$00,$1c,$1a,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$d8 ; level 4
	dta $46,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$1a,$46,$00,$00,$1e,$46,$00,$00,$00,$00,$00,$00,$00,$1a ; level 5
	dta $1e,$46,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$18 ; level 6	
	dta $a8,$0a,$00,$00,$46,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$a8,$46,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$ca ; level 7
	dta $1e,$00,$00,$00,$68,$00,$00,$00,$00,$00,$00,$00,$00,$00,$58,$00,$00,$00,$0a,$00,$00,$00,$1a,$00,$00,$00,$48,$00,$00,$00,$00,$00,$00,$00,$00,$68 ; level 8

enemy_pattern_types                                                                   ; Uses enemy type to determine which row of
;         0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f               # patterns_for_horizontal_movement
;	dta $00,$80,$02,$03,$03,$05,$43,$07,$08,$09,$0a,$0b,$0c,$0d,$0e,$0f ; $00         # and patterns_for_vertical_movement to use
	dta $00,$80,$02,$20,$20,$05,$43,$07,$08,$09,$0a,$0b,$0c,$0d,$0e,$0f ; $00         # and patterns_for_vertical_movement to use
	dta $10,$92,$12,$14,$14,$5e,$82,$87,$88,$89,$15,$95,$46,$c6,$03,$03 ; $10         # 8....... invert vertical movement
	dta $96,$03,$16,$17,$18,$19,$19,$11,$1a,$01,$54,$d4,$1b,$9b,$4f,$cf ; $20         # .4...... apply horizontal movement (x2)
	dta $03,$1c,$03,$03,$03,$03,$de,$5f,$df,$5d,$8b                     ; $30         # ...18421 movement pattern

    .align $0100
    
movement_patterns
;         0,  1,  2,  3,  4   5   6   7   8   9   a   b   c   d   e   f
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; $00
	dta $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01 ; $01
	dta $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff ; $02 BONUS $ff = -1
	dta $00,$00,$ff,$ff,$ff,$ff,$fe,$fe,$fe,$fe,$ff,$ff,$ff,$ff,$00,$00 ; $03
	dta $00,$00,$01,$01,$01,$01,$02,$02,$02,$02,$01,$01,$01,$01,$00,$00 ; $04
	dta $02,$02,$01,$01,$01,$01,$00,$00,$00,$00,$ff,$ff,$ff,$ff,$fe,$fe ; $05
	dta $fe,$fe,$ff,$ff,$ff,$ff,$00,$00,$00,$00,$01,$01,$01,$01,$02,$02 ; $06
	dta $00,$00,$01,$01,$01,$01,$01,$01,$02,$02,$02,$02,$03,$03,$03,$03 ; $07
	dta $fd,$fd,$fd,$fd,$fe,$fe,$fe,$fe,$ff,$ff,$ff,$ff,$ff,$ff,$00,$00 ; $08
	dta $02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02 ; $09
	dta $fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe ; $0a
	dta $01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00,$01,$00 ; $0b
	
	dta $ff,$00,$ff,$00,$ff,$00,$ff,$00,$ff,$00,$ff,$00,$ff,$00,$ff,$00 ; $0c
	
	dta $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$01,$01,$01,$01,$01,$01,$01,$01 ; $0d
	dta $01,$01,$01,$01,$01,$01,$01,$01,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff ; $0e
	dta $ff,$00,$ff,$00,$ff,$00,$ff,$00,$01,$00,$01,$00,$01,$00,$01,$00 ; $0f
	dta $01,$00,$01,$00,$01,$00,$01,$00,$ff,$00,$ff,$00,$ff,$00,$ff,$00 ; $10
	dta $ff,$00,$00,$00,$ff,$00,$00,$00,$ff,$00,$00,$00,$ff,$00,$00,$00 ; $11
	dta $03,$02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$fe,$fd ; $12
	dta $ff,$ff,$fe,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$02,$01,$01 ; $13
	dta $00,$fe,$fe,$ff,$ff,$ff,$ff,$00,$00,$00,$00,$00,$01,$00,$01,$00 ; $14
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$02,$02,$02,$02 ; $15
	dta $fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$00,$00,$00,$00,$00,$00 ; $16
	dta $02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$00,$00,$00,$00,$00,$00 ; $17
	
	.align $0100	
	
patterns_for_vertical_movement      ;$2b00                             	; Uses value from enemy_pattern_types to determine
;          0  1   2   3   4   5   6   7        ; movement frame      	; which row of movement_patterns to use horizontally
	dta $02,$01,$02,$01,$0a,$01,$0a,$00 ; $00
	dta $02,$00,$01,$00,$02,$00,$01,$00 ; $01
	dta $00,$04,$03,$00,$04,$03,$00,$00 ; $02
	dta $00,$00,$00,$00,$00,$00,$00,$00 ; $03
	dta $00,$00,$00,$00,$00,$00,$00,$00 ; $04
	dta $07,$08,$07,$08,$07,$08,$07,$08 ; $05
	dta $02,$02,$02,$02,$02,$02,$02,$02 ; $06
	dta $00,$00,$00,$00,$00,$0a,$0a,$0a ; $07
	dta $00,$00,$0a,$0a,$0a,$0a,$0a,$0a ; $08
	dta $00,$00,$00,$00,$0a,$0a,$0a,$0a ; $09
	dta $08,$07,$08,$07,$08,$07,$08,$07 ; $0a
	dta $00,$00,$01,$00,$00,$00,$02,$00 ; $0b
	dta $00,$0e,$0b,$0e,$0e,$0c,$0e,$0e ; $0c
	dta $00,$10,$0b,$10,$10,$0c,$10,$10 ; $0d
	dta $00,$0f,$0b,$0f,$0f,$0c,$0f,$0f ; $0e
	dta $00,$00,$0b,$00,$00,$0c,$00,$00 ; $0f
	dta $00,$0d,$0b,$0d,$0d,$0c,$0d,$0d ; $10
	dta $00,$12,$00,$00,$00,$13,$00,$00 ; $11
	dta $00,$00,$0b,$0c,$00,$00,$00,$0c ; $12
	dta $00,$00,$00,$00,$00,$00,$00,$00 ; $13
	dta $0f,$0f,$01,$02,$0f,$01,$0f,$0f ; $14
	dta $01,$01,$01,$01,$01,$01,$01,$01 ; $15
	dta $0c,$00,$0b,$00,$0c,$0b,$00,$0c ; $16
	dta $00,$00,$00,$00,$00,$00,$00,$00 ; $17
	dta $00,$00,$00,$00,$00,$00,$00,$00 ; $18
	dta $00,$00,$00,$00,$00,$00,$00,$00 ; $19
	dta $00,$00,$00,$13,$00,$00,$00,$00 ; $1a
	dta $04,$03,$04,$03,$04,$09,$04,$03 ; $1b
	dta $09,$09,$09,$09,$09,$09,$09,$09 ; $1c
	dta $00,$00,$00,$00,$00,$00,$00,$00 ; $1d
	dta $14,$0b,$0b,$0b,$09,$09,$09,$09 ; $1e
	dta $00,$15,$00,$15,$00,$15,$00,$15 ; $1f
	dta $00,$00,$00,$00,$00,$00,$00,$00 ; $20 BONUS
		
; unused                                                           			 ; $2c00 - $2c7f is a copy of $2cb1 to $2d30
	dta $02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$00,$00,$02,$02
	dta $02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02
	dta $02,$02,$02,$02,$02,$02,$02,$0a,$00,$00,$00,$0a,$00,$00,$0a,$02
	dta $00,$0c,$01,$02,$00,$0b,$0c,$02,$00,$0c,$01,$02,$00,$0b,$0c,$02
	dta $00,$0c,$01,$02,$00,$0b,$0c,$02,$00,$0c,$01,$02,$00,$0b,$0c,$02
	dta $00,$0c,$01,$02,$00,$0b,$0c,$11,$11,$11,$11,$11,$11,$11,$11,$0a
	dta $02,$02,$02,$01,$01,$01,$01,$02,$02,$02,$02,$02,$02,$02,$02,$02
	dta $02,$02,$02,$02,$02,$02,$02,$01 ;,$01,$01,$01,$01,$01,$01,$01,$02
	

patterns_for_horizontal_movement   ;$2c80                         			 ; Uses value from enemy_pattern_types to determine
;         0   1   2   3   4   5   6   7 				; movement frame     ; which row of movement_patterns to use horizontally
	dta $02,$02,$02,$02,$0a,$0a,$0a,$0a ; $00
	dta $11,$11,$11,$11,$11,$11,$11,$11 ; $01
	dta $02,$06,$05,$02,$06,$05,$02,$02 ; $02	
	dta $02,$02,$02,$02,$02,$02,$02,$02 ; $03 ROCKET
	dta $00,$00,$00,$00,$00,$00,$00,$00 ; $04
	dta $02,$02,$02,$02,$02,$02,$02,$02 ; $05
	dta $02,$02,$02,$02,$02,$02,$02,$02 ; $06
	dta $02,$02,$02,$02,$02,$00,$00,$02 ; $07
	dta $02,$02,$02,$02,$02,$02,$02,$02 ; $08
	dta $02,$02,$02,$02,$02,$02,$02,$02 ; $09
	dta $02,$02,$02,$02,$02,$02,$02,$02 ; $0a
	dta $0a,$00,$00,$00,$0a,$00,$00,$0a ; $0b
	dta $02,$00,$0c,$01,$02,$00,$0b,$0c ; $0c
	dta $02,$00,$0c,$01,$02,$00,$0b,$0c ; $0d
	dta $02,$00,$0c,$01,$02,$00,$0b,$0c ; $0e
	dta $02,$00,$0c,$01,$02,$00,$0b,$0c ; $0f
	dta $02,$00,$0c,$01,$02,$00,$0b,$0c ; $10
	dta $11,$11,$11,$11,$11,$11,$11,$11 ; $11
	dta $0a,$02,$02,$02,$01,$01,$01,$01 ; $12
	dta $02,$02,$02,$02,$02,$02,$02,$02 ; $13
	dta $02,$02,$02,$02,$02,$02,$02,$02 ; $14
	dta $01,$01,$01,$01,$01,$01,$01,$01 ; $15
	dta $02,$02,$02,$02,$02,$02,$02,$02 ; $16
	dta $02,$0a,$02,$02,$00,$02,$0a,$02 ; $17
	dta $02,$00,$02,$02,$0a,$02,$00,$0a ; $18
	dta $11,$11,$11,$11,$11,$11,$11,$11 ; $19
	dta $11,$11,$11,$11,$11,$11,$11,$11 ; $1a
	dta $02,$02,$02,$02,$02,$02,$02,$02 ; $1b
	dta $00,$00,$00,$00,$00,$00,$00,$00 ; $1c
	dta $03,$03,$03,$02,$03,$03,$03,$03 ; $1d
	dta $02,$02,$02,$02,$02,$02,$02,$02 ; $1e
	dta $0a,$16,$09,$17,$0a,$16,$09,$17 ; $1f
	dta $0c,$0c,$0c,$0c,$0c,$0c,$0c,$0c ; $20 BONUS
 				
tab_offset_row_lo   dta        0,       0,       0,<[8*8*1],<[8*8*1],<[8*8*1],<[8*8*2],<[8*8*2],<[8*8*2],<[8*8*3],<[8*8*3],<[8*8*3]
					dta <[8*8*4],<[8*8*4],<[8*8*4],<[8*8*5],<[8*8*5],<[8*8*5],<[8*8*6],<[8*8*6],<[8*8*6],<[8*8*7],<[8*8*7],<[8*8*7]
tab_offset_row_hi   dta        0,       0,       0,>[8*8*1],>[8*8*1],>[8*8*1],>[8*8*2],>[8*8*2],>[8*8*2],>[8*8*3],>[8*8*3],>[8*8*3]
					dta >[8*8*4],>[8*8*4],>[8*8*4],>[8*8*5],>[8*8*5],>[8*8*5],>[8*8*6],>[8*8*6],>[8*8*6],>[8*8*7],>[8*8*7],>[8*8*7]

tab_offset_line_lo  dta 0,0,0,8*8,0,0,8*8,0,0,8*8,0,0,8*8,0,0,8*8,0,0,8*8,0,0,8*8,0,0

 
tab_next_row320_lo   dta <(1*40*8),<(1*40*8),<(1*40*8+64)
					 dta <(1*40*8),<(1*40*8),<(1*40*8+64)
					 dta <(1*40*8),<(1*40*8),<(1*40*8+64)
					 dta <(1*40*8),<(1*40*8),<(1*40*8+64)
					 dta <(1*40*8),<(1*40*8),<(1*40*8+64)
					 dta <(1*40*8),<(1*40*8),<(1*40*8+64)
					 dta <(1*40*8),<(1*40*8),<(1*40*8+64)
					 dta <(1*40*8),<(1*40*8),<(1*40*8+64)
						                      
tab_next_row320_hi   dta >(1*40*8),>(1*40*8),>(1*40*8+64)
					 dta >(1*40*8),>(1*40*8),>(1*40*8+64)
					 dta >(1*40*8),>(1*40*8),>(1*40*8+64)
					 dta >(1*40*8),>(1*40*8),>(1*40*8+64)
					 dta >(1*40*8),>(1*40*8),>(1*40*8+64)
					 dta >(1*40*8),>(1*40*8),>(1*40*8+64)
					 dta >(1*40*8),>(1*40*8),>(1*40*8+64)
					 dta >(1*40*8),>(1*40*8),>(1*40*8+64)

tab_next_row312_lo   dta <(1*40*8-8),<(1*40*8-8),<(1*40*8+64-8)
					 dta <(1*40*8-8),<(1*40*8-8),<(1*40*8+64-8)
					 dta <(1*40*8-8),<(1*40*8-8),<(1*40*8+64-8)
					 dta <(1*40*8-8),<(1*40*8-8),<(1*40*8+64-8)
					 dta <(1*40*8-8),<(1*40*8-8),<(1*40*8+64-8)
					 dta <(1*40*8-8),<(1*40*8-8),<(1*40*8+64-8)
					 dta <(1*40*8-8),<(1*40*8-8),<(1*40*8+64-8)
					 dta <(1*40*8-8),<(1*40*8-8),<(1*40*8+64-8)
						                      
tab_next_row312_hi   dta >(1*40*8-8),>(1*40*8-8),>(1*40*8+64-8)
					 dta >(1*40*8-8),>(1*40*8-8),>(1*40*8+64-8)
					 dta >(1*40*8-8),>(1*40*8-8),>(1*40*8+64-8)
					 dta >(1*40*8-8),>(1*40*8-8),>(1*40*8+64-8)
					 dta >(1*40*8-8),>(1*40*8-8),>(1*40*8+64-8)
					 dta >(1*40*8-8),>(1*40*8-8),>(1*40*8+64-8)
					 dta >(1*40*8-8),>(1*40*8-8),>(1*40*8+64-8)
					 dta >(1*40*8-8),>(1*40*8-8),>(1*40*8+64-8)

tab_next_row313_lo   dta <(1*40*8-8+1),<(1*40*8-8+1),<(1*40*8+64-8+1)
					 dta <(1*40*8-8+1),<(1*40*8-8+1),<(1*40*8+64-8+1)
					 dta <(1*40*8-8+1),<(1*40*8-8+1),<(1*40*8+64-8+1)
					 dta <(1*40*8-8+1),<(1*40*8-8+1),<(1*40*8+64-8+1)
					 dta <(1*40*8-8+1),<(1*40*8-8+1),<(1*40*8+64-8+1)
					 dta <(1*40*8-8+1),<(1*40*8-8+1),<(1*40*8+64-8+1)
					 dta <(1*40*8-8+1),<(1*40*8-8+1),<(1*40*8+64-8+1)
					 dta <(1*40*8-8+1),<(1*40*8-8+1),<(1*40*8+64-8+1)
						                      
tab_next_row313_hi   dta >(1*40*8-8+1),>(1*40*8-8+1),>(1*40*8+64-8+1)
					 dta >(1*40*8-8+1),>(1*40*8-8+1),>(1*40*8+64-8+1)
					 dta >(1*40*8-8+1),>(1*40*8-8+1),>(1*40*8+64-8+1)
					 dta >(1*40*8-8+1),>(1*40*8-8+1),>(1*40*8+64-8+1)
					 dta >(1*40*8-8+1),>(1*40*8-8+1),>(1*40*8+64-8+1)
					 dta >(1*40*8-8+1),>(1*40*8-8+1),>(1*40*8+64-8+1)
					 dta >(1*40*8-8+1),>(1*40*8-8+1),>(1*40*8+64-8+1)
					 dta >(1*40*8-8+1),>(1*40*8-8+1),>(1*40*8+64-8+1)
	
PMG_player_shape0
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00001111
    dta %00011000
    dta %00010000
    dta %00110000
    dta %00111000 
    dta %00111111
    dta %00111110
    dta %00110111
    dta %01111000
    dta %01111100
    dta %11111000
    dta %11010000
    dta %10110000
    dta %01111000
    dta %11111110
    dta %11111111
    dta %01110011  
    dta %00001100
    dta %00111110
    dta %00011111
    dta %00001111
    dta %00000111
    dta %00000010
    dta %00000011
    dta %00000111
    dta %00001111
    dta %00011010
    dta %00001100
    dta %00000110
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
len_PMG_player_shape0 = *-PMG_player_shape0

PMG_player_shape1
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000111
    dta %00001000
    dta %00010110
    dta %00011111
    dta %00011111 
    dta %00011111
    dta %00111110
    dta %00000111
    dta %00111000
    dta %01111100
    dta %01111000
    dta %11010000
    dta %10100000
    dta %01110000
    dta %11111010
    dta %11111111
    dta %01110011  
    dta %00001100
    dta %00111100
    dta %00011110
    dta %00001111
    dta %00000111
    dta %00000010
    dta %00000001
    dta %00000011
    dta %00000111
    dta %00001010
    dta %00001100
    dta %00000110
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
len_PMG_player_shape1 = *-PMG_player_shape1
 
PMG_missile_ORA0
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000 
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00001111
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000010
    dta %00001010
    dta %00001010
    dta %00000000
    dta %00001010
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
len_PMG_missile_ORA0 = *-PMG_missile_ORA0

PMG_missile_ORA1
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %11110000 
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00100000
    dta %10100000
    dta %10100000
    dta %00000000
    dta %10100000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
    dta %00000000
len_PMG_missile_ORA1 = *-PMG_missile_ORA1    

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; write high scores
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
write_high_scores
               LDA #<buff1_high_score              
               STA $00 											; screen_address_low
               LDA #>buff1_high_score			 		
               STA $01 											; screen_address_high
			   lda #6
			   sta write_high_score_value.row
               LDA #$06
               STA $79 											; rank

write_high_scores_loop
               LDA $79 											; rank
               ASL @											; *8
               ASL @
               ASL @
               PHA
               TAX
               LDA #$07
               STA $7b 											; count
write_name_loop
               LDA high_score_names,X
               STX $75 											; offset
               JSR plot_character
               LDX $75 											; offset
               INX
               DEC $7b 											; count
               BPL write_name_loop
               
               LDA $00 											; screen_address_low
               CLC
               ADC #$20                                         ; Sixteen pixel gap between names and scores
               STA $00 											; screen_address_low
               BCC skip_page8
               
               INC $01 											; screen_address_high
skip_page8
               PLA
               TAY
               LDA #$06
               STA $7b 											; count
               JSR write_high_score_value                   	; Returns sign of rank
               BPL write_high_scores_loop
               
               RTS
    
high_score_names
    dta 'Callisto'
 	dta 'Guard   '
 	dta 'Defender'
 	dta 'Kult    '
 	dta 'LasGates'
 	dta 'LaseHawk'
 	dta 'Zybex   '
 
high_score_values
;	dta $00,$00,$00,$00,$00,$00,$10,$28 					;   00025
	dta $00,$00,$00,$10,$28,$00,$00,$00 					; 0002500
	dta $00,$00,$00,$28,$00,$00,$00,$00 					; 0005000
	dta $00,$00,$08,$00,$00,$00,$00,$00 					; 0010000
	dta $00,$00,$28,$28,$00,$00,$00,$00 					; 0055000
	dta $00,$08,$00,$00,$00,$00,$00,$00 					; 0100000
	dta $00,$28,$00,$00,$00,$00,$00,$00 					; 0500000
	dta $08,$00,$00,$00,$00,$00,$00,$00 					; 1000000

check_for_high_score 
               lda #$00
               ldx #$82  											; players_score
check_for_high_score_player_loop
               sta $9c 	 											; player
               stx score_to_check+1         						; $0b4f ; score_to_check
               stx score_to_copy+1          						; $0b99 ; score_to_copy
               lda #$00
check_for_high_score_rank_loop
               sta $79 	 											; rank
               asl @
               asl @
               asl @
               tax
               ldy #$00
               
score_to_check
check_for_high_score_digit_loop
               lda $0082,Y 											; players_score
; actually     lda score_to_check,Y
               cmp high_score_values,X
               bpl *+5
               jmp is_lower
               beq consider_next_digit
               bpl consider_higher_rank     						; Always branches
               
consider_next_digit
               INX
               INY
               CPY #$07
               BMI check_for_high_score_digit_loop

consider_higher_rank
               INC $79 												; rank
               LDA $79 												; rank
               CMP #$07
               BMI check_for_high_score_rank_loop
               
add_new_high_score
               LDA #$01
shuffle_scores_rank_loop
               STA $7b 												; rank_to_shuffle
               CMP $79 												; rank
               BEQ skip_shuffling_scores
               ASL @
               ASL @ 
               ASL @
               TAX
               LDY #$07
               
shuffle_scores_digit_loop
               LDA high_score_values,X
               STA high_score_values - 8,X
               LDA high_score_names,X
               STA high_score_names - 8,X
               INX
               DEY
               BPL shuffle_scores_digit_loop

               INC $7b 												; rank_to_shuffle
               LDA $7b 												; rank_to_shuffle
               BNE shuffle_scores_rank_loop

skip_shuffling_scores
               DEC $7b 												; rank_to_shuffle
               LDA $7b 												; rank_to_shuffle
               ASL @
               ASL @
               ASL @
               STA $76 												; high_score_offset
               LDY #$00
               TAX

score_to_copy
copy_high_score_loop
               LDA $0082,Y 										   		; players_score
; actually     LDA score_to_copy,Y
               STA high_score_values,X
               LDA #$2e ; "."
               STA high_score_names,X
               INX
               INY
               CPY #$08
               BMI copy_high_score_loop
               
               JSR plot_high_score_screen
               													   
			   lda #song_get_name
			   jsr rmt_init2
               
               JSR get_name
               mva #$ff cloc
          													   
			   lda #song_title
			   jsr rmt_init2

consider_next_player
               LDX #$89 												; player_two_score
               
               lda $9c,x												; check max lives?
			   cmp #9
			   beq *+4
				
               INC $9c  												; player
               
               LDA $9c  												; player
               CMP #$02
               beq *+5
               jmp check_for_high_score_player_loop	
				
               rts

is_lower       LDA $79 													; rank
               BNE add_new_high_score
               BEQ consider_next_player

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; write high score value on HIGH SCORE screen
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
			.align $0100
number_sprites											; definition of every digit (on HIGH SCORE Screen), 8 bytes for one digit
	dta $0e,$0a,$a0,$a0,$a0,$aa,$aa,$ee ; "0"
	dta $04,$0c,$40,$40,$40,$44,$44,$ee ; "1"
	dta $0e,$02,$20,$e0,$e0,$88,$88,$ee ; "2"
	dta $0e,$02,$20,$e0,$e0,$22,$22,$ee ; "3"
	dta $08,$08,$80,$a0,$e0,$ee,$22,$22 ; "4"
	dta $0e,$08,$80,$e0,$e0,$22,$22,$ee ; "5"
	dta $0e,$08,$80,$e0,$e0,$aa,$aa,$ee ; "6"
	dta $0e,$02,$20,$20,$20,$22,$22,$22 ; "7"
	dta $0e,$0a,$a0,$e0,$e0,$aa,$aa,$ee ; "8"
	dta $0e,$0a,$a0,$e0,$e0,$22,$22,$22 ; "9"

write_high_score_value .proc
               STY $73 											; offset
              
               LDX high_score_values,Y
               LDY #$00

plot_number_loop
               LDA number_sprites,X
               jsr conv_byte_BBC_ATARI
               STA ($00),Y 										; screen_address
               INX
               INY
               CPY #$08 
               BMI plot_number_loop
               
               TYA     											; A=8
               CLC
               ADC $00 											; screen_address_low
               STA $00 											; screen_address_low
           	   lda $01
           	   adc #$00
               sta $01    
               
               LDY $73 											; offset
               INY
               DEC $7b 											; count
               BPL write_high_score_value
          
      	   	   inc row
      	   	   inc row
      	   	   ldx row
      	   	   lda tab_address_buff1_lo,x
      	   	   add #7*8
      	   	   sta $00
      	   	   lda tab_address_buff1_hi,x
           	   adc #$00   
      	   	   sta $01
      	       
               DEC $79 											; rank
           
               RTS

row dta $00
.endp
 
;--------------------------------------------------------------------------------------------------------------------------------------------------------------------
; convert colors 
;--------------------------------------------------------------------------------------------------------------------------------------------------------------------
convert_colors_sprite_data .proc
; change color %10 ---> %01 (for weapon 0-3)
				convert_10_to_01 #sprite_player_one_weapon_0_odd  #sprite_alien_even_group_0 
				convert_10_to_01 #sprite_player_one_weapon_0_even #sprite_alien_odd_group_0 
				
				convert_10_to_01 #sprite_player_one_weapon_1_odd  #sprite_alien_even_group_1
				convert_10_to_01 #sprite_player_one_weapon_1_even #sprite_alien_odd_group_1

				convert_10_to_01 #sprite_player_one_weapon_2_odd  #sprite_alien_even_group_2
				convert_10_to_01 #sprite_player_one_weapon_2_even #sprite_alien_odd_group_2

				convert_10_to_01 #sprite_player_one_weapon_3_odd  #sprite_alien_even_group_3
				convert_10_to_01 #sprite_player_one_weapon_3_even #sprite_alien_odd_group_3

; change color %10 ---> %01 (for player one)
				convert_10_to_01 #sprite_player_one_even_group_0  #mask_player_even_group_0
				convert_10_to_01 #sprite_player_one_even_group_1  #mask_player_even_group_1 
				convert_10_to_01 #sprite_player_one_even_group_2  #mask_player_even_group_2
				convert_10_to_01 #sprite_player_one_even_group_3  #mask_player_even_group_3 

				convert_10_to_01 #sprite_player_one_odd_group_0  #mask_player_odd_group_0
				convert_10_to_01 #sprite_player_one_odd_group_1  #mask_player_odd_group_1
				convert_10_to_01 #sprite_player_one_odd_group_2  #mask_player_odd_group_2
				convert_10_to_01 #sprite_player_one_odd_group_3  #mask_player_odd_group_3

; change color %10 ---> %01 (for bonus player one & two)
				convert_10_to_01 #sprite_player_one_bonus_even_group_0  #sprite_diamond_even_group_0
				convert_10_to_01 #sprite_player_one_bonus_even_group_1  #sprite_diamond_even_group_1
				convert_10_to_01 #sprite_player_one_bonus_odd_group_0  #sprite_diamond_odd_group_0
				convert_10_to_01 #sprite_player_one_bonus_odd_group_1  #sprite_diamond_odd_group_1
				
				convert_10_to_01 #sprite_player_two_bonus_even_group_0  #sprite_diamond_even_group_2
				convert_10_to_01 #sprite_player_two_bonus_even_group_1  #sprite_diamond_even_group_3
				convert_10_to_01 #sprite_player_two_bonus_odd_group_0  #sprite_diamond_odd_group_2
				convert_10_to_01 #sprite_player_two_bonus_odd_group_1  #sprite_diamond_odd_group_3

; exchange colors %10 ---> %01 and %01 ---> %10 (for boss, enemy etc.)
				exchange_10_to_01 #sprite_claw_even_group_0 #mask_diamond_even_group_0
				exchange_10_to_01 #sprite_claw_even_group_1 #mask_diamond_even_group_1
				exchange_10_to_01 #sprite_claw_even_group_2 #mask_diamond_even_group_2
				exchange_10_to_01 #sprite_claw_even_group_3 #mask_diamond_even_group_3

				exchange_10_to_01 #sprite_claw_odd_group_0 #mask_diamond_odd_group_0
				exchange_10_to_01 #sprite_claw_odd_group_1 #mask_diamond_odd_group_1
				exchange_10_to_01 #sprite_claw_odd_group_2 #mask_diamond_odd_group_2
				exchange_10_to_01 #sprite_claw_odd_group_3 #mask_diamond_odd_group_3

				exchange_10_to_01 #sprite_alien_even_group_0 #sprite_ball_one_even_group_0
				exchange_10_to_01 #sprite_alien_even_group_1 #sprite_ball_one_even_group_1
				exchange_10_to_01 #sprite_alien_even_group_2 #sprite_ball_two_even_group_0
				exchange_10_to_01 #sprite_alien_even_group_3 #sprite_ball_two_even_group_1

				exchange_10_to_01 #sprite_alien_odd_group_0  #sprite_ball_one_odd_group_0
				exchange_10_to_01 #sprite_alien_odd_group_1  #sprite_ball_one_odd_group_1
				exchange_10_to_01 #sprite_alien_odd_group_2  #sprite_ball_two_odd_group_0
				exchange_10_to_01 #sprite_alien_odd_group_3  #sprite_ball_two_odd_group_1

				rts
.endp
            				               				            
.print 'bank $FE  = $4000 - ', *-1		
.print ' '

;--------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Fast plot on background (buffor 1)
; bank #1 EXTENSION is ON
;--------------------------------------------------------------------------------------------------------------------------------------------------------------------
	 	lmb #1
     	.pages $40
			icl 'DATA\fast_back1.asm'

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; clear bit7 (5th color)
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
clr_bit7_left_margin .proc   
				ldy #1
				sty screen_chars1+0+120*0+1
				sty screen_chars1+0+120*1+1
				sty screen_chars1+0+120*2+1
				sty screen_chars1+0+120*3+1
				sty screen_chars1+0+120*4+1
				iny
				sty screen_chars1+0+120*0+2
				sty screen_chars1+0+120*1+2
				sty screen_chars1+0+120*2+2
				sty screen_chars1+0+120*3+2
				sty screen_chars1+0+120*4+2
				
				ldy #41
				sty screen_chars1+40+120*0+1
				sty screen_chars1+40+120*1+1
				sty screen_chars1+40+120*2+1
				sty screen_chars1+40+120*3+1
				sty screen_chars1+40+120*4+1
				iny
				sty screen_chars1+40+120*0+2
				sty screen_chars1+40+120*1+2
				sty screen_chars1+40+120*2+2
				sty screen_chars1+40+120*3+2
				sty screen_chars1+40+120*4+2
				
				ldy #81
				sty screen_chars1+80+120*0+1
				sty screen_chars1+80+120*1+1
				sty screen_chars1+80+120*2+1
				sty screen_chars1+80+120*3+1
				sty screen_chars1+80+120*4+1
				iny
				sty screen_chars1+80+120*0+2
				sty screen_chars1+80+120*1+2
				sty screen_chars1+80+120*2+2
				sty screen_chars1+80+120*3+2
				sty screen_chars1+80+120*4+2
	
				rts
.endp
 
	 	.endpg
	 	
.print 'bank $01  = $4000 - ', *-1	

;--------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Fast plot on background (buffor 2)
; bank #2 EXTENSION is ON
;--------------------------------------------------------------------------------------------------------------------------------------------------------------------
	 	lmb #2
     	.pages $40
			icl 'DATA\fast_back2.asm'									
	 	.endpg
.print 'bank $02  = $4000 - ', *-1	

;--------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Continue fast plot on background (buffor 1&2)
; bank #3 EXTENSION is ON
;--------------------------------------------------------------------------------------------------------------------------------------------------------------------
	 	lmb #3
     	.pages $40
			icl 'DATA\fast_back_cont1.asm'		
			icl 'DATA\fast_back_cont2.asm'

cw_logo     ins 'DATA\graphics\cw_logo.bin'
len_cw_logo = *-cw_logo

  .align $0100        ; must be divided by 256 (lo byte must be = $00) 

horizon_0_sprite                                                			; Woodland
	dta $00,$00,$00,$00,$00,$00,$00,$99,$11,$00,$22,$22,$bb,$66,$55,$55
	dta $00,$88,$cc,$66,$cc,$aa,$66,$88,$00,$00,$00,$00,$88,$00,$22,$66
	dta $00,$00,$00,$00,$00,$00,$88,$44,$00,$00,$00,$00,$00,$11,$22,$22
	dta $00,$00,$00,$00,$88,$44,$22,$11,$22,$99,$11,$46,$02,$13,$22,$55
	dta $00,$00,$33,$44,$88,$00,$aa,$22,$66,$99,$00,$00,$44,$11,$00,$44
	dta $00,$00,$88,$77,$00,$00,$44,$11,$00,$00,$00,$00,$88,$44,$aa,$99
	dta $00,$00,$00,$00,$00,$11,$ee,$00,$00,$00,$00,$00,$ff,$00,$00,$00
	dta $00,$00,$00,$00,$00,$cc,$22,$11,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$22,$22,$00,$22,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$44,$44,$44,$44,$44,$aa,$00,$00,$00,$00,$00,$00,$44,$00
	dta $00,$22,$22,$22,$00,$22,$77,$55,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$99,$00,$00,$00,$00,$00,$66,$cc,$00
	dta $00,$00,$00,$00,$11,$88,$22,$44,$00,$33,$44,$88,$00,$00,$00,$00
	dta $00,$ee,$11,$00,$00,$00,$88,$00,$00,$00,$ee,$11,$00,$88,$44,$00
	dta $00,$00,$00,$99,$66,$00,$00,$00,$00,$00,$00,$cc,$22,$11,$00,$88
	dta $00,$00,$00,$00,$00,$00,$cc,$33,$00,$00,$00,$00,$00,$00,$00,$88
	dta $22,$00,$00,$44,$11,$80,$00,$aa,$55,$88,$22,$00,$00,$40,$33,$ff
	dta $bb,$88,$2a,$08,$08,$6e,$7f,$7f,$77,$00,$88,$77,$c4,$00,$b8,$ee
	dta $55,$cc,$88,$22,$6e,$4c,$08,$19,$44,$88,$00,$11,$00,$22,$77,$ff
	dta $00,$22,$44,$00,$00,$00,$88,$ee,$aa,$77,$44,$11,$33,$33,$67,$01
	dta $00,$88,$00,$00,$88,$88,$cc,$00,$00,$88,$99,$99,$bb,$bb,$09,$09
	dta $11,$33,$33,$77,$ff,$89,$01,$01,$00,$88,$88,$cc,$cc,$00,$00,$11
	dta $00,$11,$88,$55,$ee,$ee,$04,$04,$00,$11,$22,$44,$66,$33,$00,$00
	dta $88,$44,$44,$aa,$44,$ee,$08,$08,$cc,$22,$33,$00,$aa,$02,$02,$ff
	dta $55,$22,$55,$22,$77,$55,$02,$8a,$00,$00,$55,$11,$55,$44,$04,$bf
	dta $ee,$aa,$55,$bb,$55,$04,$04,$ff,$44,$aa,$44,$44,$44,$04,$ff,$ff
	dta $22,$55,$aa,$77,$8a,$02,$22,$ff,$77,$00,$99,$00,$88,$04,$15,$ff
	dta $22,$00,$88,$11,$00,$04,$ff,$ff,$33,$77,$ff,$aa,$df,$02,$02,$df
	dta $00,$88,$00,$99,$33,$67,$01,$01,$00,$00,$00,$00,$88,$bb,$33,$01
	dta $00,$00,$00,$44,$00,$11,$00,$11,$22,$00,$22,$66,$66,$02,$00,$cc
	dta $00,$22,$00,$44,$dd,$19,$00,$88,$33,$00,$00,$00,$88,$00,$08,$23
	dta $88,$20,$00,$ea,$33,$20,$06,$69,$44,$00,$99,$22,$44,$44,$00,$6e
  
horizon_1_sprite															; Desert
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$44,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$88,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$11,$11,$33,$33,$44,$44,$ee,$cc,$ff,$ee,$ff,$ff
	dta $00,$00,$00,$00,$00,$00,$88,$00,$00,$00,$00,$00,$11,$00,$00,$00
	dta $00,$00,$00,$00,$99,$55,$22,$57,$00,$00,$00,$88,$44,$22,$00,$00
	dta $00,$44,$aa,$99,$11,$00,$66,$89,$00,$00,$00,$33,$44,$08,$4c,$22
	dta $00,$00,$00,$00,$88,$44,$44,$00,$11,$00,$33,$33,$33,$33,$33,$33
	dta $00,$00,$88,$00,$88,$00,$88,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$11,$00,$00
	dta $00,$00,$00,$00,$cc,$22,$00,$23,$00,$00,$00,$00,$00,$00,$cc,$22
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$f0,$00,$00,$f0,$00,$f0,$fc,$00,$f0,$00,$00,$f1,$33,$f7,$ff
	dta $00,$e2,$77,$ee,$ff,$ff,$ff,$ff,$00,$f0,$00,$88,$74,$aa,$dd,$ee
	dta $00,$f0,$00,$00,$f0,$00,$f0,$f8,$00,$f0,$00,$00,$f0,$00,$f1,$f1
	dta $33,$c4,$77,$77,$f7,$00,$bb,$88,$ff,$cc,$ff,$33,$ff,$00,$ff,$00
	dta $00,$f8,$88,$88,$f8,$00,$76,$76,$00,$f0,$00,$00,$f1,$11,$f3,$f3
	dta $77,$f7,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$dd,$dd
	dta $cc,$98,$66,$cc,$bb,$ee,$dd,$ff,$00,$f1,$00,$00,$f0,$00,$f8,$71
	dta $8a,$b4,$04,$04,$78,$08,$79,$ff,$99,$f8,$44,$44,$f0,$00,$ff,$ff
	dta $01,$e1,$02,$02,$d2,$ff,$ff,$ff,$11,$f0,$00,$00,$f0,$88,$fe,$ff
	dta $00,$f8,$00,$00,$f0,$00,$f0,$fe,$33,$f3,$33,$33,$f3,$33,$f7,$f7
	dta $88,$70,$88,$00,$f8,$00,$fc,$fc,$00,$f0,$44,$0e,$f0,$00,$f0,$ff
	dta $00,$f0,$00,$11,$e1,$00,$f0,$ff,$00,$f0,$00,$00,$78,$00,$f0,$fc
	dta $45,$e9,$02,$02,$d2,$02,$d3,$ff,$88,$f4,$22,$22,$f0,$cc,$ff,$ff
	dta $00,$f0,$00,$00,$f0,$00,$f0,$fc,$00,$f0,$00,$00,$ff,$bb,$ee,$ee
	dta $00,$f0,$00,$00,$fe,$aa,$fe,$fe,$00,$f0,$00,$00,$f0,$00,$f0,$f7
	dta $00,$f0,$00,$00,$f2,$55,$ee,$ff,$00,$f0,$00,$00,$f0,$00,$f8,$74

horizon_2_sprite															; Volcanoes
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$02,$05,$00,$26,$26,$66
	dta $10,$80,$1a,$40,$00,$00,$00,$00,$20,$0c,$00,$00,$00,$00,$00,$00
	dta $00,$40,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$02,$05,$02,$04
	dta $00,$00,$10,$80,$00,$00,$00,$00,$00,$00,$80,$00,$00,$00,$00,$44
	dta $00,$00,$00,$00,$00,$00,$00,$01,$00,$00,$00,$00,$00,$00,$20,$00
	dta $00,$00,$00,$00,$00,$20,$00,$00,$00,$00,$00,$00,$00,$00,$00,$11
	dta $00,$11,$22,$00,$44,$aa,$00,$00,$00,$00,$88,$00,$44,$00,$22,$11
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$01,$06,$01,$26,$46,$66,$46,$08,$02,$48,$00,$00,$00,$00,$00
	dta $00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$66,$88
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$11,$02,$22
	dta $00,$00,$00,$00,$00,$00,$88,$00,$00,$00,$00,$00,$00,$11,$22,$01
	dta $00,$00,$00,$00,$88,$44,$2a,$11,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00,$20,$00,$80,$00,$80,$00,$08,$88
	dta $00,$00,$20,$00,$00,$00,$00,$44,$00,$40,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$01,$13,$33,$37,$ee,$19,$7f,$bb,$55,$44,$bb,$44,$ff
	dta $00,$00,$88,$88,$dd,$66,$aa,$dd,$00,$33,$55,$aa,$44,$88,$22,$88
	dta $00,$00,$88,$44,$22,$11,$00,$11,$02,$22,$33,$22,$37,$77,$6e,$ff
	dta $00,$00,$00,$88,$00,$cc,$89,$ff,$66,$66,$26,$55,$7f,$ee,$ff,$cc
	dta $00,$11,$66,$00,$00,$88,$89,$77,$bb,$00,$88,$44,$00,$00,$ee,$11
	dta $02,$88,$02,$22,$33,$37,$66,$ff,$00,$00,$00,$88,$66,$11,$88,$66
	dta $00,$00,$00,$11,$22,$88,$02,$aa,$22,$44,$aa,$00,$01,$4c,$dd,$dd
	dta $88,$00,$22,$00,$cc,$00,$44,$55,$00,$00,$00,$00,$00,$11,$8a,$ff
	dta $88,$44,$22,$00,$00,$00,$88,$55,$00,$00,$00,$00,$89,$11,$13,$77
	dta $66,$5f,$df,$df,$ef,$ef,$dd,$ee,$00,$00,$00,$00,$11,$2a,$08,$8f
	dta $11,$22,$55,$88,$44,$00,$00,$0e,$55,$00,$00,$00,$00,$00,$11,$27
	dta $00,$00,$88,$44,$22,$11,$00,$ff,$11,$44,$aa,$00,$00,$44,$11,$99
	dta $44,$22,$11,$00,$00,$00,$00,$55,$44,$00,$00,$00,$6e,$04,$44,$55
	dta $00,$00,$00,$02,$22,$37,$55,$55,$cc,$33,$00,$00,$00,$00,$00,$77
	dta $00,$00,$88,$44,$01,$11,$13,$ee,$88,$19,$aa,$88,$55,$cc,$aa,$dd
	dta $aa,$00,$99,$00,$00,$00,$00,$00,$00,$00,$00,$00,$88,$44,$11,$33

horizon_3_sprite																	; Industrial
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$11,$33,$32,$32,$32,$32
	dta $00,$00,$88,$c0,$c0,$f7,$38,$c0,$00,$00,$00,$00,$00,$ff,$f1,$00
	dta $00,$00,$00,$00,$00,$ff,$f0,$99,$00,$00,$00,$00,$00,$ff,$ba,$f5
	dta $00,$00,$00,$00,$00,$ff,$f1,$32,$00,$00,$00,$00,$00,$ff,$00,$00
	dta $00,$00,$00,$00,$00,$ff,$30,$77,$00,$88,$22,$22,$22,$ff,$ff,$ff
	dta $00,$88,$00,$00,$00,$88,$ee,$bb,$00,$11,$00,$00,$00,$00,$00,$00
	dta $00,$20,$00,$00,$00,$00,$00,$00,$00,$08,$02,$10,$11,$10,$11,$10
	dta $00,$00,$00,$00,$00,$00,$00,$00,$77,$74,$62,$11,$40,$00,$40,$00
	dta $ff,$f1,$32,$64,$c8,$44,$22,$11,$ff,$77,$f8,$cc,$ea,$b9,$ba,$64
	dta $88,$88,$88,$88,$88,$88,$88,$88,$00,$00,$00,$11,$11,$32,$22,$75
	dta $00,$ff,$fc,$62,$b9,$ba,$64,$ea,$00,$ff,$f8,$88,$88,$88,$88,$88
	dta $04,$c8,$40,$40,$e0,$40,$40,$40,$00,$00,$00,$00,$10,$00,$00,$00
	dta $08,$80,$80,$80,$c0,$80,$80,$80,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$22,$00,$02,$00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$20,$33,$0f,$32,$32,$32,$30,$76,$76,$f8,$0f
	dta $48,$80,$c0,$08,$e1,$e0,$e0,$0f,$00,$00,$03,$0c,$00,$00,$11,$03
	dta $54,$22,$99,$06,$88,$88,$44,$0f,$64,$64,$75,$ba,$65,$6c,$64,$0f
	dta $64,$c8,$80,$00,$01,$0a,$04,$00,$00,$13,$15,$3b,$33,$33,$33,$07
	dta $ff,$bf,$ff,$ff,$ff,$dd,$dd,$0f,$ff,$3f,$ff,$dd,$dd,$88,$88,$0f
	dta $dd,$6e,$ff,$ff,$ff,$ff,$ff,$0f,$88,$cf,$44,$ee,$aa,$ee,$ee,$0f
	dta $00,$08,$04,$02,$01,$00,$00,$00,$11,$10,$33,$44,$4a,$47,$88,$0f
	dta $00,$00,$88,$44,$40,$4c,$22,$0e,$40,$00,$04,$0a,$0a,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$01,$c8,$cc,$ea,$b9,$ba,$ec,$c8,$0f
	dta $88,$88,$88,$99,$99,$bb,$bb,$0f,$54,$ea,$b9,$d4,$62,$31,$ff,$0f
	dta $b9,$ba,$64,$ea,$b9,$ba,$ff,$0f,$88,$88,$88,$88,$88,$88,$98,$1c
	dta $e8,$c0,$e8,$c0,$e0,$c0,$f0,$f0,$11,$10,$11,$10,$10,$10,$30,$30
	dta $c0,$80,$c0,$80,$c0,$80,$e0,$e0,$00,$00,$00,$10,$30,$03,$10,$07
	dta $00,$00,$11,$95,$97,$0e,$40,$0f,$00,$ff,$aa,$ff,$cf,$12,$10,$0f
	dta $00,$ee,$bb,$ff,$1f,$4a,$40,$0f,$00,$00,$00,$00,$11,$02,$55,$0f
	dta $55,$0a,$55,$0a,$55,$0a,$55,$0f,$00,$08,$00,$08,$44,$0a,$55,$0f
 end_horizon_sprite = *
 	
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; plot level number on bottom panel 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
			.align $0100
number_sprites_bank													; definition of every digit (on HIGH SCORE Screen), 8 bytes for one digit
	dta $0e,$0a,$a0,$a0,$a0,$aa,$aa,$ee ; "0"
	dta $04,$0c,$40,$40,$40,$44,$44,$ee ; "1"
	dta $0e,$02,$20,$e0,$e0,$88,$88,$ee ; "2"
	dta $0e,$02,$20,$e0,$e0,$22,$22,$ee ; "3"
	dta $08,$08,$80,$a0,$e0,$ee,$22,$22 ; "4"
	dta $0e,$08,$80,$e0,$e0,$22,$22,$ee ; "5"
	dta $0e,$08,$80,$e0,$e0,$aa,$aa,$ee ; "6"
	dta $0e,$02,$20,$20,$20,$22,$22,$22 ; "7"
	dta $0e,$0a,$a0,$e0,$e0,$aa,$aa,$ee ; "8"
	dta $0e,$0a,$a0,$e0,$e0,$22,$22,$22 ; "9"
	
plot_level_number
				LDA $9b 										  	 ; level_number
				AND #$07	
				ASL @
				ASL @
				ASL @
				ADC #$08
				STA level_number_sprite_address_low+1
				
				LDY #$07
plot_level_number_loop
level_number_sprite_address_low
			    LDA number_sprites_bank + $90,Y
;     actually LDA level_number_sprite_address,Y
			    jsr conv_byte_BBC_ATARI 
				STA buff1_level_bottom_panel,Y       	      
				STA buff2_level_bottom_panel,Y       	      
				DEY
				BPL plot_level_number_loop
				
				rts

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; plot number of lives on bottom panel
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
plot_lives		LDA $9c 										 ; players_lives
				ASL @
				ASL @
				ASL @
				STA player_one_lives_sprite_address_low+1
				LDA $9d 										 ; players_lives + 1
				ASL @
				ASL @
				ASL @
				STA player_two_lives_sprite_address_low+1
				
				LDY #$07
			
plot_lives_loop
player_one_lives_sprite_address_low	
				LDA number_sprites_bank,Y
				jsr conv_byte_BBC_ATARI
;     actually LDA player_one_lives_sprite_address,Y
				STA buff1_lives_player1_bottom_panel,Y       	      ; Plot player one lives
				STA buff2_lives_player1_bottom_panel,Y       	      ; Plot player one lives

player_two_lives_sprite_address_low
				LDA number_sprites_bank,Y
				jsr conv_byte_BBC_ATARI
;     actually LDA player_two_lives_sprite_address,Y
				STA buff1_lives_player2_bottom_panel,Y      	      ; Plot player two lives
				STA buff2_lives_player2_bottom_panel,Y      	      ; Plot player two lives
				DEY
				BPL plot_lives_loop
				
				rts
				
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; plot number of bombs (4th weapon of player)
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
plot_number_bombs .proc
				stx reg_x
				sty reg_y
				
				mwa #buff1_charset7+320*0+8*11 	addr1+1					; PLAYER ONE
				mwa #buff2_charset7+320*0+8*11 	addr2+1				
				ldx #7													; show "0" always
				jsr skip1

				mwa #buff1_charset7+320*0+8*12 	addr1+1				
				mwa #buff2_charset7+320*0+8*12 	addr2+1	
				lda number_bombs 										; show "number_bombs" 0-9 always
				jsr skip0			

				mwa #buff1_charset7+320*0+8*33 	addr1+1				    ; PLAYER TWO
				mwa #buff2_charset7+320*0+8*33 	addr2+1				
				ldx #7													; show "0" always
				jsr skip1

				mwa #buff1_charset7+320*0+8*34 	addr1+1				
				mwa #buff2_charset7+320*0+8*34 	addr2+1	
				lda number_bombs+1 										; show "number_bombs" 0-9 always
					
skip0			asl @
				asl @
				asl @
				add #7
				tax						
					
skip1			ldy #7				
loop1			lda score_number_sprites,x
addr1			sta $ffff,y
addr2			sta $ffff,y
				dex
				dey
				bpl loop1
				
				ldx reg_x
				ldy reg_y
 
				rts
.endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; plot score (all digits)
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
plot_score_player_one
				ldx #$06
				stx $7b
				ldy #$37
				bne plot_score										; always branches!
				
plot_score_player_two
				ldx #$06
				stx $7b
				ldx #$0d
				ldy #$af
				
plot_score
plot_score_digit_loop
				LDA $82,X 									  		; players_score
				cmp #9*8+1
				bmi plot_score2

				lda #$00
				sta $82,x						

plot_score2		STX $79 									  		; score_offset
				add #<score_number_sprites
				STA score_number_sprite_address_low+1
				lda #>score_number_sprites
				adc #0
				sta score_number_sprite_address_low+2
				
				LDX #$07

plot_score_sprite_loop
score_number_sprite_address_low
				LDA score_number_sprites,X
;     actually LDA score_number_sprite_address,X
				STA buff2_charset0+8*9,Y               
				STA buff1_charset0+8*9,Y
				DEY
				DEX
				BPL plot_score_sprite_loop
				
				LDX $79 										; score_offset
				DEX
				DEC $7b 										; score_length
				BPL plot_score_digit_loop
				rts

score_number_sprites											; color %11 - definition of every digit (on HIGH SCORE Screen), 8 bytes for one digit
	dta %11111100
	dta %11001100
	dta %11001100
	dta %11001100
	dta %11001100
	dta %11001100
	dta %11001100
	dta %11111100
	
	dta %00110000
	dta %11110000
	dta %00110000
	dta %00110000
	dta %00110000
	dta %00110000
	dta %00110000
	dta %11111100

	dta %11111100
	dta %00001100
	dta %00001100
	dta %11111100
	dta %11111100
	dta %11000000
	dta %11000000
	dta %11111100

	dta %11111100
	dta %00001100
	dta %00001100
	dta %11111100
	dta %11111100
	dta %00001100
	dta %00001100
	dta %11111100

	dta %11000000
	dta %11000000
	dta %11001100
	dta %11111100
	dta %11111100
	dta %00001100
	dta %00001100
	dta %00001100

	dta %11111100
	dta %11000000
	dta %11000000
	dta %11111100
	dta %11111100
	dta %00001100
	dta %00001100
	dta %11111100

	dta %11111100
	dta %11000000
	dta %11000000
	dta %11111100
	dta %11111100
	dta %11001100
	dta %11001100
	dta %11111100

	dta %11111100
	dta %00001100
	dta %00001100
	dta %00001100
	dta %00001100
	dta %00001100
	dta %00001100
	dta %00001100

	dta %11111100
	dta %11001100
	dta %11001100
	dta %11111100
	dta %11111100
	dta %11001100
	dta %11001100
	dta %11111100

	dta %11111100
	dta %11001100
	dta %11001100
	dta %11111100
	dta %11111100
	dta %00001100
	dta %00001100
	dta %00001100
												
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; prepare 4 bitmaps with horizon, every bitmap is shifted by 1 pixel (2 bits)  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
prepare_shifted_horizon_sprites
				LDA $9b 							; level_number*2, every horizon bitmap has 512 bytes size (2 pages)	
				AND #$03
				ASL @
				ADC #>horizon_0_sprite              ; $4600 = horizon_0_sprite
				STA $74                             ; source_address_high                        ; Use unshifted sprite
				STA shifted_horizon_addresses_high
				LDA #>horizon_shifted_1_sprite      ; $0e00 = horizon_shifted_1_sprite
				STA $76 							; target_address_high
				JSR shift_horizon                   ; Create copy in $0e00 - $0fff shifted by one pixel
			
				LDA #>horizon_shifted_1_sprite  	; $0e00 = horizon_shifted_1_sprite
				STA $74 							; source_address_high			
				LDA #>horizon_shifted_2_sprite  	; $1000 = horizon_shifted_2_sprite
				STA $76 							; source_address_high			
				JSR shift_horizon     		        ; Create copy in $1000 - $11ff shifted by two pixels
				
				LDA #>horizon_shifted_2_sprite      ; $1000 = horizon_shifted_2_sprite
				STA $74 							; source_address_high
				LDA #>horizon_shifted_3_sprite      ; $0c00 = horizon_shifted_3_sprite
				STA $76 							; target_address_high        Create copy in $0c00 - $0dff shifted by three pixels

shift_horizon	LDA #$02 							; pages of horizon_0_sprite (512 bytes)
				STA $7a 					        ; pages

shift_horizon_page_loop
				LDA #$00
				STA $73 							; source_address_low
				STA $75 							; target_address_low
				
				LDX #$07
				
shift_horizon_row_loop
				LDA #$00
				
shift_horizon_group_loop
				STA $79 											; offset
				TAY
				LDA ($73),Y 										; source_address
				ASL @                                               ; Shift column of sprite left a pixel
				asl @
				AND #%11111100  									; #$ee ; 3330
				STA ($75),Y 										; target_address
				TYA
				CLC
				ADC #$08
				TAY
				LDA ($73),Y		 									; source_address
				AND #%11000000   									; #$88 ; 3000              ; Get left pixel of next column of sprite
				lsr @
				lsr @
				lsr @
				LSR @
				LSR @
				LSR @                                               ; Move into right pixel
				LDY $79 											; offset
				ORA ($75),Y 										; target_address
				STA ($75),Y 										; target_address
				LDA $79 											; offset
				ADC #$08
				BNE shift_horizon_group_loop
  
				INC $73 											; source_address_low
				INC $75												; target_address_low
				DEX
				BPL shift_horizon_row_loop
 				
				INC $74 											; source_address_high
				INC $76 											; target_address_high
				DEC $7a 											; pages
				BNE shift_horizon_page_loop
				
				RTS				

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; plot horizon on screen buffor2
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------				
plot_horizon_buff2
				LDA $70 											; frame_counter
				AND #$03
				TAX
				LDA shifted_horizon_addresses_high,X
				STA buffer_two_left_horizon_address_one+2
				STA buffer_two_right_horizon_address_one+2
				CLC
				ADC #$01
				STA buffer_two_left_horizon_address_two+2
				STA buffer_two_right_horizon_address_two+2
				LDA $70 											; frame_counter
				ASL @
				AND #$f8
				TAX
				LDY #$00
 										
plot_left_horizon_in_buffer_two_loop
buffer_two_left_horizon_address_one
				LDA horizon_0_sprite,X                              ; Plot left horizon   8bit Y-register - only 0-255
;     actually LDA buffer_two_left_horizon_address_one,X
				STA buff2_charset4+320*1+8*1,Y		  				; buffer_two + $140 * 8 + 8 * 1
buffer_two_left_horizon_address_two				
				LDA horizon_0_sprite+256,X              
;     actually LDA buffer_two_left_horizon_address_two,X
				STA buff2_charset4+320*2+8*1,Y 						; buffer_two + $140 * 9 + 8 * 1
				INX
				INY
				BNE plot_left_horizon_in_buffer_two_loop	
 				
plot_right_horizon_in_buffer_two_loop
buffer_two_right_horizon_address_one
				LDA horizon_0_sprite,X             
;     actually LDA buffer_two_right_horizon_address_one,X
				STA buff2_charset4+320*1+8*33,Y 					; buffer_two + $140 * 8 + 8 * 33
buffer_two_right_horizon_address_two				
				LDA horizon_0_sprite+256,X            
;     actually LDA buffer_two_right_horizon_address_two,X
				STA buff2_charset4+320*2+8*33,Y 					; buffer_two + $140 * 9 + 8 * 33
				INX
				INY
				CPY #$30
				BNE plot_right_horizon_in_buffer_two_loop
 
				LDA #>buff2_upper_markers      						;$74
				STA $74 											; distant_screen_address_high
				LDA #>buff2_middle_markers				     		;$77
				STA $09 											; middle_screen_address_high
				LDA #>buff2_bottom_markers				            ;$7b
				STA $01 											; screen_address_high
				
				jmp plot_background_in_either_buffer

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; plot horizon on screen buffor1
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------				
plot_horizon_buff1				 				 					
				LDA $70 											; frame_counter
				AND #$03
				TAX
				LDA shifted_horizon_addresses_high,X
				STA buffer_one_left_horizon_address_one+2
				STA buffer_one_right_horizon_address_one+2
				CLC
				ADC #$01
				STA buffer_one_left_horizon_address_two+2
				STA buffer_one_right_horizon_address_two+2
				LDA $70 											; frame_counter
				ASL @
				AND #$f8
				TAX
				LDY #$00
	
plot_left_horizon_in_buffer_one_loop
buffer_one_left_horizon_address_one
				LDA horizon_0_sprite,X                              ; Plot left horizon
;     actually LDA buffer_one_left_horizon_address_one,X
				STA buff1_charset4+320*1+8*1,Y 						; buffer_one + $140 * 8 + 8 * 1
buffer_one_left_horizon_address_two
				LDA horizon_0_sprite+256,X
;     actually LDA buffer_one_left_horizon_address_two,X
				STA buff1_charset4+320*2+8*1,Y 						; buffer_one + $140 * 9 + 8 * 1
				INX
				INY
				BNE plot_left_horizon_in_buffer_one_loop

plot_right_horizon_in_buffer_one_loop
buffer_one_right_horizon_address_one
				LDA horizon_0_sprite,X                              ; Plot right horizon
;     actually LDA buffer_one_right_horizon_address_one,X
				STA buff1_charset4+320*1+8*33,Y 					; buffer_one + $140 * 8 + 8 * 33
buffer_one_right_horizon_address_two
				LDA horizon_0_sprite+256,X
;     actually LDA buffer_one_right_horizon_address_two,X
				STA buff1_charset4+320*2+8*33,Y 					; buffer_one + $140 * 9 + 8 * 33
				INX
				INY
				CPY #$30
				BNE plot_right_horizon_in_buffer_one_loop
				
				LDA #>buff1_upper_markers      						;$5b
				STA $74 											; distant_screen_address_high
				LDA #>buff1_middle_markers				     		;$5e
				STA $09 											; middle_screen_address_high
				LDA #>buff1_bottom_markers				            ;$63
				STA $01 											; screen_address_high
				
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; plot distant markers on screen
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
buff1_upper_markers  = [buff1_charset5+320*0]+8+6
buff1_middle_markers = [buff1_charset5+320*2]+8+5
buff1_bottom_markers = [buff1_charset6+320*2]+8+3

buff2_upper_markers  = [buff2_charset5+320*0]+8+6
buff2_middle_markers = [buff2_charset5+320*2]+8+5
buff2_bottom_markers = [buff2_charset6+320*2]+8+3

plot_background_in_either_buffer
plot_distant_markers
				LDX #$08
				LDA $70 											; frame_counter	
				AND #$06
				EOR #$06
				CMP #$04
				BPL skip_extra_distant_marker
				
				INX

skip_extra_distant_marker
				ASL @												; *4
				ASL @
				ADC #<buff1_upper_markers							;$ce		; +206?
				STA $73 											; distant_screen_address_low	
				LDY #$00

plot_distant_markers_loop
				LDA $70 											; frame_counter
				AND #$01
				BEQ is_even1
is_odd
				LDA #%11011111 										;$bf ; 3133
				BNE plot_distant_marker                      		; Always branches

is_even1		LDA #%11111101 										; UPPER MARKERS
plot_distant_marker
				STA ($73),Y 										; distant_screen_address	
				CLC
				LDA $73 											; distant_screen_address_low
				ADC #$20
				STA $73 											; distant_screen_address_low
				BCC skip_page1
				
				INC $74 											; distant_screen_address_high
skip_page1
				DEX
				BPL plot_distant_markers_loop
 
plot_middle_markers
				LDX #$03
				LDA $70 											; frame_counter
				AND #$07
				EOR #$07
				CMP #$06
				BPL skip_extra_middle_marker

				INX

skip_extra_middle_marker
				ASL @												; *8
				ASL @
				ASL @
				ADC #<buff1_middle_markers							;$4d
				STA $08 											; middle_screen_address_low
plot_middle_markers_loop
				LDY #$00											; MIDDLE MARKERS
				lda ($08),Y
				and #%11110101
				ora #%00000101
				STA ($08),Y 										; middle_screen_address_low
				INY
				lda ($08),Y
				and #%11110101
				ora #%00000101
				STA ($08),Y 										; middle_screen_address_low
				CLC
				LDA $08 											; middle_screen_address_low
				ADC #$40
				STA $08 											; middle_screen_address_low
				BCC skip_page2
				
				INC $09 											; middle_screen_address_high
skip_page2
				DEX
				BPL plot_middle_markers_loop

plot_near_markers
				LDX #$01
				LDA $70 											; frame_counter
				AND #$07
				EOR #$07
				CMP #$03
				BPL skip_extra_near_marker

				INX

skip_extra_near_marker
				ASL @												; *16
				ASL @
				ASL @
				ASL @
				ADC #<buff1_bottom_markers							;$0b
				STA $00 											; screen_address_low
				BCC skip_page3

				INC $01 											; screen_address_high
skip_page3
plot_near_markers_loop
				LDY #$03
				LDA #%01010101  									; BOTTOM MARKERS
plot_near_marker_loop
				STA ($00),Y
				DEY
				BPL plot_near_marker_loop
				
				CLC
				LDA $00 											; screen_address_low
				ADC #$80
				STA $00 											; screen_address_low
				BCC skip_page4
				
				INC $01 											; screen_address_high
skip_page4
				DEX
				BPL plot_near_markers_loop

				rts
       							
	 	.endpg

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; update progress bar on bottom panel
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
update_progress_bar
    			LDA $71 											; level_position
				AND #$fc
				ASL @
				TAY
				LDA $71 											; level_position
				AND #$03
				TAX
				LDA progress_bar_pixel_values,X
				jsr conv_byte_BBC_ATARI
				LDX #$05
				
plot_end_of_progress_bar_loop
				STA buff1_progress_bar+1,Y         		        	 ; buffer_two + $140 * 17 + 8 * 16 + 1
				STA buff2_progress_bar+1,Y 							 ; buffer_one + $140 * 17 + 8 * 16 + 1
				INY
				DEX
				BPL plot_end_of_progress_bar_loop
				
				rts				
				
progress_bar_pixel_values dta $88,$cc,$ee,$ff	 	

; initialize colors of ground
; blink screen when boss is dead or weapon 4 is active
; blink time depends on "smart_bomb_timer"
; 
; COLPF0 - color for laser/weapon 
; COLPF1 - color for distant markers
; COLPF2 - color of horizont & ground
; COLPF3 - 5th color, color for explosion
set_color_background .proc
				ldx $96
				
				lda level_colours,x 
				add #2
				sta tab_dli_COLPF0+6+9
				sub #2
				sta tab_dli_COLPF0+8+9
				sub #2
				sta tab_dli_COLPF0+11+9

				lda level_colours,x 
    			:12 sta tab_dli_COLPF2+#+1            				; sky
  			    :2  sta tab_dli_COLPF2+#+1+12						; horizont
    			
    			ldy $72 											; smart_bomb_or_boss_active 
    			beq set1
    			
    			:12 sta tab_dli_COLPF3+#+1            				; sky
  			    :2  sta tab_dli_COLPF3+#+1+12						; horizont

set1			sbc #2
 	  			sta tab_dli_COLPF2+15								; ground
    			sta tab_dli_COLPF2+16								; ground
 	  			
 	  			ldy $72 											; smart_bomb_or_boss_active 
    			beq set2
    			
 	  			sta tab_dli_COLPF3+15								; ground
    			sta tab_dli_COLPF3+16								; ground
 	 			
set2 			sbc #2
    			sta tab_dli_COLPF1+16 			
     			sta tab_dli_COLPF2+17
    			sta tab_dli_COLPF2+18 
    			
    			sbc #2
    			sta tab_dli_COLPF1+17
    			sta tab_dli_COLPF1+18  			
    			sta tab_dli_COLPF2+19
      			sta tab_dli_COLPF2+20
    			
    			lda #0												; hide part of color on LEVEL SCREEN
    			sta tab_dli_COLPF1+19
      			sta tab_dli_COLPF1+20

				rts	 	
.endp
	 	
.print 'bank $03  = $4000 - ', *-1	

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Load the Graph2Font picture 
; bank #4 EXTENSION is ON
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
	 	lmb #4
    	.pages $40
    
cw_title         icl 'DATA\graphics\cw_title.asm'
TOPSTR           ins 'DATA\graphics\TOPSTR.BIN'     	; len=$0140, Load score section
BOTSTR           ins 'DATA\graphics\BOTSTR.BIN'         ; len=$03C0, Load status section

	.align $0100
font4x8          				ins 'DATA\fonts\nc3.fnt'  

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; show "LEVEL 1" on screen before main game
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
reset_screen_for_new_level .proc
 				jsr reset_screen      
    							
    			draw_char_buff1 #0 #0  #TOPSTR #$0140
    			draw_char_buff1 #0 #21 #BOTSTR #$03c0
    			draw_char_buff2 #0 #0  #TOPSTR #$0140
    			draw_char_buff2 #0 #21 #BOTSTR #$03c0
				jsr plot_5th_color
				jsr PMG_init											 ; active PMG graphics	
				JSR remove_player_one								 
				JSR remove_player_two									 ; show lives on bottom panel
               	ldy #$00 \ jsr plot_weapon_slots
               	ldy #$01 \ jsr plot_weapon_slots
               	
; wipe progress bar on bottom panel
				lda #$00
				LDX #$47
wipe_progress_bar
                STA buff1_progress_bar,X 
                STA buff2_progress_bar,X 
                DEX
                BPL wipe_progress_bar

; remove lasers				
				LDX #$30
remove_lasers_loop
				STA $42,X 											 ; lasers_x
				DEX
				BPL remove_lasers_loop               	

				ldx #$05
remove_enemies_loop
				STA $12,X 											; player_or_enemies_x + 2                  ; Set to zero to indicate no enemy in slot
				DEX
				BPL remove_enemies_loop
				              		
               	ldx #$01                                             ; For each player 
replot_weapon_selectors_loop
               	jsr replot_weapon_selector             		         ; replot weapon selector
               	dex
               	bpl replot_weapon_selectors_loop
  
				LDA $9b 											 ; level_number	
 				STA maximum_level_reached
 				AND #$07
 				CLC
 				ADC #$31											 ; "1"
 				sta txt_LEVEL+8
 				
 				LDA $c6 											; players_maximum_weapon
 				STA initial_players_maximum_weapon
 				LDA $c7 											; players_maximum_weapon + 1
 				STA initial_players_maximum_weapon + 1
 				LDA $9c 											; players_lives
 				STA initial_players_lives
 				LDA $9d 											; players_lives + 1
 				STA initial_players_lives + 1
 				LDY #$00
			
				lda #song_start_level
				jsr rmt_init2   
			   	
 				RTS
.endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; draw selection of weapon (on bottom panel) 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
weapon_slot_buffer_addresses_low      dta <(buff1_charset7+1*320+7*8),<(buff1_charset7+1*320+29*8)
weapon_slot_buffer_two_addresses_high dta >(buff2_charset7+1*320+7*8),>(buff2_charset7+1*320+29*8)
weapon_slot_buffer_one_addresses_high dta >(buff1_charset7+1*320+7*8),>(buff1_charset7+1*320+29*8)

plot_weapon_slots
				LDA weapon_slot_buffer_addresses_low,Y
				STA $00 											; buffer_two_address_low
				STA $73 											; buffer_one_address_low
				mva weapon_slot_buffer_two_addresses_high,Y	$01		; buffer_two_address_high
				mva weapon_slot_buffer_one_addresses_high,Y $74		; buffer_one_address_high
				
				LDA $00c6,Y 										; players_maximum_weapon
				STA counter1										; maximum_weapon
			
				ldx #$00

plot_weapon_slots_loop
				LDA #<weapon_slot_sprites 							; $0700 = weapon_slot_sprites
				STA $75 											; sprite_address_low
				LDA #>weapon_slot_sprites
				STA $76  											; sprite_address_high
				
				CPX counter1 										; maximum_weapon
				BPL plot_weapon_slot                         		; Use empty slot if weapon not collected
				
				TXA                                                 ; Otherwise use sprite for weapon
				CLC
				ADC #$01
				ASL @
				ASL @
				ASL @
				ASL @
				ADC $75 											; sprite_address_low
				STA $75 											; sprite_address_low

plot_weapon_slot
				LDY #15
				
plot_weapon_slot_loop
				LDA ($75),Y 										; sprite_address
				jsr conv_byte_BBC_ATARI
				STA ($00),Y 										; buffer_two_address
				STA ($73),Y 										; buffer_one_address
				DEY
				BPL plot_weapon_slot_loop
				
				LDA $00 											; buffer_two_address_low
				CLC
				ADC #16
				STA $00 											; buffer_two_address_low
				STA $73 											; buffer_one_address_low
				
				INX
				CPX #$03
				BNE plot_weapon_slots_loop
				
				RTS
 
		.align $0100

weapon_slot_sprites
       dta $80,$80,$80,$80,$80,$80,$80,$80,$00,$10,$00,$10,$00,$10,$00,$10               ; Empty slot
       dta $80,$91,$a2,$d5,$c4,$a2,$91,$80,$88,$10,$00,$dc,$00,$10,$00,$98               ; Multidirectional laser
       dta $93,$81,$80,$80,$80,$80,$81,$93,$08,$9c,$4e,$36,$26,$5e,$8c,$18               ; Antimatter torpedo
       dta $91,$a2,$91,$a2,$91,$a2,$91,$80,$00,$98,$4c,$be,$4c,$98,$00,$10               ; Smart bomb
 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; replot weapon selector (4th poles, clear in screen buffor 2 only beacause we copy 2nd buffor to 1st buffor later)
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
replot_weapon_selector                                            	; Called with X = player
				LDY $9e,X   										; players_selected_weapon_screen_offset
				LDA #$00											
				JSR plot_weapon_selector							; clear weapon selector (black color)			
				INY
				JSR plot_weapon_selector
				
				LDA $0e,X   										; players_selected_weapon
				AND #$fc
				ASL @												; *4
				ASL @
				ADC weapon_selector_base_screen_offsets,X
				STA $9e,X   										; players_selected_weapon_screen_offset
				TAY
				LDA #$ff
				JSR plot_weapon_selector							; plot weapon selector (white color)
				INY
					
plot_weapon_selector
				sta buff1_weapon_selector+0,y
				sta buff1_weapon_selector+8,y
				sta buff2_weapon_selector+0,y
				sta buff2_weapon_selector+8,y
				rts

weapon_selector_base_screen_offsets
		dta $00,$b0

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; init variables
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
init_variables .proc
				lda #>PMG0
				sta vbl_PMBASE
		
				lda $9b 												; level_number
				and #$07
				tax
				lda level_waves_data_addresses_low_table,X
				sta level_waves_data_address_low+1
				sta level_waves_COLPF1_address_low+1
				
				ldx #17
				stx no_stars 										 ; number of animated stars (1-17)
				stx $94												 ; Set to non-zero to use buffer two, buffer_to_use 
				ldx #$04 											 ; SPRITE_PLAYER_TWO
				stx $29 											 ; players_or_enemies_type + 1              ; Player two uses slot 1        
 				ldx #$ff											 ; clear last position of Y (PMG)
				stx waves_level_position
				inx													 ; SPRITE_PLAYER_ONE
				stx vbl_HPOSP0
				stx vbl_HPOSM0
				stx vbl_HPOSP2
				stx vbl_HPOSM2
				stx vbl_HPOSP0+1
				stx vbl_HPOSM0+1
				stx vbl_HPOSP2+1
				stx vbl_HPOSM2+1
				stx $28 											 ; players_or_enemies_type                  ; Player one uses slot 0	
				stx $70 											 ; frame_counter
				stx $71 											 ; level_position
				stx $90 											 ; next_enemy_to_add
				stx $c2 											 ; players_bonuses_collected
				stx $c3 											 ; player_two_bonuses				
				stx $04   											 ; players_firing_intent      ; Set to zero to indicate not wanting to fire
				stx $05   											 ; players_firing_intent + 1
				stx stars_ind
				stx active_bonus1
				stx active_bonus2
				stx index_tab_bonus_player1
				stx index_tab_bonus_player2
				stx is_active_bonus1 
				stx is_active_bonus2
				stx message_timer1
				stx message_timer2
				stx message_shw1
				stx message_shw2				
				stx message_clr1
				stx message_clr2				
				stx waves_COLPF1
				stx waves_depending
				stx old_player0_y
				stx old_player0_y+1
				stx old_player1_y  
				stx old_player1_y+1              		
				stx is_resume_game_vbl
				stx is_remove_bonus1
				stx is_remove_bonus2
			:8  stx tab_remove_explosion+#
						
				rts
.endp

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
; plot string on screen buffor 1 & 2
; 4x8 font, 40x24 screen  
; reg. A  - color of text ( bits 0-3 ), +bit7=1 - lda/sta, +bit7=0 lda/and/ora/sta 
; reg. XY - address of source text
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
bank_plot4x8_string .proc				
				stx src1
				stx tmp_src1
				sty src1+1
				sty tmp_src1+1	

				lda tmp_color
				bit tmp_color
				bpl _skip0
	
				mvy #<plot4x8_char83   _jsr1+1 
				mvy #>plot4x8_char83   _jsr1+2 
				jmp _skip1
							
_skip0			;and #3
				tay
				mva tab_jsr_lo,y   _jsr1+1 
				mva tab_jsr_hi,y   _jsr1+2 
						                              			
_skip1			jsr calculate_offset_on_screen
               	adw $00 #buff1_charset0 dst2
				jsr _skip2 

				mvx #1 len_src1
               	adw $00 #buff2_charset0 dst2
                mwa tmp_src1 src1
               	jsr _skip2 
			
				lda tmp_color	
				cmp #4
				bne _skip3
	
				mwa tmp_src1 src1
			   	ldy #1
               	lda (src1),y
               	tax
               	mva tab_screen_chars_lo,x dst2 
               	mva tab_screen_chars_hi,x dst2+1
       		   	dey
               	lda (src1),y
               	add dst2
               	sta dst2
               	bcc *+4
               	inc dst2+1   
               
                mwa dst2     tmp_dst2_message
                mvx len_src1 tmp_len_message   
 
set5th          ldy #$00
          
_loop2          lda (dst2),y
                ora #128												; bit7 = 128
                sta (dst2),y              
                iny
			    dex	
                bne _loop2 		

_skip3			rts               	
      				
_loop1   		tay
                lda tab_convert_ATASCII_DISPLAY,y    
				tay
				lda tab_mul8_lo,y
				add #<font4x8
				sta src2
				lda tab_mul8_hi,y
				adc #>font4x8
				sta src2+1
								
_jsr1			jsr plot4x8_char1
				
				adw src1 #1
				inc len_src1
				
_skip2     		ldy #2
				lda (src1),y			
				cmp #$9b													    ; RETURN ?
				bne _loop1
				
				dec len_src1
				
     			rts

; plot char for color = 0
plot4x8_char0 	ldy #7
					
_loop20  		lda (src2),y
				tax
				lda (dst2),y
				and tab_mask_11_to_00,x
   				sta (dst2),y
				dey
				bpl _loop20
				
				adw dst2  #8

 			    rts
 	    
; plot char for color = 1
plot4x8_char1 	ldy #7
					
_loop21			lda (src2),y
				tax
				lda (dst2),y
                and tab_mask_11_to_00,x
				ora tab_convert_11_to_01,x   	   
   				sta (dst2),y
				dey
				bpl _loop21
				
				adw dst2  #8

   			    rts
   		   
; plot char for color = 2
plot4x8_char2 	ldy #7
					
_loop22			lda (src2),y
				tax
				lda (dst2),y
                and tab_mask_11_to_00,x
			    ora tab_convert_11_to_10,x 
			    sta (dst2),y  	   
				dey
				bpl _loop22
				
				adw dst2  #8

   			    rts

; plot char for color = 3
plot4x8_char3 	ldy #7
					
_loop23			lda (src2),y
				tax
				lda (dst2),y
                and tab_mask_11_to_00,x
                ora (src2),y  				
   				sta (dst2),y
				dey
				bpl _loop23
				
				adw dst2  #8

 			    rts

; plot char for color = $83
plot4x8_char83 	ldy #7
					
_loop_c3		lda (src2),y
   				sta (dst2),y
				dey
				bpl _loop_c3
				
				adw dst2  #8

   			    rts
   			    
tab_jsr_lo     dta <plot4x8_char0,<plot4x8_char1,<plot4x8_char2,<plot4x8_char3,<plot4x8_char3
tab_jsr_hi     dta >plot4x8_char0,>plot4x8_char1,>plot4x8_char2,>plot4x8_char3,>plot4x8_char3

tab_mul8_lo     :128  dta <[#*8] 
tab_mul8_hi     :128  dta >[#*8]

tab_mask_11_to_00
			.rept 256
				?bits10 = # & %00000011
				?bits32 = # & %00001100
				?bits54 = # & %00110000
				?bits76 = # & %11000000
				
				.if ?bits10 = %00000011
					?bits10 = %11111100 
				.else
					?bits10 = %11111111 				
				.endif
				    
				.if ?bits32 = %00001100
				    ?bits32 = %11110011 
				.else
					?bits32 = %11111111 				
				.endif

				.if ?bits54 = %00110000
				    ?bits54 = %11001111
				.else
					?bits54 = %11111111 				
				.endif
							    		
				.if ?bits76 = %11000000
				    ?bits76 = %00111111
				.else
					?bits76 = %11111111 				
				.endif				
				
				dta ?bits76 & ?bits54 & ?bits32 & ?bits10
			.endr

tab_convert_11_to_01
			.rept 256
				?bits10 = # & %00000011
				?bits32 = # & %00001100
				?bits54 = # & %00110000
				?bits76 = # & %11000000
				
				.if ?bits10 = %00000011
					?bits10 = %00000001 
				.endif
				.if ?bits32 = %00001100
				    ?bits32 = %00000100 
				.endif
				.if ?bits54 = %00110000
				    ?bits54 = %00010000
			    .endif		
				.if ?bits76 = %11000000
				    ?bits76 = %01000000
				.endif
				
				dta ?bits76 | ?bits54 | ?bits32 | ?bits10
			.endr

tab_convert_11_to_10
			.rept 256
				?bits10 = # & %00000011
				?bits32 = # & %00001100
				?bits54 = # & %00110000
				?bits76 = # & %11000000
				
				.if ?bits10 = %00000011
					?bits10 = %00000010
				.endif
				.if ?bits32 = %00001100
				    ?bits32 = %00001000 
				.endif
				.if ?bits54 = %00110000
				    ?bits54 = %00100000
			    .endif		
				.if ?bits76 = %11000000
				    ?bits76 = %10000000
				.endif
				
				dta ?bits76 | ?bits54 | ?bits32 | ?bits10
			.endr
 			    
.endp

tab_convert_ATASCII_DISPLAY 
				:+32 dta [#+0]+64
				:+64 dta [#+32]-32
				:+32 dta [#+96]
				:+32 dta [#+128]+64
				:+64 dta [#+160]-32
				:+32 dta [#+224]

tab_convert_DISPLAY_ATASCII 
				:+64 dta [#+32]        				; 0-63				
				:+32 dta [#+64]-64   				; 64-95
				:+32 dta [#+96]     				; 96-127
				:+64 dta [#+32]+128     			; 0-63				
				:+32 dta [#+64]-64+128   			; 64-95
				:+32 dta [#+96]+128     			; 96-127   

	 	.endpg
.print 'bank $04  = $4000 - ', *-1		 			 
   		rmb	  

	run run_game
